/* Box.c generated by valac 0.36.4, the Vala compiler
 * generated from Box.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define TYPE_BOX_LOCATION (box_location_get_type ())

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void) G_GNUC_CONST;
GType box_complements_get_type (void) G_GNUC_CONST;
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
void box_from_rectangle (GdkRectangle* rect, Box* result);
void box_from_allocation (GtkAllocation* alloc, Box* result);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void box_from_center (GdkPoint* center, gint width, gint height, Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self, Box* box);
void box_adjust_width (Box *self, gint width);
void box_adjust_height (Box *self, gint height);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void box_get_dimensions (Box *self, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_get_rectangle (Box *self, GdkRectangle* result);
void box_get_center (Box *self, GdkPoint* result);
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result);
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result);
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result);
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result);
gboolean box_intersects (Box *self, Box* compare);
void box_get_reduced (Box *self, gint amount, Box* result);
void box_get_expanded (Box *self, gint amount, Box* result);
gboolean box_contains (Box *self, GdkPoint* point);
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted);
void box_rubber_band (Box *self, GdkPoint* point, Box* result);
gchar* box_to_string (Box *self);
gchar* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (gdouble pos, gint zone);
static gboolean box_in_between (gdouble pos, gint top, gint bottom);
static gboolean box_near_in_between (gdouble pos, gint top, gint bottom);
BoxLocation box_approx_location (Box *self, gint x, gint y);


GType box_location_get_type (void) {
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement) {
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = horizontal_complement;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp1_) {
#line 153 "Box.c"
		gboolean _tmp2_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = vertical_complement;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = _tmp2_;
#line 159 "Box.c"
	} else {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = FALSE;
#line 163 "Box.c"
	}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp0_) {
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		result = BOX_COMPLEMENTS_BOTH;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		return result;
#line 171 "Box.c"
	} else {
		gboolean _tmp3_;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp3_ = horizontal_complement;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp3_) {
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			result = BOX_COMPLEMENTS_HORIZONTAL;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			return result;
#line 182 "Box.c"
		} else {
			gboolean _tmp4_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp4_ = vertical_complement;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp4_) {
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				result = BOX_COMPLEMENTS_VERTICAL;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				return result;
#line 193 "Box.c"
			}
		}
	}
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = BOX_COMPLEMENTS_NONE;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 201 "Box.c"
}


GType box_complements_get_type (void) {
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


void box_init (Box *self, gint left, gint top, gint right, gint bottom) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	memset (self, 0, sizeof (Box));
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = left;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = CLAMP (_tmp0_, 0, G_MAXINT);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	left = _tmp1_;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = top;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = CLAMP (_tmp2_, 0, G_MAXINT);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	top = _tmp3_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = right;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = left;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp4_ <= _tmp5_) {
#line 250 "Box.c"
		gint _tmp6_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp6_ = left;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		right = _tmp6_ + 1;
#line 256 "Box.c"
	}
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = bottom;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = top;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp7_ <= _tmp8_) {
#line 264 "Box.c"
		gint _tmp9_;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp9_ = top;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		bottom = _tmp9_ + 1;
#line 270 "Box.c"
	}
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = left;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).left = _tmp10_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = top;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).top = _tmp11_;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp12_ = right;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).right = _tmp12_;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp13_ = bottom;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).bottom = _tmp13_;
#line 288 "Box.c"
}


void box_from_rectangle (GdkRectangle* rect, Box* result) {
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (rect != NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *rect;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = *rect;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = *rect;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = *rect;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = _tmp6_.width;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = *rect;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = *rect;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = _tmp10_.height;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp12_;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 338 "Box.c"
}


void box_from_allocation (GtkAllocation* alloc, Box* result) {
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	GtkAllocation _tmp6_;
	gint _tmp7_;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (alloc != NULL);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *alloc;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = *alloc;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = *alloc;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = *alloc;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = _tmp6_.width;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = *alloc;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = *alloc;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = _tmp10_.height;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp12_;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 388 "Box.c"
}


void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result) {
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkPoint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GdkPoint _tmp15_;
	gint _tmp16_;
	GdkPoint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	Box _tmp20_ = {0};
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (corner1 != NULL);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (corner2 != NULL);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *corner1;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = *corner2;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = _tmp2_.x;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = MIN (_tmp1_, _tmp3_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = *corner1;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = _tmp5_.y;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = *corner2;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = _tmp7_.y;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = MIN (_tmp6_, _tmp8_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = *corner1;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = _tmp10_.x;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp12_ = *corner2;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp13_ = _tmp12_.x;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp14_ = MAX (_tmp11_, _tmp13_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp15_ = *corner1;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp16_ = _tmp15_.y;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp17_ = *corner2;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp18_ = _tmp17_.y;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp19_ = MAX (_tmp16_, _tmp18_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp20_, _tmp4_, _tmp9_, _tmp14_, _tmp19_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp20_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 464 "Box.c"
}


void box_from_center (GdkPoint* center, gint width, gint height, Box* result) {
	GdkPoint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPoint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkPoint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (center != NULL);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *center;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = width;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = *center;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = _tmp3_.y;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = height;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = *center;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = _tmp6_.x;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = width;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = *center;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = _tmp9_.y;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = height;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp12_, _tmp1_ - (_tmp2_ / 2), _tmp4_ - (_tmp5_ / 2), _tmp7_ + (_tmp8_ / 2), _tmp10_ + (_tmp11_ / 2));
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp12_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 514 "Box.c"
}


gint box_get_width (Box *self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).right;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).left;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp0_ >= _tmp1_, "right >= left");
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).right;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).left;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = (_tmp2_ - _tmp3_) + 1;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 538 "Box.c"
}


gint box_get_height (Box *self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).bottom;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).top;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp0_ >= _tmp1_, "bottom >= top");
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).top;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = (_tmp2_ - _tmp3_) + 1;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 562 "Box.c"
}


gboolean box_is_valid (Box *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).left;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp3_ >= 0) {
#line 576 "Box.c"
		gint _tmp4_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp4_ = (*self).top;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = _tmp4_ >= 0;
#line 582 "Box.c"
	} else {
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = FALSE;
#line 586 "Box.c"
	}
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp2_) {
#line 590 "Box.c"
		gint _tmp5_;
		gint _tmp6_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp5_ = (*self).right;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp6_ = (*self).left;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = _tmp5_ >= _tmp6_;
#line 599 "Box.c"
	} else {
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = FALSE;
#line 603 "Box.c"
	}
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp1_) {
#line 607 "Box.c"
		gint _tmp7_;
		gint _tmp8_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp7_ = (*self).bottom;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = (*self).top;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = _tmp7_ >= _tmp8_;
#line 616 "Box.c"
	} else {
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = FALSE;
#line 620 "Box.c"
	}
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp0_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 626 "Box.c"
}


gboolean box_equals (Box *self, Box* box) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	Box _tmp4_;
	gint _tmp5_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_val_if_fail (box != NULL, FALSE);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).left;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = *box;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = _tmp4_.left;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp3_ == _tmp5_) {
#line 648 "Box.c"
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp6_ = (*self).top;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp7_ = *box;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = _tmp7_.top;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = _tmp6_ == _tmp8_;
#line 660 "Box.c"
	} else {
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = FALSE;
#line 664 "Box.c"
	}
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp2_) {
#line 668 "Box.c"
		gint _tmp9_;
		Box _tmp10_;
		gint _tmp11_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp9_ = (*self).right;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp10_ = *box;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp11_ = _tmp10_.right;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = _tmp9_ == _tmp11_;
#line 680 "Box.c"
	} else {
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = FALSE;
#line 684 "Box.c"
	}
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp1_) {
#line 688 "Box.c"
		gint _tmp12_;
		Box _tmp13_;
		gint _tmp14_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp12_ = (*self).bottom;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp13_ = *box;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp14_ = _tmp13_.bottom;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = _tmp12_ == _tmp14_;
#line 700 "Box.c"
	} else {
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = FALSE;
#line 704 "Box.c"
	}
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp0_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 710 "Box.c"
}


void box_adjust_width (Box *self, gint width) {
	gint center_x = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).right;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	center_x = (_tmp0_ + _tmp1_) / 2;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = width;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).left = center_x - (_tmp2_ / 2);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = width;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).right = center_x + (_tmp3_ / 2);
#line 734 "Box.c"
}


void box_adjust_height (Box *self, gint height) {
	gint center_y = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).top;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).bottom;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	center_y = (_tmp0_ + _tmp1_) / 2;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = height;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).top = center_y - (_tmp2_ / 2);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = height;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	(*self).bottom = center_y + (_tmp3_ / 2);
#line 758 "Box.c"
}


void box_get_scaled (Box *self, Dimensions* scaled, Box* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint l = 0;
	gint _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gint t = 0;
	gint _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gint r = 0;
	gint _tmp10_;
	Dimensions _tmp11_;
	gint _tmp12_;
	gint b = 0;
	gint _tmp13_;
	Dimensions _tmp14_;
	gint _tmp15_;
	Box box = {0};
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gboolean _tmp20_ = FALSE;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_get_dimensions (&(*self), &_tmp0_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = *scaled;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	dimensions_get_scale_ratios (&_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	x_scale = _tmp2_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	y_scale = _tmp3_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).left;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = x_scale;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = round (((gdouble) _tmp4_) * _tmp5_);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	l = (gint) _tmp6_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = (*self).top;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = y_scale;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = round (((gdouble) _tmp7_) * _tmp8_);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	t = (gint) _tmp9_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = l;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = *scaled;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp12_ = _tmp11_.width;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	r = (_tmp10_ + _tmp12_) - 1;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp13_ = t;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp14_ = *scaled;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp15_ = _tmp14_.height;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	b = (_tmp13_ + _tmp15_) - 1;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp16_ = l;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp17_ = t;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp18_ = r;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp19_ = b;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&box, _tmp16_, _tmp17_, _tmp18_, _tmp19_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp21_ = box_get_width (&box);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp22_ = *scaled;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp23_ = _tmp22_.width;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp21_ == _tmp23_) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp20_ = TRUE;
#line 858 "Box.c"
	} else {
		gint _tmp24_;
		Dimensions _tmp25_;
		gint _tmp26_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp24_ = box_get_height (&box);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp25_ = *scaled;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp26_ = _tmp25_.height;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp20_ = _tmp24_ == _tmp26_;
#line 871 "Box.c"
	}
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp20_, "box.get_width () == scaled.width || box.get_height () == scaled.height");
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = box;
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 879 "Box.c"
}


void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gint l = 0;
	gint _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gint t = 0;
	gint _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gint r = 0;
	gint _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gint b = 0;
	gint _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gint _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	gint _tmp20_;
	Dimensions _tmp21_;
	gint _tmp22_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	Box _tmp29_ = {0};
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (original != NULL);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *scaled;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	x_scale = _tmp1_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	y_scale = _tmp2_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).left;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = x_scale;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = round (((gdouble) _tmp3_) * _tmp4_);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	l = (gint) _tmp5_;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).top;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = y_scale;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = round (((gdouble) _tmp6_) * _tmp7_);
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	t = (gint) _tmp8_;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = (*self).right;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = x_scale;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = round (((gdouble) _tmp9_) * _tmp10_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	r = (gint) _tmp11_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp12_ = (*self).bottom;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp13_ = y_scale;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp14_ = round (((gdouble) _tmp12_) * _tmp13_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	b = (gint) _tmp14_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp15_ = r;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp16_ = *scaled;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp17_ = _tmp16_.width;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp15_ >= _tmp17_) {
#line 968 "Box.c"
		Dimensions _tmp18_;
		gint _tmp19_;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp18_ = *scaled;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp19_ = _tmp18_.width;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		r = _tmp19_ - 1;
#line 977 "Box.c"
	}
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp20_ = b;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp21_ = *scaled;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp22_ = _tmp21_.height;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp20_ >= _tmp22_) {
#line 987 "Box.c"
		Dimensions _tmp23_;
		gint _tmp24_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp23_ = *scaled;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp24_ = _tmp23_.height;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		b = _tmp24_ - 1;
#line 996 "Box.c"
	}
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp25_ = l;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp26_ = t;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp27_ = r;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp28_ = b;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp29_, _tmp25_, _tmp26_, _tmp27_, _tmp28_);
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp29_;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1012 "Box.c"
}


void box_get_offset (Box *self, gint xofs, gint yofs, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = xofs;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).top;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = yofs;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).right;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = xofs;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = yofs;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, _tmp0_ + _tmp1_, _tmp2_ + _tmp3_, _tmp4_ + _tmp5_, _tmp6_ + _tmp7_);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1048 "Box.c"
}


void box_get_dimensions (Box *self, Dimensions* result) {
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = box_get_width (&(*self));
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = box_get_height (&(*self));
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp2_;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1066 "Box.c"
}


void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right) {
	GdkPoint _vala_top_left = {0};
	GdkPoint _vala_bottom_right = {0};
	gint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_ = {0};
	gint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_ = {0};
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).top;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_.x = _tmp0_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_.y = _tmp1_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_top_left = _tmp2_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).right;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).bottom;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_.x = _tmp3_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_.y = _tmp4_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_bottom_right = _tmp5_;
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (top_left) {
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*top_left = _vala_top_left;
#line 1103 "Box.c"
	}
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (bottom_right) {
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*bottom_right = _vala_bottom_right;
#line 1109 "Box.c"
	}
}


void box_get_rectangle (Box *self, GdkRectangle* result) {
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	rect.x = _tmp0_;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).top;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	rect.y = _tmp1_;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = box_get_width (&(*self));
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	rect.width = _tmp2_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = box_get_height (&(*self));
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	rect.height = _tmp3_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = rect;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1142 "Box.c"
}


void box_get_center (Box *self, GdkPoint* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_ = {0};
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).right;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).top;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_.x = (_tmp0_ + _tmp1_) / 2;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_.y = (_tmp2_ + _tmp3_) / 2;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp4_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1168 "Box.c"
}


void box_rotate_clockwise (Box *self, Dimensions* space, Box* result) {
	gint l = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint t = 0;
	gint _tmp3_;
	gint r = 0;
	Dimensions _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint b = 0;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *space;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.width;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	l = (_tmp1_ - _tmp2_) - 1;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).left;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	t = _tmp3_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = *space;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = _tmp4_.width;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).top;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	r = (_tmp5_ - _tmp6_) - 1;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = (*self).right;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	b = _tmp7_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, l, t, r, b);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1218 "Box.c"
}


void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result) {
	gint l = 0;
	gint _tmp0_;
	gint t = 0;
	Dimensions _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint r = 0;
	gint _tmp4_;
	gint b = 0;
	Dimensions _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).top;
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	l = _tmp0_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = *space;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = _tmp1_.height;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).right;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	t = (_tmp2_ - _tmp3_) - 1;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).bottom;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	r = _tmp4_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = *space;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = _tmp5_.height;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = (*self).left;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	b = (_tmp6_ - _tmp7_) - 1;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, l, t, r, b);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1268 "Box.c"
}


void box_flip_left_to_right (Box *self, Dimensions* space, Box* result) {
	gint l = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint r = 0;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *space;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.width;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).right;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	l = (_tmp1_ - _tmp2_) - 1;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = *space;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = _tmp3_.width;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = (*self).left;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	r = (_tmp4_ - _tmp5_) - 1;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).top;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = (*self).bottom;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, l, _tmp6_, r, _tmp7_);
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1312 "Box.c"
}


void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result) {
	gint t = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint b = 0;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *space;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.height;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	t = (_tmp1_ - _tmp2_) - 1;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = *space;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = _tmp3_.height;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = (*self).top;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	b = (_tmp4_ - _tmp5_) - 1;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).left;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = (*self).right;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, _tmp6_, t, _tmp7_, b);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1356 "Box.c"
}


gboolean box_intersects (Box *self, Box* compare) {
	gboolean result = FALSE;
	gint left_intersect = 0;
	gint _tmp0_;
	Box _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint top_intersect = 0;
	gint _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint right_intersect = 0;
	gint _tmp8_;
	Box _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint bottom_intersect = 0;
	gint _tmp12_;
	Box _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gboolean _tmp16_ = FALSE;
	gint _tmp17_;
	gint _tmp18_;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_val_if_fail (compare != NULL, FALSE);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = *compare;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = _tmp1_.left;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = MAX (_tmp0_, _tmp2_);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	left_intersect = _tmp3_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).top;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = *compare;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = _tmp5_.top;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = MAX (_tmp4_, _tmp6_);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	top_intersect = _tmp7_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = (*self).right;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = *compare;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = _tmp9_.right;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = MIN (_tmp8_, _tmp10_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	right_intersect = _tmp11_;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp12_ = (*self).bottom;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp13_ = *compare;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp14_ = _tmp13_.bottom;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp15_ = MIN (_tmp12_, _tmp14_);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	bottom_intersect = _tmp15_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp17_ = right_intersect;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp18_ = left_intersect;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp17_ >= _tmp18_) {
#line 1433 "Box.c"
		gint _tmp19_;
		gint _tmp20_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp19_ = bottom_intersect;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp20_ = top_intersect;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp16_ = _tmp19_ >= _tmp20_;
#line 1442 "Box.c"
	} else {
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp16_ = FALSE;
#line 1446 "Box.c"
	}
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp16_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 1452 "Box.c"
}


void box_get_reduced (Box *self, gint amount, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = amount;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).top;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = amount;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).right;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = amount;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = amount;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, _tmp0_ + _tmp1_, _tmp2_ + _tmp3_, _tmp4_ - _tmp5_, _tmp6_ - _tmp7_);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1488 "Box.c"
}


void box_get_expanded (Box *self, gint amount, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = amount;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).top;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = amount;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).right;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = amount;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = amount;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp8_, _tmp0_ - _tmp1_, _tmp2_ - _tmp3_, _tmp4_ + _tmp5_, _tmp6_ + _tmp7_);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp8_;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 1524 "Box.c"
}


gboolean box_contains (Box *self, GdkPoint* point) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPoint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_val_if_fail (point != NULL, FALSE);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = *point;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = _tmp3_.x;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = (*self).left;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp4_ >= _tmp5_) {
#line 1546 "Box.c"
		GdkPoint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp6_ = *point;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp7_ = _tmp6_.x;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = (*self).right;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = _tmp7_ <= _tmp8_;
#line 1558 "Box.c"
	} else {
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp2_ = FALSE;
#line 1562 "Box.c"
	}
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp2_) {
#line 1566 "Box.c"
		GdkPoint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp9_ = *point;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp10_ = _tmp9_.y;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp11_ = (*self).top;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = _tmp10_ >= _tmp11_;
#line 1578 "Box.c"
	} else {
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = FALSE;
#line 1582 "Box.c"
	}
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp1_) {
#line 1586 "Box.c"
		GdkPoint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp12_ = *point;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp13_ = _tmp12_.y;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp14_ = (*self).bottom;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = _tmp13_ <= _tmp14_;
#line 1598 "Box.c"
	} else {
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp0_ = FALSE;
#line 1602 "Box.c"
	}
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp0_;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 1608 "Box.c"
}


BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged) {
	Box _vala_horizontal = {0};
	gboolean _vala_horizontal_enlarged = FALSE;
	Box _vala_vertical = {0};
	gboolean _vala_vertical_enlarged = FALSE;
	BoxComplements result = 0;
	gboolean horizontal_complement = FALSE;
	Box _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean vertical_complement = FALSE;
	Box _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	BoxComplements _tmp74_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_val_if_fail (resized != NULL, 0);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	horizontal_complement = TRUE;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *resized;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.top;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).top;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp1_ < _tmp2_) {
#line 1641 "Box.c"
		Box _tmp3_;
		gint _tmp4_;
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp3_ = *resized;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp4_ = _tmp3_.left;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp5_ = *resized;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp6_ = _tmp5_.top;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp7_ = *resized;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = _tmp7_.right;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp9_ = (*self).top;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		box_init (&_vala_horizontal, _tmp4_, _tmp6_, _tmp8_, _tmp9_);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_vala_horizontal_enlarged = TRUE;
#line 1667 "Box.c"
	} else {
		Box _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp10_ = *resized;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp11_ = _tmp10_.top;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp12_ = (*self).top;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp11_ > _tmp12_) {
#line 1680 "Box.c"
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			Box _tmp16_;
			gint _tmp17_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp13_ = (*self).left;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp14_ = (*self).top;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp15_ = (*self).right;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp16_ = *resized;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp17_ = _tmp16_.top;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_horizontal, _tmp13_, _tmp14_, _tmp15_, _tmp17_);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_vala_horizontal_enlarged = FALSE;
#line 1700 "Box.c"
		} else {
			Box _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp18_ = *resized;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp19_ = _tmp18_.bottom;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp20_ = (*self).bottom;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp19_ < _tmp20_) {
#line 1713 "Box.c"
				gint _tmp21_;
				Box _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp21_ = (*self).left;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp22_ = *resized;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp23_ = _tmp22_.bottom;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp24_ = (*self).right;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp25_ = (*self).bottom;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				box_init (&_vala_horizontal, _tmp21_, _tmp23_, _tmp24_, _tmp25_);
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_vala_horizontal_enlarged = FALSE;
#line 1733 "Box.c"
			} else {
				Box _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp26_ = *resized;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp27_ = _tmp26_.bottom;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp28_ = (*self).bottom;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				if (_tmp27_ > _tmp28_) {
#line 1746 "Box.c"
					Box _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					Box _tmp32_;
					gint _tmp33_;
					Box _tmp34_;
					gint _tmp35_;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp29_ = *resized;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp30_ = _tmp29_.left;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp31_ = (*self).bottom;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp32_ = *resized;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp33_ = _tmp32_.right;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp34_ = *resized;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp35_ = _tmp34_.bottom;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					box_init (&_vala_horizontal, _tmp30_, _tmp31_, _tmp33_, _tmp35_);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_vala_horizontal_enlarged = TRUE;
#line 1772 "Box.c"
				} else {
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					box_init (&_vala_horizontal, 0, 0, 0, 0);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_vala_horizontal_enlarged = FALSE;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					horizontal_complement = FALSE;
#line 1780 "Box.c"
				}
			}
		}
	}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	vertical_complement = TRUE;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp36_ = *resized;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp37_ = _tmp36_.left;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp38_ = (*self).left;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp37_ < _tmp38_) {
#line 1795 "Box.c"
		Box _tmp39_;
		gint _tmp40_;
		Box _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		Box _tmp44_;
		gint _tmp45_;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp39_ = *resized;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp40_ = _tmp39_.left;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp41_ = *resized;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp42_ = _tmp41_.top;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp43_ = (*self).left;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp44_ = *resized;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp45_ = _tmp44_.bottom;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		box_init (&_vala_vertical, _tmp40_, _tmp42_, _tmp43_, _tmp45_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_vala_vertical_enlarged = TRUE;
#line 1821 "Box.c"
	} else {
		Box _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp46_ = *resized;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp47_ = _tmp46_.left;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp48_ = (*self).left;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp47_ > _tmp48_) {
#line 1834 "Box.c"
			gint _tmp49_;
			gint _tmp50_;
			Box _tmp51_;
			gint _tmp52_;
			gint _tmp53_;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp49_ = (*self).left;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp50_ = (*self).top;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp51_ = *resized;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp52_ = _tmp51_.left;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp53_ = (*self).bottom;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_vertical, _tmp49_, _tmp50_, _tmp52_, _tmp53_);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_vala_vertical_enlarged = FALSE;
#line 1854 "Box.c"
		} else {
			Box _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp54_ = *resized;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp55_ = _tmp54_.right;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp56_ = (*self).right;
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp55_ < _tmp56_) {
#line 1867 "Box.c"
				Box _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp57_ = *resized;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp58_ = _tmp57_.right;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp59_ = (*self).top;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp60_ = (*self).right;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp61_ = (*self).bottom;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				box_init (&_vala_vertical, _tmp58_, _tmp59_, _tmp60_, _tmp61_);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_vala_vertical_enlarged = FALSE;
#line 1887 "Box.c"
			} else {
				Box _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp62_ = *resized;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp63_ = _tmp62_.right;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp64_ = (*self).right;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				if (_tmp63_ > _tmp64_) {
#line 1900 "Box.c"
					gint _tmp65_;
					Box _tmp66_;
					gint _tmp67_;
					Box _tmp68_;
					gint _tmp69_;
					Box _tmp70_;
					gint _tmp71_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp65_ = (*self).right;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp66_ = *resized;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp67_ = _tmp66_.top;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp68_ = *resized;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp69_ = _tmp68_.right;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp70_ = *resized;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp71_ = _tmp70_.bottom;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					box_init (&_vala_vertical, _tmp65_, _tmp67_, _tmp69_, _tmp71_);
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_vala_vertical_enlarged = TRUE;
#line 1926 "Box.c"
				} else {
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					box_init (&_vala_vertical, 0, 0, 0, 0);
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_vala_vertical_enlarged = FALSE;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					vertical_complement = FALSE;
#line 1934 "Box.c"
				}
			}
		}
	}
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp72_ = horizontal_complement;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp73_ = vertical_complement;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp74_ = box_complements_derive (_tmp72_, _tmp73_);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp74_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (horizontal) {
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*horizontal = _vala_horizontal;
#line 1951 "Box.c"
	}
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (horizontal_enlarged) {
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*horizontal_enlarged = _vala_horizontal_enlarged;
#line 1957 "Box.c"
	}
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (vertical) {
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*vertical = _vala_vertical;
#line 1963 "Box.c"
	}
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (vertical_enlarged) {
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*vertical_enlarged = _vala_vertical_enlarged;
#line 1969 "Box.c"
	}
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 1973 "Box.c"
}


BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted) {
	Box _vala_horizontal_this = {0};
	Box _vala_vertical_this = {0};
	Box _vala_horizontal_shifted = {0};
	Box _vala_vertical_shifted = {0};
	BoxComplements result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean horizontal_complement = FALSE;
	gboolean _tmp4_ = FALSE;
	Box _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean vertical_complement = FALSE;
	gboolean _tmp42_ = FALSE;
	Box _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gboolean _tmp80_;
	gboolean _tmp81_;
	BoxComplements _tmp82_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_val_if_fail (shifted != NULL, 0);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = box_get_width (&(*self));
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = box_get_width (shifted);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp0_ == _tmp1_, "get_width () == shifted.get_width ()");
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = box_get_height (&(*self));
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = box_get_height (shifted);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp2_ == _tmp3_, "get_height () == shifted.get_height ()");
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	horizontal_complement = TRUE;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = *shifted;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = _tmp5_.top;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = (*self).top;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp6_ < _tmp7_) {
#line 2024 "Box.c"
		Box _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = *shifted;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp9_ = _tmp8_.bottom;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp10_ = (*self).top;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp4_ = _tmp9_ > _tmp10_;
#line 2036 "Box.c"
	} else {
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp4_ = FALSE;
#line 2040 "Box.c"
	}
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp4_) {
#line 2044 "Box.c"
		gint _tmp11_;
		Box _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		Box _tmp16_;
		gint _tmp17_;
		Box _tmp18_;
		gint _tmp19_;
		Box _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp11_ = (*self).left;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp12_ = *shifted;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp13_ = _tmp12_.bottom;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp14_ = (*self).right;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp15_ = (*self).bottom;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		box_init (&_vala_horizontal_this, _tmp11_, _tmp13_, _tmp14_, _tmp15_);
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp16_ = *shifted;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp17_ = _tmp16_.left;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp18_ = *shifted;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp19_ = _tmp18_.top;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp20_ = *shifted;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp21_ = _tmp20_.right;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp22_ = (*self).top;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		box_init (&_vala_horizontal_shifted, _tmp17_, _tmp19_, _tmp21_, _tmp22_);
#line 2085 "Box.c"
	} else {
		gboolean _tmp23_ = FALSE;
		Box _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp24_ = *shifted;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp25_ = _tmp24_.top;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp26_ = (*self).top;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp25_ > _tmp26_) {
#line 2099 "Box.c"
			Box _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp27_ = *shifted;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp28_ = _tmp27_.top;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp29_ = (*self).bottom;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp23_ = _tmp28_ < _tmp29_;
#line 2111 "Box.c"
		} else {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp23_ = FALSE;
#line 2115 "Box.c"
		}
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp23_) {
#line 2119 "Box.c"
			gint _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			Box _tmp33_;
			gint _tmp34_;
			Box _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
			Box _tmp38_;
			gint _tmp39_;
			Box _tmp40_;
			gint _tmp41_;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp30_ = (*self).left;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp31_ = (*self).top;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp32_ = (*self).right;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp33_ = *shifted;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp34_ = _tmp33_.top;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_horizontal_this, _tmp30_, _tmp31_, _tmp32_, _tmp34_);
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp35_ = *shifted;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp36_ = _tmp35_.left;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp37_ = (*self).bottom;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp38_ = *shifted;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp39_ = _tmp38_.right;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp40_ = *shifted;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp41_ = _tmp40_.bottom;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_horizontal_shifted, _tmp36_, _tmp37_, _tmp39_, _tmp41_);
#line 2160 "Box.c"
		} else {
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_horizontal_this, 0, 0, 0, 0);
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_horizontal_shifted, 0, 0, 0, 0);
#line 324 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			horizontal_complement = FALSE;
#line 2168 "Box.c"
		}
	}
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	vertical_complement = TRUE;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp43_ = *shifted;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp44_ = _tmp43_.left;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp45_ = (*self).left;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp44_ < _tmp45_) {
#line 2181 "Box.c"
		Box _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp46_ = *shifted;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp47_ = _tmp46_.right;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp48_ = (*self).left;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp42_ = _tmp47_ > _tmp48_;
#line 2193 "Box.c"
	} else {
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp42_ = FALSE;
#line 2197 "Box.c"
	}
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp42_) {
#line 2201 "Box.c"
		Box _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
		Box _tmp54_;
		gint _tmp55_;
		Box _tmp56_;
		gint _tmp57_;
		gint _tmp58_;
		Box _tmp59_;
		gint _tmp60_;
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp49_ = *shifted;
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp50_ = _tmp49_.right;
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp51_ = (*self).top;
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp52_ = (*self).right;
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp53_ = (*self).bottom;
#line 330 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		box_init (&_vala_vertical_this, _tmp50_, _tmp51_, _tmp52_, _tmp53_);
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp54_ = *shifted;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp55_ = _tmp54_.left;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp56_ = *shifted;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp57_ = _tmp56_.top;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp58_ = (*self).left;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp59_ = *shifted;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp60_ = _tmp59_.bottom;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		box_init (&_vala_vertical_shifted, _tmp55_, _tmp57_, _tmp58_, _tmp60_);
#line 2242 "Box.c"
	} else {
		gboolean _tmp61_ = FALSE;
		Box _tmp62_;
		gint _tmp63_;
		gint _tmp64_;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp62_ = *shifted;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp63_ = _tmp62_.left;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp64_ = (*self).left;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp63_ > _tmp64_) {
#line 2256 "Box.c"
			Box _tmp65_;
			gint _tmp66_;
			gint _tmp67_;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp65_ = *shifted;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp66_ = _tmp65_.left;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp67_ = (*self).right;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp61_ = _tmp66_ < _tmp67_;
#line 2268 "Box.c"
		} else {
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp61_ = FALSE;
#line 2272 "Box.c"
		}
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp61_) {
#line 2276 "Box.c"
			gint _tmp68_;
			gint _tmp69_;
			Box _tmp70_;
			gint _tmp71_;
			gint _tmp72_;
			gint _tmp73_;
			Box _tmp74_;
			gint _tmp75_;
			Box _tmp76_;
			gint _tmp77_;
			Box _tmp78_;
			gint _tmp79_;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp68_ = (*self).left;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp69_ = (*self).top;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp70_ = *shifted;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp71_ = _tmp70_.left;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp72_ = (*self).bottom;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_vertical_this, _tmp68_, _tmp69_, _tmp71_, _tmp72_);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp73_ = (*self).right;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp74_ = *shifted;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp75_ = _tmp74_.top;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp76_ = *shifted;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp77_ = _tmp76_.right;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp78_ = *shifted;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp79_ = _tmp78_.bottom;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_vertical_shifted, _tmp73_, _tmp75_, _tmp77_, _tmp79_);
#line 2317 "Box.c"
		} else {
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_vertical_this, 0, 0, 0, 0);
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			box_init (&_vala_vertical_shifted, 0, 0, 0, 0);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			vertical_complement = FALSE;
#line 2325 "Box.c"
		}
	}
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp80_ = horizontal_complement;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp81_ = vertical_complement;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp82_ = box_complements_derive (_tmp80_, _tmp81_);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp82_;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (horizontal_this) {
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*horizontal_this = _vala_horizontal_this;
#line 2340 "Box.c"
	}
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (vertical_this) {
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*vertical_this = _vala_vertical_this;
#line 2346 "Box.c"
	}
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (horizontal_shifted) {
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*horizontal_shifted = _vala_horizontal_shifted;
#line 2352 "Box.c"
	}
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (vertical_shifted) {
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		*vertical_shifted = _vala_vertical_shifted;
#line 2358 "Box.c"
	}
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 2362 "Box.c"
}


void box_rubber_band (Box *self, GdkPoint* point, Box* result) {
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint t = 0;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint b = 0;
	gint _tmp8_;
	GdkPoint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint l = 0;
	gint _tmp12_;
	GdkPoint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint r = 0;
	gint _tmp16_;
	GdkPoint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	Box _tmp20_ = {0};
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_return_if_fail (point != NULL);
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = *point;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp1_ >= 0, "point.x >= 0");
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = *point;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_vala_assert (_tmp3_ >= 0, "point.y >= 0");
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = (*self).top;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = *point;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = _tmp5_.y;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = MIN (_tmp4_, _tmp6_);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	t = _tmp7_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = (*self).bottom;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = *point;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = _tmp9_.y;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = MAX (_tmp8_, _tmp10_);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	b = _tmp11_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp12_ = (*self).left;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp13_ = *point;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp14_ = _tmp13_.x;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp15_ = MIN (_tmp12_, _tmp14_);
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	l = _tmp15_;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp16_ = (*self).right;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp17_ = *point;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp18_ = _tmp17_.x;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp19_ = MAX (_tmp16_, _tmp18_);
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	r = _tmp19_;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_init (&_tmp20_, l, t, r, b);
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	*result = _tmp20_;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return;
#line 2452 "Box.c"
}


gchar* box_to_string (Box *self) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = (*self).left;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).top;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).right;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	box_get_dimensions (&(*self), &_tmp4_);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = dimensions_to_string (&_tmp4_);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = _tmp5_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = g_strdup_printf ("%d,%d %d,%d (%s)", _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp6_);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp8_ = _tmp7_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_g_free0 (_tmp6_);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp8_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 2491 "Box.c"
}


static gboolean box_in_zone (gdouble pos, gint zone) {
	gboolean result = FALSE;
	gint top_zone = 0;
	gint _tmp0_;
	gint bottom_zone = 0;
	gint _tmp1_;
	gdouble _tmp2_;
	gboolean _tmp3_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = zone;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	top_zone = _tmp0_ - BOX_HAND_GRENADES;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = zone;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	bottom_zone = _tmp1_ + BOX_HAND_GRENADES;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = pos;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = box_in_between (_tmp2_, top_zone, bottom_zone);
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp3_;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 2519 "Box.c"
}


static gboolean box_in_between (gdouble pos, gint top, gint bottom) {
	gboolean result = FALSE;
	gint ipos = 0;
	gdouble _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gint _tmp3_;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = pos;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	ipos = (gint) _tmp0_;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = ipos;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = top;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp2_ > _tmp3_) {
#line 2540 "Box.c"
		gint _tmp4_;
		gint _tmp5_;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp4_ = ipos;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp5_ = bottom;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = _tmp4_ < _tmp5_;
#line 2549 "Box.c"
	} else {
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp1_ = FALSE;
#line 2553 "Box.c"
	}
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp1_;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 2559 "Box.c"
}


static gboolean box_near_in_between (gdouble pos, gint top, gint bottom) {
	gboolean result = FALSE;
	gint ipos = 0;
	gdouble _tmp0_;
	gint top_zone = 0;
	gint _tmp1_;
	gint bottom_zone = 0;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint _tmp5_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = pos;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	ipos = (gint) _tmp0_;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = top;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	top_zone = _tmp1_ - BOX_HAND_GRENADES;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = bottom;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	bottom_zone = _tmp2_ + BOX_HAND_GRENADES;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = ipos;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = top_zone;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp4_ > _tmp5_) {
#line 2592 "Box.c"
		gint _tmp6_;
		gint _tmp7_;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp6_ = ipos;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp7_ = bottom_zone;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp3_ = _tmp6_ < _tmp7_;
#line 2601 "Box.c"
	} else {
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp3_ = FALSE;
#line 2605 "Box.c"
	}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	result = _tmp3_;
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return result;
#line 2611 "Box.c"
}


BoxLocation box_approx_location (Box *self, gint x, gint y) {
	BoxLocation result = 0;
	gboolean near_width = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	gboolean near_height = FALSE;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp11_;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp0_ = x;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp1_ = (*self).left;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp2_ = (*self).right;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp3_ = box_near_in_between ((gdouble) _tmp0_, _tmp1_, _tmp2_);
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	near_width = _tmp3_;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp4_ = y;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp5_ = (*self).top;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp7_ = box_near_in_between ((gdouble) _tmp4_, _tmp5_, _tmp6_);
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	near_height = _tmp7_;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp9_ = x;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp10_ = (*self).left;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	_tmp11_ = box_in_zone ((gdouble) _tmp9_, _tmp10_);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp11_) {
#line 2659 "Box.c"
		gboolean _tmp12_;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp12_ = near_height;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = _tmp12_;
#line 2665 "Box.c"
	} else {
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp8_ = FALSE;
#line 2669 "Box.c"
	}
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	if (_tmp8_) {
#line 2673 "Box.c"
		gint _tmp13_;
		gint _tmp14_;
		gboolean _tmp15_;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp13_ = y;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp14_ = (*self).top;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp15_ = box_in_zone ((gdouble) _tmp13_, _tmp14_);
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp15_) {
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			result = BOX_LOCATION_TOP_LEFT;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			return result;
#line 2689 "Box.c"
		} else {
			gint _tmp16_;
			gint _tmp17_;
			gboolean _tmp18_;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp16_ = y;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp17_ = (*self).bottom;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp18_ = box_in_zone ((gdouble) _tmp16_, _tmp17_);
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp18_) {
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				result = BOX_LOCATION_BOTTOM_LEFT;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				return result;
#line 2706 "Box.c"
			} else {
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				result = BOX_LOCATION_LEFT_SIDE;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				return result;
#line 2712 "Box.c"
			}
		}
	} else {
		gboolean _tmp19_ = FALSE;
		gint _tmp20_;
		gint _tmp21_;
		gboolean _tmp22_;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp20_ = x;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp21_ = (*self).right;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		_tmp22_ = box_in_zone ((gdouble) _tmp20_, _tmp21_);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp22_) {
#line 2728 "Box.c"
			gboolean _tmp23_;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp23_ = near_height;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp19_ = _tmp23_;
#line 2734 "Box.c"
		} else {
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp19_ = FALSE;
#line 2738 "Box.c"
		}
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
		if (_tmp19_) {
#line 2742 "Box.c"
			gint _tmp24_;
			gint _tmp25_;
			gboolean _tmp26_;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp24_ = y;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp25_ = (*self).top;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp26_ = box_in_zone ((gdouble) _tmp24_, _tmp25_);
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp26_) {
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				result = BOX_LOCATION_TOP_RIGHT;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				return result;
#line 2758 "Box.c"
			} else {
				gint _tmp27_;
				gint _tmp28_;
				gboolean _tmp29_;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp27_ = y;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp28_ = (*self).bottom;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp29_ = box_in_zone ((gdouble) _tmp27_, _tmp28_);
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				if (_tmp29_) {
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					result = BOX_LOCATION_BOTTOM_RIGHT;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					return result;
#line 2775 "Box.c"
				} else {
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					result = BOX_LOCATION_RIGHT_SIDE;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					return result;
#line 2781 "Box.c"
				}
			}
		} else {
			gboolean _tmp30_ = FALSE;
			gint _tmp31_;
			gint _tmp32_;
			gboolean _tmp33_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp31_ = y;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp32_ = (*self).top;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			_tmp33_ = box_in_zone ((gdouble) _tmp31_, _tmp32_);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp33_) {
#line 2797 "Box.c"
				gboolean _tmp34_;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp34_ = near_width;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp30_ = _tmp34_;
#line 2803 "Box.c"
			} else {
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp30_ = FALSE;
#line 2807 "Box.c"
			}
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
			if (_tmp30_) {
#line 405 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				result = BOX_LOCATION_TOP_SIDE;
#line 405 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				return result;
#line 2815 "Box.c"
			} else {
				gboolean _tmp35_ = FALSE;
				gint _tmp36_;
				gint _tmp37_;
				gboolean _tmp38_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp36_ = y;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp37_ = (*self).bottom;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				_tmp38_ = box_in_zone ((gdouble) _tmp36_, _tmp37_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				if (_tmp38_) {
#line 2829 "Box.c"
					gboolean _tmp39_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp39_ = near_width;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp35_ = _tmp39_;
#line 2835 "Box.c"
				} else {
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp35_ = FALSE;
#line 2839 "Box.c"
				}
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
				if (_tmp35_) {
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					result = BOX_LOCATION_BOTTOM_SIDE;
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					return result;
#line 2847 "Box.c"
				} else {
					gboolean _tmp40_ = FALSE;
					gint _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
					gboolean _tmp44_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp41_ = x;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp42_ = (*self).left;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp43_ = (*self).right;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					_tmp44_ = box_in_between ((gdouble) _tmp41_, _tmp42_, _tmp43_);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					if (_tmp44_) {
#line 2864 "Box.c"
						gint _tmp45_;
						gint _tmp46_;
						gint _tmp47_;
						gboolean _tmp48_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						_tmp45_ = y;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						_tmp46_ = (*self).top;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						_tmp47_ = (*self).bottom;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						_tmp48_ = box_in_between ((gdouble) _tmp45_, _tmp46_, _tmp47_);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						_tmp40_ = _tmp48_;
#line 2879 "Box.c"
					} else {
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						_tmp40_ = FALSE;
#line 2883 "Box.c"
					}
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
					if (_tmp40_) {
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						result = BOX_LOCATION_INSIDE;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						return result;
#line 2891 "Box.c"
					} else {
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						result = BOX_LOCATION_OUTSIDE;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
						return result;
#line 2897 "Box.c"
					}
				}
			}
		}
	}
}


Box* box_dup (const Box* self) {
	Box* dup;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	dup = g_new0 (Box, 1);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	memcpy (dup, self, sizeof (Box));
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	return dup;
#line 2914 "Box.c"
}


void box_free (Box* self) {
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Box.vala"
	g_free (self);
#line 2921 "Box.c"
}


GType box_get_type (void) {
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}



