/* ProgressDialog.c generated by valac 0.36.4, the Vala compiler
 * generated from ProgressDialog.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017 elementary  LLC. (https://launchpad.net/pantheon-photos)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define TYPE_PROGRESS_DIALOG (progress_dialog_get_type ())
#define PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROGRESS_DIALOG, ProgressDialog))
#define PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROGRESS_DIALOG, ProgressDialogClass))
#define IS_PROGRESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROGRESS_DIALOG))
#define IS_PROGRESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROGRESS_DIALOG))
#define PROGRESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROGRESS_DIALOG, ProgressDialogClass))

typedef struct _ProgressDialog ProgressDialog;
typedef struct _ProgressDialogClass ProgressDialogClass;
typedef struct _ProgressDialogPrivate ProgressDialogPrivate;

#define TYPE_UNITY_PROGRESS_BAR (unity_progress_bar_get_type ())
#define UNITY_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNITY_PROGRESS_BAR, UnityProgressBar))
#define UNITY_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNITY_PROGRESS_BAR, UnityProgressBarClass))
#define IS_UNITY_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNITY_PROGRESS_BAR))
#define IS_UNITY_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNITY_PROGRESS_BAR))
#define UNITY_PROGRESS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNITY_PROGRESS_BAR, UnityProgressBarClass))

typedef struct _UnityProgressBar UnityProgressBar;
typedef struct _UnityProgressBarClass UnityProgressBarClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ProgressDialog {
	GtkWindow parent_instance;
	ProgressDialogPrivate * priv;
};

struct _ProgressDialogClass {
	GtkWindowClass parent_class;
};

struct _ProgressDialogPrivate {
	GtkProgressBar* progress_bar;
	GtkButton* cancel_button;
	GCancellable* cancellable;
	guint64 last_count;
	gint update_every;
	gint minimum_on_screen_time_msec;
	gulong time_started;
	UnityProgressBar* uniprobar;
};


static gpointer progress_dialog_parent_class = NULL;

GType progress_dialog_get_type (void) G_GNUC_CONST;
GType unity_progress_bar_get_type (void) G_GNUC_CONST;
#define PROGRESS_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PROGRESS_DIALOG, ProgressDialogPrivate))
enum  {
	PROGRESS_DIALOG_DUMMY_PROPERTY
};
UnityProgressBar* unity_progress_bar_get_instance (void);
ProgressDialog* progress_dialog_new (GtkWindow* owner, const gchar* text, GCancellable* cancellable);
ProgressDialog* progress_dialog_construct (GType object_type, GtkWindow* owner, const gchar* text, GCancellable* cancellable);
static void progress_dialog_on_cancel (ProgressDialog* self);
static void _progress_dialog_on_cancel_gtk_button_clicked (GtkButton* _sender, gpointer self);
static gboolean progress_dialog_on_window_closed (ProgressDialog* self);
static gboolean _progress_dialog_on_window_closed_gtk_widget_delete_event (GtkWidget* _sender, GdkEventAny* event, gpointer self);
gulong now_ms (void);
static void progress_dialog_real_realize (GtkWidget* base);
void progress_dialog_update_display_every (ProgressDialog* self, gint update_every);
void progress_dialog_set_minimum_on_screen_time_msec (ProgressDialog* self, gint minimum_on_screen_time_msec);
void progress_dialog_set_fraction (ProgressDialog* self, gint current, gint total);
void progress_dialog_set_percentage (ProgressDialog* self, gdouble pct);
static void progress_dialog_maybe_show_all (ProgressDialog* self, gdouble pct);
void unity_progress_bar_set_progress (UnityProgressBar* self, gdouble percent);
void progress_dialog_set_status (ProgressDialog* self, const gchar* text);
void unity_progress_bar_set_visible (UnityProgressBar* self, gboolean visible);
gboolean progress_dialog_monitor (ProgressDialog* self, guint64 count, guint64 total, gboolean do_event_loop);
void spin_event_loop (void);
void progress_dialog_close (ProgressDialog* self);
void unity_progress_bar_reset (UnityProgressBar* self);
static void progress_dialog_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 120 "ProgressDialog.c"
}


static void _progress_dialog_on_cancel_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	progress_dialog_on_cancel ((ProgressDialog*) self);
#line 127 "ProgressDialog.c"
}


static gboolean _progress_dialog_on_window_closed_gtk_widget_delete_event (GtkWidget* _sender, GdkEventAny* event, gpointer self) {
	gboolean result;
	result = progress_dialog_on_window_closed ((ProgressDialog*) self);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	return result;
#line 136 "ProgressDialog.c"
}


ProgressDialog* progress_dialog_construct (GType object_type, GtkWindow* owner, const gchar* text, GCancellable* cancellable) {
	ProgressDialog * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	const gchar* _tmp2_;
	GtkWindow* _tmp3_;
	GtkProgressBar* _tmp5_;
	GtkProgressBar* _tmp6_;
	GtkBox* vbox_bar = NULL;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkProgressBar* _tmp9_;
	GCancellable* _tmp10_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkButton* _tmp16_;
	GtkLabel* primary_text_label = NULL;
	GtkLabel* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkAlignment* alignment = NULL;
	GtkAlignment* _tmp25_;
	gulong _tmp26_;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self = (ProgressDialog*) g_object_new (object_type, NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = cancellable;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->cancellable = _tmp1_;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp2_ = text;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp2_);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp3_ = owner;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp3_ != NULL) {
#line 193 "ProgressDialog.c"
		GtkWindow* _tmp4_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp4_ = owner;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		gtk_window_set_transient_for ((GtkWindow*) self, _tmp4_);
#line 199 "ProgressDialog.c"
	}
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_window_set_type_hint ((GtkWindow*) self, GDK_WINDOW_TYPE_HINT_DIALOG);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp5_ = self->priv->progress_bar;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp5_, 300, -1);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp6_ = self->priv->progress_bar;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_show_text (_tmp6_, TRUE);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp7_);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	vbox_bar = _tmp7_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp8_ = vbox_bar;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp9_ = self->priv->progress_bar;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_box_pack_start (_tmp8_, (GtkWidget*) _tmp9_, TRUE, FALSE, (guint) 0);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp10_ = cancellable;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp10_ != NULL) {
#line 229 "ProgressDialog.c"
		GtkButton* _tmp11_;
		GtkButton* _tmp12_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp11_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Cancel"));
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		g_object_ref_sink (_tmp11_);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_g_object_unref0 (self->priv->cancel_button);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		self->priv->cancel_button = _tmp11_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp12_ = self->priv->cancel_button;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		g_signal_connect_object (_tmp12_, "clicked", (GCallback) _progress_dialog_on_cancel_gtk_button_clicked, self, 0);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) _progress_dialog_on_window_closed_gtk_widget_delete_event, self, 0);
#line 246 "ProgressDialog.c"
	}
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp13_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 8);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	hbox = _tmp13_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp14_ = hbox;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp15_ = vbox_bar;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_box_pack_start (_tmp14_, (GtkWidget*) _tmp15_, TRUE, FALSE, (guint) 0);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp16_ = self->priv->cancel_button;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp16_ != NULL) {
#line 264 "ProgressDialog.c"
		GtkBox* _tmp17_;
		GtkButton* _tmp18_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp17_ = hbox;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp18_ = self->priv->cancel_button;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		gtk_box_pack_end (_tmp17_, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 0);
#line 273 "ProgressDialog.c"
	}
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp19_ = (GtkLabel*) gtk_label_new ("");
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp19_);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	primary_text_label = _tmp19_;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp20_ = text;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp21_ = g_strdup_printf ("<span weight=\"bold\">%s</span>", _tmp20_);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp22_ = _tmp21_;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_label_set_markup (primary_text_label, _tmp22_);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_free0 (_tmp22_);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) primary_text_label, (gfloat) 0, 0.5f);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp23_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	vbox = _tmp23_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) primary_text_label, FALSE, FALSE, (guint) 0);
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp24_ = hbox;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) _tmp24_, TRUE, FALSE, (guint) 0);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp25_ = (GtkAlignment*) gtk_alignment_new (0.5f, 0.5f, 1.0f, 1.0f);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp25_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	alignment = _tmp25_;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_alignment_set_padding (alignment, (guint) 12, (guint) 12, (guint) 12, (guint) 12);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_container_add ((GtkContainer*) alignment, (GtkWidget*) vbox);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) alignment);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp26_ = now_ms ();
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->time_started = _tmp26_;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (alignment);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (vbox);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (primary_text_label);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (hbox);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (vbox_bar);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	return self;
#line 333 "ProgressDialog.c"
}


ProgressDialog* progress_dialog_new (GtkWindow* owner, const gchar* text, GCancellable* cancellable) {
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	return progress_dialog_construct (TYPE_PROGRESS_DIALOG, owner, text, cancellable);
#line 340 "ProgressDialog.c"
}


static void progress_dialog_real_realize (GtkWidget* base) {
	ProgressDialog * self;
	GCancellable* _tmp0_;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self = (ProgressDialog*) base;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	GTK_WIDGET_CLASS (progress_dialog_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->cancellable;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp0_ == NULL) {
#line 355 "ProgressDialog.c"
		GdkWindow* _tmp1_;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		gdk_window_set_functions (_tmp1_, GDK_FUNC_MOVE);
#line 361 "ProgressDialog.c"
	}
}


void progress_dialog_update_display_every (ProgressDialog* self, gint update_every) {
	gint _tmp0_;
	gint _tmp1_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = update_every;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_vala_assert (_tmp0_ >= 1, "update_every >= 1");
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = update_every;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->update_every = _tmp1_;
#line 379 "ProgressDialog.c"
}


void progress_dialog_set_minimum_on_screen_time_msec (ProgressDialog* self, gint minimum_on_screen_time_msec) {
	gint _tmp0_;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = minimum_on_screen_time_msec;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->minimum_on_screen_time_msec = _tmp0_;
#line 391 "ProgressDialog.c"
}


void progress_dialog_set_fraction (ProgressDialog* self, gint current, gint total) {
	gint _tmp0_;
	gint _tmp1_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = current;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = total;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	progress_dialog_set_percentage (self, ((gdouble) _tmp0_) / ((gdouble) _tmp1_));
#line 406 "ProgressDialog.c"
}


void progress_dialog_set_percentage (ProgressDialog* self, gdouble pct) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GtkProgressBar* _tmp3_;
	gdouble _tmp4_;
	GtkProgressBar* _tmp5_;
	gdouble _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	UnityProgressBar* _tmp9_;
	gdouble _tmp10_;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = pct;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = CLAMP (_tmp0_, 0.0, 1.0);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	pct = _tmp1_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp2_ = pct;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	progress_dialog_maybe_show_all (self, _tmp2_);
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp3_ = self->priv->progress_bar;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp4_ = pct;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_fraction (_tmp3_, _tmp4_);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp5_ = self->priv->progress_bar;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp6_ = pct;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp7_ = g_strdup_printf (_ ("%d%%"), (gint) (_tmp6_ * 100.0));
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp8_ = _tmp7_;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_text (_tmp5_, _tmp8_);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_free0 (_tmp8_);
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp9_ = self->priv->uniprobar;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp10_ = pct;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	unity_progress_bar_set_progress (_tmp9_, _tmp10_);
#line 458 "ProgressDialog.c"
}


void progress_dialog_set_status (ProgressDialog* self, const gchar* text) {
	GtkProgressBar* _tmp0_;
	const gchar* _tmp1_;
	UnityProgressBar* _tmp2_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (text != NULL);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->progress_bar;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = text;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_progress_bar_set_text (_tmp0_, _tmp1_);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp2_ = self->priv->uniprobar;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	unity_progress_bar_set_visible (_tmp2_, TRUE);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 482 "ProgressDialog.c"
}


gboolean progress_dialog_monitor (ProgressDialog* self, guint64 count, guint64 total, gboolean do_event_loop) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint64 _tmp1_;
	gboolean _tmp8_ = FALSE;
	GCancellable* _tmp9_;
	gboolean keep_going = FALSE;
	gboolean _tmp12_;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = self->priv->last_count;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp1_ == G_MAXUINT64) {
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp0_ = TRUE;
#line 502 "ProgressDialog.c"
	} else {
		guint64 _tmp2_;
		guint64 _tmp3_;
		gint _tmp4_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp2_ = count;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp3_ = self->priv->last_count;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp4_ = self->priv->update_every;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp0_ = (_tmp2_ - _tmp3_) >= ((guint64) _tmp4_);
#line 515 "ProgressDialog.c"
	}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp0_) {
#line 519 "ProgressDialog.c"
		guint64 _tmp5_;
		guint64 _tmp6_;
		guint64 _tmp7_;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp5_ = count;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp6_ = total;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		progress_dialog_set_percentage (self, ((gdouble) _tmp5_) / ((gdouble) _tmp6_));
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp7_ = count;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		self->priv->last_count = _tmp7_;
#line 533 "ProgressDialog.c"
	}
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp9_ = self->priv->cancellable;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp9_ != NULL) {
#line 539 "ProgressDialog.c"
		GCancellable* _tmp10_;
		gboolean _tmp11_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp10_ = self->priv->cancellable;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp11_ = g_cancellable_is_cancelled (_tmp10_);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp8_ = !_tmp11_;
#line 548 "ProgressDialog.c"
	} else {
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp8_ = TRUE;
#line 552 "ProgressDialog.c"
	}
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	keep_going = _tmp8_;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp12_ = do_event_loop;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp12_) {
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		spin_event_loop ();
#line 562 "ProgressDialog.c"
	}
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	result = keep_going;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	return result;
#line 568 "ProgressDialog.c"
}


void progress_dialog_close (ProgressDialog* self) {
	UnityProgressBar* _tmp0_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->uniprobar;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	unity_progress_bar_reset (_tmp0_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 584 "ProgressDialog.c"
}


static gboolean progress_dialog_on_window_closed (ProgressDialog* self) {
	gboolean result = FALSE;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	progress_dialog_on_cancel (self);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	result = FALSE;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	return result;
#line 598 "ProgressDialog.c"
}


static void progress_dialog_on_cancel (ProgressDialog* self) {
	GCancellable* _tmp0_;
	GtkButton* _tmp2_;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 161 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = self->priv->cancellable;
#line 161 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp0_ != NULL) {
#line 611 "ProgressDialog.c"
		GCancellable* _tmp1_;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		g_cancellable_cancel (_tmp1_);
#line 617 "ProgressDialog.c"
	}
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp2_ = self->priv->cancel_button;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
#line 623 "ProgressDialog.c"
}


static void progress_dialog_maybe_show_all (ProgressDialog* self, gdouble pct) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_return_if_fail (self != NULL);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp2_ = _tmp1_;
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (!_tmp2_) {
#line 639 "ProgressDialog.c"
		gulong _tmp3_;
		gulong _tmp4_;
		gint _tmp5_;
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp3_ = now_ms ();
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp4_ = self->priv->time_started;
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp5_ = self->priv->minimum_on_screen_time_msec;
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp0_ = (_tmp3_ - _tmp4_) > ((gulong) _tmp5_);
#line 651 "ProgressDialog.c"
	} else {
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp0_ = FALSE;
#line 655 "ProgressDialog.c"
	}
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	if (_tmp0_) {
#line 659 "ProgressDialog.c"
		gdouble pps = 0.0;
		gdouble _tmp6_;
		gint _tmp7_;
		gdouble ttc = 0.0;
		gdouble _tmp8_;
		gdouble _tmp9_;
		gint _tmp10_;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp6_ = pct;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp7_ = self->priv->minimum_on_screen_time_msec;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		pps = (_tmp6_ * 100.0) / _tmp7_;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp8_ = pps;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		ttc = 100.0 / _tmp8_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp9_ = ttc;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		_tmp10_ = self->priv->minimum_on_screen_time_msec;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
		if (_tmp9_ > ((gdouble) _tmp10_)) {
#line 683 "ProgressDialog.c"
			UnityProgressBar* _tmp11_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
			_tmp11_ = self->priv->uniprobar;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
			unity_progress_bar_set_visible (_tmp11_, TRUE);
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
			gtk_widget_show_all ((GtkWidget*) self);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
			spin_event_loop ();
#line 693 "ProgressDialog.c"
		}
	}
}


static void progress_dialog_class_init (ProgressDialogClass * klass) {
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	progress_dialog_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_type_class_add_private (klass, sizeof (ProgressDialogPrivate));
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget *)) progress_dialog_real_realize;
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = progress_dialog_finalize;
#line 708 "ProgressDialog.c"
}


static void progress_dialog_instance_init (ProgressDialog * self) {
	GtkProgressBar* _tmp0_;
	UnityProgressBar* _tmp1_;
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv = PROGRESS_DIALOG_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp0_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	g_object_ref_sink (_tmp0_);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->progress_bar = _tmp0_;
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->cancel_button = NULL;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->last_count = G_MAXUINT64;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->update_every = 1;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->minimum_on_screen_time_msec = 500;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_tmp1_ = unity_progress_bar_get_instance ();
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self->priv->uniprobar = _tmp1_;
#line 735 "ProgressDialog.c"
}


static void progress_dialog_finalize (GObject * obj) {
	ProgressDialog * self;
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROGRESS_DIALOG, ProgressDialog);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->cancel_button);
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	_g_object_unref0 (self->priv->uniprobar);
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/Dialogs/ProgressDialog.vala"
	G_OBJECT_CLASS (progress_dialog_parent_class)->finalize (obj);
#line 753 "ProgressDialog.c"
}


GType progress_dialog_get_type (void) {
	static volatile gsize progress_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&progress_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProgressDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) progress_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ProgressDialog), 0, (GInstanceInitFunc) progress_dialog_instance_init, NULL };
		GType progress_dialog_type_id;
		progress_dialog_type_id = g_type_register_static (gtk_window_get_type (), "ProgressDialog", &g_define_type_info, 0);
		g_once_init_leave (&progress_dialog_type_id__volatile, progress_dialog_type_id);
	}
	return progress_dialog_type_id__volatile;
}



