/* MediaMetadata.c generated by valac 0.36.4, the Vala compiler
 * generated from MediaMetadata.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
typedef struct _ParamSpecMediaMetadata ParamSpecMediaMetadata;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MetadataDateTimePrivate MetadataDateTimePrivate;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _ParamSpecMetadataDateTime ParamSpecMetadataDateTime;

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
	gchar* (*get_comment) (MediaMetadata* self);
};

struct _ParamSpecMediaMetadata {
	GParamSpec parent_instance;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _MetadataDateTime {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MetadataDateTimePrivate * priv;
};

struct _MetadataDateTimeClass {
	GTypeClass parent_class;
	void (*finalize) (MetadataDateTime *self);
};

struct _MetadataDateTimePrivate {
	time_t timestamp;
};

struct _ParamSpecMetadataDateTime {
	GParamSpec parent_instance;
};


static gpointer media_metadata_parent_class = NULL;
static gpointer metadata_date_time_parent_class = NULL;

gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
enum  {
	MEDIA_METADATA_DUMMY_PROPERTY
};
MediaMetadata* media_metadata_construct (GType object_type);
void media_metadata_read_from_file (MediaMetadata* self, GFile* file, GError** error);
static void media_metadata_real_read_from_file (MediaMetadata* self, GFile* file, GError** error);
MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self);
static MetadataDateTime* media_metadata_real_get_creation_date_time (MediaMetadata* self);
gchar* media_metadata_get_title (MediaMetadata* self);
static gchar* media_metadata_real_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
static gchar* media_metadata_real_get_comment (MediaMetadata* self);
static void media_metadata_finalize (MediaMetadata * obj);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator);
static gboolean metadata_rational_is_component_valid (MetadataRational *self, gint component);
gboolean metadata_rational_is_valid (MetadataRational *self);
gchar* metadata_rational_to_string (MetadataRational *self);
GQuark metadata_date_time_error_quark (void);
#define METADATA_DATE_TIME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_DATE_TIME, MetadataDateTimePrivate))
enum  {
	METADATA_DATE_TIME_DUMMY_PROPERTY
};
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const gchar* label, GError** error);
gboolean metadata_date_time_from_exif_date_time (const gchar* date_time, time_t* timestamp);
MetadataDateTime* metadata_date_time_new_from_iptc (const gchar* date, const gchar* time, GError** error);
MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type, const gchar* date, const gchar* time, GError** error);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const gchar* label, GError** error);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_to_exif_date_time (time_t timestamp);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
gchar* metadata_date_time_to_string (MetadataDateTime* self);
static void metadata_date_time_finalize (MetadataDateTime * obj);


MediaMetadata* media_metadata_construct (GType object_type) {
	MediaMetadata* self = NULL;
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = (MediaMetadata*) g_type_create_instance (object_type);
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return self;
#line 177 "MediaMetadata.c"
}


static void media_metadata_real_read_from_file (MediaMetadata* self, GFile* file, GError** error) {
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_read_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return;
#line 186 "MediaMetadata.c"
}


void media_metadata_read_from_file (MediaMetadata* self, GFile* file, GError** error) {
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	MEDIA_METADATA_GET_CLASS (self)->read_from_file (self, file, error);
#line 195 "MediaMetadata.c"
}


static MetadataDateTime* media_metadata_real_get_creation_date_time (MediaMetadata* self) {
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_creation_date_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 204 "MediaMetadata.c"
}


MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self) {
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return MEDIA_METADATA_GET_CLASS (self)->get_creation_date_time (self);
#line 213 "MediaMetadata.c"
}


static gchar* media_metadata_real_get_title (MediaMetadata* self) {
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_title'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 222 "MediaMetadata.c"
}


gchar* media_metadata_get_title (MediaMetadata* self) {
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return MEDIA_METADATA_GET_CLASS (self)->get_title (self);
#line 231 "MediaMetadata.c"
}


static gchar* media_metadata_real_get_comment (MediaMetadata* self) {
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 240 "MediaMetadata.c"
}


gchar* media_metadata_get_comment (MediaMetadata* self) {
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return MEDIA_METADATA_GET_CLASS (self)->get_comment (self);
#line 249 "MediaMetadata.c"
}


static void value_media_metadata_init (GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 256 "MediaMetadata.c"
}


static void value_media_metadata_free_value (GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		media_metadata_unref (value->data[0].v_pointer);
#line 265 "MediaMetadata.c"
	}
}


static void value_media_metadata_copy_value (const GValue* src_value, GValue* dest_value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = media_metadata_ref (src_value->data[0].v_pointer);
#line 275 "MediaMetadata.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 279 "MediaMetadata.c"
	}
}


static gpointer value_media_metadata_peek_pointer (const GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 287 "MediaMetadata.c"
}


static gchar* value_media_metadata_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 294 "MediaMetadata.c"
		MediaMetadata * object;
		object = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 301 "MediaMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 305 "MediaMetadata.c"
		}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = media_metadata_ref (object);
#line 309 "MediaMetadata.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 313 "MediaMetadata.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 317 "MediaMetadata.c"
}


static gchar* value_media_metadata_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	MediaMetadata ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (!object_p) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 328 "MediaMetadata.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*object_p = NULL;
#line 334 "MediaMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 338 "MediaMetadata.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*object_p = media_metadata_ref (value->data[0].v_pointer);
#line 342 "MediaMetadata.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 346 "MediaMetadata.c"
}


GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecMediaMetadata* spec;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MEDIA_METADATA), NULL);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 360 "MediaMetadata.c"
}


gpointer value_get_media_metadata (const GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA), NULL);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 369 "MediaMetadata.c"
}


void value_set_media_metadata (GValue* value, gpointer v_object) {
	MediaMetadata * old;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		media_metadata_ref (value->data[0].v_pointer);
#line 389 "MediaMetadata.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 393 "MediaMetadata.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		media_metadata_unref (old);
#line 399 "MediaMetadata.c"
	}
}


void value_take_media_metadata (GValue* value, gpointer v_object) {
	MediaMetadata * old;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 418 "MediaMetadata.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 422 "MediaMetadata.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		media_metadata_unref (old);
#line 428 "MediaMetadata.c"
	}
}


static void media_metadata_class_init (MediaMetadataClass * klass) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	media_metadata_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = media_metadata_finalize;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata *, GFile*, GError**)) media_metadata_real_read_from_file;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata *)) media_metadata_real_get_creation_date_time;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata *)) media_metadata_real_get_title;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata *)) media_metadata_real_get_comment;
#line 446 "MediaMetadata.c"
}


static void media_metadata_instance_init (MediaMetadata * self) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self->ref_count = 1;
#line 453 "MediaMetadata.c"
}


static void media_metadata_finalize (MediaMetadata * obj) {
	MediaMetadata * self;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_METADATA, MediaMetadata);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_signal_handlers_destroy (self);
#line 463 "MediaMetadata.c"
}


GType media_metadata_get_type (void) {
	static volatile gsize media_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&media_metadata_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_media_metadata_init, value_media_metadata_free_value, value_media_metadata_copy_value, value_media_metadata_peek_pointer, "p", value_media_metadata_collect_value, "p", value_media_metadata_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (MediaMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaMetadata), 0, (GInstanceInitFunc) media_metadata_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType media_metadata_type_id;
		media_metadata_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MediaMetadata", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&media_metadata_type_id__volatile, media_metadata_type_id);
	}
	return media_metadata_type_id__volatile;
}


gpointer media_metadata_ref (gpointer instance) {
	MediaMetadata * self;
	self = instance;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return instance;
#line 488 "MediaMetadata.c"
}


void media_metadata_unref (gpointer instance) {
	MediaMetadata * self;
	self = instance;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		MEDIA_METADATA_GET_CLASS (self)->finalize (self);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 501 "MediaMetadata.c"
	}
}


void metadata_rational_init (MetadataRational *self, gint numerator, gint denominator) {
	gint _tmp0_;
	gint _tmp1_;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	memset (self, 0, sizeof (MetadataRational));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = numerator;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	(*self).numerator = _tmp0_;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = denominator;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	(*self).denominator = _tmp1_;
#line 519 "MediaMetadata.c"
}


static gboolean metadata_rational_is_component_valid (MetadataRational *self, gint component) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = component;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp1_ >= 0) {
#line 531 "MediaMetadata.c"
		gint _tmp2_;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp2_ = component;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp0_ = _tmp2_ <= 1000000;
#line 537 "MediaMetadata.c"
	} else {
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp0_ = FALSE;
#line 541 "MediaMetadata.c"
	}
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 547 "MediaMetadata.c"
}


gboolean metadata_rational_is_valid (MetadataRational *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp2_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = (*self).numerator;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp2_ = metadata_rational_is_component_valid (&(*self), _tmp1_);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp2_) {
#line 562 "MediaMetadata.c"
		gint _tmp3_;
		gboolean _tmp4_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp3_ = (*self).denominator;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp4_ = metadata_rational_is_component_valid (&(*self), _tmp3_);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp0_ = _tmp4_;
#line 571 "MediaMetadata.c"
	} else {
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp0_ = FALSE;
#line 575 "MediaMetadata.c"
	}
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp0_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 581 "MediaMetadata.c"
}


gchar* metadata_rational_to_string (MetadataRational *self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = metadata_rational_is_valid (&(*self));
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp1_) {
#line 593 "MediaMetadata.c"
		gint _tmp2_;
		gint _tmp3_;
		gchar* _tmp4_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp2_ = (*self).numerator;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp3_ = (*self).denominator;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp4_ = g_strdup_printf ("%d/%d", _tmp2_, _tmp3_);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_g_free0 (_tmp0_);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp0_ = _tmp4_;
#line 607 "MediaMetadata.c"
	} else {
		gchar* _tmp5_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp5_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_g_free0 (_tmp0_);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp0_ = _tmp5_;
#line 616 "MediaMetadata.c"
	}
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp0_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 622 "MediaMetadata.c"
}


MetadataRational* metadata_rational_dup (const MetadataRational* self) {
	MetadataRational* dup;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	dup = g_new0 (MetadataRational, 1);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	memcpy (dup, self, sizeof (MetadataRational));
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return dup;
#line 634 "MediaMetadata.c"
}


void metadata_rational_free (MetadataRational* self) {
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_free (self);
#line 641 "MediaMetadata.c"
}


GType metadata_rational_get_type (void) {
	static volatile gsize metadata_rational_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_rational_type_id__volatile)) {
		GType metadata_rational_type_id;
		metadata_rational_type_id = g_boxed_type_register_static ("MetadataRational", (GBoxedCopyFunc) metadata_rational_dup, (GBoxedFreeFunc) metadata_rational_free);
		g_once_init_leave (&metadata_rational_type_id__volatile, metadata_rational_type_id);
	}
	return metadata_rational_type_id__volatile;
}


GQuark metadata_date_time_error_quark (void) {
	return g_quark_from_static_string ("metadata_date_time_error-quark");
}


MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp) {
	MetadataDateTime* self = NULL;
	time_t _tmp0_;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = timestamp;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self->priv->timestamp = _tmp0_;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return self;
#line 672 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_new (time_t timestamp) {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return metadata_date_time_construct (TYPE_METADATA_DATE_TIME, timestamp);
#line 679 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const gchar* label, GError** error) {
	MetadataDateTime* self = NULL;
	const gchar* _tmp0_;
	time_t _tmp1_ = 0;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = label;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp2_ = metadata_date_time_from_exif_date_time (_tmp0_, &_tmp1_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self->priv->timestamp = _tmp1_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (!_tmp2_) {
#line 701 "MediaMetadata.c"
		const gchar* _tmp3_;
		GError* _tmp4_;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp3_ = label;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp4_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not EXIF format date/time", _tmp3_);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_inner_error_ = _tmp4_;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			g_propagate_error (error, _inner_error_);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			_metadata_date_time_unref0 (self);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return NULL;
#line 718 "MediaMetadata.c"
		} else {
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			g_clear_error (&_inner_error_);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return NULL;
#line 726 "MediaMetadata.c"
		}
	}
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return self;
#line 731 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label, GError** error) {
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return metadata_date_time_construct_from_exif (TYPE_METADATA_DATE_TIME, label, error);
#line 738 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type, const gchar* date, const gchar* time, GError** error) {
	MetadataDateTime* self = NULL;
	GError* _tmp0_;
	GError * _inner_error_ = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = g_error_new_literal (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT, "IPTC date/time format not currently supported");
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_inner_error_ = _tmp0_;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_metadata_date_time_unref0 (self);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		return NULL;
#line 764 "MediaMetadata.c"
	} else {
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_clear_error (&_inner_error_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		return NULL;
#line 772 "MediaMetadata.c"
	}
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return self;
#line 776 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_new_from_iptc (const gchar* date, const gchar* time, GError** error) {
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return metadata_date_time_construct_from_iptc (TYPE_METADATA_DATE_TIME, date, time, error);
#line 783 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const gchar* label, GError** error) {
	MetadataDateTime* self = NULL;
	GTimeVal time_val = {0};
	const gchar* _tmp0_;
	gboolean _tmp1_;
	GTimeVal _tmp4_;
	glong _tmp5_;
	GError * _inner_error_ = NULL;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = (MetadataDateTime*) g_type_create_instance (object_type);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_get_current_time (&time_val);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = label;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = g_time_val_from_iso8601 (_tmp0_, &time_val);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (!_tmp1_) {
#line 807 "MediaMetadata.c"
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp2_ = label;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp3_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not XMP format date/time", _tmp2_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_inner_error_ = _tmp3_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		if (_inner_error_->domain == METADATA_DATE_TIME_ERROR) {
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			g_propagate_error (error, _inner_error_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			_metadata_date_time_unref0 (self);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return NULL;
#line 824 "MediaMetadata.c"
		} else {
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			g_clear_error (&_inner_error_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return NULL;
#line 832 "MediaMetadata.c"
		}
	}
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp4_ = time_val;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp5_ = _tmp4_.tv_sec;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self->priv->timestamp = (time_t) _tmp5_;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return self;
#line 843 "MediaMetadata.c"
}


MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label, GError** error) {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return metadata_date_time_construct_from_xmp (TYPE_METADATA_DATE_TIME, label, error);
#line 850 "MediaMetadata.c"
}


time_t metadata_date_time_get_timestamp (MetadataDateTime* self) {
	time_t result = 0;
	time_t _tmp0_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = self->priv->timestamp;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp0_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 865 "MediaMetadata.c"
}


gchar* metadata_date_time_get_exif_label (MetadataDateTime* self) {
	gchar* result = NULL;
	time_t _tmp0_;
	gchar* _tmp1_;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = self->priv->timestamp;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = metadata_date_time_to_exif_date_time (_tmp0_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp1_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 883 "MediaMetadata.c"
}


gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self) {
	gchar* result = NULL;
	GTimeVal time_val = {0};
	time_t _tmp0_;
	gchar* _tmp1_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_get_current_time (&time_val);
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = self->priv->timestamp;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	time_val.tv_sec = (glong) _tmp0_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	time_val.tv_usec = (glong) 0;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = g_time_val_to_iso8601 (&time_val);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp1_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 908 "MediaMetadata.c"
}


gboolean metadata_date_time_from_exif_date_time (const gchar* date_time, time_t* timestamp) {
	time_t _vala_timestamp = 0;
	gboolean result = FALSE;
	struct tm tm = {0};
	const gchar* _tmp0_;
	gint _tmp1_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	struct tm _tmp12_;
	gint _tmp13_;
	gint _tmp24_;
	gint _tmp25_;
	time_t _tmp26_;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (date_time != NULL, FALSE);
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_vala_timestamp = (time_t) 0;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	memset (&tm, 0, sizeof (struct tm));
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = date_time;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = sscanf (_tmp0_, "%d:%d:%d %d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec);
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp1_ != 6) {
#line 940 "MediaMetadata.c"
		gchar* tmp = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp2_ = date_time;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		tmp = _tmp3_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp4_ = tmp;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_strcanon (_tmp4_, "0123456789", ' ');
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp5_ = tmp;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp6_ = sscanf (_tmp5_, "%4d%2d%2d%2d%2d%2d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		if (_tmp6_ != 6) {
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			result = FALSE;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			_g_free0 (tmp);
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			if (timestamp) {
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
				*timestamp = _vala_timestamp;
#line 971 "MediaMetadata.c"
			}
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return result;
#line 975 "MediaMetadata.c"
		}
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_g_free0 (tmp);
#line 979 "MediaMetadata.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp12_ = tm;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp13_ = _tmp12_.tm_year;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp13_ <= 1900) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp11_ = TRUE;
#line 989 "MediaMetadata.c"
	} else {
		struct tm _tmp14_;
		gint _tmp15_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp14_ = tm;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp15_ = _tmp14_.tm_mon;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp11_ = _tmp15_ <= 0;
#line 999 "MediaMetadata.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp11_) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp10_ = TRUE;
#line 1005 "MediaMetadata.c"
	} else {
		struct tm _tmp16_;
		gint _tmp17_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp16_ = tm;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp17_ = _tmp16_.tm_mday;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp10_ = _tmp17_ < 0;
#line 1015 "MediaMetadata.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp10_) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp9_ = TRUE;
#line 1021 "MediaMetadata.c"
	} else {
		struct tm _tmp18_;
		gint _tmp19_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp18_ = tm;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp19_ = _tmp18_.tm_hour;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp9_ = _tmp19_ < 0;
#line 1031 "MediaMetadata.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp9_) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp8_ = TRUE;
#line 1037 "MediaMetadata.c"
	} else {
		struct tm _tmp20_;
		gint _tmp21_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp20_ = tm;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp21_ = _tmp20_.tm_min;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp8_ = _tmp21_ < 0;
#line 1047 "MediaMetadata.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp8_) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp7_ = TRUE;
#line 1053 "MediaMetadata.c"
	} else {
		struct tm _tmp22_;
		gint _tmp23_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp22_ = tm;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp23_ = _tmp22_.tm_sec;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		_tmp7_ = _tmp23_ < 0;
#line 1063 "MediaMetadata.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (_tmp7_) {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		result = FALSE;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		if (timestamp) {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			*timestamp = _vala_timestamp;
#line 1073 "MediaMetadata.c"
		}
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		return result;
#line 1077 "MediaMetadata.c"
	}
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp24_ = tm.tm_year;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	tm.tm_year = _tmp24_ - 1900;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp25_ = tm.tm_mon;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	tm.tm_mon = _tmp25_ - 1;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	tm.tm_isdst = -1;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp26_ = mktime (&tm);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_vala_timestamp = _tmp26_;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = TRUE;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (timestamp) {
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*timestamp = _vala_timestamp;
#line 1099 "MediaMetadata.c"
	}
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 1103 "MediaMetadata.c"
}


static void g_time_local (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
#line 2845 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	localtime_r (&time, &_tmp0_);
#line 2845 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 2846 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	*result = _result_;
#line 2846 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return;
#line 1118 "MediaMetadata.c"
}


static gchar* g_time_format (struct tm *self, const gchar* format) {
	gchar* result = NULL;
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
#line 2853 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 2854 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 64);
#line 2854 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	buffer = _tmp0_;
#line 2854 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	buffer_length1 = 64;
#line 2854 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_buffer_size_ = buffer_length1;
#line 2855 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = buffer;
#line 2855 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1__length1 = buffer_length1;
#line 2855 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = format;
#line 2855 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	strftime (_tmp1_, _tmp1__length1, _tmp2_, &(*self));
#line 2856 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = buffer;
#line 2856 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3__length1 = buffer_length1;
#line 2856 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp4_ = g_strdup ((const gchar*) _tmp3_);
#line 2856 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 2856 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	buffer = (g_free (buffer), NULL);
#line 2856 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 1164 "MediaMetadata.c"
}


gchar* metadata_date_time_to_exif_date_time (time_t timestamp) {
	gchar* result = NULL;
	time_t _tmp0_;
	struct tm _tmp1_ = {0};
	gchar* _tmp2_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = timestamp;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_time_local (_tmp0_, &_tmp1_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp2_ = g_time_format (&_tmp1_, "%Y:%m:%d %H:%M:%S");
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp2_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 1183 "MediaMetadata.c"
}


gchar* metadata_date_time_to_string (MetadataDateTime* self) {
	gchar* result = NULL;
	time_t _tmp0_;
	gchar* _tmp1_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp0_ = self->priv->timestamp;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	_tmp1_ = metadata_date_time_to_exif_date_time (_tmp0_);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	result = _tmp1_;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return result;
#line 1201 "MediaMetadata.c"
}


static void value_metadata_date_time_init (GValue* value) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1208 "MediaMetadata.c"
}


static void value_metadata_date_time_free_value (GValue* value) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (value->data[0].v_pointer) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		metadata_date_time_unref (value->data[0].v_pointer);
#line 1217 "MediaMetadata.c"
	}
}


static void value_metadata_date_time_copy_value (const GValue* src_value, GValue* dest_value) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = metadata_date_time_ref (src_value->data[0].v_pointer);
#line 1227 "MediaMetadata.c"
	} else {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1231 "MediaMetadata.c"
	}
}


static gpointer value_metadata_date_time_peek_pointer (const GValue* value) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 1239 "MediaMetadata.c"
}


static gchar* value_metadata_date_time_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1246 "MediaMetadata.c"
		MetadataDateTime * object;
		object = collect_values[0].v_pointer;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1253 "MediaMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1257 "MediaMetadata.c"
		}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = metadata_date_time_ref (object);
#line 1261 "MediaMetadata.c"
	} else {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1265 "MediaMetadata.c"
	}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 1269 "MediaMetadata.c"
}


static gchar* value_metadata_date_time_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	MetadataDateTime ** object_p;
	object_p = collect_values[0].v_pointer;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (!object_p) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1280 "MediaMetadata.c"
	}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*object_p = NULL;
#line 1286 "MediaMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1290 "MediaMetadata.c"
	} else {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		*object_p = metadata_date_time_ref (value->data[0].v_pointer);
#line 1294 "MediaMetadata.c"
	}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return NULL;
#line 1298 "MediaMetadata.c"
}


GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecMetadataDateTime* spec;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_METADATA_DATE_TIME), NULL);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1312 "MediaMetadata.c"
}


gpointer value_get_metadata_date_time (const GValue* value) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME), NULL);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return value->data[0].v_pointer;
#line 1321 "MediaMetadata.c"
}


void value_set_metadata_date_time (GValue* value, gpointer v_object) {
	MetadataDateTime * old;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (v_object) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		metadata_date_time_ref (value->data[0].v_pointer);
#line 1341 "MediaMetadata.c"
	} else {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1345 "MediaMetadata.c"
	}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (old) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		metadata_date_time_unref (old);
#line 1351 "MediaMetadata.c"
	}
}


void value_take_metadata_date_time (GValue* value, gpointer v_object) {
	MetadataDateTime * old;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	old = value->data[0].v_pointer;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (v_object) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1370 "MediaMetadata.c"
	} else {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1374 "MediaMetadata.c"
	}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (old) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		metadata_date_time_unref (old);
#line 1380 "MediaMetadata.c"
	}
}


static void metadata_date_time_class_init (MetadataDateTimeClass * klass) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	metadata_date_time_parent_class = g_type_class_peek_parent (klass);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	((MetadataDateTimeClass *) klass)->finalize = metadata_date_time_finalize;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_type_class_add_private (klass, sizeof (MetadataDateTimePrivate));
#line 1392 "MediaMetadata.c"
}


static void metadata_date_time_instance_init (MetadataDateTime * self) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self->priv = METADATA_DATE_TIME_GET_PRIVATE (self);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self->ref_count = 1;
#line 1401 "MediaMetadata.c"
}


static void metadata_date_time_finalize (MetadataDateTime * obj) {
	MetadataDateTime * self;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_METADATA_DATE_TIME, MetadataDateTime);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_signal_handlers_destroy (self);
#line 1411 "MediaMetadata.c"
}


GType metadata_date_time_get_type (void) {
	static volatile gsize metadata_date_time_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_date_time_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_metadata_date_time_init, value_metadata_date_time_free_value, value_metadata_date_time_copy_value, value_metadata_date_time_peek_pointer, "p", value_metadata_date_time_collect_value, "p", value_metadata_date_time_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (MetadataDateTimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_date_time_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataDateTime), 0, (GInstanceInitFunc) metadata_date_time_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType metadata_date_time_type_id;
		metadata_date_time_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MetadataDateTime", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&metadata_date_time_type_id__volatile, metadata_date_time_type_id);
	}
	return metadata_date_time_type_id__volatile;
}


gpointer metadata_date_time_ref (gpointer instance) {
	MetadataDateTime * self;
	self = instance;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	return instance;
#line 1436 "MediaMetadata.c"
}


void metadata_date_time_unref (gpointer instance) {
	MetadataDateTime * self;
	self = instance;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		METADATA_DATE_TIME_GET_CLASS (self)->finalize (self);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/MediaMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1449 "MediaMetadata.c"
	}
}



