/* Orientation.c generated by valac 0.36.4, the Vala compiler
 * generated from Orientation.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void) G_GNUC_CONST;
gchar* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self, Rotation rotation);
Rotation* orientation_to_rotations (Orientation self, int* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);


gchar* orientation_to_string (Orientation self) {
	gchar* result = NULL;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 117 "Orientation.c"
		{
			gchar* _tmp0_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = g_strdup ("top-left");
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp0_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 126 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 130 "Orientation.c"
		{
			gchar* _tmp1_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = g_strdup ("top-right");
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 139 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 143 "Orientation.c"
		{
			gchar* _tmp2_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = g_strdup ("bottom-right");
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp2_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 152 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 156 "Orientation.c"
		{
			gchar* _tmp3_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = g_strdup ("bottom-left");
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 165 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 169 "Orientation.c"
		{
			gchar* _tmp4_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = g_strdup ("left-top");
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp4_;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 178 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 182 "Orientation.c"
		{
			gchar* _tmp5_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = g_strdup ("right-top");
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp5_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 191 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 195 "Orientation.c"
		{
			gchar* _tmp6_;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = g_strdup ("right-bottom");
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp6_;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 204 "Orientation.c"
		}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 208 "Orientation.c"
		{
			gchar* _tmp7_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = g_strdup ("left-bottom");
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp7_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 217 "Orientation.c"
		}
		default:
		{
			gchar* _tmp8_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp8_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 228 "Orientation.c"
		}
	}
}


Orientation orientation_rotate_clockwise (Orientation self) {
	Orientation result = 0;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 240 "Orientation.c"
		{
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 246 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 250 "Orientation.c"
		{
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 256 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 260 "Orientation.c"
		{
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 266 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 270 "Orientation.c"
		{
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 276 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 280 "Orientation.c"
		{
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 286 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 290 "Orientation.c"
		{
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 296 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 300 "Orientation.c"
		{
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 306 "Orientation.c"
		}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 310 "Orientation.c"
		{
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 316 "Orientation.c"
		}
		default:
		{
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:90: rotate_clockwise: %d", (gint) self);
#line 322 "Orientation.c"
		}
	}
}


Orientation orientation_rotate_counterclockwise (Orientation self) {
	Orientation result = 0;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 334 "Orientation.c"
		{
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 340 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 344 "Orientation.c"
		{
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 350 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 354 "Orientation.c"
		{
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 360 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 364 "Orientation.c"
		{
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 370 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 374 "Orientation.c"
		{
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 380 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 384 "Orientation.c"
		{
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 390 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 394 "Orientation.c"
		{
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 400 "Orientation.c"
		}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 404 "Orientation.c"
		{
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 410 "Orientation.c"
		}
		default:
		{
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:121: rotate_counterclockwise: %d", (gint) self);
#line 416 "Orientation.c"
		}
	}
}


Orientation orientation_flip_top_to_bottom (Orientation self) {
	Orientation result = 0;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 428 "Orientation.c"
		{
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 434 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 438 "Orientation.c"
		{
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 444 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 448 "Orientation.c"
		{
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 454 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 458 "Orientation.c"
		{
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 464 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 468 "Orientation.c"
		{
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 474 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 478 "Orientation.c"
		{
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 484 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 488 "Orientation.c"
		{
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 494 "Orientation.c"
		}
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 498 "Orientation.c"
		{
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 504 "Orientation.c"
		}
		default:
		{
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:152: flip_top_to_bottom: %d", (gint) self);
#line 510 "Orientation.c"
		}
	}
}


Orientation orientation_flip_left_to_right (Orientation self) {
	Orientation result = 0;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 522 "Orientation.c"
		{
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 528 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 532 "Orientation.c"
		{
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 538 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 542 "Orientation.c"
		{
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 548 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 552 "Orientation.c"
		{
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 558 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 562 "Orientation.c"
		{
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 568 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 572 "Orientation.c"
		{
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 578 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 582 "Orientation.c"
		{
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 588 "Orientation.c"
		}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 592 "Orientation.c"
		{
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 598 "Orientation.c"
		}
		default:
		{
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:183: flip_left_to_right: %d", (gint) self);
#line 604 "Orientation.c"
		}
	}
}


Orientation orientation_perform (Orientation self, Rotation rotation) {
	Orientation result = 0;
	Rotation _tmp0_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp0_ = rotation;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (_tmp0_) {
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 619 "Orientation.c"
		{
			Orientation _tmp1_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = orientation_rotate_clockwise (self);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 628 "Orientation.c"
		}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 632 "Orientation.c"
		{
			Orientation _tmp2_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = orientation_rotate_counterclockwise (self);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp2_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 641 "Orientation.c"
		}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 645 "Orientation.c"
		{
			Orientation _tmp3_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = orientation_flip_left_to_right (self);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 654 "Orientation.c"
		}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 658 "Orientation.c"
		{
			Orientation _tmp4_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = orientation_flip_top_to_bottom (self);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp4_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 667 "Orientation.c"
		}
		default:
		{
			Rotation _tmp5_;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = rotation;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:202: perform: %d", (gint) _tmp5_);
#line 676 "Orientation.c"
		}
	}
}


Rotation* orientation_to_rotations (Orientation self, int* result_length1) {
	Rotation* result = NULL;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 688 "Orientation.c"
		{
			Rotation* _tmp0_;
			Rotation* _tmp1_;
			gint _tmp1__length1;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = g_new0 (Rotation, 0);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = _tmp0_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1__length1 = 0;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp1__length1;
#line 703 "Orientation.c"
			}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 709 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 713 "Orientation.c"
		{
			Rotation* _tmp2_;
			Rotation* _tmp3_;
			gint _tmp3__length1;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = g_new0 (Rotation, 1);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_[0] = ROTATION_MIRROR;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = _tmp2_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3__length1 = 1;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp3__length1;
#line 730 "Orientation.c"
			}
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 736 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 740 "Orientation.c"
		{
			Rotation* _tmp4_;
			Rotation* _tmp5_;
			gint _tmp5__length1;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = g_new0 (Rotation, 1);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_[0] = ROTATION_UPSIDE_DOWN;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5__length1 = 1;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp5__length1;
#line 757 "Orientation.c"
			}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp5_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 763 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 767 "Orientation.c"
		{
			Rotation* _tmp6_;
			Rotation* _tmp7_;
			gint _tmp7__length1;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = g_new0 (Rotation, 2);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_[0] = ROTATION_MIRROR;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_[1] = ROTATION_UPSIDE_DOWN;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = _tmp6_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7__length1 = 2;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp7__length1;
#line 786 "Orientation.c"
			}
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp7_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 792 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 796 "Orientation.c"
		{
			Rotation* _tmp8_;
			Rotation* _tmp9_;
			gint _tmp9__length1;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = g_new0 (Rotation, 2);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_[0] = ROTATION_COUNTERCLOCKWISE;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_[1] = ROTATION_UPSIDE_DOWN;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9__length1 = 2;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp9__length1;
#line 815 "Orientation.c"
			}
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp9_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 821 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 825 "Orientation.c"
		{
			Rotation* _tmp10_;
			Rotation* _tmp11_;
			gint _tmp11__length1;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_ = g_new0 (Rotation, 1);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_[0] = ROTATION_CLOCKWISE;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11_ = _tmp10_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11__length1 = 1;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp11__length1;
#line 842 "Orientation.c"
			}
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp11_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 848 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 852 "Orientation.c"
		{
			Rotation* _tmp12_;
			Rotation* _tmp13_;
			gint _tmp13__length1;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_ = g_new0 (Rotation, 2);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_[0] = ROTATION_CLOCKWISE;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_[1] = ROTATION_UPSIDE_DOWN;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = _tmp12_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13__length1 = 2;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp13__length1;
#line 871 "Orientation.c"
			}
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp13_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 877 "Orientation.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 881 "Orientation.c"
		{
			Rotation* _tmp14_;
			Rotation* _tmp15_;
			gint _tmp15__length1;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = g_new0 (Rotation, 1);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_[0] = ROTATION_COUNTERCLOCKWISE;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = _tmp14_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15__length1 = 1;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			if (result_length1) {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
				*result_length1 = _tmp15__length1;
#line 898 "Orientation.c"
			}
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp15_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 904 "Orientation.c"
		}
		default:
		{
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:235: to_rotations: %d", (gint) self);
#line 910 "Orientation.c"
		}
	}
}


void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 929 "Orientation.c"
		{
			Dimensions _tmp0_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = *dim;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			*result = _tmp0_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return;
#line 938 "Orientation.c"
		}
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 948 "Orientation.c"
		{
			Dimensions _tmp1_;
			gint _tmp2_;
			Dimensions _tmp3_;
			gint _tmp4_;
			Dimensions _tmp5_ = {0};
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = *dim;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = _tmp1_.height;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = *dim;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = _tmp3_.width;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			dimensions_init (&_tmp5_, _tmp2_, _tmp4_);
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			*result = _tmp5_;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return;
#line 969 "Orientation.c"
		}
		default:
		{
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:256: rotate_dimensions: %d", (gint) self);
#line 975 "Orientation.c"
		}
	}
}


void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
	Dimensions _tmp0_;
	Dimensions _tmp1_ = {0};
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp0_ = *dim;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_rotate_dimensions (self, &_tmp0_, &_tmp1_);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = _tmp1_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 994 "Orientation.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return self ? g_object_ref (self) : NULL;
#line 1001 "Orientation.c"
}


GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* rotated = NULL;
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1014 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
			GdkPixbuf* _tmp1_;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = pixbuf;
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = _g_object_ref0 (_tmp0_);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 269 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp1_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1028 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1032 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
			GdkPixbuf* _tmp3_;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = pixbuf;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (_tmp2_, TRUE);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp3_;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1046 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1050 "Orientation.c"
		{
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = pixbuf;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = gdk_pixbuf_rotate_simple (_tmp4_, GDK_PIXBUF_ROTATE_UPSIDEDOWN);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp5_;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1064 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1068 "Orientation.c"
		{
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = pixbuf;
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_flip (_tmp6_, FALSE);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 283 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp7_;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1082 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1086 "Orientation.c"
		{
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = pixbuf;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9_ = gdk_pixbuf_rotate_simple (_tmp8_, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_ = _tmp9_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11_ = gdk_pixbuf_flip (_tmp10_, FALSE);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp11_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (_tmp10_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1108 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1112 "Orientation.c"
		{
			GdkPixbuf* _tmp12_;
			GdkPixbuf* _tmp13_;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_ = pixbuf;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = gdk_pixbuf_rotate_simple (_tmp12_, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp13_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1126 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1130 "Orientation.c"
		{
			GdkPixbuf* _tmp14_;
			GdkPixbuf* _tmp15_;
			GdkPixbuf* _tmp16_;
			GdkPixbuf* _tmp17_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = pixbuf;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = gdk_pixbuf_rotate_simple (_tmp14_, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp16_ = _tmp15_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp17_ = gdk_pixbuf_flip (_tmp16_, FALSE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp17_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (_tmp16_);
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1152 "Orientation.c"
		}
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1156 "Orientation.c"
		{
			GdkPixbuf* _tmp18_;
			GdkPixbuf* _tmp19_;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp18_ = pixbuf;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp19_ = gdk_pixbuf_rotate_simple (_tmp18_, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp19_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1170 "Orientation.c"
		}
		default:
		{
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:303: rotate_pixbuf: %d", (gint) self);
#line 1176 "Orientation.c"
		}
	}
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	result = rotated;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return result;
#line 1183 "Orientation.c"
}


void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
	gboolean _tmp0_;
	GdkPoint _tmp1_;
	gint _tmp2_;
	GdkPoint _tmp3_;
	gint _tmp4_;
	Dimensions _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
	GdkPoint _tmp9_;
	gint _tmp10_;
	Dimensions _tmp11_;
	gint _tmp12_;
	GdkPoint rotated = {0};
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp0_ = dimensions_has_area (space);
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp0_, "space.has_area ()");
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp1_ = *point;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp2_ = _tmp1_.x;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp2_ >= 0, "point.x >= 0");
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp3_ = *point;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp4_ = _tmp3_.x;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp5_ = *space;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp6_ = _tmp5_.width;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp4_ < _tmp6_, "point.x < space.width");
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp7_ = *point;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp8_ = _tmp7_.y;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp8_ >= 0, "point.y >= 0");
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp9_ = *point;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp10_ = _tmp9_.y;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp11_ = *space;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp12_ = _tmp11_.height;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp10_ < _tmp12_, "point.y < space.height");
#line 317 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1248 "Orientation.c"
		{
			GdkPoint _tmp13_;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = *point;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated = _tmp13_;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1257 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1261 "Orientation.c"
		{
			Dimensions _tmp14_;
			gint _tmp15_;
			GdkPoint _tmp16_;
			gint _tmp17_;
			GdkPoint _tmp18_;
			gint _tmp19_;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = *space;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = _tmp14_.width;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp16_ = *point;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp17_ = _tmp16_.x;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp15_ - _tmp17_) - 1;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp18_ = *point;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp19_ = _tmp18_.y;
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = _tmp19_;
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1287 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1291 "Orientation.c"
		{
			Dimensions _tmp20_;
			gint _tmp21_;
			GdkPoint _tmp22_;
			gint _tmp23_;
			Dimensions _tmp24_;
			gint _tmp25_;
			GdkPoint _tmp26_;
			gint _tmp27_;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp20_ = *space;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp21_ = _tmp20_.width;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp22_ = *point;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp23_ = _tmp22_.x;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp21_ - _tmp23_) - 1;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp24_ = *space;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp25_ = _tmp24_.height;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp26_ = *point;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp27_ = _tmp26_.y;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp25_ - _tmp27_) - 1;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1323 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1327 "Orientation.c"
		{
			GdkPoint _tmp28_;
			gint _tmp29_;
			Dimensions _tmp30_;
			gint _tmp31_;
			GdkPoint _tmp32_;
			gint _tmp33_;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp28_ = *point;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp29_ = _tmp28_.x;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = _tmp29_;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp30_ = *space;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp31_ = _tmp30_.height;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp32_ = *point;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp33_ = _tmp32_.y;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp31_ - _tmp33_) - 1;
#line 341 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1353 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1357 "Orientation.c"
		{
			GdkPoint _tmp34_;
			gint _tmp35_;
			GdkPoint _tmp36_;
			gint _tmp37_;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp34_ = *point;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp35_ = _tmp34_.y;
#line 345 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = _tmp35_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp36_ = *point;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp37_ = _tmp36_.x;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = _tmp37_;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1377 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1381 "Orientation.c"
		{
			Dimensions _tmp38_;
			gint _tmp39_;
			GdkPoint _tmp40_;
			gint _tmp41_;
			GdkPoint _tmp42_;
			gint _tmp43_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp38_ = *space;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp39_ = _tmp38_.height;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp40_ = *point;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp41_ = _tmp40_.y;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp39_ - _tmp41_) - 1;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp42_ = *point;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp43_ = _tmp42_.x;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = _tmp43_;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1407 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1411 "Orientation.c"
		{
			Dimensions _tmp44_;
			gint _tmp45_;
			GdkPoint _tmp46_;
			gint _tmp47_;
			Dimensions _tmp48_;
			gint _tmp49_;
			GdkPoint _tmp50_;
			gint _tmp51_;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp44_ = *space;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp45_ = _tmp44_.height;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp46_ = *point;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp47_ = _tmp46_.y;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = (_tmp45_ - _tmp47_) - 1;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp48_ = *space;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp49_ = _tmp48_.width;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp50_ = *point;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp51_ = _tmp50_.x;
#line 358 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp49_ - _tmp51_) - 1;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1443 "Orientation.c"
		}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1447 "Orientation.c"
		{
			GdkPoint _tmp52_;
			gint _tmp53_;
			Dimensions _tmp54_;
			gint _tmp55_;
			GdkPoint _tmp56_;
			gint _tmp57_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp52_ = *point;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp53_ = _tmp52_.y;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.x = _tmp53_;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp54_ = *space;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp55_ = _tmp54_.width;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp56_ = *point;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp57_ = _tmp56_.x;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			rotated.y = (_tmp55_ - _tmp57_) - 1;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1473 "Orientation.c"
		}
		default:
		{
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:368: rotate_point: %d", (gint) self);
#line 1479 "Orientation.c"
		}
	}
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = rotated;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1486 "Orientation.c"
}


void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
	gboolean _tmp0_;
	GdkPoint derotated = {0};
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp0_ = dimensions_has_area (space);
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_vala_assert (_tmp0_, "space.has_area ()");
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1507 "Orientation.c"
		{
			GdkPoint _tmp1_;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = *point;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated = _tmp1_;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1516 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1520 "Orientation.c"
		{
			Dimensions _tmp2_;
			gint _tmp3_;
			GdkPoint _tmp4_;
			gint _tmp5_;
			GdkPoint _tmp6_;
			gint _tmp7_;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = *space;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = _tmp2_.width;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = *point;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = _tmp4_.x;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp3_ - _tmp5_) - 1;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = *point;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = _tmp6_.y;
#line 389 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = _tmp7_;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1546 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1550 "Orientation.c"
		{
			Dimensions _tmp8_;
			gint _tmp9_;
			GdkPoint _tmp10_;
			gint _tmp11_;
			Dimensions _tmp12_;
			gint _tmp13_;
			GdkPoint _tmp14_;
			gint _tmp15_;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp8_ = *space;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp9_ = _tmp8_.width;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp10_ = *point;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp11_ = _tmp10_.x;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp9_ - _tmp11_) - 1;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp12_ = *space;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp13_ = _tmp12_.height;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp14_ = *point;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp15_ = _tmp14_.y;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp13_ - _tmp15_) - 1;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1582 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1586 "Orientation.c"
		{
			GdkPoint _tmp16_;
			gint _tmp17_;
			Dimensions _tmp18_;
			gint _tmp19_;
			GdkPoint _tmp20_;
			gint _tmp21_;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp16_ = *point;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp17_ = _tmp16_.x;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = _tmp17_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp18_ = *space;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp19_ = _tmp18_.height;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp20_ = *point;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp21_ = _tmp20_.y;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp19_ - _tmp21_) - 1;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1612 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1616 "Orientation.c"
		{
			GdkPoint _tmp22_;
			gint _tmp23_;
			GdkPoint _tmp24_;
			gint _tmp25_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp22_ = *point;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp23_ = _tmp22_.y;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = _tmp23_;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp24_ = *point;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp25_ = _tmp24_.x;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = _tmp25_;
#line 408 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1636 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1640 "Orientation.c"
		{
			GdkPoint _tmp26_;
			gint _tmp27_;
			Dimensions _tmp28_;
			gint _tmp29_;
			GdkPoint _tmp30_;
			gint _tmp31_;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp26_ = *point;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp27_ = _tmp26_.y;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = _tmp27_;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp28_ = *space;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp29_ = _tmp28_.height;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp30_ = *point;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp31_ = _tmp30_.x;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp29_ - _tmp31_) - 1;
#line 414 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1666 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1670 "Orientation.c"
		{
			Dimensions _tmp32_;
			gint _tmp33_;
			GdkPoint _tmp34_;
			gint _tmp35_;
			Dimensions _tmp36_;
			gint _tmp37_;
			GdkPoint _tmp38_;
			gint _tmp39_;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp32_ = *space;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp33_ = _tmp32_.width;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp34_ = *point;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp35_ = _tmp34_.y;
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp33_ - _tmp35_) - 1;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp36_ = *space;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp37_ = _tmp36_.height;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp38_ = *point;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp39_ = _tmp38_.x;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = (_tmp37_ - _tmp39_) - 1;
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1702 "Orientation.c"
		}
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1706 "Orientation.c"
		{
			Dimensions _tmp40_;
			gint _tmp41_;
			GdkPoint _tmp42_;
			gint _tmp43_;
			GdkPoint _tmp44_;
			gint _tmp45_;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp40_ = *space;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp41_ = _tmp40_.width;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp42_ = *point;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp43_ = _tmp42_.y;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.x = (_tmp41_ - _tmp43_) - 1;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp44_ = *point;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp45_ = _tmp44_.x;
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			derotated.y = _tmp45_;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			break;
#line 1732 "Orientation.c"
		}
		default:
		{
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:429: rotate_point: %d", (gint) self);
#line 1738 "Orientation.c"
		}
	}
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = derotated;
#line 432 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1745 "Orientation.c"
}


void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
	Dimensions _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GdkPoint _tmp12_;
	gint _tmp13_;
	Dimensions _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GdkPoint _tmp17_;
	gint _tmp18_;
	Dimensions _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	GdkPoint _tmp23_;
	GdkPoint _tmp24_ = {0};
	Dimensions _tmp25_;
	GdkPoint _tmp26_;
	GdkPoint _tmp27_ = {0};
	GdkPoint _tmp28_;
	GdkPoint _tmp29_;
	Box _tmp30_ = {0};
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp0_;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp1_;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp2_ = top_left;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp3_ = _tmp2_.x;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp4_ = *space;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp5_ = _tmp4_.width;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp6_ = CLAMP (_tmp3_, 0, _tmp5_ - 1);
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left.x = _tmp6_;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp7_ = top_left;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp8_ = _tmp7_.y;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp9_ = *space;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp10_ = _tmp9_.height;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp11_ = CLAMP (_tmp8_, 0, _tmp10_ - 1);
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left.y = _tmp11_;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp12_ = bottom_right;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp13_ = _tmp12_.x;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp14_ = *space;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp15_ = _tmp14_.width;
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp16_ = CLAMP (_tmp13_, 0, _tmp15_ - 1);
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right.x = _tmp16_;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp17_ = bottom_right;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp18_ = _tmp17_.y;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp19_ = *space;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp20_ = _tmp19_.height;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp21_ = CLAMP (_tmp18_, 0, _tmp20_ - 1);
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right.y = _tmp21_;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp22_ = *space;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp23_ = top_left;
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_rotate_point (self, &_tmp22_, &_tmp23_, &_tmp24_);
#line 446 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp24_;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp25_ = *space;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp26_ = bottom_right;
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_rotate_point (self, &_tmp25_, &_tmp26_, &_tmp27_);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp27_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp28_ = top_left;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp29_ = bottom_right;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_from_points (&_tmp28_, &_tmp29_, &_tmp30_);
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = _tmp30_;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1867 "Orientation.c"
}


void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_ = {0};
	Dimensions _tmp5_;
	GdkPoint _tmp6_;
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_;
	GdkPoint _tmp9_;
	Box _tmp10_ = {0};
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp0_;
#line 455 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp1_;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp2_ = *space;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp3_ = top_left;
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_derotate_point (self, &_tmp2_, &_tmp3_, &_tmp4_);
#line 457 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	top_left = _tmp4_;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp5_ = *space;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	orientation_derotate_point (self, &_tmp5_, &_tmp6_, &_tmp7_);
#line 458 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	bottom_right = _tmp7_;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp8_ = top_left;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	_tmp9_ = bottom_right;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	box_from_points (&_tmp8_, &_tmp9_, &_tmp10_);
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	*result = _tmp10_;
#line 460 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	return;
#line 1921 "Orientation.c"
}


GType orientation_get_type (void) {
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}


GdkPixbuf* rotation_perform (Rotation self, GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
#line 470 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1945 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
			GdkPixbuf* _tmp1_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp0_ = pixbuf;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_rotate_simple (_tmp0_, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp1_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 1957 "Orientation.c"
		}
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1961 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
			GdkPixbuf* _tmp3_;
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp2_ = pixbuf;
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_rotate_simple (_tmp2_, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp3_;
#line 476 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 1973 "Orientation.c"
		}
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 1977 "Orientation.c"
		{
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp4_ = pixbuf;
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp5_ = gdk_pixbuf_flip (_tmp4_, TRUE);
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp5_;
#line 479 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 1989 "Orientation.c"
		}
#line 471 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 1993 "Orientation.c"
		{
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp6_ = pixbuf;
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_flip (_tmp6_, FALSE);
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = _tmp7_;
#line 482 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2005 "Orientation.c"
		}
		default:
		{
#line 485 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:485: Unknown rotation: %d", (gint) self);
#line 2011 "Orientation.c"
		}
	}
}


Rotation rotation_opposite (Rotation self) {
	Rotation result = 0;
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
	switch (self) {
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 2023 "Orientation.c"
		{
#line 492 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ROTATION_COUNTERCLOCKWISE;
#line 492 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2029 "Orientation.c"
		}
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 2033 "Orientation.c"
		{
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = ROTATION_CLOCKWISE;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2039 "Orientation.c"
		}
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_MIRROR:
#line 490 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 2045 "Orientation.c"
		{
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			result = self;
#line 499 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			return result;
#line 2051 "Orientation.c"
		}
		default:
		{
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/Orientation.vala"
			g_error ("Orientation.vala:502: Unknown rotation: %d", (gint) self);
#line 2057 "Orientation.c"
		}
	}
}


GType rotation_get_type (void) {
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}



