/* SortedList.c generated by valac 0.36.4, the Vala compiler
 * generated from SortedList.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
};


static gpointer sorted_list_parent_class = NULL;
static GeeTraversableIface * sorted_list_gee_traversable_parent_iface = NULL;
static GeeIterableIface * sorted_list_gee_iterable_parent_iface = NULL;
static GeeCollectionIface * sorted_list_gee_collection_parent_iface = NULL;

gchar* g_utf8_collate_key_for_filename (const gchar* str, gssize len);
gint64 file_comparator (void* a, void* b);
GType sorted_list_get_type (void) G_GNUC_CONST;
#define SORTED_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SORTED_LIST, SortedListPrivate))
enum  {
	SORTED_LIST_DUMMY_PROPERTY,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC,
	SORTED_LIST_ELEMENT_TYPE,
	SORTED_LIST_READ_ONLY,
	SORTED_LIST_IS_EMPTY,
	SORTED_LIST_SIZE,
	SORTED_LIST_READ_ONLY_VIEW,
	SORTED_LIST_READ_ONLY_VIEW_AS_LIST
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gboolean sorted_list_real_foreach (GeeTraversable* base, GeeForallFunc f, void* f_target);
static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item);
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item);
static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection);
gboolean sorted_list_add_list (SortedList* self, GeeList* items);
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add);
static void sorted_list_real_clear (GeeCollection* base);
static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item);
static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection);
static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection);
gint sorted_list_get_count (SortedList* self);
gpointer sorted_list_get_at (SortedList* self, gint index);
static gint sorted_list_binary_search (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self, gconstpointer search);
gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func);
gpointer sorted_list_remove_at (SortedList* self, gint index);
static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index);
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index);
GeeList* sorted_list_get_read_only_view_as_list (SortedList* self);
static void sorted_list_finalize (GObject * obj);
static void _vala_sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gint64 file_comparator (void* a, void* b) {
	gint64 result = 0LL;
	gchar* path_a = NULL;
	void* _tmp0_;
	gchar* _tmp1_;
	gchar* path_b = NULL;
	void* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp7_;
	GCompareFunc _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gint _tmp15_;
	gint64 _tmp16_;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = a;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = g_file_get_path ((GFile*) _tmp0_);
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	path_a = _tmp1_;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = b;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = g_file_get_path ((GFile*) _tmp2_);
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	path_b = _tmp3_;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp4_ = path_a;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp4_ == NULL) {
#line 160 "SortedList.c"
		gint _tmp5_ = 0;
		const gchar* _tmp6_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp6_ = path_b;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (_tmp6_ == NULL) {
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp5_ = 0;
#line 169 "SortedList.c"
		} else {
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp5_ = 1;
#line 173 "SortedList.c"
		}
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = (gint64) _tmp5_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_free0 (path_b);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_free0 (path_a);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 183 "SortedList.c"
	}
#line 32 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp7_ = path_b;
#line 32 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp7_ == NULL) {
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = (gint64) -1;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_free0 (path_b);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_free0 (path_a);
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 197 "SortedList.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8_ = g_strcmp0;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp9_ = path_a;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp10_ = g_utf8_collate_key_for_filename (_tmp9_, (gssize) -1);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp11_ = _tmp10_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp12_ = path_b;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp13_ = g_utf8_collate_key_for_filename (_tmp12_, (gssize) -1);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp14_ = _tmp13_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp15_ = _tmp8_ (_tmp11_, _tmp14_);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp16_ = (gint64) _tmp15_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_free0 (_tmp14_);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_free0 (_tmp11_);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp16_;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_free0 (path_b);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_free0 (path_a);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 229 "SortedList.c"
}


SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
	SortedList * self = NULL;
	GeeArrayList* _tmp0_;
	Comparator _tmp1_;
	void* _tmp1__target;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->g_type = g_type;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->g_dup_func = g_dup_func;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, NULL, NULL, NULL);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_object_unref0 (self->priv->list);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->list = _tmp0_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = cmp;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1__target = cmp_target;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->cmp = _tmp1_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->cmp_target = _tmp1__target;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self;
#line 262 "SortedList.c"
}


SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
#line 269 "SortedList.c"
}


static GeeIterator* sorted_list_real_iterator (GeeIterable* base) {
	SortedList * self;
	GeeIterator* result = NULL;
	GeeArrayList* _tmp0_;
	GeeIterator* _tmp1_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp1_;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 288 "SortedList.c"
}


static gboolean sorted_list_real_foreach (GeeTraversable* base, GeeForallFunc f, void* f_target) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeForallFunc _tmp1_;
	void* _tmp1__target;
	gboolean _tmp2_;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = f;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1__target = f_target;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp0_, _tmp1_, _tmp1__target);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 313 "SortedList.c"
}


static gboolean sorted_list_real_add (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp0_ == NULL) {
#line 330 "SortedList.c"
		GeeArrayList* _tmp1_;
		gconstpointer _tmp2_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp1_ = self->priv->list;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp2_ = item;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp2_);
#line 339 "SortedList.c"
	} else {
		GeeArrayList* _tmp3_;
		gconstpointer _tmp4_;
		gint _tmp5_;
		gconstpointer _tmp6_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp3_ = self->priv->list;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp4_ = item;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp5_ = sorted_list_get_sorted_insert_pos (self, _tmp4_);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp6_ = item;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp3_, _tmp5_, _tmp6_);
#line 355 "SortedList.c"
	}
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = TRUE;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 361 "SortedList.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self ? g_object_ref (self) : NULL;
#line 368 "SortedList.c"
}


static gboolean sorted_list_real_add_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeList* as_list = NULL;
	GeeCollection* _tmp3_;
	GeeList* _tmp4_;
	GeeList* _tmp5_;
	Comparator _tmp8_;
	void* _tmp8__target;
	gboolean changed = FALSE;
	GeeCollection* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = collection;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp2_ == 0) {
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = FALSE;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 404 "SortedList.c"
	}
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = collection;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GEE_TYPE_LIST) ? ((GeeList*) _tmp3_) : NULL);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	as_list = _tmp4_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp5_ = as_list;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp5_ != NULL) {
#line 416 "SortedList.c"
		GeeList* _tmp6_;
		gboolean _tmp7_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp6_ = as_list;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp7_ = sorted_list_add_list (self, _tmp6_);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = _tmp7_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_object_unref0 (as_list);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 429 "SortedList.c"
	}
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8_ = self->priv->cmp;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8__target = self->priv->cmp_target;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp8_ == NULL) {
#line 437 "SortedList.c"
		GeeArrayList* _tmp9_;
		GeeCollection* _tmp10_;
		gboolean _tmp11_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp9_ = self->priv->list;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp10_ = collection;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp11_ = gee_array_list_add_all (_tmp9_, _tmp10_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = _tmp11_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_object_unref0 (as_list);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 453 "SortedList.c"
	}
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	changed = FALSE;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp12_ = collection;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp13_ = gee_collection_get_size (_tmp12_);
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp14_ = _tmp13_;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp14_ == 1) {
#line 465 "SortedList.c"
		GeeIterator* iter = NULL;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
		gpointer item = NULL;
		GeeIterator* _tmp18_;
		gpointer _tmp19_;
		GeeArrayList* _tmp20_;
		gconstpointer _tmp21_;
		gint _tmp22_;
		gconstpointer _tmp23_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp15_ = collection;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		iter = _tmp16_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp17_ = iter;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_iterator_next (_tmp17_);
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp18_ = iter;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp19_ = gee_iterator_get (_tmp18_);
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		item = _tmp19_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp20_ = self->priv->list;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp21_ = item;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp22_ = sorted_list_get_sorted_insert_pos (self, _tmp21_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp23_ = item;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp20_, _tmp22_, _tmp23_);
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		changed = TRUE;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_object_unref0 (iter);
#line 509 "SortedList.c"
	} else {
		GeeList* items = NULL;
		GeeArrayList* _tmp24_;
		GeeList* _tmp25_;
		GeeCollection* _tmp26_;
		GeeList* _tmp27_;
		gboolean _tmp28_;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp24_ = gee_array_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, NULL, NULL, NULL);
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		items = (GeeList*) _tmp24_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp25_ = items;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp26_ = collection;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_collection_add_all ((GeeCollection*) _tmp25_, _tmp26_);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp27_ = items;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp28_ = sorted_list_merge_sort (self, _tmp27_);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		changed = _tmp28_;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_g_object_unref0 (items);
#line 535 "SortedList.c"
	}
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = changed;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_object_unref0 (as_list);
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 543 "SortedList.c"
}


gboolean sorted_list_add_list (SortedList* self, GeeList* items) {
	gboolean result = FALSE;
	gboolean added = FALSE;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (items != NULL, FALSE);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	added = FALSE;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = items;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp2_ == 0) {
#line 567 "SortedList.c"
	} else {
		Comparator _tmp3_;
		void* _tmp3__target;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp3_ = self->priv->cmp;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp3__target = self->priv->cmp_target;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (_tmp3_ != NULL) {
#line 577 "SortedList.c"
			GeeList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp4_ = items;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp6_ = _tmp5_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp6_ == 1) {
#line 589 "SortedList.c"
				GeeArrayList* _tmp7_;
				GeeList* _tmp8_;
				gpointer _tmp9_;
				gpointer _tmp10_;
				gint _tmp11_;
				GeeList* _tmp12_;
				gpointer _tmp13_;
				gpointer _tmp14_;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp7_ = self->priv->list;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp8_ = items;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp9_ = gee_list_get (_tmp8_, 0);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp10_ = _tmp9_;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp11_ = sorted_list_get_sorted_insert_pos (self, _tmp10_);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp12_ = items;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp13_ = gee_list_get (_tmp12_, 0);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp14_ = _tmp13_;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				gee_abstract_list_insert ((GeeAbstractList*) _tmp7_, _tmp11_, _tmp14_);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((_tmp14_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp14_ = (self->priv->g_destroy_func (_tmp14_), NULL));
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((_tmp10_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp10_ = (self->priv->g_destroy_func (_tmp10_), NULL));
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				added = TRUE;
#line 622 "SortedList.c"
			} else {
				GeeList* _tmp15_;
				gboolean _tmp16_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp15_ = items;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp16_ = sorted_list_merge_sort (self, _tmp15_);
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				added = _tmp16_;
#line 632 "SortedList.c"
			}
		} else {
			GeeArrayList* _tmp17_;
			GeeList* _tmp18_;
			gboolean _tmp19_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp17_ = self->priv->list;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp18_ = items;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp19_ = gee_array_list_add_all (_tmp17_, (GeeCollection*) _tmp18_);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			added = _tmp19_;
#line 646 "SortedList.c"
		}
	}
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = added;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 653 "SortedList.c"
}


static void sorted_list_real_clear (GeeCollection* base) {
	SortedList * self;
	GeeArrayList* _tmp0_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 666 "SortedList.c"
}


static gboolean sorted_list_real_contains (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = item;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 688 "SortedList.c"
}


static gboolean sorted_list_real_contains_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = collection;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_collection_contains_all ((GeeCollection*) _tmp0_, _tmp1_);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 712 "SortedList.c"
}


static gboolean sorted_list_real_remove (GeeCollection* base, gconstpointer item) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = item;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 734 "SortedList.c"
}


static gboolean sorted_list_real_remove_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = collection;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_collection_remove_all ((GeeCollection*) _tmp0_, _tmp1_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 758 "SortedList.c"
}


static gboolean sorted_list_real_retain_all (GeeCollection* base, GeeCollection* collection) {
	SortedList * self;
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = collection;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_collection_retain_all ((GeeCollection*) _tmp0_, _tmp1_);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 782 "SortedList.c"
}


inline gint sorted_list_get_count (SortedList* self) {
	gint result = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 803 "SortedList.c"
}


gpointer sorted_list_get_at (SortedList* self, gint index) {
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gpointer _tmp2_;
#line 176 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = index;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp1_);
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 824 "SortedList.c"
}


static gint sorted_list_binary_search (SortedList* self, gconstpointer search, GEqualFunc equal_func) {
	gint result = 0;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint min = 0;
	gint max = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp0_ != NULL, "cmp != null");
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	min = 0;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = self->priv->list;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	max = _tmp3_;
#line 855 "SortedList.c"
	{
		gboolean _tmp4_ = FALSE;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp4_ = TRUE;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		while (TRUE) {
#line 862 "SortedList.c"
			gint mid = 0;
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gpointer item = NULL;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_ = FALSE;
			GEqualFunc _tmp12_;
			gint64 compare = 0LL;
			Comparator _tmp17_;
			void* _tmp17__target;
			gconstpointer _tmp18_;
			gconstpointer _tmp19_;
			gint64 _tmp20_;
			gint64 _tmp21_;
			gint _tmp25_;
			gint _tmp26_;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (!_tmp4_) {
#line 884 "SortedList.c"
			}
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp4_ = FALSE;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp5_ = min;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp6_ = max;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp7_ = min;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			mid = _tmp5_ + ((_tmp6_ - _tmp7_) / 2);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp8_ = self->priv->list;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp9_ = mid;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			item = _tmp10_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp12_ = equal_func;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp12_ != NULL) {
#line 908 "SortedList.c"
				GEqualFunc _tmp13_;
				gconstpointer _tmp14_;
				gconstpointer _tmp15_;
				gboolean _tmp16_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp13_ = equal_func;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp14_ = item;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp15_ = search;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp16_ = _tmp13_ (_tmp14_, _tmp15_);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp11_ = _tmp16_;
#line 923 "SortedList.c"
			} else {
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp11_ = FALSE;
#line 927 "SortedList.c"
			}
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp11_) {
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				result = mid;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				return result;
#line 937 "SortedList.c"
			}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp17_ = self->priv->cmp;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp17__target = self->priv->cmp_target;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp18_ = item;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp19_ = search;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp20_ = _tmp17_ (_tmp18_, _tmp19_, _tmp17__target);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			compare = _tmp20_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp21_ = compare;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp21_ == ((gint64) 0)) {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				result = mid;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				return result;
#line 961 "SortedList.c"
			} else {
				gint64 _tmp22_;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp22_ = compare;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				if (_tmp22_ > ((gint64) 0)) {
#line 968 "SortedList.c"
					gint _tmp23_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp23_ = mid;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					max = _tmp23_ - 1;
#line 974 "SortedList.c"
				} else {
					gint _tmp24_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp24_ = mid;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					min = _tmp24_ + 1;
#line 981 "SortedList.c"
				}
			}
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp25_ = min;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp26_ = max;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp25_ > _tmp26_) {
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				break;
#line 994 "SortedList.c"
			}
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 998 "SortedList.c"
		}
	}
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = -1;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1005 "SortedList.c"
}


gint sorted_list_index_of (SortedList* self, gconstpointer search) {
	gint result = 0;
	gint _tmp0_ = 0;
	Comparator _tmp1_;
	void* _tmp1__target;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = self->priv->cmp;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1__target = self->priv->cmp_target;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp1_ != NULL) {
#line 1022 "SortedList.c"
		gconstpointer _tmp2_;
		gint _tmp3_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp2_ = search;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp3_ = sorted_list_binary_search (self, _tmp2_, NULL);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp0_ = _tmp3_;
#line 1031 "SortedList.c"
	} else {
		gconstpointer _tmp4_;
		GEqualFunc _tmp5_;
		gint _tmp6_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp4_ = search;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp5_ = g_direct_equal;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp6_ = sorted_list_locate (self, _tmp4_, FALSE, _tmp5_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp0_ = _tmp6_;
#line 1044 "SortedList.c"
	}
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp0_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1050 "SortedList.c"
}


gint sorted_list_locate (SortedList* self, gconstpointer search, gboolean altered, GEqualFunc equal_func) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	Comparator _tmp1_;
	void* _tmp1__target;
	gconstpointer _tmp18_;
	GEqualFunc _tmp19_;
	gint _tmp20_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = self->priv->cmp;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1__target = self->priv->cmp_target;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp1_ == NULL) {
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp0_ = TRUE;
#line 1072 "SortedList.c"
	} else {
		gboolean _tmp2_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp2_ = altered;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp0_ = _tmp2_;
#line 1079 "SortedList.c"
	}
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp0_) {
#line 1083 "SortedList.c"
		gint count = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp3_ = self->priv->list;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp5_ = _tmp4_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		count = _tmp5_;
#line 1096 "SortedList.c"
		{
			gint ctr = 0;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			ctr = 0;
#line 1101 "SortedList.c"
			{
				gboolean _tmp6_ = FALSE;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp6_ = TRUE;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				while (TRUE) {
#line 1108 "SortedList.c"
					gint _tmp8_;
					gint _tmp9_;
					GEqualFunc _tmp10_;
					GeeArrayList* _tmp11_;
					gint _tmp12_;
					gpointer _tmp13_;
					gpointer _tmp14_;
					gconstpointer _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					if (!_tmp6_) {
#line 1121 "SortedList.c"
						gint _tmp7_;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
						_tmp7_ = ctr;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
						ctr = _tmp7_ + 1;
#line 1127 "SortedList.c"
					}
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp6_ = FALSE;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp8_ = ctr;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp9_ = count;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					if (!(_tmp8_ < _tmp9_)) {
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
						break;
#line 1139 "SortedList.c"
					}
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp10_ = equal_func;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp11_ = self->priv->list;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp12_ = ctr;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp14_ = _tmp13_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp15_ = search;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp16_ = _tmp10_ (_tmp14_, _tmp15_);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp17_ = _tmp16_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					((_tmp14_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp14_ = (self->priv->g_destroy_func (_tmp14_), NULL));
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					if (_tmp17_) {
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
						result = ctr;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
						return result;
#line 1165 "SortedList.c"
					}
				}
			}
		}
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = -1;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 1174 "SortedList.c"
	}
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp18_ = search;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp19_ = equal_func;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp20_ = sorted_list_binary_search (self, _tmp18_, _tmp19_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp20_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1186 "SortedList.c"
}


gpointer sorted_list_remove_at (SortedList* self, gint index) {
	gpointer result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gpointer _tmp2_;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = index;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp0_, _tmp1_);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1207 "SortedList.c"
}


static gpointer* sorted_list_real_to_array (GeeCollection* base, int* result_length1) {
	SortedList * self;
	gpointer* result = NULL;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gpointer* _tmp2_;
	gpointer* _tmp3_;
	gint _tmp3__length1;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_collection_to_array ((GeeCollection*) _tmp0_, &_tmp1_);
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3__length1 = _tmp1_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (result_length1) {
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		*result_length1 = _tmp3__length1;
#line 1233 "SortedList.c"
	}
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp3_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1239 "SortedList.c"
}


void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target) {
	Comparator _tmp0_;
	void* _tmp0__target;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_if_fail (self != NULL);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = new_cmp;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0__target = new_cmp_target;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->cmp = _tmp0_;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv->cmp_target = _tmp0__target;
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	sorted_list_merge_sort (self, NULL);
#line 1258 "SortedList.c"
}


gboolean sorted_list_resort_item (SortedList* self, gconstpointer item) {
	gboolean result = FALSE;
	gint index = 0;
	gconstpointer _tmp0_;
	GEqualFunc _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint new_index = 0;
	gconstpointer _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = item;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = g_direct_equal;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = sorted_list_locate (self, _tmp0_, TRUE, _tmp1_);
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	index = _tmp2_;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = index;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp3_ >= 0, "index >= 0");
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp4_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp5_ = sorted_list_get_sorted_insert_pos (self, _tmp4_);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	new_index = _tmp5_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp6_ = index;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp7_ = new_index;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp6_ == _tmp7_) {
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = FALSE;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 1306 "SortedList.c"
	}
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8_ = new_index;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp9_ = index;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp8_ > _tmp9_) {
#line 1314 "SortedList.c"
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gconstpointer _tmp12_;
		gpointer removed_item = NULL;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gpointer _tmp15_;
		gconstpointer _tmp16_;
		gconstpointer _tmp17_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp10_ = self->priv->list;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp11_ = new_index;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp12_ = item;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp10_, _tmp11_, _tmp12_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp13_ = self->priv->list;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp14_ = index;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp15_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp13_, _tmp14_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		removed_item = _tmp15_;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp16_ = item;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp17_ = removed_item;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_vala_assert (_tmp16_ == _tmp17_, "item == removed_item");
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
#line 1348 "SortedList.c"
	} else {
		gpointer removed_item = NULL;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gpointer _tmp20_;
		gconstpointer _tmp21_;
		gconstpointer _tmp22_;
		GeeArrayList* _tmp23_;
		gint _tmp24_;
		gconstpointer _tmp25_;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp18_ = self->priv->list;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp19_ = index;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp20_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp18_, _tmp19_);
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		removed_item = _tmp20_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp21_ = item;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp22_ = removed_item;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_vala_assert (_tmp21_ == _tmp22_, "item == removed_item");
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp23_ = self->priv->list;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp24_ = new_index;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp25_ = item;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp23_, _tmp24_, _tmp25_);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
#line 1383 "SortedList.c"
	}
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = TRUE;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1389 "SortedList.c"
}


static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item) {
	gint result = 0;
	gint low = 0;
	gint high = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 293 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	low = 0;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	high = _tmp2_;
#line 1412 "SortedList.c"
	{
		gboolean _tmp3_ = FALSE;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp3_ = TRUE;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		while (TRUE) {
#line 1419 "SortedList.c"
			gint _tmp4_;
			gint _tmp5_;
			gint mid = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gpointer cmp_item = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gconstpointer _tmp12_;
			gconstpointer _tmp13_;
			gint64 _result_ = 0LL;
			Comparator _tmp24_;
			void* _tmp24__target;
			gconstpointer _tmp25_;
			gconstpointer _tmp26_;
			gint64 _tmp27_;
			gint64 _tmp28_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (!_tmp3_) {
#line 1441 "SortedList.c"
			}
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp3_ = FALSE;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp4_ = low;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp5_ = high;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp4_ == _tmp5_) {
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				result = low;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				return result;
#line 1455 "SortedList.c"
			}
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp6_ = low;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp7_ = high;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp8_ = low;
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			mid = _tmp6_ + ((_tmp7_ - _tmp8_) / 2);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp9_ = self->priv->list;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp10_ = mid;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			cmp_item = _tmp11_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp12_ = item;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp13_ = cmp_item;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp12_ == _tmp13_) {
#line 1479 "SortedList.c"
				gint _tmp14_;
				GeeArrayList* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				GeeArrayList* _tmp21_;
				gint _tmp22_;
				gpointer _tmp23_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp14_ = mid;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp15_ = self->priv->list;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp17_ = _tmp16_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				if (_tmp14_ >= (_tmp17_ - 1)) {
#line 1497 "SortedList.c"
					GeeArrayList* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp18_ = self->priv->list;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp20_ = _tmp19_;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					result = _tmp20_;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					return result;
#line 1513 "SortedList.c"
				}
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp21_ = self->priv->list;
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp22_ = mid;
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _tmp22_ + 1);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				cmp_item = _tmp23_;
#line 1525 "SortedList.c"
			}
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp24_ = self->priv->cmp;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp24__target = self->priv->cmp_target;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp25_ = item;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp26_ = cmp_item;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp27_ = _tmp24_ (_tmp25_, _tmp26_, _tmp24__target);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_result_ = _tmp27_;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp28_ = _result_;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (_tmp28_ < ((gint64) 0)) {
#line 1543 "SortedList.c"
				gint _tmp29_;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp29_ = mid;
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				high = _tmp29_;
#line 1549 "SortedList.c"
			} else {
				gint64 _tmp30_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp30_ = _result_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				if (_tmp30_ > ((gint64) 0)) {
#line 1556 "SortedList.c"
					gint _tmp31_;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp31_ = mid;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					low = _tmp31_ + 1;
#line 1562 "SortedList.c"
				} else {
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					result = mid;
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 318 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					return result;
#line 1570 "SortedList.c"
				}
			}
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 1575 "SortedList.c"
		}
	}
}


SortedList* sorted_list_copy (SortedList* self) {
	SortedList* result = NULL;
	SortedList* copy = NULL;
	Comparator _tmp0_;
	void* _tmp0__target;
	SortedList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp0_, _tmp0__target);
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	copy = _tmp1_;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = copy->priv->list;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = self->priv->list;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	gee_array_list_add_all (_tmp2_, (GeeCollection*) _tmp3_);
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = copy;
#line 327 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1609 "SortedList.c"
}


static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add) {
	gboolean result = FALSE;
	Comparator _tmp0_;
	void* _tmp0__target;
	gint list_count = 0;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	GeeList* _tmp5_;
	gint add_count = 0;
	gint count = 0;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gpointer* array = NULL;
	gint _tmp12_;
	gpointer* _tmp13_;
	gint array_length1;
	gint _array_size_;
	gint offset = 0;
	GeeList* _tmp23_;
	gint _tmp33_;
	gint _tmp34_;
	gpointer* _tmp35_;
	gint _tmp35__length1;
	gint _tmp36_;
	gpointer* _tmp37_;
	gpointer* _tmp38_;
	gint _tmp38__length1;
	gint _tmp39_;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->cmp;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0__target = self->priv->cmp_target;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp0_ != NULL, "cmp != null");
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = self->priv->list;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = _tmp2_;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	list_count = _tmp3_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp5_ = add;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp5_ != NULL) {
#line 1664 "SortedList.c"
		GeeList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp6_ = add;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp8_ = _tmp7_;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp4_ = _tmp8_;
#line 1676 "SortedList.c"
	} else {
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp4_ = 0;
#line 1680 "SortedList.c"
	}
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	add_count = _tmp4_;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp9_ = list_count;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp10_ = add_count;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	count = _tmp9_ + _tmp10_;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp11_ = count;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp11_ == 0) {
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		result = FALSE;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return result;
#line 1698 "SortedList.c"
	}
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp12_ = count;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp13_ = g_new0 (gpointer, _tmp12_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	array = _tmp13_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	array_length1 = _tmp12_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_array_size_ = array_length1;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	offset = 0;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	while (TRUE) {
#line 1714 "SortedList.c"
		gint _tmp14_;
		gint _tmp15_;
		gpointer* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gpointer _tmp20_;
		gpointer _tmp21_;
		gint _tmp22_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp14_ = offset;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp15_ = list_count;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (!(_tmp14_ < _tmp15_)) {
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			break;
#line 1733 "SortedList.c"
		}
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp16_ = array;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp16__length1 = array_length1;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp17_ = offset;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp18_ = self->priv->list;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp19_ = offset;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _tmp19_);
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((_tmp16_[_tmp17_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp16_[_tmp17_] = (self->priv->g_destroy_func (_tmp16_[_tmp17_]), NULL));
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp16_[_tmp17_] = _tmp20_;
#line 364 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp21_ = _tmp16_[_tmp17_];
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp22_ = offset;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		offset = _tmp22_ + 1;
#line 1757 "SortedList.c"
	}
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp23_ = add;
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp23_ != NULL) {
#line 1763 "SortedList.c"
		gint add_ctr = 0;
#line 369 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		add_ctr = 0;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		while (TRUE) {
#line 1769 "SortedList.c"
			gint _tmp24_;
			gint _tmp25_;
			gpointer* _tmp26_;
			gint _tmp26__length1;
			gint _tmp27_;
			GeeList* _tmp28_;
			gint _tmp29_;
			gpointer _tmp30_;
			gpointer _tmp31_;
			gint _tmp32_;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp24_ = offset;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp25_ = count;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			if (!(_tmp24_ < _tmp25_)) {
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				break;
#line 1788 "SortedList.c"
			}
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp26_ = array;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp26__length1 = array_length1;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp27_ = offset;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp28_ = add;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp29_ = add_ctr;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			add_ctr = _tmp29_ + 1;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp30_ = gee_list_get (_tmp28_, _tmp29_);
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			((_tmp26_[_tmp27_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp26_[_tmp27_] = (self->priv->g_destroy_func (_tmp26_[_tmp27_]), NULL));
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp26_[_tmp27_] = _tmp30_;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp31_ = _tmp26_[_tmp27_];
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp32_ = offset;
#line 372 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			offset = _tmp32_ + 1;
#line 1814 "SortedList.c"
		}
	}
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp33_ = offset;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp34_ = count;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp33_ == _tmp34_, "offset == count");
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp35_ = array;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp35__length1 = array_length1;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp36_ = count;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp37_ = g_new0 (gpointer, _tmp36_);
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp38_ = _tmp37_;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp38__length1 = _tmp36_;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp39_ = count;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp35_, _tmp35__length1, _tmp38_, _tmp36_, 0, _tmp39_ - 1);
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp38_ = (_vala_array_free (_tmp38_, _tmp38__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 380 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	offset = 0;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	while (TRUE) {
#line 1845 "SortedList.c"
		gint _tmp40_;
		gint _tmp41_;
		GeeArrayList* _tmp42_;
		gint _tmp43_;
		gpointer* _tmp44_;
		gint _tmp44__length1;
		gint _tmp45_;
		gconstpointer _tmp46_;
		gint _tmp47_;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp40_ = offset;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp41_ = list_count;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (!(_tmp40_ < _tmp41_)) {
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			break;
#line 1863 "SortedList.c"
		}
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp42_ = self->priv->list;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp43_ = offset;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp44_ = array;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp44__length1 = array_length1;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp45_ = offset;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp46_ = _tmp44_[_tmp45_];
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_list_set ((GeeAbstractList*) _tmp42_, _tmp43_, _tmp46_);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp47_ = offset;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		offset = _tmp47_ + 1;
#line 1883 "SortedList.c"
	}
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	while (TRUE) {
#line 1887 "SortedList.c"
		gint _tmp48_;
		gint _tmp49_;
		GeeArrayList* _tmp50_;
		gint _tmp51_;
		gpointer* _tmp52_;
		gint _tmp52__length1;
		gint _tmp53_;
		gconstpointer _tmp54_;
		gint _tmp55_;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp48_ = offset;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp49_ = count;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (!(_tmp48_ < _tmp49_)) {
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			break;
#line 1905 "SortedList.c"
		}
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp50_ = self->priv->list;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp51_ = offset;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp52_ = array;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp52__length1 = array_length1;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp53_ = offset;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp54_ = _tmp52_[_tmp53_];
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		gee_abstract_list_insert ((GeeAbstractList*) _tmp50_, _tmp51_, _tmp54_);
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp55_ = offset;
#line 388 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		offset = _tmp55_ + 1;
#line 1925 "SortedList.c"
	}
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = TRUE;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 1933 "SortedList.c"
}


static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index) {
	gint _tmp0_;
	gint _tmp1_;
	gint count = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint middle_index = 0;
	gint _tmp5_;
	gint _tmp6_;
	gpointer* _tmp7_;
	gint _tmp7__length1;
	gpointer* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint _tmp10_;
	gpointer* _tmp11_;
	gint _tmp11__length1;
	gpointer* _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
	gint _tmp14_;
	Comparator _tmp15_;
	void* _tmp15__target;
	gpointer* _tmp16_;
	gint _tmp16__length1;
	gint _tmp17_;
	gconstpointer _tmp18_;
	gpointer* _tmp19_;
	gint _tmp19__length1;
	gint _tmp20_;
	gconstpointer _tmp21_;
	gint64 _tmp22_;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_if_fail (self != NULL);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = start_index;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = end_index;
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp0_ <= _tmp1_, "start_index <= end_index");
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = end_index;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = start_index;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	count = (_tmp2_ - _tmp3_) + 1;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp4_ = count;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp4_ <= 1) {
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		return;
#line 1990 "SortedList.c"
	}
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp5_ = start_index;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp6_ = count;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	middle_index = _tmp5_ + (_tmp6_ / 2);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp7_ = array;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp7__length1 = array_length1;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8_ = scratch;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8__length1 = scratch_length1;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp9_ = start_index;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp10_ = middle_index;
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp7_, _tmp7__length1, _tmp8_, _tmp8__length1, _tmp9_, _tmp10_ - 1);
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp11_ = array;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp11__length1 = array_length1;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp12_ = scratch;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp12__length1 = scratch_length1;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp13_ = middle_index;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp14_ = end_index;
#line 404 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_sorted_list_merge_sort (self, _tmp11_, _tmp11__length1, _tmp12_, _tmp12__length1, _tmp13_, _tmp14_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp15_ = self->priv->cmp;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp15__target = self->priv->cmp_target;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp16_ = array;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp16__length1 = array_length1;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp17_ = middle_index;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp18_ = _tmp16_[_tmp17_ - 1];
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp19_ = array;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp19__length1 = array_length1;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp20_ = middle_index;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp21_ = _tmp19_[_tmp20_];
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp22_ = _tmp15_ (_tmp18_, _tmp21_, _tmp15__target);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	if (_tmp22_ > ((gint64) 0)) {
#line 2050 "SortedList.c"
		gpointer* _tmp23_;
		gint _tmp23__length1;
		gpointer* _tmp24_;
		gint _tmp24__length1;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp23_ = array;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp23__length1 = array_length1;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp24_ = scratch;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp24__length1 = scratch_length1;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp25_ = start_index;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp26_ = middle_index;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp27_ = end_index;
#line 407 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		sorted_list_merge (self, _tmp23_, _tmp23__length1, _tmp24_, _tmp24__length1, _tmp25_, _tmp26_, _tmp27_);
#line 2074 "SortedList.c"
	}
}


static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index) {
	gint _tmp0_;
	gint _tmp1_;
	gint count = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint left_start = 0;
	gint _tmp4_;
	gint left_end = 0;
	gint _tmp5_;
	gint right_start = 0;
	gint _tmp6_;
	gint right_end = 0;
	gint _tmp7_;
	gpointer* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	gint scratch_index = 0;
	gint _tmp57_;
	gint _tmp58_;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_if_fail (self != NULL);
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = start_index;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = end_index;
#line 411 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp0_ < _tmp1_, "start_index < end_index");
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = end_index;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp3_ = start_index;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	count = (_tmp2_ - _tmp3_) + 1;
#line 414 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp4_ = start_index;
#line 414 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	left_start = _tmp4_;
#line 415 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp5_ = middle_index;
#line 415 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	left_end = _tmp5_ - 1;
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp6_ = middle_index;
#line 416 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	right_start = _tmp6_;
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp7_ = end_index;
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	right_end = _tmp7_;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8_ = scratch;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp8__length1 = scratch_length1;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp9_ = count;
#line 419 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp8__length1 >= _tmp9_, "scratch.length >= count");
#line 420 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	scratch_index = 0;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	while (TRUE) {
#line 2141 "SortedList.c"
		gboolean _tmp10_ = FALSE;
		gint _tmp11_;
		gint _tmp12_;
		gpointer left = NULL;
		gpointer* _tmp15_;
		gint _tmp15__length1;
		gint _tmp16_;
		gconstpointer _tmp17_;
		gpointer _tmp18_;
		gpointer right = NULL;
		gpointer* _tmp19_;
		gint _tmp19__length1;
		gint _tmp20_;
		gconstpointer _tmp21_;
		gpointer _tmp22_;
		Comparator _tmp23_;
		void* _tmp23__target;
		gconstpointer _tmp24_;
		gconstpointer _tmp25_;
		gint64 _tmp26_;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp11_ = left_start;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp12_ = left_end;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (_tmp11_ <= _tmp12_) {
#line 2168 "SortedList.c"
			gint _tmp13_;
			gint _tmp14_;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp13_ = right_start;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp14_ = right_end;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp10_ = _tmp13_ <= _tmp14_;
#line 2177 "SortedList.c"
		} else {
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp10_ = FALSE;
#line 2181 "SortedList.c"
		}
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (!_tmp10_) {
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			break;
#line 2187 "SortedList.c"
		}
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp15_ = array;
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp15__length1 = array_length1;
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp16_ = left_start;
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp17_ = _tmp15_[_tmp16_];
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp18_ = ((_tmp17_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp17_) : ((gpointer) _tmp17_);
#line 423 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		left = _tmp18_;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp19_ = array;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp19__length1 = array_length1;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp20_ = right_start;
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp21_ = _tmp19_[_tmp20_];
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp22_ = ((_tmp21_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp21_) : ((gpointer) _tmp21_);
#line 424 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		right = _tmp22_;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp23_ = self->priv->cmp;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp23__target = self->priv->cmp_target;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp24_ = left;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp25_ = right;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp26_ = _tmp23_ (_tmp24_, _tmp25_, _tmp23__target);
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (_tmp26_ <= ((gint64) 0)) {
#line 2225 "SortedList.c"
			gpointer* _tmp27_;
			gint _tmp27__length1;
			gint _tmp28_;
			gconstpointer _tmp29_;
			gpointer _tmp30_;
			gpointer _tmp31_;
			gint _tmp32_;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp27_ = scratch;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp27__length1 = scratch_length1;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp28_ = scratch_index;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			scratch_index = _tmp28_ + 1;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp29_ = left;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp30_ = ((_tmp29_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp29_) : ((gpointer) _tmp29_);
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			((_tmp27_[_tmp28_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp27_[_tmp28_] = (self->priv->g_destroy_func (_tmp27_[_tmp28_]), NULL));
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp27_[_tmp28_] = _tmp30_;
#line 427 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp31_ = _tmp27_[_tmp28_];
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp32_ = left_start;
#line 428 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			left_start = _tmp32_ + 1;
#line 2255 "SortedList.c"
		} else {
			gpointer* _tmp33_;
			gint _tmp33__length1;
			gint _tmp34_;
			gconstpointer _tmp35_;
			gpointer _tmp36_;
			gpointer _tmp37_;
			gint _tmp38_;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp33_ = scratch;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp33__length1 = scratch_length1;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp34_ = scratch_index;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			scratch_index = _tmp34_ + 1;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp35_ = right;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp36_ = ((_tmp35_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp35_) : ((gpointer) _tmp35_);
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			((_tmp33_[_tmp34_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp33_[_tmp34_] = (self->priv->g_destroy_func (_tmp33_[_tmp34_]), NULL));
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp33_[_tmp34_] = _tmp36_;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp37_ = _tmp33_[_tmp34_];
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp38_ = right_start;
#line 431 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			right_start = _tmp38_ + 1;
#line 2286 "SortedList.c"
		}
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
#line 2292 "SortedList.c"
	}
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	while (TRUE) {
#line 2296 "SortedList.c"
		gint _tmp39_;
		gint _tmp40_;
		gpointer* _tmp41_;
		gint _tmp41__length1;
		gint _tmp42_;
		gpointer* _tmp43_;
		gint _tmp43__length1;
		gint _tmp44_;
		gconstpointer _tmp45_;
		gpointer _tmp46_;
		gpointer _tmp47_;
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp39_ = left_start;
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp40_ = left_end;
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (!(_tmp39_ <= _tmp40_)) {
#line 435 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			break;
#line 2316 "SortedList.c"
		}
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp41_ = scratch;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp41__length1 = scratch_length1;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp42_ = scratch_index;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		scratch_index = _tmp42_ + 1;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp43_ = array;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp43__length1 = array_length1;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp44_ = left_start;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		left_start = _tmp44_ + 1;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp45_ = _tmp43_[_tmp44_];
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp46_ = ((_tmp45_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp45_) : ((gpointer) _tmp45_);
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((_tmp41_[_tmp42_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp41_[_tmp42_] = (self->priv->g_destroy_func (_tmp41_[_tmp42_]), NULL));
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp41_[_tmp42_] = _tmp46_;
#line 436 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp47_ = _tmp41_[_tmp42_];
#line 2344 "SortedList.c"
	}
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	while (TRUE) {
#line 2348 "SortedList.c"
		gint _tmp48_;
		gint _tmp49_;
		gpointer* _tmp50_;
		gint _tmp50__length1;
		gint _tmp51_;
		gpointer* _tmp52_;
		gint _tmp52__length1;
		gint _tmp53_;
		gconstpointer _tmp54_;
		gpointer _tmp55_;
		gpointer _tmp56_;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp48_ = right_start;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp49_ = right_end;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		if (!(_tmp48_ <= _tmp49_)) {
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			break;
#line 2368 "SortedList.c"
		}
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp50_ = scratch;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp50__length1 = scratch_length1;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp51_ = scratch_index;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		scratch_index = _tmp51_ + 1;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp52_ = array;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp52__length1 = array_length1;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp53_ = right_start;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		right_start = _tmp53_ + 1;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp54_ = _tmp52_[_tmp53_];
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp55_ = ((_tmp54_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp54_) : ((gpointer) _tmp54_);
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		((_tmp50_[_tmp51_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp50_[_tmp51_] = (self->priv->g_destroy_func (_tmp50_[_tmp51_]), NULL));
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp50_[_tmp51_] = _tmp55_;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp56_ = _tmp50_[_tmp51_];
#line 2396 "SortedList.c"
	}
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp57_ = scratch_index;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp58_ = count;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_vala_assert (_tmp57_ == _tmp58_, "scratch_index == count");
#line 443 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	scratch_index = 0;
#line 2406 "SortedList.c"
	{
		gint list_index = 0;
		gint _tmp59_;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		_tmp59_ = start_index;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		list_index = _tmp59_;
#line 2414 "SortedList.c"
		{
			gboolean _tmp60_ = FALSE;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			_tmp60_ = TRUE;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
			while (TRUE) {
#line 2421 "SortedList.c"
				gint _tmp62_;
				gint _tmp63_;
				gpointer* _tmp64_;
				gint _tmp64__length1;
				gint _tmp65_;
				gpointer* _tmp66_;
				gint _tmp66__length1;
				gint _tmp67_;
				gconstpointer _tmp68_;
				gpointer _tmp69_;
				gpointer _tmp70_;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				if (!_tmp60_) {
#line 2435 "SortedList.c"
					gint _tmp61_;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					_tmp61_ = list_index;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					list_index = _tmp61_ + 1;
#line 2441 "SortedList.c"
				}
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp60_ = FALSE;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp62_ = list_index;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp63_ = end_index;
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				if (!(_tmp62_ <= _tmp63_)) {
#line 444 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
					break;
#line 2453 "SortedList.c"
				}
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp64_ = array;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp64__length1 = array_length1;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp65_ = list_index;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp66_ = scratch;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp66__length1 = scratch_length1;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp67_ = scratch_index;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				scratch_index = _tmp67_ + 1;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp68_ = _tmp66_[_tmp67_];
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp69_ = ((_tmp68_ != NULL) && (self->priv->g_dup_func != NULL)) ? self->priv->g_dup_func ((gpointer) _tmp68_) : ((gpointer) _tmp68_);
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				((_tmp64_[_tmp65_] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp64_[_tmp65_] = (self->priv->g_destroy_func (_tmp64_[_tmp65_]), NULL));
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp64_[_tmp65_] = _tmp69_;
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
				_tmp70_ = _tmp64_[_tmp65_];
#line 2479 "SortedList.c"
			}
		}
	}
}


static GType sorted_list_real_get_element_type (GeeTraversable* base) {
	GType result;
	SortedList* self;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = self->priv->g_type;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 2495 "SortedList.c"
}


static gboolean sorted_list_real_get_read_only (GeeCollection* base) {
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_read_only ((GeeAbstractCollection*) _tmp0_);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 2517 "SortedList.c"
}


static gboolean sorted_list_real_get_is_empty (GeeCollection* base) {
	gboolean result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 2539 "SortedList.c"
}


static gint sorted_list_real_get_size (GeeCollection* base) {
	gint result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = _tmp2_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 2561 "SortedList.c"
}


static GeeCollection* sorted_list_real_get_read_only_view (GeeCollection* base) {
	GeeCollection* result;
	SortedList* self;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = (SortedList*) base;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = (GeeCollection*) _tmp2_;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 2583 "SortedList.c"
}


GeeList* sorted_list_get_read_only_view_as_list (SortedList* self) {
	GeeList* result;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp0_ = self->priv->list;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_tmp2_ = _tmp1_;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	result = (GeeList*) _tmp2_;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return result;
#line 2604 "SortedList.c"
}


static void sorted_list_class_init (SortedListClass * klass) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	sorted_list_parent_class = g_type_class_peek_parent (klass);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_type_class_add_private (klass, sizeof (SortedListPrivate));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sorted_list_get_property;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sorted_list_set_property;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE, g_param_spec_gtype ("element-type", "element-type", "element-type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY, g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_IS_EMPTY, g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE, g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW, g_param_spec_object ("read-only-view", "read-only-view", "read-only-view", GEE_TYPE_COLLECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_READ_ONLY_VIEW_AS_LIST, g_param_spec_object ("read-only-view-as-list", "read-only-view-as-list", "read-only-view-as-list", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 2637 "SortedList.c"
}


static GType sorted_list_gee_traversable_get_g_type (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_type;
#line 2644 "SortedList.c"
}


static GBoxedCopyFunc sorted_list_gee_traversable_get_g_dup_func (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_dup_func;
#line 2651 "SortedList.c"
}


static GDestroyNotify sorted_list_gee_traversable_get_g_destroy_func (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_destroy_func;
#line 2658 "SortedList.c"
}


static void sorted_list_gee_traversable_interface_init (GeeTraversableIface * iface) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	sorted_list_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->foreach = (gboolean (*) (GeeTraversable *, GeeForallFunc, void*)) sorted_list_real_foreach;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_type;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_dup_func;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) sorted_list_gee_traversable_get_g_destroy_func;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_element_type = sorted_list_real_get_element_type;
#line 2675 "SortedList.c"
}


static GType sorted_list_gee_iterable_get_g_type (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_type;
#line 2682 "SortedList.c"
}


static GBoxedCopyFunc sorted_list_gee_iterable_get_g_dup_func (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_dup_func;
#line 2689 "SortedList.c"
}


static GDestroyNotify sorted_list_gee_iterable_get_g_destroy_func (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_destroy_func;
#line 2696 "SortedList.c"
}


static void sorted_list_gee_iterable_interface_init (GeeIterableIface * iface) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->iterator = (GeeIterator* (*) (GeeIterable *)) sorted_list_real_iterator;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_type = (GType (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_type;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_dup_func;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) sorted_list_gee_iterable_get_g_destroy_func;
#line 2711 "SortedList.c"
}


static GType sorted_list_gee_collection_get_g_type (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_type;
#line 2718 "SortedList.c"
}


static GBoxedCopyFunc sorted_list_gee_collection_get_g_dup_func (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_dup_func;
#line 2725 "SortedList.c"
}


static GDestroyNotify sorted_list_gee_collection_get_g_destroy_func (SortedList* self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	return self->priv->g_destroy_func;
#line 2732 "SortedList.c"
}


static void sorted_list_gee_collection_interface_init (GeeCollectionIface * iface) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	sorted_list_gee_collection_parent_iface = g_type_interface_peek_parent (iface);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->add = (gboolean (*) (GeeCollection *, gconstpointer)) sorted_list_real_add;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->add_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_add_all;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->clear = (void (*) (GeeCollection *)) sorted_list_real_clear;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->contains = (gboolean (*) (GeeCollection *, gconstpointer)) sorted_list_real_contains;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->contains_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_contains_all;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->remove = (gboolean (*) (GeeCollection *, gconstpointer)) sorted_list_real_remove;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->remove_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_remove_all;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->retain_all = (gboolean (*) (GeeCollection *, GeeCollection*)) sorted_list_real_retain_all;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->to_array = (gpointer* (*) (GeeCollection *, int*)) sorted_list_real_to_array;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_type = (GType (*) (GeeCollection *)) sorted_list_gee_collection_get_g_type;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeCollection *)) sorted_list_gee_collection_get_g_dup_func;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeCollection *)) sorted_list_gee_collection_get_g_destroy_func;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_read_only = sorted_list_real_get_read_only;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_is_empty = sorted_list_real_get_is_empty;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_size = sorted_list_real_get_size;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	iface->get_read_only_view = sorted_list_real_get_read_only_view;
#line 2771 "SortedList.c"
}


static void sorted_list_instance_init (SortedList * self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self->priv = SORTED_LIST_GET_PRIVATE (self);
#line 2778 "SortedList.c"
}


static void sorted_list_finalize (GObject * obj) {
	SortedList * self;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SORTED_LIST, SortedList);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	_g_object_unref0 (self->priv->list);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
#line 2790 "SortedList.c"
}


GType sorted_list_get_type (void) {
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) sorted_list_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_collection_info = { (GInterfaceInitFunc) sorted_list_gee_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_COLLECTION, &gee_collection_info);
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void _vala_sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	switch (property_id) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_ELEMENT_TYPE:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		g_value_set_gtype (value, gee_traversable_get_element_type ((GeeTraversable*) self));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_READ_ONLY:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		g_value_set_boolean (value, gee_collection_get_read_only ((GeeCollection*) self));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_IS_EMPTY:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		g_value_set_boolean (value, gee_collection_get_is_empty ((GeeCollection*) self));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_SIZE:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		g_value_set_int (value, gee_collection_get_size ((GeeCollection*) self));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_VIEW:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		g_value_take_object (value, gee_collection_get_read_only_view ((GeeCollection*) self));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_READ_ONLY_VIEW_AS_LIST:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		g_value_take_object (value, sorted_list_get_read_only_view_as_list (self));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 2853 "SortedList.c"
		default:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 2859 "SortedList.c"
	}
}


static void _vala_sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SORTED_LIST, SortedList);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
	switch (property_id) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_G_TYPE:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		self->priv->g_type = g_value_get_gtype (value);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_G_DUP_FUNC:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		self->priv->g_dup_func = g_value_get_pointer (value);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		case SORTED_LIST_G_DESTROY_FUNC:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		self->priv->g_destroy_func = g_value_get_pointer (value);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 2887 "SortedList.c"
		default:
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/SortedList.vala"
		break;
#line 2893 "SortedList.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



