/* TimedQueue.c generated by valac 0.36.4, the Vala compiler
 * generated from TimedQueue.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* TimedQueue is a specialized collection class.  It holds items in order, but rather than being*/
/* manually dequeued, they are dequeued automatically after a specified amount of time has elapsed*/
/* for that item.  As of today, it's possible the item will be dequeued a bit later than asked*/
/* for, but it will never be early.  Future implementations might tighten up the lateness.*/
/**/
/* The original design was to use a signal to notify when an item has been dequeued, but Vala has*/
/* a bug with passing an unnamed type as a signal parameter:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=628639*/
/**/
/* The rate the items come off the queue can be spaced out.  Note that this can cause items to back*/
/* up.  As of today, TimedQueue makes no effort to combat this.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;
typedef struct _TimedQueuePrivate TimedQueuePrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;

#define TIMED_QUEUE_TYPE_ELEMENT (timed_queue_element_get_type ())
#define TIMED_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement))
#define TIMED_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementClass))
#define TIMED_QUEUE_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TIMED_QUEUE_TYPE_ELEMENT))
#define TIMED_QUEUE_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TIMED_QUEUE_TYPE_ELEMENT))
#define TIMED_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementClass))

typedef struct _TimedQueueElement TimedQueueElement;
typedef struct _TimedQueueElementClass TimedQueueElementClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TimedQueueElementPrivate TimedQueueElementPrivate;
#define _timed_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_element_unref (var), NULL)))
#define _g_destroy_func0(var) (((var == NULL) || (g_destroy_func == NULL)) ? NULL : (var = (g_destroy_func (var), NULL)))
typedef struct _TimedQueueParamSpecElement TimedQueueParamSpecElement;
typedef struct _ParamSpecTimedQueue ParamSpecTimedQueue;
enum  {
	TIMED_QUEUE_PAUSED_SIGNAL,
	TIMED_QUEUE_LAST_SIGNAL
};
static guint timed_queue_signals[TIMED_QUEUE_LAST_SIGNAL] = {0};

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
typedef struct _HashTimedQueuePrivate HashTimedQueuePrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
struct _TimedQueue {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimedQueuePrivate * priv;
};

struct _TimedQueueClass {
	GTypeClass parent_class;
	void (*finalize) (TimedQueue *self);
	void (*notify_dequeued) (TimedQueue* self, gconstpointer item);
	void (*clear) (TimedQueue* self);
	gboolean (*contains) (TimedQueue* self, gconstpointer item);
	gboolean (*enqueue) (TimedQueue* self, gconstpointer item);
	gboolean (*enqueue_many) (TimedQueue* self, GeeCollection* items);
	gboolean (*remove_first) (TimedQueue* self, gconstpointer item);
	void (*paused) (TimedQueue* self, gboolean is_paused);
	gint (*get_size) (TimedQueue* self);
};

struct _TimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	guint hold_msec;
	DequeuedCallback callback;
	gpointer callback_target;
	GeeEqualDataFunc equal_func;
	gpointer equal_func_target;
	GDestroyNotify equal_func_target_destroy_notify;
	gint priority;
	guint timer_id;
	SortedList* queue;
	guint dequeue_spacing_msec;
	gulong last_dequeue;
	gboolean paused_state;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _TimedQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TimedQueueElementPrivate * priv;
	gpointer item;
	gulong ready;
};

struct _TimedQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (TimedQueueElement *self);
};

struct _TimedQueueElementPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
};

struct _TimedQueueParamSpecElement {
	GParamSpec parent_instance;
};

struct _ParamSpecTimedQueue {
	GParamSpec parent_instance;
};

struct _HashTimedQueue {
	TimedQueue parent_instance;
	HashTimedQueuePrivate * priv;
};

struct _HashTimedQueueClass {
	TimedQueueClass parent_class;
};

struct _HashTimedQueuePrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeHashMap* item_count;
};


static gpointer timed_queue_parent_class = NULL;
static gpointer timed_queue_element_parent_class = NULL;
static gpointer hash_timed_queue_parent_class = NULL;

gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_timed_queue (GValue* value, gpointer v_object);
void value_take_timed_queue (GValue* value, gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType sorted_list_get_type (void) G_GNUC_CONST;
static gpointer timed_queue_element_ref (gpointer instance);
static void timed_queue_element_unref (gpointer instance);
static GParamSpec* timed_queue_param_spec_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void timed_queue_value_set_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void timed_queue_value_take_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer timed_queue_value_get_element (const GValue* value) G_GNUC_UNUSED;
static GType timed_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define TIMED_QUEUE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TIMED_QUEUE, TimedQueuePrivate))
enum  {
	TIMED_QUEUE_DUMMY_PROPERTY
};
TimedQueue* timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority);
TimedQueue* timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority);
static gint64 timed_queue_element_comparator (void* a, void* b);
static gint64 _timed_queue_element_comparator_comparator (void* a, void* b, gpointer self);
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
static guint timed_queue_get_heartbeat_timeout (TimedQueue* self);
static gboolean timed_queue_on_heartbeat (TimedQueue* self);
static gboolean _timed_queue_on_heartbeat_gsource_func (gpointer self);
guint timed_queue_get_dequeue_spacing_msec (TimedQueue* self);
void timed_queue_set_dequeue_spacing_msec (TimedQueue* self, guint msec);
void timed_queue_notify_dequeued (TimedQueue* self, gconstpointer item);
static void timed_queue_real_notify_dequeued (TimedQueue* self, gconstpointer item);
gboolean timed_queue_is_paused (TimedQueue* self);
void timed_queue_pause (TimedQueue* self);
void timed_queue_unpause (TimedQueue* self);
void timed_queue_clear (TimedQueue* self);
static void timed_queue_real_clear (TimedQueue* self);
gboolean timed_queue_contains (TimedQueue* self, gconstpointer item);
static gboolean timed_queue_real_contains (TimedQueue* self, gconstpointer item);
gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item);
static gboolean timed_queue_real_enqueue (TimedQueue* self, gconstpointer item);
static gulong timed_queue_calc_ready_time (TimedQueue* self);
static TimedQueueElement* timed_queue_element_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer item, gulong ready);
static TimedQueueElement* timed_queue_element_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer item, gulong ready);
gboolean timed_queue_enqueue_many (TimedQueue* self, GeeCollection* items);
static gboolean timed_queue_real_enqueue_many (TimedQueue* self, GeeCollection* items);
gboolean sorted_list_add_list (SortedList* self, GeeList* items);
gboolean timed_queue_remove_first (TimedQueue* self, gconstpointer item);
static gboolean timed_queue_real_remove_first (TimedQueue* self, gconstpointer item);
gulong now_ms (void);
gpointer sorted_list_get_at (SortedList* self, gint index);
gpointer sorted_list_remove_at (SortedList* self, gint index);
gint timed_queue_get_size (TimedQueue* self);
static void timed_queue_real_paused (TimedQueue* self, gboolean is_paused);
#define TIMED_QUEUE_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElementPrivate))
enum  {
	TIMED_QUEUE_ELEMENT_DUMMY_PROPERTY
};
static void timed_queue_element_finalize (TimedQueueElement * obj);
static void timed_queue_finalize (TimedQueue * obj);
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
#define HASH_TIMED_QUEUE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HASH_TIMED_QUEUE, HashTimedQueuePrivate))
enum  {
	HASH_TIMED_QUEUE_DUMMY_PROPERTY
};
HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeHashDataFunc hash_func, void* hash_func_target, GDestroyNotify hash_func_target_destroy_notify, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeHashDataFunc hash_func, void* hash_func_target, GDestroyNotify hash_func_target_destroy_notify, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority);
static void hash_timed_queue_real_notify_dequeued (TimedQueue* base, gconstpointer item);
static void hash_timed_queue_removed (HashTimedQueue* self, gconstpointer item);
static void hash_timed_queue_real_clear (TimedQueue* base);
static gboolean hash_timed_queue_real_contains (TimedQueue* base, gconstpointer item);
static gboolean hash_timed_queue_real_enqueue (TimedQueue* base, gconstpointer item);
static gboolean hash_timed_queue_real_enqueue_many (TimedQueue* base, GeeCollection* items);
static gboolean hash_timed_queue_real_remove_first (TimedQueue* base, gconstpointer item);
static void hash_timed_queue_finalize (TimedQueue * obj);


static gint64 _timed_queue_element_comparator_comparator (void* a, void* b, gpointer self) {
	gint64 result;
	result = timed_queue_element_comparator (a, b);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 267 "TimedQueue.c"
}


static gboolean _timed_queue_on_heartbeat_gsource_func (gpointer self) {
	gboolean result;
	result = timed_queue_on_heartbeat ((TimedQueue*) self);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 276 "TimedQueue.c"
}


TimedQueue* timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority) {
	TimedQueue* self = NULL;
	guint _tmp0_;
	DequeuedCallback _tmp1_;
	void* _tmp1__target;
	GeeEqualDataFunc _tmp2_;
	void* _tmp2__target;
	gint _tmp7_;
	SortedList* _tmp8_;
	guint _tmp9_;
	gint _tmp10_;
	guint _tmp11_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (TimedQueue*) g_type_create_instance (object_type);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = hold_msec;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->hold_msec = _tmp0_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = callback;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1__target = callback_target;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->callback = _tmp1_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->callback_target = _tmp1__target;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = equal_func;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2__target = equal_func_target;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp2_ != NULL) {
#line 318 "TimedQueue.c"
		GeeEqualDataFunc _tmp3_;
		void* _tmp3__target;
		GDestroyNotify _tmp3__target_destroy_notify;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = equal_func;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3__target = equal_func_target;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3__target_destroy_notify = equal_func_target_destroy_notify;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		equal_func = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		equal_func_target = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		equal_func_target_destroy_notify = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = _tmp3_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp3__target;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp3__target_destroy_notify;
#line 348 "TimedQueue.c"
	} else {
		void* _tmp4_;
		GDestroyNotify _tmp5_;
		GeeEqualDataFunc _tmp6_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp6_ = gee_functions_get_equal_func_for (g_type, &_tmp4_, &_tmp5_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = NULL;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func = (GeeEqualDataFunc) _tmp6_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target = _tmp4_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		self->priv->equal_func_target_destroy_notify = _tmp5_;
#line 369 "TimedQueue.c"
	}
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp7_ = priority;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->priority = _tmp7_;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp8_ = sorted_list_new (TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) timed_queue_element_ref, (GDestroyNotify) timed_queue_element_unref, _timed_queue_element_comparator_comparator, NULL);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->queue = _tmp8_;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp9_ = timed_queue_get_heartbeat_timeout (self);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp10_ = priority;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp11_ = g_timeout_add_full (_tmp10_, _tmp9_, _timed_queue_on_heartbeat_gsource_func, timed_queue_ref (self), timed_queue_unref);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->timer_id = _tmp11_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return self;
#line 399 "TimedQueue.c"
}


TimedQueue* timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return timed_queue_construct (TYPE_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 406 "TimedQueue.c"
}


guint timed_queue_get_dequeue_spacing_msec (TimedQueue* self) {
	guint result = 0U;
	guint _tmp0_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->dequeue_spacing_msec;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp0_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 421 "TimedQueue.c"
}


void timed_queue_set_dequeue_spacing_msec (TimedQueue* self, guint msec) {
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp4_;
	guint _tmp5_;
	gint _tmp6_;
	guint _tmp7_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = msec;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->dequeue_spacing_msec;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_ == _tmp1_) {
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 443 "TimedQueue.c"
	}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = self->priv->timer_id;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp2_ != ((guint) 0)) {
#line 449 "TimedQueue.c"
		guint _tmp3_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = self->priv->timer_id;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_source_remove (_tmp3_);
#line 455 "TimedQueue.c"
	}
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = msec;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = _tmp4_;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5_ = timed_queue_get_heartbeat_timeout (self);
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp6_ = self->priv->priority;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp7_ = g_timeout_add_full (_tmp6_, _tmp5_, _timed_queue_on_heartbeat_gsource_func, timed_queue_ref (self), timed_queue_unref);
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->timer_id = _tmp7_;
#line 469 "TimedQueue.c"
}


static guint timed_queue_get_heartbeat_timeout (TimedQueue* self) {
	guint result = 0U;
	guint _tmp0_ = 0U;
	guint _tmp1_;
	guint _tmp4_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->dequeue_spacing_msec;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 484 "TimedQueue.c"
		guint _tmp2_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = self->priv->hold_msec;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = _tmp2_ / 10;
#line 490 "TimedQueue.c"
	} else {
		guint _tmp3_;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = self->priv->dequeue_spacing_msec;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = _tmp3_ / 2;
#line 497 "TimedQueue.c"
	}
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = CLAMP (_tmp0_, (guint) 10, G_MAXUINT);
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp4_;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 505 "TimedQueue.c"
}


static void timed_queue_real_notify_dequeued (TimedQueue* self, gconstpointer item) {
	DequeuedCallback _tmp0_;
	void* _tmp0__target;
	gconstpointer _tmp1_;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->callback;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0__target = self->priv->callback_target;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = item;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ (_tmp1_, _tmp0__target);
#line 521 "TimedQueue.c"
}


void timed_queue_notify_dequeued (TimedQueue* self, gconstpointer item) {
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_GET_CLASS (self)->notify_dequeued (self, item);
#line 530 "TimedQueue.c"
}


gboolean timed_queue_is_paused (TimedQueue* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp0_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 545 "TimedQueue.c"
}


void timed_queue_pause (TimedQueue* self) {
	gboolean _tmp0_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_) {
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 559 "TimedQueue.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->paused_state = TRUE;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_emit (self, timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL], 0, TRUE);
#line 565 "TimedQueue.c"
}


void timed_queue_unpause (TimedQueue* self) {
	gboolean _tmp0_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!_tmp0_) {
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 579 "TimedQueue.c"
	}
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_emit (self, timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL], 0, FALSE);
#line 585 "TimedQueue.c"
}


static void timed_queue_real_clear (TimedQueue* self) {
	SortedList* _tmp0_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	gee_collection_clear ((GeeCollection*) _tmp0_);
#line 595 "TimedQueue.c"
}


void timed_queue_clear (TimedQueue* self) {
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_GET_CLASS (self)->clear (self);
#line 604 "TimedQueue.c"
}


static gboolean timed_queue_real_contains (TimedQueue* self, gconstpointer item) {
	gboolean result = FALSE;
	{
		GeeIterator* _e_it = NULL;
		SortedList* _tmp0_;
		GeeIterator* _tmp1_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp0_ = self->priv->queue;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_e_it = _tmp1_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 622 "TimedQueue.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_;
			TimedQueueElement* e = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GeeEqualDataFunc _tmp6_;
			void* _tmp6__target;
			gconstpointer _tmp7_;
			TimedQueueElement* _tmp8_;
			gconstpointer _tmp9_;
			gboolean _tmp10_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp2_ = _e_it;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!_tmp3_) {
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 642 "TimedQueue.c"
			}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = _e_it;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			e = (TimedQueueElement*) _tmp5_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = self->priv->equal_func;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6__target = self->priv->equal_func_target;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = item;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp8_ = e;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp9_ = _tmp8_->item;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp10_ = _tmp6_ (_tmp7_, _tmp9_, _tmp6__target);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp10_) {
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				result = TRUE;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (e);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_g_object_unref0 (_e_it);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				return result;
#line 672 "TimedQueue.c"
			}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (e);
#line 676 "TimedQueue.c"
		}
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_g_object_unref0 (_e_it);
#line 680 "TimedQueue.c"
	}
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = FALSE;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 686 "TimedQueue.c"
}


gboolean timed_queue_contains (TimedQueue* self, gconstpointer item) {
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->contains (self, item);
#line 695 "TimedQueue.c"
}


static gboolean timed_queue_real_enqueue (TimedQueue* self, gconstpointer item) {
	gboolean result = FALSE;
	SortedList* _tmp0_;
	gconstpointer _tmp1_;
	gulong _tmp2_;
	TimedQueueElement* _tmp3_;
	TimedQueueElement* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = item;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = timed_queue_calc_ready_time (self);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp1_, _tmp2_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = _tmp3_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5_ = gee_collection_add ((GeeCollection*) _tmp0_, _tmp4_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp6_ = _tmp5_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_timed_queue_element_unref0 (_tmp4_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp6_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 728 "TimedQueue.c"
}


gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->enqueue (self, item);
#line 737 "TimedQueue.c"
}


static gboolean timed_queue_real_enqueue_many (TimedQueue* self, GeeCollection* items) {
	gboolean result = FALSE;
	gulong ready_time = 0UL;
	gulong _tmp0_;
	GeeArrayList* elements = NULL;
	GeeArrayList* _tmp1_;
	SortedList* _tmp13_;
	GeeArrayList* _tmp14_;
	gboolean _tmp15_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (items != NULL, FALSE);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = timed_queue_calc_ready_time (self);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	ready_time = _tmp0_;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = gee_array_list_new (TIMED_QUEUE_TYPE_ELEMENT, (GBoxedCopyFunc) timed_queue_element_ref, (GDestroyNotify) timed_queue_element_unref, NULL, NULL, NULL);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	elements = _tmp1_;
#line 760 "TimedQueue.c"
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = items;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_item_it = _tmp3_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 773 "TimedQueue.c"
			GeeIterator* _tmp4_;
			gboolean _tmp5_;
			gpointer item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeArrayList* _tmp8_;
			gconstpointer _tmp9_;
			gulong _tmp10_;
			TimedQueueElement* _tmp11_;
			TimedQueueElement* _tmp12_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = _item_it;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = gee_iterator_next (_tmp4_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!_tmp5_) {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 792 "TimedQueue.c"
			}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = _item_it;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			item = _tmp7_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp8_ = elements;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp9_ = item;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp10_ = ready_time;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp11_ = timed_queue_element_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, (GDestroyNotify) self->priv->g_destroy_func, _tmp9_, _tmp10_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp12_ = _tmp11_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp12_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (_tmp12_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 816 "TimedQueue.c"
		}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 820 "TimedQueue.c"
	}
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp13_ = self->priv->queue;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp14_ = elements;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp15_ = sorted_list_add_list (_tmp13_, (GeeList*) _tmp14_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp15_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (elements);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 834 "TimedQueue.c"
}


gboolean timed_queue_enqueue_many (TimedQueue* self, GeeCollection* items) {
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->enqueue_many (self, items);
#line 843 "TimedQueue.c"
}


static gboolean timed_queue_real_remove_first (TimedQueue* self, gconstpointer item) {
	gboolean result = FALSE;
	GeeIterator* iter = NULL;
	SortedList* _tmp0_;
	GeeIterator* _tmp1_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	iter = _tmp1_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	while (TRUE) {
#line 860 "TimedQueue.c"
		GeeIterator* _tmp2_;
		gboolean _tmp3_;
		TimedQueueElement* e = NULL;
		GeeIterator* _tmp4_;
		gpointer _tmp5_;
		GeeEqualDataFunc _tmp6_;
		void* _tmp6__target;
		gconstpointer _tmp7_;
		TimedQueueElement* _tmp8_;
		gconstpointer _tmp9_;
		gboolean _tmp10_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = iter;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = gee_iterator_next (_tmp2_);
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (!_tmp3_) {
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			break;
#line 880 "TimedQueue.c"
		}
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp4_ = iter;
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp5_ = gee_iterator_get (_tmp4_);
#line 165 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		e = (TimedQueueElement*) _tmp5_;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp6_ = self->priv->equal_func;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp6__target = self->priv->equal_func_target;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp7_ = item;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp8_ = e;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp9_ = _tmp8_->item;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp10_ = _tmp6_ (_tmp7_, _tmp9_, _tmp6__target);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (_tmp10_) {
#line 902 "TimedQueue.c"
			GeeIterator* _tmp11_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp11_ = iter;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			gee_iterator_remove (_tmp11_);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			result = TRUE;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (e);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_g_object_unref0 (iter);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return result;
#line 916 "TimedQueue.c"
		}
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_timed_queue_element_unref0 (e);
#line 920 "TimedQueue.c"
	}
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = FALSE;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (iter);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 928 "TimedQueue.c"
}


gboolean timed_queue_remove_first (TimedQueue* self, gconstpointer item) {
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->remove_first (self, item);
#line 937 "TimedQueue.c"
}


static gulong timed_queue_calc_ready_time (TimedQueue* self) {
	gulong result = 0UL;
	gulong _tmp0_;
	guint _tmp1_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = now_ms ();
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = self->priv->hold_msec;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp0_ + ((gulong) _tmp1_);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 955 "TimedQueue.c"
}


static gboolean timed_queue_on_heartbeat (TimedQueue* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	gulong now = 0UL;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->paused_state;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_) {
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = TRUE;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 973 "TimedQueue.c"
	}
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	now = (gulong) 0;
#line 977 "TimedQueue.c"
	{
		gboolean _tmp1_ = FALSE;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = TRUE;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 984 "TimedQueue.c"
			SortedList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			TimedQueueElement* head = NULL;
			SortedList* _tmp5_;
			gpointer _tmp6_;
			TimedQueueElement* _tmp7_;
			gulong _tmp8_;
			TimedQueueElement* _tmp10_;
			gulong _tmp11_;
			gulong _tmp12_;
			gboolean _tmp13_ = FALSE;
			guint _tmp14_;
			TimedQueueElement* h = NULL;
			SortedList* _tmp18_;
			gpointer _tmp19_;
			TimedQueueElement* _tmp20_;
			TimedQueueElement* _tmp21_;
			TimedQueueElement* _tmp22_;
			gconstpointer _tmp23_;
			gulong _tmp24_;
			guint _tmp25_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!_tmp1_) {
#line 1009 "TimedQueue.c"
			}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp1_ = FALSE;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp2_ = self->priv->queue;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = _tmp3_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp4_ == 0) {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1023 "TimedQueue.c"
			}
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = self->priv->queue;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = sorted_list_get_at (_tmp5_, 0);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			head = (TimedQueueElement*) _tmp6_;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = head;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_vala_assert (_tmp7_ != NULL, "head != null");
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp8_ = now;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp8_ == ((gulong) 0)) {
#line 1039 "TimedQueue.c"
				gulong _tmp9_;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp9_ = now_ms ();
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				now = _tmp9_;
#line 1045 "TimedQueue.c"
			}
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp10_ = head;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp11_ = _tmp10_->ready;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp12_ = now;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp11_ > _tmp12_) {
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1059 "TimedQueue.c"
			}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp14_ = self->priv->dequeue_spacing_msec;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp14_ != ((guint) 0)) {
#line 1065 "TimedQueue.c"
				gulong _tmp15_;
				gulong _tmp16_;
				guint _tmp17_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp15_ = now;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp16_ = self->priv->last_dequeue;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp17_ = self->priv->dequeue_spacing_msec;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp13_ = (_tmp15_ - _tmp16_) < ((gulong) _tmp17_);
#line 1077 "TimedQueue.c"
			} else {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp13_ = FALSE;
#line 1081 "TimedQueue.c"
			}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp13_) {
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1089 "TimedQueue.c"
			}
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp18_ = self->priv->queue;
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp19_ = sorted_list_remove_at (_tmp18_, 0);
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			h = (TimedQueueElement*) _tmp19_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp20_ = head;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp21_ = h;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_vala_assert (_tmp20_ == _tmp21_, "head == h");
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp22_ = head;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp23_ = _tmp22_->item;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			timed_queue_notify_dequeued (self, _tmp23_);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp24_ = now;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			self->priv->last_dequeue = _tmp24_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp25_ = self->priv->dequeue_spacing_msec;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp25_ != ((guint) 0)) {
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (h);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_timed_queue_element_unref0 (head);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 1123 "TimedQueue.c"
			}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (h);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_timed_queue_element_unref0 (head);
#line 1129 "TimedQueue.c"
		}
	}
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1136 "TimedQueue.c"
}


gint timed_queue_get_size (TimedQueue* self) {
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return TIMED_QUEUE_GET_CLASS (self)->get_size (self);
#line 1145 "TimedQueue.c"
}


static gint timed_queue_real_get_size (TimedQueue* base) {
	gint result;
	TimedQueue* self;
	SortedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = base;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->queue;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = _tmp1_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp2_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1167 "TimedQueue.c"
}


static void timed_queue_real_paused (TimedQueue* self, gboolean is_paused) {
}


static TimedQueueElement* timed_queue_element_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer item, gulong ready) {
	TimedQueueElement* self = NULL;
	gconstpointer _tmp0_;
	gpointer _tmp1_;
	gulong _tmp2_;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (TimedQueueElement*) g_type_create_instance (object_type);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = item;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = ((_tmp0_ != NULL) && (g_dup_func != NULL)) ? g_dup_func ((gpointer) _tmp0_) : ((gpointer) _tmp0_);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_destroy_func0 (self->item);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->item = _tmp1_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = ready;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->ready = _tmp2_;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return self;
#line 1202 "TimedQueue.c"
}


static TimedQueueElement* timed_queue_element_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer item, gulong ready) {
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return timed_queue_element_construct (TIMED_QUEUE_TYPE_ELEMENT, g_type, g_dup_func, g_destroy_func, item, ready);
#line 1209 "TimedQueue.c"
}


static gint64 timed_queue_element_comparator (void* a, void* b) {
	gint64 result = 0LL;
	void* _tmp0_;
	gulong _tmp1_;
	void* _tmp2_;
	gulong _tmp3_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = a;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = ((TimedQueueElement*) _tmp0_)->ready;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = b;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = ((TimedQueueElement*) _tmp2_)->ready;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = ((gint64) _tmp1_) - ((gint64) _tmp3_);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1231 "TimedQueue.c"
}


static void timed_queue_value_element_init (GValue* value) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1238 "TimedQueue.c"
}


static void timed_queue_value_element_free_value (GValue* value) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_unref (value->data[0].v_pointer);
#line 1247 "TimedQueue.c"
	}
}


static void timed_queue_value_element_copy_value (const GValue* src_value, GValue* dest_value) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = timed_queue_element_ref (src_value->data[0].v_pointer);
#line 1257 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1261 "TimedQueue.c"
	}
}


static gpointer timed_queue_value_element_peek_pointer (const GValue* value) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1269 "TimedQueue.c"
}


static gchar* timed_queue_value_element_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1276 "TimedQueue.c"
		TimedQueueElement * object;
		object = collect_values[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1283 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1287 "TimedQueue.c"
		}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = timed_queue_element_ref (object);
#line 1291 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1295 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1299 "TimedQueue.c"
}


static gchar* timed_queue_value_element_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TimedQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!object_p) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1310 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = NULL;
#line 1316 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1320 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = timed_queue_element_ref (value->data[0].v_pointer);
#line 1324 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1328 "TimedQueue.c"
}


static GParamSpec* timed_queue_param_spec_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	TimedQueueParamSpecElement* spec;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1342 "TimedQueue.c"
}


static gpointer timed_queue_value_get_element (const GValue* value) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT), NULL);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1351 "TimedQueue.c"
}


static void timed_queue_value_set_element (GValue* value, gpointer v_object) {
	TimedQueueElement * old;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_ref (value->data[0].v_pointer);
#line 1371 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1375 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_unref (old);
#line 1381 "TimedQueue.c"
	}
}


static void timed_queue_value_take_element (GValue* value, gpointer v_object) {
	TimedQueueElement * old;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TIMED_QUEUE_TYPE_ELEMENT));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1400 "TimedQueue.c"
	} else {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1404 "TimedQueue.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_element_unref (old);
#line 1410 "TimedQueue.c"
	}
}


static void timed_queue_element_class_init (TimedQueueElementClass * klass) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	timed_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueElementClass *) klass)->finalize = timed_queue_element_finalize;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_type_class_add_private (klass, sizeof (TimedQueueElementPrivate));
#line 1422 "TimedQueue.c"
}


static void timed_queue_element_instance_init (TimedQueueElement * self) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv = TIMED_QUEUE_ELEMENT_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->ref_count = 1;
#line 1431 "TimedQueue.c"
}


static void timed_queue_element_finalize (TimedQueueElement * obj) {
	TimedQueueElement * self;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TIMED_QUEUE_TYPE_ELEMENT, TimedQueueElement);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((self->item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (self->item = (self->priv->g_destroy_func (self->item), NULL));
#line 1443 "TimedQueue.c"
}


static GType timed_queue_element_get_type (void) {
	static volatile gsize timed_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&timed_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { timed_queue_value_element_init, timed_queue_value_element_free_value, timed_queue_value_element_copy_value, timed_queue_value_element_peek_pointer, "p", timed_queue_value_element_collect_value, "p", timed_queue_value_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TimedQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timed_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimedQueueElement), 0, (GInstanceInitFunc) timed_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType timed_queue_element_type_id;
		timed_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimedQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&timed_queue_element_type_id__volatile, timed_queue_element_type_id);
	}
	return timed_queue_element_type_id__volatile;
}


static gpointer timed_queue_element_ref (gpointer instance) {
	TimedQueueElement * self;
	self = instance;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return instance;
#line 1468 "TimedQueue.c"
}


static void timed_queue_element_unref (gpointer instance) {
	TimedQueueElement * self;
	self = instance;
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		TIMED_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1481 "TimedQueue.c"
	}
}


static void value_timed_queue_init (GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	value->data[0].v_pointer = NULL;
#line 1489 "TimedQueue.c"
}


static void value_timed_queue_free_value (GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_unref (value->data[0].v_pointer);
#line 1498 "TimedQueue.c"
	}
}


static void value_timed_queue_copy_value (const GValue* src_value, GValue* dest_value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = timed_queue_ref (src_value->data[0].v_pointer);
#line 1508 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1512 "TimedQueue.c"
	}
}


static gpointer value_timed_queue_peek_pointer (const GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1520 "TimedQueue.c"
}


static gchar* value_timed_queue_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (collect_values[0].v_pointer) {
#line 1527 "TimedQueue.c"
		TimedQueue * object;
		object = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1534 "TimedQueue.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1538 "TimedQueue.c"
		}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = timed_queue_ref (object);
#line 1542 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1546 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1550 "TimedQueue.c"
}


static gchar* value_timed_queue_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TimedQueue ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!object_p) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1561 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = NULL;
#line 1567 "TimedQueue.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = value->data[0].v_pointer;
#line 1571 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		*object_p = timed_queue_ref (value->data[0].v_pointer);
#line 1575 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return NULL;
#line 1579 "TimedQueue.c"
}


GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTimedQueue* spec;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TIMED_QUEUE), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return G_PARAM_SPEC (spec);
#line 1593 "TimedQueue.c"
}


gpointer value_get_timed_queue (const GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return value->data[0].v_pointer;
#line 1602 "TimedQueue.c"
}


void value_set_timed_queue (GValue* value, gpointer v_object) {
	TimedQueue * old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_ref (value->data[0].v_pointer);
#line 1622 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1626 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_unref (old);
#line 1632 "TimedQueue.c"
	}
}


void value_take_timed_queue (GValue* value, gpointer v_object) {
	TimedQueue * old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TIMED_QUEUE));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = v_object;
#line 1651 "TimedQueue.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		value->data[0].v_pointer = NULL;
#line 1655 "TimedQueue.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		timed_queue_unref (old);
#line 1661 "TimedQueue.c"
	}
}


static void timed_queue_class_init (TimedQueueClass * klass) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->finalize = timed_queue_finalize;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_type_class_add_private (klass, sizeof (TimedQueuePrivate));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->notify_dequeued = (void (*) (TimedQueue *, gconstpointer)) timed_queue_real_notify_dequeued;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->clear = (void (*) (TimedQueue *)) timed_queue_real_clear;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->contains = (gboolean (*) (TimedQueue *, gconstpointer)) timed_queue_real_contains;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue = (gboolean (*) (TimedQueue *, gconstpointer)) timed_queue_real_enqueue;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue_many = (gboolean (*) (TimedQueue *, GeeCollection*)) timed_queue_real_enqueue_many;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->remove_first = (gboolean (*) (TimedQueue *, gconstpointer)) timed_queue_real_remove_first;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->paused = timed_queue_real_paused;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (klass)->get_size = timed_queue_real_get_size;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	timed_queue_signals[TIMED_QUEUE_PAUSED_SIGNAL] = g_signal_new ("paused", TYPE_TIMED_QUEUE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (TimedQueueClass, paused), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 1691 "TimedQueue.c"
}


static void timed_queue_instance_init (TimedQueue * self) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv = TIMED_QUEUE_GET_PRIVATE (self);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->timer_id = (guint) 0;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->dequeue_spacing_msec = (guint) 0;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->last_dequeue = (gulong) 0;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->paused_state = FALSE;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->ref_count = 1;
#line 1708 "TimedQueue.c"
}


static void timed_queue_finalize (TimedQueue * obj) {
	TimedQueue * self;
	guint _tmp0_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMED_QUEUE, TimedQueue);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_signal_handlers_destroy (self);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->timer_id;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 1723 "TimedQueue.c"
		guint _tmp1_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp1_ = self->priv->timer_id;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_source_remove (_tmp1_);
#line 1729 "TimedQueue.c"
	}
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(self->priv->equal_func_target_destroy_notify == NULL) ? NULL : (self->priv->equal_func_target_destroy_notify (self->priv->equal_func_target), NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->equal_func = NULL;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->equal_func_target = NULL;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->equal_func_target_destroy_notify = NULL;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->queue);
#line 1741 "TimedQueue.c"
}


GType timed_queue_get_type (void) {
	static volatile gsize timed_queue_type_id__volatile = 0;
	if (g_once_init_enter (&timed_queue_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_timed_queue_init, value_timed_queue_free_value, value_timed_queue_copy_value, value_timed_queue_peek_pointer, "p", value_timed_queue_collect_value, "p", value_timed_queue_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimedQueue), 0, (GInstanceInitFunc) timed_queue_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType timed_queue_type_id;
		timed_queue_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TimedQueue", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&timed_queue_type_id__volatile, timed_queue_type_id);
	}
	return timed_queue_type_id__volatile;
}


gpointer timed_queue_ref (gpointer instance) {
	TimedQueue * self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return instance;
#line 1766 "TimedQueue.c"
}


void timed_queue_unref (gpointer instance) {
	TimedQueue * self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		TIMED_QUEUE_GET_CLASS (self)->finalize (self);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1779 "TimedQueue.c"
	}
}


HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeHashDataFunc hash_func, void* hash_func_target, GDestroyNotify hash_func_target_destroy_notify, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority) {
	HashTimedQueue* self = NULL;
	guint _tmp0_;
	DequeuedCallback _tmp1_;
	void* _tmp1__target;
	GeeEqualDataFunc _tmp2_;
	void* _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	gint _tmp3_;
	GeeHashDataFunc _tmp4_;
	void* _tmp4__target;
	GDestroyNotify _tmp4__target_destroy_notify;
	GeeEqualDataFunc _tmp5_;
	void* _tmp5__target;
	GDestroyNotify _tmp5__target_destroy_notify;
	GeeHashMap* _tmp6_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = hold_msec;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = callback;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1__target = callback_target;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = equal_func;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2__target = equal_func_target;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2__target_destroy_notify = equal_func_target_destroy_notify;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = priority;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) timed_queue_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, _tmp0_, _tmp1_, _tmp1__target, _tmp2_, _tmp2__target, _tmp2__target_destroy_notify, _tmp3_);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_type = g_type;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_dup_func = g_dup_func;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = hash_func;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4__target = hash_func_target;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4__target_destroy_notify = hash_func_target_destroy_notify;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5_ = equal_func;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5__target = equal_func_target;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5__target_destroy_notify = equal_func_target_destroy_notify;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp6_ = gee_hash_map_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func, G_TYPE_INT, NULL, NULL, _tmp4_, _tmp4__target, _tmp4__target_destroy_notify, _tmp5_, _tmp5__target, _tmp5__target_destroy_notify, NULL, NULL, NULL);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv->item_count = _tmp6_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(hash_func_target_destroy_notify == NULL) ? NULL : (hash_func_target_destroy_notify (hash_func_target), NULL);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_func_target_destroy_notify = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	(equal_func_target_destroy_notify == NULL) ? NULL : (equal_func_target_destroy_notify (equal_func_target), NULL);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	equal_func_target_destroy_notify = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return self;
#line 1876 "TimedQueue.c"
}


HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GeeHashDataFunc hash_func, void* hash_func_target, GDestroyNotify hash_func_target_destroy_notify, GeeEqualDataFunc equal_func, void* equal_func_target, GDestroyNotify equal_func_target_destroy_notify, gint priority) {
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return hash_timed_queue_construct (TYPE_HASH_TIMED_QUEUE, g_type, g_dup_func, g_destroy_func, hold_msec, callback, callback_target, hash_func, hash_func_target, hash_func_target_destroy_notify, equal_func, equal_func_target, equal_func_target_destroy_notify, priority);
#line 1883 "TimedQueue.c"
}


static void hash_timed_queue_real_notify_dequeued (TimedQueue* base, gconstpointer item) {
	HashTimedQueue * self;
	gconstpointer _tmp0_;
	gconstpointer _tmp1_;
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = item;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_timed_queue_removed (self, _tmp0_);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = item;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->notify_dequeued (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), _tmp1_);
#line 1901 "TimedQueue.c"
}


static void hash_timed_queue_real_clear (TimedQueue* base) {
	HashTimedQueue * self;
	GeeHashMap* _tmp0_;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue));
#line 1916 "TimedQueue.c"
}


static gboolean hash_timed_queue_real_contains (TimedQueue* base, gconstpointer item) {
	HashTimedQueue * self;
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = item;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = _tmp2_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 1938 "TimedQueue.c"
}


static gboolean hash_timed_queue_real_enqueue (TimedQueue* base, gconstpointer item) {
	HashTimedQueue * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_ = 0;
	GeeHashMap* _tmp3_;
	gconstpointer _tmp4_;
	gboolean _tmp5_;
	GeeHashMap* _tmp9_;
	gconstpointer _tmp10_;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = item;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->enqueue (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), _tmp0_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!_tmp1_) {
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = FALSE;
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 1965 "TimedQueue.c"
	}
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = self->priv->item_count;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = item;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp5_) {
#line 1975 "TimedQueue.c"
		GeeHashMap* _tmp6_;
		gconstpointer _tmp7_;
		gpointer _tmp8_;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp6_ = self->priv->item_count;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp7_ = item;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = ((gint) ((gintptr) _tmp8_)) + 1;
#line 1987 "TimedQueue.c"
	} else {
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = 1;
#line 1991 "TimedQueue.c"
	}
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp9_ = self->priv->item_count;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp10_ = item;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, (gpointer) ((gintptr) _tmp2_));
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 260 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2003 "TimedQueue.c"
}


static gboolean hash_timed_queue_real_enqueue_many (TimedQueue* base, GeeCollection* items) {
	HashTimedQueue * self;
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
	gboolean _tmp1_;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_val_if_fail (items != NULL, FALSE);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = items;
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->enqueue_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), _tmp0_);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!_tmp1_) {
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = FALSE;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 2026 "TimedQueue.c"
	}
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp2_ = items;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_item_it = _tmp3_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		while (TRUE) {
#line 2040 "TimedQueue.c"
			GeeIterator* _tmp4_;
			gboolean _tmp5_;
			gpointer item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			gint _tmp8_ = 0;
			GeeHashMap* _tmp9_;
			gconstpointer _tmp10_;
			gboolean _tmp11_;
			GeeHashMap* _tmp15_;
			gconstpointer _tmp16_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp4_ = _item_it;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp5_ = gee_iterator_next (_tmp4_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (!_tmp5_) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				break;
#line 2060 "TimedQueue.c"
			}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp6_ = _item_it;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			item = _tmp7_;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp9_ = self->priv->item_count;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp10_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp11_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp9_, _tmp10_);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			if (_tmp11_) {
#line 2076 "TimedQueue.c"
				GeeHashMap* _tmp12_;
				gconstpointer _tmp13_;
				gpointer _tmp14_;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp12_ = self->priv->item_count;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp13_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, _tmp13_);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp8_ = ((gint) ((gintptr) _tmp14_)) + 1;
#line 2088 "TimedQueue.c"
			} else {
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
				_tmp8_ = 1;
#line 2092 "TimedQueue.c"
			}
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp15_ = self->priv->item_count;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			_tmp16_ = item;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, (gpointer) ((gintptr) _tmp8_));
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
			((item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (item = (self->priv->g_destroy_func (item), NULL));
#line 2102 "TimedQueue.c"
		}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_g_object_unref0 (_item_it);
#line 2106 "TimedQueue.c"
	}
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2112 "TimedQueue.c"
}


static gboolean hash_timed_queue_real_remove_first (TimedQueue* base, gconstpointer item) {
	HashTimedQueue * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gboolean _tmp1_;
	gconstpointer _tmp2_;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = (HashTimedQueue*) base;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = item;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->remove_first (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMED_QUEUE, TimedQueue), _tmp0_);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!_tmp1_) {
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		result = FALSE;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return result;
#line 2134 "TimedQueue.c"
	}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = item;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_timed_queue_removed (self, _tmp2_);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	result = TRUE;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	return result;
#line 2144 "TimedQueue.c"
}


static void hash_timed_queue_removed (HashTimedQueue* self, gconstpointer item) {
	GeeHashMap* _tmp0_;
	gconstpointer _tmp1_;
	gboolean _tmp2_;
	gint count = 0;
	GeeHashMap* _tmp3_;
	gconstpointer _tmp4_;
	gpointer _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_return_if_fail (self != NULL);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp0_ = self->priv->item_count;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp1_ = item;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (!_tmp2_) {
#line 286 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		return;
#line 2171 "TimedQueue.c"
	}
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp3_ = self->priv->item_count;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp4_ = item;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	count = (gint) ((gintptr) _tmp5_);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp6_ = count;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_vala_assert (_tmp6_ > 0, "count > 0");
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp7_ = count;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	count = _tmp7_ - 1;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_tmp8_ = count;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	if (_tmp8_ == 0) {
#line 2193 "TimedQueue.c"
		GeeHashMap* _tmp9_;
		gconstpointer _tmp10_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp9_ = self->priv->item_count;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp10_ = item;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp9_, _tmp10_, NULL);
#line 2202 "TimedQueue.c"
	} else {
		GeeHashMap* _tmp11_;
		gconstpointer _tmp12_;
		gint _tmp13_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp11_ = self->priv->item_count;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp12_ = item;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		_tmp13_ = count;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, _tmp12_, (gpointer) ((gintptr) _tmp13_));
#line 2215 "TimedQueue.c"
	}
}


static void hash_timed_queue_class_init (HashTimedQueueClass * klass) {
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	hash_timed_queue_parent_class = g_type_class_peek_parent (klass);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->finalize = hash_timed_queue_finalize;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	g_type_class_add_private (klass, sizeof (HashTimedQueuePrivate));
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->notify_dequeued = (void (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_notify_dequeued;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->clear = (void (*) (TimedQueue *)) hash_timed_queue_real_clear;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->contains = (gboolean (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_contains;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue = (gboolean (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_enqueue;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->enqueue_many = (gboolean (*) (TimedQueue *, GeeCollection*)) hash_timed_queue_real_enqueue_many;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	((TimedQueueClass *) klass)->remove_first = (gboolean (*) (TimedQueue *, gconstpointer)) hash_timed_queue_real_remove_first;
#line 2239 "TimedQueue.c"
}


static void hash_timed_queue_instance_init (HashTimedQueue * self) {
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self->priv = HASH_TIMED_QUEUE_GET_PRIVATE (self);
#line 2246 "TimedQueue.c"
}


static void hash_timed_queue_finalize (TimedQueue * obj) {
	HashTimedQueue * self;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HASH_TIMED_QUEUE, HashTimedQueue);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	_g_object_unref0 (self->priv->item_count);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/TimedQueue.vala"
	TIMED_QUEUE_CLASS (hash_timed_queue_parent_class)->finalize (obj);
#line 2258 "TimedQueue.c"
}


GType hash_timed_queue_get_type (void) {
	static volatile gsize hash_timed_queue_type_id__volatile = 0;
	if (g_once_init_enter (&hash_timed_queue_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (HashTimedQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hash_timed_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HashTimedQueue), 0, (GInstanceInitFunc) hash_timed_queue_instance_init, NULL };
		GType hash_timed_queue_type_id;
		hash_timed_queue_type_id = g_type_register_static (TYPE_TIMED_QUEUE, "HashTimedQueue", &g_define_type_info, 0);
		g_once_init_leave (&hash_timed_queue_type_id__volatile, hash_timed_queue_type_id);
	}
	return hash_timed_queue_type_id__volatile;
}



