/* Alteration.c generated by valac 0.36.4, the Vala compiler
 * generated from Alteration.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* Alteration represents a description of what has changed in the DataObject (reported via the*/
/* "altered" signal).  Since the descriptions can vary wildly depending on the semantics of each*/
/* DataObject, no assumptions or requirements are placed on Alteration other than it must have*/
/* one or more "subjects", each with a "detail".  Subscribers to the "altered" signal can query*/
/* the Alteration object to determine if the change is important to them.*/
/**/
/* Alteration is an immutable type.  This means it's possible to store const Alterations of oft-used*/
/* values for reuse.*/
/**/
/* Alterations may be compressed, merging their subjects and details into a new aggregated*/
/* Alteration.  Generally this is handled automatically by DataObject and DataCollection, when*/
/* necessary.*/
/**/
/* NOTE: subjects and details should be ASCII labels (as in, plain-old ASCII, no code pages).*/
/* They are treated as case-sensitive strings.*/
/**/
/* Recommended subjects include: image, thumbnail, metadata.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef struct _AlterationPrivate AlterationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecAlteration ParamSpecAlteration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Alteration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AlterationPrivate * priv;
};

struct _AlterationClass {
	GTypeClass parent_class;
	void (*finalize) (Alteration *self);
};

struct _AlterationPrivate {
	gchar* subject;
	gchar* detail;
	GeeMultiMap* map;
};

struct _ParamSpecAlteration {
	GParamSpec parent_instance;
};


static gpointer alteration_parent_class = NULL;

gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
#define ALTERATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ALTERATION, AlterationPrivate))
enum  {
	ALTERATION_DUMMY_PROPERTY
};
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
static void alteration_add_detail (Alteration* self, const gchar* sub, const gchar* det);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
static Alteration* alteration_new_from_map (GeeMultiMap* map);
static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map);
static GeeMultiMap* alteration_create_map (Alteration* self);
static guint alteration_case_hash (const gchar* a);
static guint _alteration_case_hash_gee_hash_data_func (gconstpointer v, gpointer self);
static gboolean alteration_case_equal (const gchar* a, const gchar* b);
static gboolean _alteration_case_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self);
static inline gboolean alteration_equal_values (const gchar* str1, const gchar* str2);
static inline guint alteration_hash_value (const gchar* str);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
GeeCollection* alteration_get_details (Alteration* self, const gchar* subject);
gchar* alteration_to_string (Alteration* self);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean alteration_equals (Alteration* self, Alteration* other);
static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src);
Alteration* alteration_compress (Alteration* self, Alteration* other);
static void alteration_finalize (Alteration * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail) {
	Alteration* self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (detail != NULL, NULL);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = subject;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = detail;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	alteration_add_detail (self, _tmp0_, _tmp1_);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return self;
#line 152 "Alteration.c"
}


Alteration* alteration_new (const gchar* subject, const gchar* detail) {
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return alteration_construct (TYPE_ALTERATION, subject, detail);
#line 159 "Alteration.c"
}


Alteration* alteration_construct_from_list (GType object_type, const gchar* list) {
	Alteration* self = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar** pairs = NULL;
	const gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint pairs_length1;
	gint _pairs_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp7_;
	gint _tmp7__length1;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = list;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = strlen (_tmp0_);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp2_ = _tmp1_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_return_val_if_fail (_tmp2_ > 0, "list.length > 0", NULL);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp3_ = list;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, ",", 0);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	pairs = _tmp5_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	pairs_length1 = _vala_array_length (_tmp4_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_pairs_size_ = pairs_length1;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp6_ = pairs;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp6__length1 = pairs_length1;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_assert (_tmp6__length1 >= 1, "pairs.length >= 1");
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp7_ = pairs;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp7__length1 = pairs_length1;
#line 210 "Alteration.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		pair_collection = _tmp7_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		pair_collection_length1 = _tmp7__length1;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		for (pair_it = 0; pair_it < _tmp7__length1; pair_it = pair_it + 1) {
#line 222 "Alteration.c"
			gchar* _tmp8_;
			gchar* pair = NULL;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp8_ = g_strdup (pair_collection[pair_it]);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			pair = _tmp8_;
#line 229 "Alteration.c"
			{
				gchar** subject_detail = NULL;
				const gchar* _tmp9_;
				gchar** _tmp10_;
				gchar** _tmp11_;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp9_ = pair;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, ":", 2);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject_detail = _tmp11_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject_detail_length1 = _vala_array_length (_tmp10_);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_subject_detail_size_ = subject_detail_length1;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp12_ = subject_detail;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp12__length1 = subject_detail_length1;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_vala_assert (_tmp12__length1 == 2, "subject_detail.length == 2");
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp13_ = subject_detail;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp13__length1 = subject_detail_length1;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp14_ = _tmp13_[0];
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp15_ = subject_detail;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp15__length1 = subject_detail_length1;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp16_ = _tmp15_[1];
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				alteration_add_detail (self, _tmp14_, _tmp16_);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_free0 (pair);
#line 279 "Alteration.c"
			}
		}
	}
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	pairs = (_vala_array_free (pairs, pairs_length1, (GDestroyNotify) g_free), NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return self;
#line 287 "Alteration.c"
}


Alteration* alteration_new_from_list (const gchar* list) {
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return alteration_construct_from_list (TYPE_ALTERATION, list);
#line 294 "Alteration.c"
}


Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1) {
	Alteration* self = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = array;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0__length1 = array_length1;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_return_val_if_fail (_tmp0__length1 > 0, "array.length > 0", NULL);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = array;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1__length1 = array_length1;
#line 316 "Alteration.c"
	{
		gchar** pair_collection = NULL;
		gint pair_collection_length1 = 0;
		gint _pair_collection_size_ = 0;
		gint pair_it = 0;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		pair_collection = _tmp1_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		pair_collection_length1 = _tmp1__length1;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		for (pair_it = 0; pair_it < _tmp1__length1; pair_it = pair_it + 1) {
#line 328 "Alteration.c"
			gchar* _tmp2_;
			gchar* pair = NULL;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp2_ = g_strdup (pair_collection[pair_it]);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			pair = _tmp2_;
#line 335 "Alteration.c"
			{
				gchar** subject_detail = NULL;
				const gchar* _tmp3_;
				gchar** _tmp4_;
				gchar** _tmp5_;
				gint subject_detail_length1;
				gint _subject_detail_size_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp3_ = pair;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, ":", 2);
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject_detail = _tmp5_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject_detail_length1 = _vala_array_length (_tmp4_);
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_subject_detail_size_ = subject_detail_length1;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp6_ = subject_detail;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp6__length1 = subject_detail_length1;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_vala_assert (_tmp6__length1 == 2, "subject_detail.length == 2");
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp7_ = subject_detail;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp7__length1 = subject_detail_length1;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp8_ = _tmp7_[0];
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp9_ = subject_detail;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp9__length1 = subject_detail_length1;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp10_ = _tmp9_[1];
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				alteration_add_detail (self, _tmp8_, _tmp10_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject_detail = (_vala_array_free (subject_detail, subject_detail_length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_free0 (pair);
#line 385 "Alteration.c"
			}
		}
	}
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return self;
#line 391 "Alteration.c"
}


Alteration* alteration_new_from_array (gchar** array, int array_length1) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return alteration_construct_from_array (TYPE_ALTERATION, array, array_length1);
#line 398 "Alteration.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return self ? g_object_ref (self) : NULL;
#line 405 "Alteration.c"
}


static Alteration* alteration_construct_from_map (GType object_type, GeeMultiMap* map) {
	Alteration* self = NULL;
	GeeMultiMap* _tmp0_;
	GeeMultiMap* _tmp1_;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (map != NULL, NULL);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self = (Alteration*) g_type_create_instance (object_type);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = map;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_object_unref0 (self->priv->map);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self->priv->map = _tmp1_;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return self;
#line 427 "Alteration.c"
}


static Alteration* alteration_new_from_map (GeeMultiMap* map) {
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return alteration_construct_from_map (TYPE_ALTERATION, map);
#line 434 "Alteration.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1234 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1235 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1235 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1236 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1236 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1237 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _result_;
#line 1237 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 457 "Alteration.c"
}


static void alteration_add_detail (Alteration* self, const gchar* sub, const gchar* det) {
	gchar* subject = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* detail = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	GeeMultiMap* _tmp18_;
	const gchar* _tmp20_;
	GeeMultiMap* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (self != NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (sub != NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (det != NULL);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = sub;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	subject = _tmp1_;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp2_ = subject;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp3_ = strlen (_tmp2_);
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp4_ = _tmp3_;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_assert (_tmp4_ > 0, "subject.length > 0");
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp5_ = det;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	detail = _tmp6_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp7_ = detail;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp8_ = strlen (_tmp7_);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp9_ = _tmp8_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_assert (_tmp9_ > 0, "detail.length > 0");
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp11_ = self->priv->subject;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp11_ == NULL) {
#line 519 "Alteration.c"
		GeeMultiMap* _tmp12_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp12_ = self->priv->map;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp10_ = _tmp12_ == NULL;
#line 525 "Alteration.c"
	} else {
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp10_ = FALSE;
#line 529 "Alteration.c"
	}
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp10_) {
#line 533 "Alteration.c"
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp13_ = self->priv->detail;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp13_ == NULL, "this.detail == null");
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp14_ = subject;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (self->priv->subject);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		self->priv->subject = _tmp15_;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp16_ = detail;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (self->priv->detail);
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		self->priv->detail = _tmp17_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (detail);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (subject);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return;
#line 565 "Alteration.c"
	}
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp18_ = self->priv->map;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp18_ == NULL) {
#line 571 "Alteration.c"
		GeeMultiMap* _tmp19_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp19_ = alteration_create_map (self);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (self->priv->map);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		self->priv->map = _tmp19_;
#line 579 "Alteration.c"
	}
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp20_ = self->priv->subject;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp20_ != NULL) {
#line 585 "Alteration.c"
		const gchar* _tmp21_;
		GeeMultiMap* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp21_ = self->priv->detail;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp21_ != NULL, "this.detail != null");
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp22_ = self->priv->map;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp23_ = self->priv->subject;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp24_ = self->priv->detail;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		gee_multi_map_set (_tmp22_, _tmp23_, _tmp24_);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (self->priv->subject);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		self->priv->subject = NULL;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (self->priv->detail);
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		self->priv->detail = NULL;
#line 610 "Alteration.c"
	}
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp25_ = self->priv->map;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp26_ = subject;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp27_ = detail;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	gee_multi_map_set (_tmp25_, _tmp26_, _tmp27_);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_free0 (detail);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_free0 (subject);
#line 624 "Alteration.c"
}


static guint _alteration_case_hash_gee_hash_data_func (gconstpointer v, gpointer self) {
	guint result;
	result = alteration_case_hash ((const gchar*) v);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 633 "Alteration.c"
}


static gboolean _alteration_case_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gboolean result;
	result = alteration_case_equal ((const gchar*) a, (const gchar*) b);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 642 "Alteration.c"
}


static GeeMultiMap* alteration_create_map (Alteration* self) {
	GeeMultiMap* result = NULL;
	GeeHashMultiMap* _tmp0_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _alteration_case_hash_gee_hash_data_func, NULL, NULL, _alteration_case_equal_gee_equal_data_func, NULL, NULL, _alteration_case_hash_gee_hash_data_func, NULL, NULL, _alteration_case_equal_gee_equal_data_func, NULL, NULL);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = (GeeMultiMap*) _tmp0_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 657 "Alteration.c"
}


static gboolean alteration_case_equal (const gchar* a, const gchar* b) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = a;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = b;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp2_ = alteration_equal_values (_tmp0_, _tmp1_);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = _tmp2_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 676 "Alteration.c"
}


static guint alteration_case_hash (const gchar* a) {
	guint result = 0U;
	const gchar* _tmp0_;
	guint _tmp1_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = a;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = alteration_hash_value (_tmp0_);
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = _tmp1_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 692 "Alteration.c"
}


static inline gboolean alteration_equal_values (const gchar* str1, const gchar* str2) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (str1 != NULL, FALSE);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (str2 != NULL, FALSE);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = str1;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = str2;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp2_ = g_ascii_strcasecmp (_tmp0_, _tmp1_);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = _tmp2_ == 0;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 715 "Alteration.c"
}


static inline guint alteration_hash_value (const gchar* str) {
	guint result = 0U;
	GHashFunc _tmp0_;
	const gchar* _tmp1_;
	guint _tmp2_;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = g_str_hash;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = str;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp2_ = _tmp0_ (_tmp1_);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = _tmp2_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 736 "Alteration.c"
}


gboolean alteration_has_subject (Alteration* self, const gchar* subject) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	GeeMultiMap* _tmp4_;
	GeeSet* keys = NULL;
	GeeMultiMap* _tmp5_;
	GeeSet* _tmp6_;
	GeeSet* _tmp7_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = self->priv->subject;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp0_ != NULL) {
#line 756 "Alteration.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gboolean _tmp3_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = self->priv->subject;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = subject;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = alteration_equal_values (_tmp1_, _tmp2_);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp3_;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 770 "Alteration.c"
	}
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp4_ = self->priv->map;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_assert (_tmp4_ != NULL, "map != null");
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp5_ = self->priv->map;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp6_ = gee_multi_map_get_keys (_tmp5_);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	keys = _tmp6_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp7_ = keys;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp7_ != NULL) {
#line 786 "Alteration.c"
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp8_;
			GeeIterator* _tmp9_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp8_ = keys;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_key_it = _tmp9_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			while (TRUE) {
#line 799 "Alteration.c"
				GeeIterator* _tmp10_;
				gboolean _tmp11_;
				gchar* key = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gboolean _tmp16_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp10_ = _key_it;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp11_ = gee_iterator_next (_tmp10_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp11_) {
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					break;
#line 816 "Alteration.c"
				}
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp12_ = _key_it;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				key = (gchar*) _tmp13_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp14_ = key;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp15_ = subject;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp16_ = alteration_equal_values (_tmp14_, _tmp15_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (_tmp16_) {
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					result = TRUE;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (key);
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					return result;
#line 842 "Alteration.c"
				}
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_free0 (key);
#line 846 "Alteration.c"
			}
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (_key_it);
#line 850 "Alteration.c"
		}
	}
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = FALSE;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_object_unref0 (keys);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 859 "Alteration.c"
}


gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GeeMultiMap* _tmp10_;
	GeeCollection* values = NULL;
	GeeMultiMap* _tmp11_;
	const gchar* _tmp12_;
	GeeCollection* _tmp13_;
	GeeCollection* _tmp14_;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (detail != NULL, FALSE);
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = self->priv->subject;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp1_ != NULL) {
#line 883 "Alteration.c"
		const gchar* _tmp2_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = self->priv->detail;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 889 "Alteration.c"
	} else {
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 893 "Alteration.c"
	}
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp0_) {
#line 897 "Alteration.c"
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gboolean _tmp6_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp4_ = self->priv->subject;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp5_ = subject;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp6_ = alteration_equal_values (_tmp4_, _tmp5_);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp6_) {
#line 910 "Alteration.c"
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp7_ = self->priv->detail;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp8_ = detail;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp9_ = alteration_equal_values (_tmp7_, _tmp8_);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp3_ = _tmp9_;
#line 922 "Alteration.c"
		} else {
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp3_ = FALSE;
#line 926 "Alteration.c"
		}
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp3_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 932 "Alteration.c"
	}
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp10_ = self->priv->map;
#line 154 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_assert (_tmp10_ != NULL, "map != null");
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp11_ = self->priv->map;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp12_ = subject;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp13_ = gee_multi_map_get (_tmp11_, _tmp12_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	values = _tmp13_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp14_ = values;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp14_ != NULL) {
#line 950 "Alteration.c"
		{
			GeeIterator* _value_it = NULL;
			GeeCollection* _tmp15_;
			GeeIterator* _tmp16_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp15_ = values;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_value_it = _tmp16_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			while (TRUE) {
#line 963 "Alteration.c"
				GeeIterator* _tmp17_;
				gboolean _tmp18_;
				gchar* value = NULL;
				GeeIterator* _tmp19_;
				gpointer _tmp20_;
				const gchar* _tmp21_;
				const gchar* _tmp22_;
				gboolean _tmp23_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp17_ = _value_it;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp18_ = gee_iterator_next (_tmp17_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp18_) {
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					break;
#line 980 "Alteration.c"
				}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp19_ = _value_it;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp20_ = gee_iterator_get (_tmp19_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				value = (gchar*) _tmp20_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp21_ = value;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp22_ = detail;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp23_ = alteration_equal_values (_tmp21_, _tmp22_);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (_tmp23_) {
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					result = TRUE;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (value);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (_value_it);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					return result;
#line 1006 "Alteration.c"
				}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_free0 (value);
#line 1010 "Alteration.c"
			}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (_value_it);
#line 1014 "Alteration.c"
		}
	}
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = FALSE;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_object_unref0 (values);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 1023 "Alteration.c"
}


GeeCollection* alteration_get_details (Alteration* self, const gchar* subject) {
	GeeCollection* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GeeCollection* _tmp10_ = NULL;
	GeeMultiMap* _tmp11_;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (subject != NULL, NULL);
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp2_ = self->priv->subject;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp2_ != NULL) {
#line 1042 "Alteration.c"
		const gchar* _tmp3_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = self->priv->detail;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 1048 "Alteration.c"
	} else {
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1052 "Alteration.c"
	}
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp1_) {
#line 1056 "Alteration.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gboolean _tmp6_;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp4_ = self->priv->subject;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp5_ = subject;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp6_ = alteration_equal_values (_tmp4_, _tmp5_);
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp0_ = _tmp6_;
#line 1068 "Alteration.c"
	} else {
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp0_ = FALSE;
#line 1072 "Alteration.c"
	}
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp0_) {
#line 1076 "Alteration.c"
		GeeArrayList* details = NULL;
		GeeArrayList* _tmp7_;
		GeeArrayList* _tmp8_;
		const gchar* _tmp9_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp7_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		details = _tmp7_;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp8_ = details;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp9_ = self->priv->detail;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = (GeeCollection*) details;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 1095 "Alteration.c"
	}
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp11_ = self->priv->map;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp11_ != NULL) {
#line 1101 "Alteration.c"
		GeeMultiMap* _tmp12_;
		const gchar* _tmp13_;
		GeeCollection* _tmp14_;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp12_ = self->priv->map;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp13_ = subject;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp14_ = gee_multi_map_get (_tmp12_, _tmp13_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (_tmp10_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp10_ = _tmp14_;
#line 1115 "Alteration.c"
	} else {
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (_tmp10_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp10_ = NULL;
#line 1121 "Alteration.c"
	}
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = _tmp10_;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 1127 "Alteration.c"
}


gchar* alteration_to_string (Alteration* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	GeeMultiMap* _tmp5_;
	gchar* str = NULL;
	gchar* _tmp6_;
#line 177 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = self->priv->subject;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp0_ != NULL) {
#line 1143 "Alteration.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = self->priv->detail;
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp1_ != NULL, "detail != null");
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = self->priv->subject;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = self->priv->detail;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp4_ = g_strdup_printf ("%s:%s", _tmp2_, _tmp3_);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp4_;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 1162 "Alteration.c"
	}
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp5_ = self->priv->map;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_vala_assert (_tmp5_ != NULL, "map != null");
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp6_ = g_strdup ("");
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	str = _tmp6_;
#line 1172 "Alteration.c"
	{
		GeeIterator* _key_it = NULL;
		GeeMultiMap* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp7_ = self->priv->map;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp8_ = gee_multi_map_get_keys (_tmp7_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp9_ = _tmp8_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp11_ = _tmp10_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (_tmp9_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_key_it = _tmp11_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		while (TRUE) {
#line 1196 "Alteration.c"
			GeeIterator* _tmp12_;
			gboolean _tmp13_;
			gchar* key = NULL;
			GeeIterator* _tmp14_;
			gpointer _tmp15_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp12_ = _key_it;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp13_ = gee_iterator_next (_tmp12_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			if (!_tmp13_) {
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				break;
#line 1210 "Alteration.c"
			}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp14_ = _key_it;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp15_ = gee_iterator_get (_tmp14_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			key = (gchar*) _tmp15_;
#line 1218 "Alteration.c"
			{
				GeeIterator* _value_it = NULL;
				GeeMultiMap* _tmp16_;
				const gchar* _tmp17_;
				GeeCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp16_ = self->priv->map;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp17_ = key;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp18_ = gee_multi_map_get (_tmp16_, _tmp17_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp19_ = _tmp18_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp21_ = _tmp20_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (_tmp19_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_value_it = _tmp21_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				while (TRUE) {
#line 1245 "Alteration.c"
					GeeIterator* _tmp22_;
					gboolean _tmp23_;
					gchar* value = NULL;
					GeeIterator* _tmp24_;
					gpointer _tmp25_;
					const gchar* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp22_ = _value_it;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp23_ = gee_iterator_next (_tmp22_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					if (!_tmp23_) {
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						break;
#line 1268 "Alteration.c"
					}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp24_ = _value_it;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp25_ = gee_iterator_get (_tmp24_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					value = (gchar*) _tmp25_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp26_ = str;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp27_ = strlen (_tmp26_);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp28_ = _tmp27_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					if (_tmp28_ != 0) {
#line 1284 "Alteration.c"
						const gchar* _tmp29_;
						gchar* _tmp30_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_tmp29_ = str;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_tmp30_ = g_strconcat (_tmp29_, ", ", NULL);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_g_free0 (str);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						str = _tmp30_;
#line 1295 "Alteration.c"
					}
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp31_ = str;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp32_ = key;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp33_ = value;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp34_ = g_strdup_printf ("%s:%s", _tmp32_, _tmp33_);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp35_ = _tmp34_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp36_ = g_strconcat (_tmp31_, _tmp35_, NULL);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (str);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					str = _tmp36_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (_tmp35_);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (value);
#line 1317 "Alteration.c"
				}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (_value_it);
#line 1321 "Alteration.c"
			}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_free0 (key);
#line 1325 "Alteration.c"
		}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (_key_it);
#line 1329 "Alteration.c"
	}
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = str;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 1335 "Alteration.c"
}


gboolean alteration_contains_any (Alteration* self, Alteration* other) {
	gboolean result = FALSE;
	Alteration* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	GeeMultiMap* _tmp21_;
	gboolean _tmp56_ = FALSE;
	GeeMultiMap* _tmp57_;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = other;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (self == _tmp0_) {
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = TRUE;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 1363 "Alteration.c"
	}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp4_ = self->priv->subject;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp4_ != NULL) {
#line 1369 "Alteration.c"
		Alteration* _tmp5_;
		const gchar* _tmp6_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp5_ = other;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp6_ = _tmp5_->priv->subject;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = _tmp6_ != NULL;
#line 1378 "Alteration.c"
	} else {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = FALSE;
#line 1382 "Alteration.c"
	}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp3_) {
#line 1386 "Alteration.c"
		const gchar* _tmp7_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp7_ = self->priv->detail;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = _tmp7_ != NULL;
#line 1392 "Alteration.c"
	} else {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 1396 "Alteration.c"
	}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp2_) {
#line 1400 "Alteration.c"
		Alteration* _tmp8_;
		const gchar* _tmp9_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp8_ = other;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp9_ = _tmp8_->priv->detail;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = _tmp9_ != NULL;
#line 1409 "Alteration.c"
	} else {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1413 "Alteration.c"
	}
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp1_) {
#line 1417 "Alteration.c"
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		Alteration* _tmp12_;
		const gchar* _tmp13_;
		gboolean _tmp14_;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp11_ = self->priv->subject;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp12_ = other;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp13_ = _tmp12_->priv->subject;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp14_ = alteration_equal_values (_tmp11_, _tmp13_);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp14_) {
#line 1433 "Alteration.c"
			const gchar* _tmp15_;
			Alteration* _tmp16_;
			const gchar* _tmp17_;
			gboolean _tmp18_;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp15_ = self->priv->detail;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp16_ = other;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp17_ = _tmp16_->priv->detail;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp18_ = alteration_equal_values (_tmp15_, _tmp17_);
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp10_ = _tmp18_;
#line 1448 "Alteration.c"
		} else {
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp10_ = FALSE;
#line 1452 "Alteration.c"
		}
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp10_;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 1458 "Alteration.c"
	}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp21_ = self->priv->map;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp21_ != NULL) {
#line 1464 "Alteration.c"
		Alteration* _tmp22_;
		GeeMultiMap* _tmp23_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp22_ = other;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp23_ = _tmp22_->priv->map;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp20_ = _tmp23_ == NULL;
#line 1473 "Alteration.c"
	} else {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp20_ = FALSE;
#line 1477 "Alteration.c"
	}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp20_) {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp19_ = TRUE;
#line 1483 "Alteration.c"
	} else {
		gboolean _tmp24_ = FALSE;
		GeeMultiMap* _tmp25_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp25_ = self->priv->map;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp25_ == NULL) {
#line 1491 "Alteration.c"
			Alteration* _tmp26_;
			GeeMultiMap* _tmp27_;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp26_ = other;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp27_ = _tmp26_->priv->map;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp24_ = _tmp27_ != NULL;
#line 1500 "Alteration.c"
		} else {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp24_ = FALSE;
#line 1504 "Alteration.c"
		}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp19_ = _tmp24_;
#line 1508 "Alteration.c"
	}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp19_) {
#line 1512 "Alteration.c"
		const gchar* _tmp28_ = NULL;
		const gchar* _tmp29_;
		gchar* single_subject = NULL;
		gchar* _tmp33_;
		const gchar* _tmp34_ = NULL;
		const gchar* _tmp35_;
		gchar* single_detail = NULL;
		gchar* _tmp39_;
		GeeMultiMap* _tmp40_ = NULL;
		GeeMultiMap* _tmp41_;
		GeeMultiMap* multimap = NULL;
		GeeMultiMap* _tmp45_;
		gboolean _tmp46_ = FALSE;
		GeeMultiMap* _tmp47_;
		const gchar* _tmp48_;
		gboolean _tmp49_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp29_ = self->priv->subject;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp29_ != NULL) {
#line 1533 "Alteration.c"
			const gchar* _tmp30_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp30_ = self->priv->subject;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp28_ = _tmp30_;
#line 1539 "Alteration.c"
		} else {
			Alteration* _tmp31_;
			const gchar* _tmp32_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp31_ = other;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp32_ = _tmp31_->priv->subject;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp28_ = _tmp32_;
#line 1549 "Alteration.c"
		}
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp33_ = g_strdup (_tmp28_);
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		single_subject = _tmp33_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp35_ = self->priv->detail;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp35_ != NULL) {
#line 1559 "Alteration.c"
			const gchar* _tmp36_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp36_ = self->priv->detail;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp34_ = _tmp36_;
#line 1565 "Alteration.c"
		} else {
			Alteration* _tmp37_;
			const gchar* _tmp38_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp37_ = other;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp38_ = _tmp37_->priv->detail;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp34_ = _tmp38_;
#line 1575 "Alteration.c"
		}
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp39_ = g_strdup (_tmp34_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		single_detail = _tmp39_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp41_ = self->priv->map;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp41_ != NULL) {
#line 1585 "Alteration.c"
			GeeMultiMap* _tmp42_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp42_ = self->priv->map;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp40_ = _tmp42_;
#line 1591 "Alteration.c"
		} else {
			Alteration* _tmp43_;
			GeeMultiMap* _tmp44_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp43_ = other;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp44_ = _tmp43_->priv->map;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp40_ = _tmp44_;
#line 1601 "Alteration.c"
		}
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp45_ = _g_object_ref0 (_tmp40_);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		multimap = _tmp45_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp47_ = multimap;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp48_ = single_subject;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp49_ = gee_multi_map_contains (_tmp47_, _tmp48_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp49_) {
#line 1615 "Alteration.c"
			GeeMultiMap* _tmp50_;
			const gchar* _tmp51_;
			GeeCollection* _tmp52_;
			GeeCollection* _tmp53_;
			const gchar* _tmp54_;
			gboolean _tmp55_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp50_ = self->priv->map;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp51_ = single_subject;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp52_ = gee_multi_map_get (_tmp50_, _tmp51_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp53_ = _tmp52_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp54_ = single_detail;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp55_ = gee_collection_contains (_tmp53_, _tmp54_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp46_ = _tmp55_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (_tmp53_);
#line 1638 "Alteration.c"
		} else {
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp46_ = FALSE;
#line 1642 "Alteration.c"
		}
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp46_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (multimap);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (single_detail);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_free0 (single_subject);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 1654 "Alteration.c"
	}
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp57_ = self->priv->map;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp57_ != NULL) {
#line 1660 "Alteration.c"
		Alteration* _tmp58_;
		GeeMultiMap* _tmp59_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp58_ = other;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp59_ = _tmp58_->priv->map;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp56_ = _tmp59_ != NULL;
#line 1669 "Alteration.c"
	} else {
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp56_ = FALSE;
#line 1673 "Alteration.c"
	}
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp56_) {
#line 1677 "Alteration.c"
		GeeSet* keys = NULL;
		GeeMultiMap* _tmp60_;
		GeeSet* _tmp61_;
		GeeSet* _tmp62_;
		GeeSet* other_keys = NULL;
		Alteration* _tmp63_;
		GeeMultiMap* _tmp64_;
		GeeSet* _tmp65_;
		GeeSet* _tmp66_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp60_ = self->priv->map;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp61_ = gee_multi_map_get_keys (_tmp60_);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		keys = _tmp61_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp62_ = keys;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp62_ != NULL, "keys != null");
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp63_ = other;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp64_ = _tmp63_->priv->map;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp65_ = gee_multi_map_get_keys (_tmp64_);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		other_keys = _tmp65_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp66_ = other_keys;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp66_ != NULL, "other_keys != null");
#line 1709 "Alteration.c"
		{
			GeeIterator* _subject_it = NULL;
			GeeSet* _tmp67_;
			GeeIterator* _tmp68_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp67_ = other_keys;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp68_ = gee_iterable_iterator ((GeeIterable*) _tmp67_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_subject_it = _tmp68_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			while (TRUE) {
#line 1722 "Alteration.c"
				GeeIterator* _tmp69_;
				gboolean _tmp70_;
				gchar* subject = NULL;
				GeeIterator* _tmp71_;
				gpointer _tmp72_;
				GeeSet* _tmp73_;
				const gchar* _tmp74_;
				gboolean _tmp75_;
				GeeCollection* details = NULL;
				GeeMultiMap* _tmp76_;
				const gchar* _tmp77_;
				GeeCollection* _tmp78_;
				GeeCollection* other_details = NULL;
				Alteration* _tmp79_;
				GeeMultiMap* _tmp80_;
				const gchar* _tmp81_;
				GeeCollection* _tmp82_;
				gboolean _tmp83_ = FALSE;
				GeeCollection* _tmp84_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp69_ = _subject_it;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp70_ = gee_iterator_next (_tmp69_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp70_) {
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					break;
#line 1750 "Alteration.c"
				}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp71_ = _subject_it;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp72_ = gee_iterator_get (_tmp71_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				subject = (gchar*) _tmp72_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp73_ = keys;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp74_ = subject;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp75_ = gee_collection_contains ((GeeCollection*) _tmp73_, _tmp74_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp75_) {
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (subject);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					continue;
#line 1770 "Alteration.c"
				}
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp76_ = self->priv->map;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp77_ = subject;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp78_ = gee_multi_map_get (_tmp76_, _tmp77_);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				details = _tmp78_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp79_ = other;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp80_ = _tmp79_->priv->map;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp81_ = subject;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp82_ = gee_multi_map_get (_tmp80_, _tmp81_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				other_details = _tmp82_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp84_ = details;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (_tmp84_ != NULL) {
#line 1794 "Alteration.c"
					GeeCollection* _tmp85_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp85_ = other_details;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp83_ = _tmp85_ != NULL;
#line 1800 "Alteration.c"
				} else {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp83_ = FALSE;
#line 1804 "Alteration.c"
				}
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (_tmp83_) {
#line 1808 "Alteration.c"
					{
						GeeIterator* _detail_it = NULL;
						GeeCollection* _tmp86_;
						GeeIterator* _tmp87_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_tmp86_ = other_details;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_tmp87_ = gee_iterable_iterator ((GeeIterable*) _tmp86_);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_detail_it = _tmp87_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						while (TRUE) {
#line 1821 "Alteration.c"
							GeeIterator* _tmp88_;
							gboolean _tmp89_;
							gchar* detail = NULL;
							GeeIterator* _tmp90_;
							gpointer _tmp91_;
							GeeCollection* _tmp92_;
							const gchar* _tmp93_;
							gboolean _tmp94_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp88_ = _detail_it;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp89_ = gee_iterator_next (_tmp88_);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							if (!_tmp89_) {
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								break;
#line 1838 "Alteration.c"
							}
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp90_ = _detail_it;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp91_ = gee_iterator_get (_tmp90_);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							detail = (gchar*) _tmp91_;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp92_ = details;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp93_ = detail;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_tmp94_ = gee_collection_contains (_tmp92_, _tmp93_);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							if (_tmp94_) {
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								result = TRUE;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_free0 (detail);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_object_unref0 (_detail_it);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_object_unref0 (other_details);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_object_unref0 (details);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_free0 (subject);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_object_unref0 (_subject_it);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_object_unref0 (other_keys);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								_g_object_unref0 (keys);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
								return result;
#line 1874 "Alteration.c"
							}
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
							_g_free0 (detail);
#line 1878 "Alteration.c"
						}
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						_g_object_unref0 (_detail_it);
#line 1882 "Alteration.c"
					}
				}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (other_details);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (details);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_free0 (subject);
#line 1891 "Alteration.c"
			}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (_subject_it);
#line 1895 "Alteration.c"
		}
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (other_keys);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (keys);
#line 1901 "Alteration.c"
	}
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = FALSE;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 1907 "Alteration.c"
}


gboolean alteration_equals (Alteration* self, Alteration* other) {
	gboolean result = FALSE;
	Alteration* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp19_ = FALSE;
	GeeMultiMap* _tmp20_;
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 244 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = other;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (self == _tmp0_) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = TRUE;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 1932 "Alteration.c"
	}
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp4_ = self->priv->subject;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp4_ != NULL) {
#line 1938 "Alteration.c"
		Alteration* _tmp5_;
		const gchar* _tmp6_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp5_ = other;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp6_ = _tmp5_->priv->subject;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = _tmp6_ != NULL;
#line 1947 "Alteration.c"
	} else {
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = FALSE;
#line 1951 "Alteration.c"
	}
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp3_) {
#line 1955 "Alteration.c"
		const gchar* _tmp7_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp7_ = self->priv->detail;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = _tmp7_ != NULL;
#line 1961 "Alteration.c"
	} else {
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = FALSE;
#line 1965 "Alteration.c"
	}
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp2_) {
#line 1969 "Alteration.c"
		Alteration* _tmp8_;
		const gchar* _tmp9_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp8_ = other;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp9_ = _tmp8_->priv->detail;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = _tmp9_ != NULL;
#line 1978 "Alteration.c"
	} else {
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp1_ = FALSE;
#line 1982 "Alteration.c"
	}
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp1_) {
#line 1986 "Alteration.c"
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		Alteration* _tmp12_;
		const gchar* _tmp13_;
		gboolean _tmp14_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp11_ = self->priv->subject;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp12_ = other;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp13_ = _tmp12_->priv->subject;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp14_ = alteration_equal_values (_tmp11_, _tmp13_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp14_) {
#line 2002 "Alteration.c"
			const gchar* _tmp15_;
			Alteration* _tmp16_;
			const gchar* _tmp17_;
			gboolean _tmp18_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp15_ = self->priv->detail;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp16_ = other;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp17_ = _tmp16_->priv->detail;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp18_ = alteration_equal_values (_tmp15_, _tmp17_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp10_ = _tmp18_;
#line 2017 "Alteration.c"
		} else {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp10_ = FALSE;
#line 2021 "Alteration.c"
		}
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp10_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 2027 "Alteration.c"
	}
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp20_ = self->priv->map;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp20_ != NULL) {
#line 2033 "Alteration.c"
		Alteration* _tmp21_;
		GeeMultiMap* _tmp22_;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp21_ = other;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp22_ = _tmp21_->priv->map;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp19_ = _tmp22_ != NULL;
#line 2042 "Alteration.c"
	} else {
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp19_ = FALSE;
#line 2046 "Alteration.c"
	}
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp19_) {
#line 2050 "Alteration.c"
		GeeSet* keys = NULL;
		GeeMultiMap* _tmp23_;
		GeeSet* _tmp24_;
		GeeSet* _tmp25_;
		GeeSet* other_keys = NULL;
		Alteration* _tmp26_;
		GeeMultiMap* _tmp27_;
		GeeSet* _tmp28_;
		GeeSet* _tmp29_;
		GeeSet* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		GeeSet* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		GeeSet* _tmp36_;
		GeeSet* _tmp37_;
		gboolean _tmp38_;
		GeeSet* _tmp39_;
		GeeSet* _tmp40_;
		gboolean _tmp41_;
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp23_ = self->priv->map;
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp24_ = gee_multi_map_get_keys (_tmp23_);
#line 256 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		keys = _tmp24_;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp25_ = keys;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp25_ != NULL, "keys != null");
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp26_ = other;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp27_ = _tmp26_->priv->map;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp28_ = gee_multi_map_get_keys (_tmp27_);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		other_keys = _tmp28_;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp29_ = other_keys;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp29_ != NULL, "other_keys != null");
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp30_ = keys;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp31_ = gee_collection_get_size ((GeeCollection*) _tmp30_);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp32_ = _tmp31_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp33_ = other_keys;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp34_ = gee_collection_get_size ((GeeCollection*) _tmp33_);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp35_ = _tmp34_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (_tmp32_ != _tmp35_) {
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			result = FALSE;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			return result;
#line 2116 "Alteration.c"
		}
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp36_ = keys;
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp37_ = other_keys;
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp38_ = gee_collection_contains_all ((GeeCollection*) _tmp36_, (GeeCollection*) _tmp37_);
#line 264 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (!_tmp38_) {
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			result = FALSE;
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 265 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			return result;
#line 2134 "Alteration.c"
		}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp39_ = other_keys;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp40_ = keys;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp41_ = gee_collection_contains_all ((GeeCollection*) _tmp39_, (GeeCollection*) _tmp40_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (!_tmp41_) {
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			result = FALSE;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (other_keys);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (keys);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			return result;
#line 2152 "Alteration.c"
		}
		{
			GeeIterator* _key_it = NULL;
			GeeSet* _tmp42_;
			GeeIterator* _tmp43_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp42_ = keys;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp43_ = gee_iterable_iterator ((GeeIterable*) _tmp42_);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_key_it = _tmp43_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			while (TRUE) {
#line 2166 "Alteration.c"
				GeeIterator* _tmp44_;
				gboolean _tmp45_;
				gchar* key = NULL;
				GeeIterator* _tmp46_;
				gpointer _tmp47_;
				GeeCollection* values = NULL;
				GeeMultiMap* _tmp48_;
				const gchar* _tmp49_;
				GeeCollection* _tmp50_;
				GeeCollection* other_values = NULL;
				Alteration* _tmp51_;
				GeeMultiMap* _tmp52_;
				const gchar* _tmp53_;
				GeeCollection* _tmp54_;
				GeeCollection* _tmp55_;
				gint _tmp56_;
				gint _tmp57_;
				GeeCollection* _tmp58_;
				gint _tmp59_;
				gint _tmp60_;
				GeeCollection* _tmp61_;
				GeeCollection* _tmp62_;
				gboolean _tmp63_;
				GeeCollection* _tmp64_;
				GeeCollection* _tmp65_;
				gboolean _tmp66_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp44_ = _key_it;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp45_ = gee_iterator_next (_tmp44_);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp45_) {
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					break;
#line 2201 "Alteration.c"
				}
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp46_ = _key_it;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp47_ = gee_iterator_get (_tmp46_);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				key = (gchar*) _tmp47_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp48_ = self->priv->map;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp49_ = key;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp50_ = gee_multi_map_get (_tmp48_, _tmp49_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				values = _tmp50_;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp51_ = other;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp52_ = _tmp51_->priv->map;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp53_ = key;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp54_ = gee_multi_map_get (_tmp52_, _tmp53_);
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				other_values = _tmp54_;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp55_ = values;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp56_ = gee_collection_get_size (_tmp55_);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp57_ = _tmp56_;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp58_ = other_values;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp59_ = gee_collection_get_size (_tmp58_);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp60_ = _tmp59_;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (_tmp57_ != _tmp60_) {
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					result = FALSE;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (key);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					return result;
#line 2257 "Alteration.c"
				}
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp61_ = values;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp62_ = other_values;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp63_ = gee_collection_contains_all (_tmp61_, _tmp62_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp63_) {
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					result = FALSE;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (key);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					return result;
#line 2283 "Alteration.c"
				}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp64_ = other_values;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp65_ = values;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp66_ = gee_collection_contains_all (_tmp64_, _tmp65_);
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				if (!_tmp66_) {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					result = FALSE;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (other_values);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (values);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (key);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (_key_it);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (other_keys);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_object_unref0 (keys);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					return result;
#line 2309 "Alteration.c"
				}
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (other_values);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (values);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_free0 (key);
#line 2317 "Alteration.c"
			}
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (_key_it);
#line 2321 "Alteration.c"
		}
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = TRUE;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (other_keys);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (keys);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 2331 "Alteration.c"
	}
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = FALSE;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 2337 "Alteration.c"
}


static void alteration_multimap_add_all (GeeMultiMap* dest, GeeMultiMap* src) {
	GeeSet* keys = NULL;
	GeeMultiMap* _tmp0_;
	GeeSet* _tmp1_;
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (dest != NULL);
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (src != NULL);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = src;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = gee_multi_map_get_keys (_tmp0_);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	keys = _tmp1_;
#line 2355 "Alteration.c"
	{
		GeeIterator* _key_it = NULL;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = keys;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_key_it = _tmp3_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		while (TRUE) {
#line 2368 "Alteration.c"
			GeeIterator* _tmp4_;
			gboolean _tmp5_;
			gchar* key = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeCollection* values = NULL;
			GeeMultiMap* _tmp8_;
			const gchar* _tmp9_;
			GeeCollection* _tmp10_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp4_ = _key_it;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp5_ = gee_iterator_next (_tmp4_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			if (!_tmp5_) {
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				break;
#line 2386 "Alteration.c"
			}
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp6_ = _key_it;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			key = (gchar*) _tmp7_;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp8_ = src;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp9_ = key;
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_tmp10_ = gee_multi_map_get (_tmp8_, _tmp9_);
#line 296 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			values = _tmp10_;
#line 2402 "Alteration.c"
			{
				GeeIterator* _value_it = NULL;
				GeeCollection* _tmp11_;
				GeeIterator* _tmp12_;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp11_ = values;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_value_it = _tmp12_;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				while (TRUE) {
#line 2415 "Alteration.c"
					GeeIterator* _tmp13_;
					gboolean _tmp14_;
					gchar* value = NULL;
					GeeIterator* _tmp15_;
					gpointer _tmp16_;
					GeeMultiMap* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp13_ = _value_it;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp14_ = gee_iterator_next (_tmp13_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					if (!_tmp14_) {
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
						break;
#line 2432 "Alteration.c"
					}
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp15_ = _value_it;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp16_ = gee_iterator_get (_tmp15_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					value = (gchar*) _tmp16_;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp17_ = dest;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp18_ = key;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_tmp19_ = value;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					gee_multi_map_set (_tmp17_, _tmp18_, _tmp19_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
					_g_free0 (value);
#line 2450 "Alteration.c"
				}
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
				_g_object_unref0 (_value_it);
#line 2454 "Alteration.c"
			}
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_object_unref0 (values);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			_g_free0 (key);
#line 2460 "Alteration.c"
		}
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_g_object_unref0 (_key_it);
#line 2464 "Alteration.c"
	}
#line 292 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_object_unref0 (keys);
#line 2468 "Alteration.c"
}


static gpointer _alteration_ref0 (gpointer self) {
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return self ? alteration_ref (self) : NULL;
#line 2475 "Alteration.c"
}


Alteration* alteration_compress (Alteration* self, Alteration* other) {
	Alteration* result = NULL;
	Alteration* _tmp0_;
	gboolean _tmp1_;
	GeeMultiMap* compressed = NULL;
	GeeMultiMap* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp13_ = FALSE;
	Alteration* _tmp14_;
	const gchar* _tmp15_;
	GeeMultiMap* _tmp28_;
	Alteration* _tmp29_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (other != NULL, NULL);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp0_ = other;
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp1_ = alteration_equals (self, _tmp0_);
#line 305 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp1_) {
#line 2502 "Alteration.c"
		Alteration* _tmp2_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp2_ = _alteration_ref0 (self);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		result = _tmp2_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return result;
#line 2510 "Alteration.c"
	}
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp3_ = alteration_create_map (self);
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	compressed = _tmp3_;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp5_ = self->priv->subject;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp5_ != NULL) {
#line 2520 "Alteration.c"
		const gchar* _tmp6_;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp6_ = self->priv->detail;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp4_ = _tmp6_ != NULL;
#line 2526 "Alteration.c"
	} else {
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp4_ = FALSE;
#line 2530 "Alteration.c"
	}
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp4_) {
#line 2534 "Alteration.c"
		GeeMultiMap* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp7_ = compressed;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp8_ = self->priv->subject;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp9_ = self->priv->detail;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		gee_multi_map_set (_tmp7_, _tmp8_, _tmp9_);
#line 2546 "Alteration.c"
	} else {
		GeeMultiMap* _tmp10_;
		GeeMultiMap* _tmp11_;
		GeeMultiMap* _tmp12_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp10_ = self->priv->map;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp10_ != NULL, "map != null");
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp11_ = compressed;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp12_ = self->priv->map;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		alteration_multimap_add_all (_tmp11_, _tmp12_);
#line 2561 "Alteration.c"
	}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp14_ = other;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp15_ = _tmp14_->priv->subject;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp15_ != NULL) {
#line 2569 "Alteration.c"
		Alteration* _tmp16_;
		const gchar* _tmp17_;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp16_ = other;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp17_ = _tmp16_->priv->detail;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp13_ = _tmp17_ != NULL;
#line 2578 "Alteration.c"
	} else {
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp13_ = FALSE;
#line 2582 "Alteration.c"
	}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (_tmp13_) {
#line 2586 "Alteration.c"
		GeeMultiMap* _tmp18_;
		Alteration* _tmp19_;
		const gchar* _tmp20_;
		Alteration* _tmp21_;
		const gchar* _tmp22_;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp18_ = compressed;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp19_ = other;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp20_ = _tmp19_->priv->subject;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp21_ = other;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp22_ = _tmp21_->priv->detail;
#line 320 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		gee_multi_map_set (_tmp18_, _tmp20_, _tmp22_);
#line 2604 "Alteration.c"
	} else {
		Alteration* _tmp23_;
		GeeMultiMap* _tmp24_;
		GeeMultiMap* _tmp25_;
		Alteration* _tmp26_;
		GeeMultiMap* _tmp27_;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp23_ = other;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp24_ = _tmp23_->priv->map;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_vala_assert (_tmp24_ != NULL, "other.map != null");
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp25_ = compressed;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp26_ = other;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		_tmp27_ = _tmp26_->priv->map;
#line 323 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		alteration_multimap_add_all (_tmp25_, _tmp27_);
#line 2625 "Alteration.c"
	}
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp28_ = compressed;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_tmp29_ = alteration_new_from_map (_tmp28_);
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	result = _tmp29_;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_object_unref0 (compressed);
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return result;
#line 2637 "Alteration.c"
}


static void value_alteration_init (GValue* value) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	value->data[0].v_pointer = NULL;
#line 2644 "Alteration.c"
}


static void value_alteration_free_value (GValue* value) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (value->data[0].v_pointer) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		alteration_unref (value->data[0].v_pointer);
#line 2653 "Alteration.c"
	}
}


static void value_alteration_copy_value (const GValue* src_value, GValue* dest_value) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (src_value->data[0].v_pointer) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		dest_value->data[0].v_pointer = alteration_ref (src_value->data[0].v_pointer);
#line 2663 "Alteration.c"
	} else {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2667 "Alteration.c"
	}
}


static gpointer value_alteration_peek_pointer (const GValue* value) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return value->data[0].v_pointer;
#line 2675 "Alteration.c"
}


static gchar* value_alteration_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (collect_values[0].v_pointer) {
#line 2682 "Alteration.c"
		Alteration * object;
		object = collect_values[0].v_pointer;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		if (object->parent_instance.g_class == NULL) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2689 "Alteration.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2693 "Alteration.c"
		}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		value->data[0].v_pointer = alteration_ref (object);
#line 2697 "Alteration.c"
	} else {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2701 "Alteration.c"
	}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return NULL;
#line 2705 "Alteration.c"
}


static gchar* value_alteration_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Alteration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (!object_p) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2716 "Alteration.c"
	}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (!value->data[0].v_pointer) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		*object_p = NULL;
#line 2722 "Alteration.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		*object_p = value->data[0].v_pointer;
#line 2726 "Alteration.c"
	} else {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		*object_p = alteration_ref (value->data[0].v_pointer);
#line 2730 "Alteration.c"
	}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return NULL;
#line 2734 "Alteration.c"
}


GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAlteration* spec;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ALTERATION), NULL);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return G_PARAM_SPEC (spec);
#line 2748 "Alteration.c"
}


gpointer value_get_alteration (const GValue* value) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION), NULL);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return value->data[0].v_pointer;
#line 2757 "Alteration.c"
}


void value_set_alteration (GValue* value, gpointer v_object) {
	Alteration * old;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	old = value->data[0].v_pointer;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (v_object) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		value->data[0].v_pointer = v_object;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		alteration_ref (value->data[0].v_pointer);
#line 2777 "Alteration.c"
	} else {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2781 "Alteration.c"
	}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (old) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		alteration_unref (old);
#line 2787 "Alteration.c"
	}
}


void value_take_alteration (GValue* value, gpointer v_object) {
	Alteration * old;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ALTERATION));
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	old = value->data[0].v_pointer;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (v_object) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ALTERATION));
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		value->data[0].v_pointer = v_object;
#line 2806 "Alteration.c"
	} else {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		value->data[0].v_pointer = NULL;
#line 2810 "Alteration.c"
	}
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (old) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		alteration_unref (old);
#line 2816 "Alteration.c"
	}
}


static void alteration_class_init (AlterationClass * klass) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	alteration_parent_class = g_type_class_peek_parent (klass);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	((AlterationClass *) klass)->finalize = alteration_finalize;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_type_class_add_private (klass, sizeof (AlterationPrivate));
#line 2828 "Alteration.c"
}


static void alteration_instance_init (Alteration * self) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self->priv = ALTERATION_GET_PRIVATE (self);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self->priv->subject = NULL;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self->priv->detail = NULL;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self->priv->map = NULL;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self->ref_count = 1;
#line 2843 "Alteration.c"
}


static void alteration_finalize (Alteration * obj) {
	Alteration * self;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ALTERATION, Alteration);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_signal_handlers_destroy (self);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_free0 (self->priv->subject);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_free0 (self->priv->detail);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	_g_object_unref0 (self->priv->map);
#line 2859 "Alteration.c"
}


GType alteration_get_type (void) {
	static volatile gsize alteration_type_id__volatile = 0;
	if (g_once_init_enter (&alteration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_alteration_init, value_alteration_free_value, value_alteration_copy_value, value_alteration_peek_pointer, "p", value_alteration_collect_value, "p", value_alteration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AlterationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) alteration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Alteration), 0, (GInstanceInitFunc) alteration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType alteration_type_id;
		alteration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Alteration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&alteration_type_id__volatile, alteration_type_id);
	}
	return alteration_type_id__volatile;
}


gpointer alteration_ref (gpointer instance) {
	Alteration * self;
	self = instance;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	g_atomic_int_inc (&self->ref_count);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	return instance;
#line 2884 "Alteration.c"
}


void alteration_unref (gpointer instance) {
	Alteration * self;
	self = instance;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		ALTERATION_GET_CLASS (self)->finalize (self);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/core/Alteration.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2897 "Alteration.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



