/* DataObject.c generated by valac 0.36.4, the Vala compiler
 * generated from DataObject.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DataObject*/
/**/
/* Object IDs are incremented for each DataObject, and therefore may be used to compare*/
/* creation order.  This behavior may be relied upon elsewhere.  Object IDs may be recycled when*/
/* DataObjects are reconstituted by a proxy.*/
/**/
/* Ordinal IDs are supplied by DataCollections to record the ordering of the object being added*/
/* to the collection.  This value is primarily only used by DataCollection, but may be used*/
/* elsewhere to resolve ordering questions (including stabilizing a sort).*/
/**/
/* Have to inherit from Object due to ContainerSource and this bug:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=615904*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataObjectPrivate {
	gint64 object_id;
	DataCollection* member_of;
	gint64 ordinal;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);

static gpointer data_object_parent_class = NULL;
static gint64 data_object_object_id_generator;
static gint64 data_object_object_id_generator = (gint64) 0;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_OBJECT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_OBJECT, DataObjectPrivate))
enum  {
	DATA_OBJECT_DUMMY_PROPERTY
};
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) -1)
DataObject* data_object_construct (GType object_type, gint64 object_id);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
static void data_object_real_notify_altered (DataObject* self, Alteration* alteration);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_object_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val);
static void data_object_real_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val);
void data_object_notify_collection_property_cleared (DataObject* self, const gchar* name);
static void data_object_real_notify_collection_property_cleared (DataObject* self, const gchar* name);
gchar* data_object_get_name (DataObject* self);
static gchar* data_object_real_get_name (DataObject* self);
gchar* data_object_to_string (DataObject* self);
static gchar* data_object_real_to_string (DataObject* self);
DataCollection* data_object_get_membership (DataObject* self);
gboolean data_object_has_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
void data_object_internal_clear_membership (DataObject* self);
gint64 data_object_internal_get_ordinal (DataObject* self);
gint64 data_object_get_object_id (DataObject* self);
GValue* data_object_get_collection_property (DataObject* self, const gchar* name, GValue* def);
static GValue* _g_value_dup (GValue* self);
GValue* data_collection_get_property (DataCollection* self, const gchar* name);
static void _vala_GValue_free (GValue* self);
void data_object_set_collection_property (DataObject* self, const gchar* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_collection_set_property (DataCollection* self, const gchar* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_clear_collection_property (DataObject* self, const gchar* name);
void data_collection_clear_property (DataCollection* self, const gchar* name);
static void data_object_finalize (GObject * obj);


DataObject* data_object_construct (GType object_type, gint64 object_id) {
	DataObject * self = NULL;
	gint64 _tmp0_ = 0LL;
	gint64 _tmp1_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self = (DataObject*) g_object_new (object_type, NULL);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp1_ = object_id;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	if (_tmp1_ == DATA_OBJECT_INVALID_OBJECT_ID) {
#line 170 "DataObject.c"
		gint64 _tmp2_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp2_ = data_object_object_id_generator;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		data_object_object_id_generator = _tmp2_ + 1;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp0_ = _tmp2_;
#line 178 "DataObject.c"
	} else {
		gint64 _tmp3_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp3_ = object_id;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp0_ = _tmp3_;
#line 185 "DataObject.c"
	}
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->object_id = _tmp0_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return self;
#line 191 "DataObject.c"
}


static void data_object_real_notify_altered (DataObject* self, Alteration* alteration) {
	DataCollection* _tmp0_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (alteration != NULL);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	if (_tmp0_ != NULL) {
#line 203 "DataObject.c"
		DataCollection* _tmp1_;
		Alteration* _tmp2_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp1_ = self->priv->member_of;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp2_ = alteration;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		data_collection_internal_notify_altered (_tmp1_, self, _tmp2_);
#line 212 "DataObject.c"
	}
}


void data_object_notify_altered (DataObject* self, Alteration* alteration) {
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_altered (self, alteration);
#line 222 "DataObject.c"
}


static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection) {
}


void data_object_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_membership_changed (self, collection);
#line 235 "DataObject.c"
}


static void data_object_real_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val) {
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (name != NULL);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (val != NULL);
#line 244 "DataObject.c"
}


void data_object_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val) {
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_set (self, name, old, val);
#line 253 "DataObject.c"
}


static void data_object_real_notify_collection_property_cleared (DataObject* self, const gchar* name) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (name != NULL);
#line 260 "DataObject.c"
}


void data_object_notify_collection_property_cleared (DataObject* self, const gchar* name) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_cleared (self, name);
#line 269 "DataObject.c"
}


static gchar* data_object_real_get_name (DataObject* self) {
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_critical ("Type `%s' does not implement abstract method `data_object_get_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return NULL;
#line 278 "DataObject.c"
}


gchar* data_object_get_name (DataObject* self) {
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->get_name (self);
#line 287 "DataObject.c"
}


static gchar* data_object_real_to_string (DataObject* self) {
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_critical ("Type `%s' does not implement abstract method `data_object_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return NULL;
#line 296 "DataObject.c"
}


gchar* data_object_to_string (DataObject* self) {
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->to_string (self);
#line 305 "DataObject.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return self ? data_collection_ref (self) : NULL;
#line 312 "DataObject.c"
}


DataCollection* data_object_get_membership (DataObject* self) {
	DataCollection* result = NULL;
	DataCollection* _tmp0_;
	DataCollection* _tmp1_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp1_ = _data_collection_ref0 (_tmp0_);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	result = _tmp1_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return result;
#line 330 "DataObject.c"
}


gboolean data_object_has_membership (DataObject* self) {
	gboolean result = FALSE;
	DataCollection* _tmp0_;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	result = _tmp0_ != NULL;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return result;
#line 345 "DataObject.c"
}


void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal) {
	DataCollection* _tmp0_;
	DataCollection* _tmp1_;
	DataCollection* _tmp2_;
	gint64 _tmp3_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (collection != NULL);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_vala_assert (_tmp0_ == NULL, "member_of == null");
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp1_ = collection;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp2_ = _data_collection_ref0 (_tmp1_);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_data_collection_unref0 (self->priv->member_of);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->member_of = _tmp2_;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp3_ = ordinal;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->ordinal = _tmp3_;
#line 374 "DataObject.c"
}


void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal) {
	DataCollection* _tmp0_;
	gint64 _tmp1_;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_vala_assert (_tmp0_ == NULL, "member_of == null");
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp1_ = ordinal;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->ordinal = _tmp1_;
#line 391 "DataObject.c"
}


void data_object_internal_clear_membership (DataObject* self) {
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_data_collection_unref0 (self->priv->member_of);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->member_of = NULL;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
#line 404 "DataObject.c"
}


inline gint64 data_object_internal_get_ordinal (DataObject* self) {
	gint64 result = 0LL;
	gint64 _tmp0_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->ordinal;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	result = _tmp0_;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return result;
#line 419 "DataObject.c"
}


inline gint64 data_object_get_object_id (DataObject* self) {
	gint64 result = 0LL;
	gint64 _tmp0_;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->object_id;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	result = _tmp0_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return result;
#line 434 "DataObject.c"
}


static GValue* _g_value_dup (GValue* self) {
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 441 "DataObject.c"
}


static gpointer __g_value_dup0 (gpointer self) {
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return self ? _g_value_dup (self) : NULL;
#line 448 "DataObject.c"
}


static void _vala_GValue_free (GValue* self) {
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_value_unset (self);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_free (self);
#line 457 "DataObject.c"
}


GValue* data_object_get_collection_property (DataObject* self, const gchar* name, GValue* def) {
	GValue* result = NULL;
	DataCollection* _tmp0_;
	GValue* _result_ = NULL;
	DataCollection* _tmp3_;
	const gchar* _tmp4_;
	GValue* _tmp5_;
	GValue* _tmp6_ = NULL;
	GValue* _tmp7_;
	GValue* _tmp10_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	if (_tmp0_ == NULL) {
#line 479 "DataObject.c"
		GValue* _tmp1_;
		GValue* _tmp2_;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp1_ = def;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp2_ = __g_value_dup0 (_tmp1_);
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		result = _tmp2_;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		return result;
#line 490 "DataObject.c"
	}
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp3_ = self->priv->member_of;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp4_ = name;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp5_ = data_collection_get_property (_tmp3_, _tmp4_);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_result_ = _tmp5_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp7_ = _result_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	if (_tmp7_ != NULL) {
#line 504 "DataObject.c"
		GValue* _tmp8_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp8_ = _result_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp6_ = _tmp8_;
#line 510 "DataObject.c"
	} else {
		GValue* _tmp9_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp9_ = def;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp6_ = _tmp9_;
#line 517 "DataObject.c"
	}
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp10_ = __g_value_dup0 (_tmp6_);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	result = _tmp10_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	__vala_GValue_free0 (_result_);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	return result;
#line 527 "DataObject.c"
}


void data_object_set_collection_property (DataObject* self, const gchar* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
	DataCollection* _tmp0_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (name != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (val != NULL);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	if (_tmp0_ != NULL) {
#line 543 "DataObject.c"
		DataCollection* _tmp1_;
		const gchar* _tmp2_;
		GValue _tmp3_;
		ValueEqualFunc _tmp4_;
		void* _tmp4__target;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp1_ = self->priv->member_of;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp2_ = name;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp3_ = *val;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp4_ = value_equals;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp4__target = value_equals_target;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		data_collection_set_property (_tmp1_, _tmp2_, &_tmp3_, _tmp4_, _tmp4__target);
#line 561 "DataObject.c"
	}
}


void data_object_clear_collection_property (DataObject* self, const gchar* name) {
	DataCollection* _tmp0_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (self != NULL);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_return_if_fail (name != NULL);
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_tmp0_ = self->priv->member_of;
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	if (_tmp0_ != NULL) {
#line 576 "DataObject.c"
		DataCollection* _tmp1_;
		const gchar* _tmp2_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp1_ = self->priv->member_of;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		_tmp2_ = name;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
		data_collection_clear_property (_tmp1_, _tmp2_);
#line 585 "DataObject.c"
	}
}


static void data_object_class_init (DataObjectClass * klass) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	data_object_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	g_type_class_add_private (klass, sizeof (DataObjectPrivate));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject *, Alteration*)) data_object_real_notify_altered;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	((DataObjectClass *) klass)->notify_membership_changed = (void (*) (DataObject *, DataCollection*)) data_object_real_notify_membership_changed;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	((DataObjectClass *) klass)->notify_collection_property_set = (void (*) (DataObject *, const gchar*, GValue*, GValue*)) data_object_real_notify_collection_property_set;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	((DataObjectClass *) klass)->notify_collection_property_cleared = (void (*) (DataObject *, const gchar*)) data_object_real_notify_collection_property_cleared;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	((DataObjectClass *) klass)->get_name = (gchar* (*) (DataObject *)) data_object_real_get_name;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject *)) data_object_real_to_string;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	G_OBJECT_CLASS (klass)->finalize = data_object_finalize;
#line 609 "DataObject.c"
}


static void data_object_instance_init (DataObject * self) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv = DATA_OBJECT_GET_PRIVATE (self);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->object_id = DATA_OBJECT_INVALID_OBJECT_ID;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->member_of = NULL;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
#line 622 "DataObject.c"
}


static void data_object_finalize (GObject * obj) {
	DataObject * self;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATA_OBJECT, DataObject);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	_data_collection_unref0 (self->priv->member_of);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/core/DataObject.vala"
	G_OBJECT_CLASS (data_object_parent_class)->finalize (obj);
#line 634 "DataObject.c"
}


GType data_object_get_type (void) {
	static volatile gsize data_object_type_id__volatile = 0;
	if (g_once_init_enter (&data_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataObject), 0, (GInstanceInitFunc) data_object_instance_init, NULL };
		GType data_object_type_id;
		data_object_type_id = g_type_register_static (G_TYPE_OBJECT, "DataObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_object_type_id__volatile, data_object_type_id);
	}
	return data_object_type_id__volatile;
}



