/* SourceHoldingTank.c generated by valac 0.36.4, the Vala compiler
 * generated from SourceHoldingTank.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* A SourceHoldingTank is similar to the holding tank used by ContainerSourceCollection, but for*/
/* non-ContainerSources to be held offline from their natural SourceCollection (i.e. PhotoSources*/
/* being held in a trashcan, for example).  It is *not* a DataCollection (important!), but rather*/
/* a signalled collection that moves DataSources to and from their SourceCollection.*/
/**/
/* DataSources can be shuttled from their SourceCollection to the SourceHoldingTank manually*/
/* (via unlink_and_hold) or can be automatically moved by installing a HoldingPredicate.*/
/* Only one HoldingConditional may be installed.  Because of assertions in the methods, it's unwise*/
/* to use more than one method.  add () and add_many () should ONLY be used for DataSources not*/
/* first installed in their SourceCollection (i.e. they're born in the SourceHoldingTank).*/
/**/
/* NOTE: DataSources should never be in more than one SourceHoldingTank.  No tests are performed*/
/* here to verify this.  This is why a filter/predicate method (which could automatically move*/
/* them in as they're altered) is not offered; there's no easy way to keep DataSources from being*/
/* moved into more than one holding tank, or which should have preference.  The CheckToRemove*/
/* predicate is offered only to know when to release them.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_SINGLETON_COLLECTION (singleton_collection_get_type ())
#define SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollection))
#define SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))
#define IS_SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLETON_COLLECTION))
#define IS_SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLETON_COLLECTION))
#define SINGLETON_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))

typedef struct _SingletonCollection SingletonCollection;
typedef struct _SingletonCollectionClass SingletonCollectionClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecSourceHoldingTank ParamSpecSourceHoldingTank;
enum  {
	SOURCE_HOLDING_TANK_CONTENTS_ALTERED_SIGNAL,
	SOURCE_HOLDING_TANK_LAST_SIGNAL
};
static guint source_holding_tank_signals[SOURCE_HOLDING_TANK_LAST_SIGNAL] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _SourceHoldingTankPrivate {
	SourceCollection* sources;
	SourceHoldingTankCheckToKeep check_to_keep;
	gpointer check_to_keep_target;
	DataSet* tank;
	GeeHashSet* relinks;
	GeeHashSet* unlinking;
	gint64 ordinal;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _ParamSpecSourceHoldingTank {
	GParamSpec parent_instance;
};


static gpointer source_holding_tank_parent_class = NULL;

gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
#define SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankPrivate))
enum  {
	SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source);
static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self);
static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
gint source_holding_tank_get_count (SourceHoldingTank* self);
gint data_set_get_count (DataSet* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
GeeList* data_set_get_all (DataSet* self);
gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source);
gboolean data_set_contains (DataSet* self, DataObject* object);
void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink);
GType marker_get_type (void) G_GNUC_CONST;
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
DataObject* data_set_get_at (DataSet* self, gint index);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed);
gboolean data_set_remove_many (DataSet* self, GeeCollection* objects);
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
gboolean data_set_remove (DataSet* self, DataObject* object);
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
GType singleton_collection_get_type (void) G_GNUC_CONST;
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration);
gchar* data_object_to_string (DataObject* self);
gchar* source_holding_tank_to_string (SourceHoldingTank* self);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void source_collection_relink (SourceCollection* self, DataSource* source);
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink);
static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void source_holding_tank_finalize (SourceHoldingTank * obj);


static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_on_source_destroyed ((SourceHoldingTank*) self, source);
#line 297 "SourceHoldingTank.c"
}


static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_on_source_collection_thawed ((SourceHoldingTank*) self);
#line 304 "SourceHoldingTank.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return self ? data_collection_ref (self) : NULL;
#line 311 "SourceHoldingTank.c"
}


SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
	SourceHoldingTank* self = NULL;
	SourceCollection* _tmp0_;
	SourceCollection* _tmp1_;
	SourceHoldingTankCheckToKeep _tmp2_;
	void* _tmp2__target;
	SourceCollection* _tmp3_;
	SourceCollection* _tmp4_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self = (SourceHoldingTank*) g_type_create_instance (object_type);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = sources;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = _data_collection_ref0 (_tmp0_);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_data_collection_unref0 (self->priv->sources);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->sources = _tmp1_;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = check_to_keep;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2__target = check_to_keep_target;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->check_to_keep = _tmp2_;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->check_to_keep_target = _tmp2__target;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp3_ = self->priv->sources;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_connect (_tmp3_, "item-destroyed", (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp4_ = self->priv->sources;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_connect ((DataCollection*) _tmp4_, "thawed", (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return self;
#line 353 "SourceHoldingTank.c"
}


SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return source_holding_tank_construct (TYPE_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target);
#line 360 "SourceHoldingTank.c"
}


static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp8_;
	GeeCollection* _tmp16_;
	GeeCollection* _tmp17_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = added;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp0_ != NULL) {
#line 373 "SourceHoldingTank.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp1_;
			GeeIterator* _tmp2_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp1_ = added;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_source_it = _tmp2_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			while (TRUE) {
#line 386 "SourceHoldingTank.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_;
				DataSource* source = NULL;
				GeeIterator* _tmp5_;
				gpointer _tmp6_;
				DataSource* _tmp7_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp3_ = _source_it;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!_tmp4_) {
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					break;
#line 401 "SourceHoldingTank.c"
				}
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp5_ = _source_it;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				source = (DataSource*) _tmp6_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp7_ = source;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				data_source_notify_held_in_tank (_tmp7_, self);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_g_object_unref0 (source);
#line 415 "SourceHoldingTank.c"
			}
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_g_object_unref0 (_source_it);
#line 419 "SourceHoldingTank.c"
		}
	}
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8_ = removed;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp8_ != NULL) {
#line 426 "SourceHoldingTank.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp9_ = removed;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_source_it = _tmp10_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			while (TRUE) {
#line 439 "SourceHoldingTank.c"
				GeeIterator* _tmp11_;
				gboolean _tmp12_;
				DataSource* source = NULL;
				GeeIterator* _tmp13_;
				gpointer _tmp14_;
				DataSource* _tmp15_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp11_ = _source_it;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp12_ = gee_iterator_next (_tmp11_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!_tmp12_) {
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					break;
#line 454 "SourceHoldingTank.c"
				}
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp13_ = _source_it;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				source = (DataSource*) _tmp14_;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp15_ = source;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				data_source_notify_held_in_tank (_tmp15_, NULL);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_g_object_unref0 (source);
#line 468 "SourceHoldingTank.c"
			}
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_g_object_unref0 (_source_it);
#line 472 "SourceHoldingTank.c"
		}
	}
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp16_ = added;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp17_ = removed;
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_emit (self, source_holding_tank_signals[SOURCE_HOLDING_TANK_CONTENTS_ALTERED_SIGNAL], 0, _tmp16_, _tmp17_);
#line 481 "SourceHoldingTank.c"
}


void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	SOURCE_HOLDING_TANK_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 490 "SourceHoldingTank.c"
}


gint source_holding_tank_get_count (SourceHoldingTank* self) {
	gint result = 0;
	DataSet* _tmp0_;
	gint _tmp1_;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->tank;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	result = _tmp1_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return result;
#line 508 "SourceHoldingTank.c"
}


GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self) {
	GeeCollection* result = NULL;
	DataSet* _tmp0_;
	GeeList* _tmp1_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->tank;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = data_set_get_all (_tmp0_);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return result;
#line 526 "SourceHoldingTank.c"
}


gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	DataSet* _tmp1_;
	DataSource* _tmp2_;
	gboolean _tmp3_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = self->priv->tank;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = source;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp3_ = data_set_contains (_tmp1_, (DataObject*) _tmp2_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp3_) {
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp0_ = TRUE;
#line 550 "SourceHoldingTank.c"
	} else {
		GeeHashSet* _tmp4_;
		DataSource* _tmp5_;
		gboolean _tmp6_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp4_ = self->priv->unlinking;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp5_ = source;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp6_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, _tmp5_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp0_ = _tmp6_;
#line 563 "SourceHoldingTank.c"
	}
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	result = _tmp0_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return result;
#line 569 "SourceHoldingTank.c"
}


void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean added = FALSE;
	DataSet* _tmp11_;
	GeeCollection* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GeeCollection* _tmp15_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (many != NULL);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = many;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = _tmp1_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp2_ == 0) {
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 597 "SourceHoldingTank.c"
	}
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp3_ = many;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_source_it = _tmp4_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		while (TRUE) {
#line 611 "SourceHoldingTank.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_;
			DataSource* source = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			DataSource* _tmp9_;
			gint64 _tmp10_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp5_ = _source_it;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			if (!_tmp6_) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				break;
#line 627 "SourceHoldingTank.c"
			}
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp7_ = _source_it;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			source = (DataSource*) _tmp8_;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp9_ = source;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp10_ = self->priv->ordinal;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			self->priv->ordinal = _tmp10_ + 1;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			data_object_internal_set_ordinal ((DataObject*) _tmp9_, _tmp10_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_g_object_unref0 (source);
#line 645 "SourceHoldingTank.c"
		}
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_g_object_unref0 (_source_it);
#line 649 "SourceHoldingTank.c"
	}
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp11_ = self->priv->tank;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp12_ = many;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp13_ = data_set_add_many (_tmp11_, _tmp12_);
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	added = _tmp13_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp14_ = added;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_vala_assert (_tmp14_, "added");
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp15_ = many;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_notify_contents_altered (self, _tmp15_, NULL);
#line 667 "SourceHoldingTank.c"
}


void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeHashSet* _tmp3_;
	GeeCollection* _tmp4_;
	SourceCollection* _tmp5_;
	SourceCollection* _tmp6_;
	GeeCollection* _tmp7_;
	Marker* _tmp8_;
	Marker* _tmp9_;
	GeeCollection* _tmp10_;
	GeeCollection* _tmp11_;
	gboolean added = FALSE;
	DataSet* _tmp20_;
	GeeCollection* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	GeeHashSet* _tmp24_;
	GeeCollection* _tmp25_;
	GeeCollection* _tmp26_;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (unlink != NULL);
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = unlink;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = _tmp1_;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp2_ == 0) {
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 706 "SourceHoldingTank.c"
	}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp3_ = self->priv->unlinking;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp4_ = unlink;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	gee_collection_add_all ((GeeCollection*) _tmp3_, _tmp4_);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp5_ = self->priv->sources;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp6_ = self->priv->sources;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp7_ = unlink;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8_ = data_collection_mark_many ((DataCollection*) _tmp6_, _tmp7_);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp9_ = _tmp8_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp10_ = source_collection_unlink_marked (_tmp5_, _tmp9_, NULL, NULL);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp11_ = _tmp10_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (_tmp11_);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (_tmp9_);
#line 732 "SourceHoldingTank.c"
	{
		GeeIterator* _source_it = NULL;
		GeeCollection* _tmp12_;
		GeeIterator* _tmp13_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp12_ = unlink;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_source_it = _tmp13_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		while (TRUE) {
#line 745 "SourceHoldingTank.c"
			GeeIterator* _tmp14_;
			gboolean _tmp15_;
			DataSource* source = NULL;
			GeeIterator* _tmp16_;
			gpointer _tmp17_;
			DataSource* _tmp18_;
			gint64 _tmp19_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp14_ = _source_it;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp15_ = gee_iterator_next (_tmp14_);
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			if (!_tmp15_) {
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				break;
#line 761 "SourceHoldingTank.c"
			}
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp16_ = _source_it;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			source = (DataSource*) _tmp17_;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp18_ = source;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp19_ = self->priv->ordinal;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			self->priv->ordinal = _tmp19_ + 1;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			data_object_internal_set_ordinal ((DataObject*) _tmp18_, _tmp19_);
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_g_object_unref0 (source);
#line 779 "SourceHoldingTank.c"
		}
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_g_object_unref0 (_source_it);
#line 783 "SourceHoldingTank.c"
	}
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp20_ = self->priv->tank;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp21_ = unlink;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp22_ = data_set_add_many (_tmp20_, _tmp21_);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	added = _tmp22_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp23_ = added;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_vala_assert (_tmp23_, "added");
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp24_ = self->priv->unlinking;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp25_ = unlink;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp24_, _tmp25_);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp26_ = unlink;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_notify_contents_altered (self, _tmp26_, NULL);
#line 807 "SourceHoldingTank.c"
}


gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
	gboolean result = FALSE;
	gint count = 0;
	DataSet* _tmp0_;
	gint _tmp1_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->tank;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	count = _tmp1_;
#line 826 "SourceHoldingTank.c"
	{
		gint ctr = 0;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		ctr = 0;
#line 831 "SourceHoldingTank.c"
		{
			gboolean _tmp2_ = FALSE;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp2_ = TRUE;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			while (TRUE) {
#line 838 "SourceHoldingTank.c"
				gint _tmp4_;
				gint _tmp5_;
				DataSet* _tmp6_;
				gint _tmp7_;
				DataObject* _tmp8_;
				DataSource* _tmp9_;
				SourceBacklink* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!_tmp2_) {
#line 850 "SourceHoldingTank.c"
					gint _tmp3_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp3_ = ctr;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					ctr = _tmp3_ + 1;
#line 856 "SourceHoldingTank.c"
				}
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp2_ = FALSE;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp4_ = ctr;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp5_ = count;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!(_tmp4_ < _tmp5_)) {
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					break;
#line 868 "SourceHoldingTank.c"
				}
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp6_ = self->priv->tank;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp7_ = ctr;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp8_ = data_set_get_at (_tmp6_, _tmp7_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_SOURCE, DataSource);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp10_ = backlink;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp11_ = data_source_has_backlink (_tmp9_, _tmp10_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp12_ = _tmp11_;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_g_object_unref0 (_tmp9_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (_tmp12_) {
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					result = TRUE;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					return result;
#line 892 "SourceHoldingTank.c"
				}
			}
		}
	}
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	result = FALSE;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return result;
#line 901 "SourceHoldingTank.c"
}


void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
	gint count = 0;
	DataSet* _tmp0_;
	gint _tmp1_;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (backlink != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->tank;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	count = _tmp1_;
#line 919 "SourceHoldingTank.c"
	{
		gint ctr = 0;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		ctr = 0;
#line 924 "SourceHoldingTank.c"
		{
			gboolean _tmp2_ = FALSE;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp2_ = TRUE;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			while (TRUE) {
#line 931 "SourceHoldingTank.c"
				gint _tmp4_;
				gint _tmp5_;
				DataSet* _tmp6_;
				gint _tmp7_;
				DataObject* _tmp8_;
				DataSource* _tmp9_;
				SourceBacklink* _tmp10_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!_tmp2_) {
#line 941 "SourceHoldingTank.c"
					gint _tmp3_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp3_ = ctr;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					ctr = _tmp3_ + 1;
#line 947 "SourceHoldingTank.c"
				}
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp2_ = FALSE;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp4_ = ctr;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp5_ = count;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!(_tmp4_ < _tmp5_)) {
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					break;
#line 959 "SourceHoldingTank.c"
				}
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp6_ = self->priv->tank;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp7_ = ctr;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp8_ = data_set_get_at (_tmp6_, _tmp7_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_SOURCE, DataSource);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp10_ = backlink;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				data_source_remove_backlink (_tmp9_, _tmp10_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_g_object_unref0 (_tmp9_);
#line 975 "SourceHoldingTank.c"
			}
		}
	}
}


void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed) {
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean removed = FALSE;
	DataSet* _tmp3_;
	GeeList* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GeeList* _tmp7_;
	gint count = 0;
	GeeList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (destroy != NULL);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = destroy;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = _tmp1_;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp2_ == 0) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 1010 "SourceHoldingTank.c"
	}
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp3_ = self->priv->tank;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp4_ = destroy;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp5_ = data_set_remove_many (_tmp3_, (GeeCollection*) _tmp4_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	removed = _tmp5_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp6_ = removed;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_vala_assert (_tmp6_, "removed");
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp7_ = destroy;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_notify_contents_altered (self, NULL, (GeeCollection*) _tmp7_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8_ = destroy;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp10_ = _tmp9_;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	count = _tmp10_;
#line 1036 "SourceHoldingTank.c"
	{
		gint ctr = 0;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		ctr = 0;
#line 1041 "SourceHoldingTank.c"
		{
			gboolean _tmp11_ = FALSE;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			_tmp11_ = TRUE;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			while (TRUE) {
#line 1048 "SourceHoldingTank.c"
				gint _tmp13_;
				gint _tmp14_;
				DataSource* source = NULL;
				GeeList* _tmp15_;
				gint _tmp16_;
				gpointer _tmp17_;
				DataSource* _tmp18_;
				gboolean _tmp19_;
				gboolean _tmp20_;
				ProgressMonitor _tmp24_;
				void* _tmp24__target;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!_tmp11_) {
#line 1062 "SourceHoldingTank.c"
					gint _tmp12_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp12_ = ctr;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					ctr = _tmp12_ + 1;
#line 1068 "SourceHoldingTank.c"
				}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp11_ = FALSE;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp13_ = ctr;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp14_ = count;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					break;
#line 1080 "SourceHoldingTank.c"
				}
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp15_ = destroy;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp16_ = ctr;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp17_ = gee_list_get (_tmp15_, _tmp16_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				source = (DataSource*) _tmp17_;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp18_ = source;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp19_ = delete_backing;
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp20_ = data_source_destroy_orphan (_tmp18_, _tmp19_);
#line 158 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (!_tmp20_) {
#line 1098 "SourceHoldingTank.c"
					GeeList* _tmp21_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp21_ = not_removed;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					if (NULL != _tmp21_) {
#line 1104 "SourceHoldingTank.c"
						GeeList* _tmp22_;
						DataSource* _tmp23_;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
						_tmp22_ = not_removed;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
						_tmp23_ = source;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
						gee_collection_add ((GeeCollection*) _tmp22_, _tmp23_);
#line 1113 "SourceHoldingTank.c"
					}
				}
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp24_ = monitor;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_tmp24__target = monitor_target;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				if (_tmp24_ != NULL) {
#line 1122 "SourceHoldingTank.c"
					ProgressMonitor _tmp25_;
					void* _tmp25__target;
					gint _tmp26_;
					gint _tmp27_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp25_ = monitor;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp25__target = monitor_target;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp26_ = ctr;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp27_ = count;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
					_tmp25_ ((guint64) (_tmp26_ + 1), (guint64) _tmp27_, TRUE, _tmp25__target);
#line 1137 "SourceHoldingTank.c"
				}
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
				_g_object_unref0 (source);
#line 1141 "SourceHoldingTank.c"
			}
		}
	}
}


static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source) {
	DataSet* _tmp0_;
	DataSource* _tmp1_;
	gboolean _tmp2_;
	gboolean removed = FALSE;
	DataSet* _tmp3_;
	DataSource* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	DataSource* _tmp7_;
	SingletonCollection* _tmp8_;
	SingletonCollection* _tmp9_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (source != NULL);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->tank;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = source;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = data_set_contains (_tmp0_, (DataObject*) _tmp1_);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (!_tmp2_) {
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 1174 "SourceHoldingTank.c"
	}
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp3_ = self->priv->tank;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp4_ = source;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp5_ = data_set_remove (_tmp3_, (DataObject*) _tmp4_);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	removed = _tmp5_;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp6_ = removed;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_vala_assert (_tmp6_, "removed");
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp7_ = source;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp9_ = _tmp8_;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_notify_contents_altered (self, NULL, (GeeCollection*) _tmp9_);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (_tmp9_);
#line 1198 "SourceHoldingTank.c"
}


void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration) {
	DataSet* _tmp0_;
	DataSource* _tmp1_;
	gboolean _tmp2_;
	SourceHoldingTankCheckToKeep _tmp8_;
	void* _tmp8__target;
	DataSource* _tmp9_;
	Alteration* _tmp10_;
	gboolean _tmp11_;
	gboolean removed = FALSE;
	DataSet* _tmp12_;
	DataSource* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SourceCollection* _tmp16_;
	gboolean _tmp17_;
	DataSource* _tmp20_;
	SingletonCollection* _tmp21_;
	SingletonCollection* _tmp22_;
	SourceCollection* _tmp23_;
	DataSource* _tmp24_;
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (source != NULL);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (alteration != NULL);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->tank;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = source;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = data_set_contains (_tmp0_, (DataObject*) _tmp1_);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (!_tmp2_) {
#line 1237 "SourceHoldingTank.c"
		DataSource* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp3_ = source;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp4_ = data_object_to_string ((DataObject*) _tmp3_);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp5_ = _tmp4_;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp6_ = source_holding_tank_to_string (self);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp7_ = _tmp6_;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		g_debug ("SourceHoldingTank.vala:181: SourceHoldingTank.internal_notify_altered " \
"called for %s not stored in %s", _tmp5_, _tmp7_);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_g_free0 (_tmp7_);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_g_free0 (_tmp5_);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 1261 "SourceHoldingTank.c"
	}
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8_ = self->priv->check_to_keep;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8__target = self->priv->check_to_keep_target;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp9_ = source;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp10_ = alteration;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp11_ = _tmp8_ (_tmp9_, _tmp10_, _tmp8__target);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp11_) {
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 1277 "SourceHoldingTank.c"
	}
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp12_ = self->priv->tank;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp13_ = source;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp14_ = data_set_remove (_tmp12_, (DataObject*) _tmp13_);
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	removed = _tmp14_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp15_ = removed;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_vala_assert (_tmp15_, "removed");
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp16_ = self->priv->sources;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp17_ = data_collection_are_notifications_frozen ((DataCollection*) _tmp16_);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp17_) {
#line 1297 "SourceHoldingTank.c"
		GeeHashSet* _tmp18_;
		DataSource* _tmp19_;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp18_ = self->priv->relinks;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		_tmp19_ = source;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 1308 "SourceHoldingTank.c"
	}
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp20_ = source;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp21_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp20_);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp22_ = _tmp21_;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_notify_contents_altered (self, NULL, (GeeCollection*) _tmp22_);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (_tmp22_);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp23_ = self->priv->sources;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp24_ = source;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_collection_relink (_tmp23_, _tmp24_);
#line 1326 "SourceHoldingTank.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return self ? g_object_ref (self) : NULL;
#line 1333 "SourceHoldingTank.c"
}


static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self) {
	GeeHashSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeHashSet* copy = NULL;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
	GeeHashSet* _tmp5_;
	GeeHashSet* _tmp6_;
	SourceCollection* _tmp7_;
	GeeHashSet* _tmp8_;
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (self != NULL);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->relinks;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = _tmp1_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (_tmp2_ == 0) {
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return;
#line 1360 "SourceHoldingTank.c"
	}
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp3_ = self->priv->relinks;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	copy = _tmp4_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp5_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (self->priv->relinks);
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->relinks = _tmp5_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp6_ = copy;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_notify_contents_altered (self, NULL, (GeeCollection*) _tmp6_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp7_ = self->priv->sources;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp8_ = copy;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_collection_relink_many (_tmp7_, (GeeCollection*) _tmp8_);
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (copy);
#line 1386 "SourceHoldingTank.c"
}


gchar* source_holding_tank_to_string (SourceHoldingTank* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = g_strdup_printf ("SourceHoldingTank @ 0x%p", self);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	result = _tmp0_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return result;
#line 1401 "SourceHoldingTank.c"
}


static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (n_param_values == 3);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		data1 = closure->data;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		data2 = param_values->data[0].v_pointer;
#line 1424 "SourceHoldingTank.c"
	} else {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		data2 = closure->data;
#line 1430 "SourceHoldingTank.c"
	}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1436 "SourceHoldingTank.c"
}


static void value_source_holding_tank_init (GValue* value) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	value->data[0].v_pointer = NULL;
#line 1443 "SourceHoldingTank.c"
}


static void value_source_holding_tank_free_value (GValue* value) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (value->data[0].v_pointer) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		source_holding_tank_unref (value->data[0].v_pointer);
#line 1452 "SourceHoldingTank.c"
	}
}


static void value_source_holding_tank_copy_value (const GValue* src_value, GValue* dest_value) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (src_value->data[0].v_pointer) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		dest_value->data[0].v_pointer = source_holding_tank_ref (src_value->data[0].v_pointer);
#line 1462 "SourceHoldingTank.c"
	} else {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1466 "SourceHoldingTank.c"
	}
}


static gpointer value_source_holding_tank_peek_pointer (const GValue* value) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return value->data[0].v_pointer;
#line 1474 "SourceHoldingTank.c"
}


static gchar* value_source_holding_tank_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (collect_values[0].v_pointer) {
#line 1481 "SourceHoldingTank.c"
		SourceHoldingTank * object;
		object = collect_values[0].v_pointer;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		if (object->parent_instance.g_class == NULL) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1488 "SourceHoldingTank.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1492 "SourceHoldingTank.c"
		}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		value->data[0].v_pointer = source_holding_tank_ref (object);
#line 1496 "SourceHoldingTank.c"
	} else {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		value->data[0].v_pointer = NULL;
#line 1500 "SourceHoldingTank.c"
	}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return NULL;
#line 1504 "SourceHoldingTank.c"
}


static gchar* value_source_holding_tank_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceHoldingTank ** object_p;
	object_p = collect_values[0].v_pointer;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (!object_p) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1515 "SourceHoldingTank.c"
	}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (!value->data[0].v_pointer) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		*object_p = NULL;
#line 1521 "SourceHoldingTank.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		*object_p = value->data[0].v_pointer;
#line 1525 "SourceHoldingTank.c"
	} else {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		*object_p = source_holding_tank_ref (value->data[0].v_pointer);
#line 1529 "SourceHoldingTank.c"
	}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return NULL;
#line 1533 "SourceHoldingTank.c"
}


GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceHoldingTank* spec;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_HOLDING_TANK), NULL);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return G_PARAM_SPEC (spec);
#line 1547 "SourceHoldingTank.c"
}


gpointer value_get_source_holding_tank (const GValue* value) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK), NULL);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return value->data[0].v_pointer;
#line 1556 "SourceHoldingTank.c"
}


void value_set_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank * old;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	old = value->data[0].v_pointer;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (v_object) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		value->data[0].v_pointer = v_object;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		source_holding_tank_ref (value->data[0].v_pointer);
#line 1576 "SourceHoldingTank.c"
	} else {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		value->data[0].v_pointer = NULL;
#line 1580 "SourceHoldingTank.c"
	}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (old) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		source_holding_tank_unref (old);
#line 1586 "SourceHoldingTank.c"
	}
}


void value_take_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank * old;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	old = value->data[0].v_pointer;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (v_object) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		value->data[0].v_pointer = v_object;
#line 1605 "SourceHoldingTank.c"
	} else {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		value->data[0].v_pointer = NULL;
#line 1609 "SourceHoldingTank.c"
	}
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (old) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		source_holding_tank_unref (old);
#line 1615 "SourceHoldingTank.c"
	}
}


static void source_holding_tank_class_init (SourceHoldingTankClass * klass) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	((SourceHoldingTankClass *) klass)->finalize = source_holding_tank_finalize;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_type_class_add_private (klass, sizeof (SourceHoldingTankPrivate));
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank *, GeeCollection*, GeeCollection*)) source_holding_tank_real_notify_contents_altered;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	((SourceHoldingTankClass *) klass)->contents_altered = source_holding_tank_real_contents_altered;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	source_holding_tank_signals[SOURCE_HOLDING_TANK_CONTENTS_ALTERED_SIGNAL] = g_signal_new ("contents_altered", TYPE_SOURCE_HOLDING_TANK, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceHoldingTankClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
#line 1633 "SourceHoldingTank.c"
}


static void source_holding_tank_instance_init (SourceHoldingTank * self) {
	DataSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv = SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = data_set_new ();
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->tank = _tmp0_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp1_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->relinks = _tmp1_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->unlinking = _tmp2_;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->priv->ordinal = (gint64) 0;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self->ref_count = 1;
#line 1659 "SourceHoldingTank.c"
}


static void source_holding_tank_finalize (SourceHoldingTank * obj) {
	SourceHoldingTank * self;
	SourceCollection* _tmp0_;
	guint _tmp1_;
	SourceCollection* _tmp2_;
	guint _tmp3_;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_handlers_destroy (self);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp0_ = self->priv->sources;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp1_, NULL, FALSE);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_tmp2_ = self->priv->sources;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp3_, NULL, FALSE);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_signal_handlers_disconnect_matched ((DataCollection*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_data_collection_unref0 (self->priv->sources);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_data_set_unref0 (self->priv->tank);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (self->priv->relinks);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	_g_object_unref0 (self->priv->unlinking);
#line 1693 "SourceHoldingTank.c"
}


GType source_holding_tank_get_type (void) {
	static volatile gsize source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&source_holding_tank_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_holding_tank_init, value_source_holding_tank_free_value, value_source_holding_tank_copy_value, value_source_holding_tank_peek_pointer, "p", value_source_holding_tank_collect_value, "p", value_source_holding_tank_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceHoldingTank), 0, (GInstanceInitFunc) source_holding_tank_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_holding_tank_type_id;
		source_holding_tank_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceHoldingTank", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_holding_tank_type_id__volatile, source_holding_tank_type_id);
	}
	return source_holding_tank_type_id__volatile;
}


gpointer source_holding_tank_ref (gpointer instance) {
	SourceHoldingTank * self;
	self = instance;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	g_atomic_int_inc (&self->ref_count);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	return instance;
#line 1718 "SourceHoldingTank.c"
}


void source_holding_tank_unref (gpointer instance) {
	SourceHoldingTank * self;
	self = instance;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		SOURCE_HOLDING_TANK_GET_CLASS (self)->finalize (self);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/core/SourceHoldingTank.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1731 "SourceHoldingTank.c"
	}
}



