/* Db.c generated by valac 0.36.4, the Vala compiler
 * generated from Db.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "config.h"
#include <granite.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;


extern gchar* db_filename;
gchar* db_filename = NULL;

#define DB_IN_MEMORY_NAME ":memory:"
void db_preconfigure (GFile* db_file);
void db_init (GError** error);
void database_table_init (const gchar* filename);
void db_terminate (void);
void database_table_terminate (void);
GType db_verify_result_get_type (void) G_GNUC_CONST;
DbVerifyResult db_verify_database (gchar* * app_version, gint* schema_version);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self, gchar* * app_version);
#define DATABASE_TABLE_SCHEMA_VERSION 21
#define RESOURCES_APP_VERSION _VERSION
void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data);
DbVerifyResult db_upgrade_database (gint input_version);
gboolean database_table_has_column (const gchar* table_name, const gchar* column_name);
gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
void application_set_raw_thumbs_fix_required (Application* self, gboolean should_fixup);
void version_table_update_version (VersionTable* self, gint version, const gchar* app_version);


void db_preconfigure (GFile* db_file) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	gchar* _tmp5_;
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp1_ = db_file;
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (_tmp1_ != NULL) {
#line 121 "Db.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp2_ = db_file;
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp0_ = _tmp3_;
#line 132 "Db.c"
	} else {
		gchar* _tmp4_;
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp4_ = g_strdup (DB_IN_MEMORY_NAME);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp0_ = _tmp4_;
#line 141 "Db.c"
	}
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp5_ = g_strdup (_tmp0_);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_g_free0 (db_filename);
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	db_filename = _tmp5_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_g_free0 (_tmp0_);
#line 151 "Db.c"
}


void db_init (GError** error) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 32 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp0_ = db_filename;
#line 32 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_vala_assert (_tmp0_ != NULL, "filename != null");
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp1_ = db_filename;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	database_table_init (_tmp1_);
#line 166 "Db.c"
}


void db_terminate (void) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	database_table_terminate ();
#line 173 "Db.c"
}


GType db_verify_result_get_type (void) {
	static volatile gsize db_verify_result_type_id__volatile = 0;
	if (g_once_init_enter (&db_verify_result_type_id__volatile)) {
		static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
		GType db_verify_result_type_id;
		db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
		g_once_init_leave (&db_verify_result_type_id__volatile, db_verify_result_type_id);
	}
	return db_verify_result_type_id__volatile;
}


DbVerifyResult db_verify_database (gchar* * app_version, gint* schema_version) {
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	DbVerifyResult result = 0;
	VersionTable* version_table = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp7_;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp0_ = version_table_get_instance ();
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	version_table = _tmp0_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp1_ = version_table;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_g_free0 (_vala_app_version);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_vala_app_version = _tmp2_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_vala_schema_version = _tmp3_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp4_ = _vala_schema_version;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (_tmp4_ >= 0) {
#line 218 "Db.c"
		gint _tmp5_;
		const gchar* _tmp6_;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp5_ = _vala_schema_version;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp6_ = _vala_app_version;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		g_debug ("Db.vala:53: Database schema version %d created by app version %s", _tmp5_, _tmp6_);
#line 227 "Db.c"
	}
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp7_ = _vala_schema_version;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (_tmp7_ == -1) {
#line 233 "Db.c"
		VersionTable* _tmp8_;
		gchar* _tmp9_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		g_debug ("Db.vala:57: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp8_ = version_table;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		version_table_set_version (_tmp8_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp9_ = g_strdup (RESOURCES_APP_VERSION);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_vala_app_version = _tmp9_;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
#line 250 "Db.c"
	} else {
		gint _tmp10_;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp10_ = _vala_schema_version;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		if (_tmp10_ > DATABASE_TABLE_SCHEMA_VERSION) {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			_database_table_unref0 (version_table);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			if (app_version) {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				*app_version = _vala_app_version;
#line 265 "Db.c"
			} else {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				_g_free0 (_vala_app_version);
#line 269 "Db.c"
			}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			if (schema_version) {
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				*schema_version = _vala_schema_version;
#line 275 "Db.c"
			}
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			return result;
#line 279 "Db.c"
		} else {
			gint _tmp11_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			_tmp11_ = _vala_schema_version;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			if (_tmp11_ < DATABASE_TABLE_SCHEMA_VERSION) {
#line 286 "Db.c"
				DbVerifyResult _result_ = 0;
				gint _tmp12_;
				DbVerifyResult _tmp13_;
				DbVerifyResult _tmp14_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				_tmp12_ = _vala_schema_version;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				_tmp13_ = db_upgrade_database (_tmp12_);
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				_result_ = _tmp13_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				_tmp14_ = _result_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
				if (_tmp14_ != DB_VERIFY_RESULT_OK) {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
					result = _result_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
					_database_table_unref0 (version_table);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
					if (app_version) {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
						*app_version = _vala_app_version;
#line 309 "Db.c"
					} else {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
						_g_free0 (_vala_app_version);
#line 313 "Db.c"
					}
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
					if (schema_version) {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
						*schema_version = _vala_schema_version;
#line 319 "Db.c"
					}
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
					return result;
#line 323 "Db.c"
				}
			}
		}
	}
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_database_table_unref0 (version_table);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (app_version) {
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		*app_version = _vala_app_version;
#line 336 "Db.c"
	} else {
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 340 "Db.c"
	}
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (schema_version) {
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		*schema_version = _vala_schema_version;
#line 346 "Db.c"
	}
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	return result;
#line 350 "Db.c"
}


DbVerifyResult db_upgrade_database (gint input_version) {
	DbVerifyResult result = 0;
	gint _tmp0_;
	gboolean _tmp1_;
	gint version = 0;
	gint _tmp3_;
	gboolean _tmp6_;
	gboolean _tmp8_;
	gint _tmp10_;
	VersionTable* _tmp11_;
	VersionTable* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp0_ = input_version;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_vala_assert (_tmp0_ < DATABASE_TABLE_SCHEMA_VERSION, "input_version < DatabaseTable.SCHEMA_VERSION");
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp1_ = database_table_has_column ("EventTable", "comment");
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (!_tmp1_) {
#line 375 "Db.c"
		gboolean _tmp2_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		g_message ("Db.vala:84: upgrade_database: adding comment column to EventTable");
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp2_ = database_table_add_column ("EventTable", "comment", "TEXT");
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		if (!_tmp2_) {
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			return result;
#line 387 "Db.c"
		}
	}
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	version = 18;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp3_ = input_version;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (_tmp3_ < 19) {
#line 396 "Db.c"
		Application* _tmp4_;
		Application* _tmp5_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp4_ = application_get_instance ();
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp5_ = _tmp4_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		application_set_raw_thumbs_fix_required (_tmp5_, TRUE);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_g_object_unref0 (_tmp5_);
#line 407 "Db.c"
	}
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	version = 19;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	version = 20;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp6_ = database_table_has_column ("PhotoTable", "enhanced");
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (!_tmp6_) {
#line 417 "Db.c"
		gboolean _tmp7_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		g_message ("Db.vala:126: upgrade_database: adding enhanced column to PhotoTable");
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp7_ = database_table_add_column ("PhotoTable", "enhanced", "INTEGER DEFAULT 0");
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		if (!_tmp7_) {
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			return result;
#line 429 "Db.c"
		}
	}
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp8_ = database_table_has_column ("PhotoTable", "original_transforms");
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	if (!_tmp8_) {
#line 436 "Db.c"
		gboolean _tmp9_;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		g_message ("Db.vala:132: upgrade_database: adding original_transforms column to Ph" \
"otoTable");
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		_tmp9_ = database_table_add_column ("PhotoTable", "original_transforms", "TEXT");
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
		if (!_tmp9_) {
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
			return result;
#line 448 "Db.c"
		}
	}
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	version = 21;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp10_ = version;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_vala_assert (_tmp10_ == DATABASE_TABLE_SCHEMA_VERSION, "version == DatabaseTable.SCHEMA_VERSION");
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp11_ = version_table_get_instance ();
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp12_ = _tmp11_;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp13_ = version;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	version_table_update_version (_tmp12_, _tmp13_, RESOURCES_APP_VERSION);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_database_table_unref0 (_tmp12_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	_tmp14_ = version;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	g_message ("Db.vala:141: Database upgrade to schema version %d successful", _tmp14_);
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/db/Db.vala"
	return result;
#line 475 "Db.c"
}



