/* TombstoneTable.c generated by valac 0.36.4, the Vala compiler
 * generated from TombstoneTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TOMBSTONE_ID (tombstone_id_get_type ())
typedef struct _TombstoneID TombstoneID;

#define TYPE_TOMBSTONE_ROW (tombstone_row_get_type ())
#define TOMBSTONE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_ROW, TombstoneRow))
#define TOMBSTONE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_ROW, TombstoneRowClass))
#define IS_TOMBSTONE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_ROW))
#define IS_TOMBSTONE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_ROW))
#define TOMBSTONE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_ROW, TombstoneRowClass))

typedef struct _TombstoneRow TombstoneRow;
typedef struct _TombstoneRowClass TombstoneRowClass;
typedef struct _TombstoneRowPrivate TombstoneRowPrivate;

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecTombstoneRow ParamSpecTombstoneRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TOMBSTONE_TABLE (tombstone_table_get_type ())
#define TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTable))
#define TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))
#define IS_TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_TABLE))
#define IS_TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_TABLE))
#define TOMBSTONE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))

typedef struct _TombstoneTable TombstoneTable;
typedef struct _TombstoneTableClass TombstoneTableClass;
typedef struct _TombstoneTablePrivate TombstoneTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _tombstone_row_unref0(var) ((var == NULL) ? NULL : (var = (tombstone_row_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TombstoneID {
	gint64 id;
};

typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

struct _TombstoneRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TombstoneRowPrivate * priv;
	TombstoneID id;
	gchar* filepath;
	gint64 filesize;
	gchar* md5;
	time_t time_created;
	TombstoneReason reason;
};

struct _TombstoneRowClass {
	GTypeClass parent_class;
	void (*finalize) (TombstoneRow *self);
};

struct _ParamSpecTombstoneRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TombstoneTable {
	DatabaseTable parent_instance;
	TombstoneTablePrivate * priv;
};

struct _TombstoneTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer tombstone_row_parent_class = NULL;
static gpointer tombstone_table_parent_class = NULL;
static TombstoneTable* tombstone_table_instance;
static TombstoneTable* tombstone_table_instance = NULL;
extern sqlite3* database_table_db;

GType tombstone_id_get_type (void) G_GNUC_CONST;
TombstoneID* tombstone_id_dup (const TombstoneID* self);
void tombstone_id_free (TombstoneID* self);
#define TOMBSTONE_ID_INVALID ((gint64) -1)
void tombstone_id_init (TombstoneID *self, gint64 id);
gboolean tombstone_id_is_invalid (TombstoneID *self);
gboolean tombstone_id_is_valid (TombstoneID *self);
gpointer tombstone_row_ref (gpointer instance);
void tombstone_row_unref (gpointer instance);
GParamSpec* param_spec_tombstone_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_tombstone_row (GValue* value, gpointer v_object);
void value_take_tombstone_row (GValue* value, gpointer v_object);
gpointer value_get_tombstone_row (const GValue* value);
GType tombstone_row_get_type (void) G_GNUC_CONST;
GType tombstone_reason_get_type (void) G_GNUC_CONST;
enum  {
	TOMBSTONE_ROW_DUMMY_PROPERTY
};
TombstoneRow* tombstone_row_new (void);
TombstoneRow* tombstone_row_construct (GType object_type);
static void tombstone_row_finalize (TombstoneRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType tombstone_table_get_type (void) G_GNUC_CONST;
enum  {
	TOMBSTONE_TABLE_DUMMY_PROPERTY
};
static TombstoneTable* tombstone_table_new (void);
static TombstoneTable* tombstone_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self, const gchar* data);
void database_table_fatal (const gchar* op, gint res);
TombstoneTable* tombstone_table_get_instance (void);
GQuark database_error_quark (void);
TombstoneRow* tombstone_table_add (TombstoneTable* self, const gchar* filepath, gint64 filesize, const gchar* md5, TombstoneReason reason, GError** error);
gulong now_sec (void);
void database_table_bind_text (sqlite3_stmt* stmt, gint column, const gchar* data);
void database_table_bind_int64 (sqlite3_stmt* stmt, gint column, gint64 data);
void database_table_bind_int (sqlite3_stmt* stmt, gint column, gint data);
gint tombstone_reason_serialize (TombstoneReason self);
void database_table_throw_error (const gchar* method, gint res, GError** error);
TombstoneRow** tombstone_table_fetch_all (TombstoneTable* self, int* result_length1, GError** error);
gint database_table_get_row_count (DatabaseTable* self);
TombstoneReason tombstone_reason_unserialize (gint value);
void tombstone_table_update_file (TombstoneTable* self, TombstoneID* tombstone_id, const gchar* filepath, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void tombstone_table_remove (TombstoneTable* self, TombstoneID* tombstone_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
static void tombstone_table_finalize (DatabaseTable * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


void tombstone_id_init (TombstoneID *self, gint64 id) {
	gint64 _tmp0_;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	memset (self, 0, sizeof (TombstoneID));
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = id;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	(*self).id = _tmp0_;
#line 214 "TombstoneTable.c"
}


gboolean tombstone_id_is_invalid (TombstoneID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = (*self).id;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	result = _tmp0_ == TOMBSTONE_ID_INVALID;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return result;
#line 227 "TombstoneTable.c"
}


gboolean tombstone_id_is_valid (TombstoneID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = (*self).id;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	result = _tmp0_ != TOMBSTONE_ID_INVALID;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return result;
#line 240 "TombstoneTable.c"
}


TombstoneID* tombstone_id_dup (const TombstoneID* self) {
	TombstoneID* dup;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	dup = g_new0 (TombstoneID, 1);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	memcpy (dup, self, sizeof (TombstoneID));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return dup;
#line 252 "TombstoneTable.c"
}


void tombstone_id_free (TombstoneID* self) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_free (self);
#line 259 "TombstoneTable.c"
}


GType tombstone_id_get_type (void) {
	static volatile gsize tombstone_id_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_id_type_id__volatile)) {
		GType tombstone_id_type_id;
		tombstone_id_type_id = g_boxed_type_register_static ("TombstoneID", (GBoxedCopyFunc) tombstone_id_dup, (GBoxedFreeFunc) tombstone_id_free);
		g_once_init_leave (&tombstone_id_type_id__volatile, tombstone_id_type_id);
	}
	return tombstone_id_type_id__volatile;
}


TombstoneRow* tombstone_row_construct (GType object_type) {
	TombstoneRow* self = NULL;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	self = (TombstoneRow*) g_type_create_instance (object_type);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return self;
#line 280 "TombstoneTable.c"
}


TombstoneRow* tombstone_row_new (void) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return tombstone_row_construct (TYPE_TOMBSTONE_ROW);
#line 287 "TombstoneTable.c"
}


static void value_tombstone_row_init (GValue* value) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	value->data[0].v_pointer = NULL;
#line 294 "TombstoneTable.c"
}


static void value_tombstone_row_free_value (GValue* value) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (value->data[0].v_pointer) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		tombstone_row_unref (value->data[0].v_pointer);
#line 303 "TombstoneTable.c"
	}
}


static void value_tombstone_row_copy_value (const GValue* src_value, GValue* dest_value) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (src_value->data[0].v_pointer) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		dest_value->data[0].v_pointer = tombstone_row_ref (src_value->data[0].v_pointer);
#line 313 "TombstoneTable.c"
	} else {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 317 "TombstoneTable.c"
	}
}


static gpointer value_tombstone_row_peek_pointer (const GValue* value) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return value->data[0].v_pointer;
#line 325 "TombstoneTable.c"
}


static gchar* value_tombstone_row_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (collect_values[0].v_pointer) {
#line 332 "TombstoneTable.c"
		TombstoneRow * object;
		object = collect_values[0].v_pointer;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 339 "TombstoneTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 343 "TombstoneTable.c"
		}
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		value->data[0].v_pointer = tombstone_row_ref (object);
#line 347 "TombstoneTable.c"
	} else {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		value->data[0].v_pointer = NULL;
#line 351 "TombstoneTable.c"
	}
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return NULL;
#line 355 "TombstoneTable.c"
}


static gchar* value_tombstone_row_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TombstoneRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (!object_p) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 366 "TombstoneTable.c"
	}
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (!value->data[0].v_pointer) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		*object_p = NULL;
#line 372 "TombstoneTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		*object_p = value->data[0].v_pointer;
#line 376 "TombstoneTable.c"
	} else {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		*object_p = tombstone_row_ref (value->data[0].v_pointer);
#line 380 "TombstoneTable.c"
	}
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return NULL;
#line 384 "TombstoneTable.c"
}


GParamSpec* param_spec_tombstone_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTombstoneRow* spec;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TOMBSTONE_ROW), NULL);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return G_PARAM_SPEC (spec);
#line 398 "TombstoneTable.c"
}


gpointer value_get_tombstone_row (const GValue* value) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TOMBSTONE_ROW), NULL);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return value->data[0].v_pointer;
#line 407 "TombstoneTable.c"
}


void value_set_tombstone_row (GValue* value, gpointer v_object) {
	TombstoneRow * old;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TOMBSTONE_ROW));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	old = value->data[0].v_pointer;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (v_object) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TOMBSTONE_ROW));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		value->data[0].v_pointer = v_object;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		tombstone_row_ref (value->data[0].v_pointer);
#line 427 "TombstoneTable.c"
	} else {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		value->data[0].v_pointer = NULL;
#line 431 "TombstoneTable.c"
	}
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (old) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		tombstone_row_unref (old);
#line 437 "TombstoneTable.c"
	}
}


void value_take_tombstone_row (GValue* value, gpointer v_object) {
	TombstoneRow * old;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TOMBSTONE_ROW));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	old = value->data[0].v_pointer;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (v_object) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TOMBSTONE_ROW));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		value->data[0].v_pointer = v_object;
#line 456 "TombstoneTable.c"
	} else {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		value->data[0].v_pointer = NULL;
#line 460 "TombstoneTable.c"
	}
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (old) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		tombstone_row_unref (old);
#line 466 "TombstoneTable.c"
	}
}


static void tombstone_row_class_init (TombstoneRowClass * klass) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	tombstone_row_parent_class = g_type_class_peek_parent (klass);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	((TombstoneRowClass *) klass)->finalize = tombstone_row_finalize;
#line 476 "TombstoneTable.c"
}


static void tombstone_row_instance_init (TombstoneRow * self) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	self->ref_count = 1;
#line 483 "TombstoneTable.c"
}


static void tombstone_row_finalize (TombstoneRow * obj) {
	TombstoneRow * self;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOMBSTONE_ROW, TombstoneRow);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_signal_handlers_destroy (self);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_g_free0 (self->filepath);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_g_free0 (self->md5);
#line 497 "TombstoneTable.c"
}


GType tombstone_row_get_type (void) {
	static volatile gsize tombstone_row_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_tombstone_row_init, value_tombstone_row_free_value, value_tombstone_row_copy_value, value_tombstone_row_peek_pointer, "p", value_tombstone_row_collect_value, "p", value_tombstone_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TombstoneRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tombstone_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TombstoneRow), 0, (GInstanceInitFunc) tombstone_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType tombstone_row_type_id;
		tombstone_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TombstoneRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&tombstone_row_type_id__volatile, tombstone_row_type_id);
	}
	return tombstone_row_type_id__volatile;
}


gpointer tombstone_row_ref (gpointer instance) {
	TombstoneRow * self;
	self = instance;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return instance;
#line 522 "TombstoneTable.c"
}


void tombstone_row_unref (gpointer instance) {
	TombstoneRow * self;
	self = instance;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		TOMBSTONE_ROW_GET_CLASS (self)->finalize (self);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 535 "TombstoneTable.c"
	}
}


static TombstoneTable* tombstone_table_construct (GType object_type) {
	TombstoneTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	self = (TombstoneTable*) database_table_construct (object_type);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "TombstoneTable");
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS " "TombstoneTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT NOT NULL, " "filesize INTEGER, " "md5 TEXT, " "time_created INTEGER, " "reason INTEGER DEFAULT 0 " ")");
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	stmt = _tmp0_;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp1_ = stmt;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp2_ = sqlite3_step (_tmp1_);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	res = _tmp2_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp3_ = res;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (_tmp3_ != SQLITE_DONE) {
#line 566 "TombstoneTable.c"
		gint _tmp4_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_tmp4_ = res;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		database_table_fatal ("create TombstoneTable", _tmp4_);
#line 572 "TombstoneTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return self;
#line 578 "TombstoneTable.c"
}


static TombstoneTable* tombstone_table_new (void) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return tombstone_table_construct (TYPE_TOMBSTONE_TABLE);
#line 585 "TombstoneTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 592 "TombstoneTable.c"
}


TombstoneTable* tombstone_table_get_instance (void) {
	TombstoneTable* result = NULL;
	TombstoneTable* _tmp0_;
	TombstoneTable* _tmp2_;
	TombstoneTable* _tmp3_;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = tombstone_table_instance;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (_tmp0_ == NULL) {
#line 605 "TombstoneTable.c"
		TombstoneTable* _tmp1_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_tmp1_ = tombstone_table_new ();
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_database_table_unref0 (tombstone_table_instance);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		tombstone_table_instance = _tmp1_;
#line 613 "TombstoneTable.c"
	}
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp2_ = tombstone_table_instance;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	result = _tmp3_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return result;
#line 623 "TombstoneTable.c"
}


TombstoneRow* tombstone_table_add (TombstoneTable* self, const gchar* filepath, gint64 filesize, const gchar* md5, TombstoneReason reason, GError** error) {
	TombstoneRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	time_t time_created = 0;
	gulong _tmp1_;
	sqlite3_stmt* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint64 _tmp5_;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	sqlite3_stmt* _tmp8_;
	time_t _tmp9_;
	sqlite3_stmt* _tmp10_;
	TombstoneReason _tmp11_;
	gint _tmp12_;
	gint res = 0;
	sqlite3_stmt* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	TombstoneRow* row = NULL;
	TombstoneRow* _tmp17_;
	TombstoneRow* _tmp18_;
	sqlite3* _tmp19_;
	gint64 _tmp20_;
	TombstoneRow* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	TombstoneRow* _tmp24_;
	gint64 _tmp25_;
	TombstoneRow* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	TombstoneRow* _tmp29_;
	time_t _tmp30_;
	TombstoneRow* _tmp31_;
	TombstoneReason _tmp32_;
	GError * _inner_error_ = NULL;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_val_if_fail (filepath != NULL, NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO TombstoneTable " "(filepath, filesize, md5, time_created, reason) " "VALUES (?, ?, ?, ?, ?)");
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	stmt = _tmp0_;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp1_ = now_sec ();
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	time_created = (time_t) _tmp1_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp2_ = stmt;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp3_ = filepath;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_bind_text (_tmp2_, 1, _tmp3_);
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp4_ = stmt;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp5_ = filesize;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_bind_int64 (_tmp4_, 2, _tmp5_);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp6_ = stmt;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp7_ = md5;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_bind_text (_tmp6_, 3, _tmp7_);
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp8_ = stmt;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp9_ = time_created;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_bind_int64 (_tmp8_, 4, (gint64) _tmp9_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp10_ = stmt;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp11_ = reason;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp12_ = tombstone_reason_serialize (_tmp11_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_bind_int (_tmp10_, 5, _tmp12_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp13_ = stmt;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp14_ = sqlite3_step (_tmp13_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	res = _tmp14_;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp15_ = res;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (_tmp15_ != SQLITE_DONE) {
#line 720 "TombstoneTable.c"
		gint _tmp16_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_tmp16_ = res;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		database_table_throw_error ("TombstoneTable.add", _tmp16_, &_inner_error_);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				g_propagate_error (error, _inner_error_);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				_sqlite3_finalize0 (stmt);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				return NULL;
#line 736 "TombstoneTable.c"
			} else {
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				_sqlite3_finalize0 (stmt);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				g_clear_error (&_inner_error_);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				return NULL;
#line 746 "TombstoneTable.c"
			}
		}
	}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp17_ = tombstone_row_new ();
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	row = _tmp17_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp18_ = row;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp19_ = database_table_db;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp20_ = sqlite3_last_insert_rowid (_tmp19_);
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	tombstone_id_init (&_tmp18_->id, _tmp20_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp21_ = row;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp22_ = filepath;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_g_free0 (_tmp21_->filepath);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp21_->filepath = _tmp23_;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp24_ = row;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp25_ = filesize;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp24_->filesize = _tmp25_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp26_ = row;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp27_ = md5;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_g_free0 (_tmp26_->md5);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp26_->md5 = _tmp28_;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp29_ = row;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp30_ = time_created;
#line 100 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp29_->time_created = _tmp30_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp31_ = row;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp32_ = reason;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp31_->reason = _tmp32_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	result = row;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return result;
#line 806 "TombstoneTable.c"
}


static gpointer _tombstone_row_ref0 (gpointer self) {
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return self ? tombstone_row_ref (self) : NULL;
#line 813 "TombstoneTable.c"
}


TombstoneRow** tombstone_table_fetch_all (TombstoneTable* self, int* result_length1, GError** error) {
	TombstoneRow** result = NULL;
	gint row_count = 0;
	gint _tmp0_;
	gint _tmp1_;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp3_;
	TombstoneRow** rows = NULL;
	gint _tmp4_;
	TombstoneRow** _tmp5_;
	gint rows_length1;
	gint _rows_size_;
	gint index = 0;
	gint _tmp39_;
	gint _tmp40_;
	TombstoneRow** _tmp41_;
	gint _tmp41__length1;
	GError * _inner_error_ = NULL;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = database_table_get_row_count ((DatabaseTable*) self);
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	row_count = _tmp0_;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp1_ = row_count;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (_tmp1_ == 0) {
#line 845 "TombstoneTable.c"
		TombstoneRow** _tmp2_;
		gint _tmp2__length1;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_tmp2_ = NULL;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_tmp2__length1 = 0;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		if (result_length1) {
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			*result_length1 = _tmp2__length1;
#line 856 "TombstoneTable.c"
		}
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		result = _tmp2_;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		return result;
#line 862 "TombstoneTable.c"
	}
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp3_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, filepath, filesize, md5, time_created, reason " "FROM TombstoneTable");
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	stmt = _tmp3_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp4_ = row_count;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp5_ = g_new0 (TombstoneRow*, _tmp4_ + 1);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	rows = _tmp5_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	rows_length1 = _tmp4_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_rows_size_ = rows_length1;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	index = 0;
#line 880 "TombstoneTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		_tmp6_ = TRUE;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		while (TRUE) {
#line 887 "TombstoneTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			TombstoneRow* row = NULL;
			TombstoneRow* _tmp12_;
			TombstoneRow* _tmp13_;
			sqlite3_stmt* _tmp14_;
			gint64 _tmp15_;
			TombstoneRow* _tmp16_;
			sqlite3_stmt* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			TombstoneRow* _tmp20_;
			sqlite3_stmt* _tmp21_;
			gint64 _tmp22_;
			TombstoneRow* _tmp23_;
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			TombstoneRow* _tmp27_;
			sqlite3_stmt* _tmp28_;
			gint64 _tmp29_;
			TombstoneRow* _tmp30_;
			sqlite3_stmt* _tmp31_;
			gint _tmp32_;
			TombstoneReason _tmp33_;
			TombstoneRow** _tmp34_;
			gint _tmp34__length1;
			gint _tmp35_;
			TombstoneRow* _tmp36_;
			TombstoneRow* _tmp37_;
			TombstoneRow* _tmp38_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			if (!_tmp6_) {
#line 923 "TombstoneTable.c"
			}
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp6_ = FALSE;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp7_ = stmt;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp8_ = sqlite3_step (_tmp7_);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			res = _tmp8_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp9_ = res;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			if (_tmp9_ == SQLITE_DONE) {
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				break;
#line 939 "TombstoneTable.c"
			} else {
				gint _tmp10_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				_tmp10_ = res;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
				if (_tmp10_ != SQLITE_ROW) {
#line 946 "TombstoneTable.c"
					gint _tmp11_;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
					_tmp11_ = res;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
					database_table_throw_error ("TombstoneTable.fetch_all", _tmp11_, &_inner_error_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							g_propagate_error (error, _inner_error_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) tombstone_row_unref), NULL);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							_sqlite3_finalize0 (stmt);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							return NULL;
#line 964 "TombstoneTable.c"
						} else {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) tombstone_row_unref), NULL);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							_sqlite3_finalize0 (stmt);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							g_clear_error (&_inner_error_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
							return NULL;
#line 976 "TombstoneTable.c"
						}
					}
				}
			}
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp12_ = tombstone_row_new ();
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			row = _tmp12_;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp13_ = row;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp14_ = stmt;
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp15_ = sqlite3_column_int64 (_tmp14_, 0);
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			tombstone_id_init (&_tmp13_->id, _tmp15_);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp16_ = row;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp17_ = stmt;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp18_ = sqlite3_column_text (_tmp17_, 1);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_g_free0 (_tmp16_->filepath);
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp16_->filepath = _tmp19_;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp20_ = row;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp21_ = stmt;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp22_ = sqlite3_column_int64 (_tmp21_, 2);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp20_->filesize = _tmp22_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp23_ = row;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp24_ = stmt;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp25_ = sqlite3_column_text (_tmp24_, 3);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_g_free0 (_tmp23_->md5);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp23_->md5 = _tmp26_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp27_ = row;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp28_ = stmt;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp29_ = sqlite3_column_int64 (_tmp28_, 4);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp27_->time_created = (time_t) _tmp29_;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp30_ = row;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp31_ = stmt;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp32_ = sqlite3_column_int (_tmp31_, 5);
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp33_ = tombstone_reason_unserialize (_tmp32_);
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp30_->reason = _tmp33_;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp34_ = rows;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp34__length1 = rows_length1;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp35_ = index;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			index = _tmp35_ + 1;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp36_ = row;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp37_ = _tombstone_row_ref0 (_tmp36_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tombstone_row_unref0 (_tmp34_[_tmp35_]);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp34_[_tmp35_] = _tmp37_;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tmp38_ = _tmp34_[_tmp35_];
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			_tombstone_row_unref0 (row);
#line 1063 "TombstoneTable.c"
		}
	}
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp39_ = index;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp40_ = row_count;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_vala_assert (_tmp39_ == _tmp40_, "index == row_count");
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp41_ = rows;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp41__length1 = rows_length1;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (result_length1) {
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		*result_length1 = _tmp41__length1;
#line 1080 "TombstoneTable.c"
	}
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	result = _tmp41_;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	return result;
#line 1088 "TombstoneTable.c"
}


void tombstone_table_update_file (TombstoneTable* self, TombstoneID* tombstone_id, const gchar* filepath, GError** error) {
	TombstoneID _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (self != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (tombstone_id != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (filepath != NULL);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = *tombstone_id;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp1_ = _tmp0_.id;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp2_ = filepath;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_, "filepath", _tmp2_, &_inner_error_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			g_propagate_error (error, _inner_error_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			return;
#line 1119 "TombstoneTable.c"
		} else {
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			g_clear_error (&_inner_error_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			return;
#line 1127 "TombstoneTable.c"
		}
	}
}


void tombstone_table_remove (TombstoneTable* self, TombstoneID* tombstone_id, GError** error) {
	TombstoneID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (self != NULL);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	g_return_if_fail (tombstone_id != NULL);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp0_ = *tombstone_id;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	_tmp1_ = _tmp0_.id;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	database_table_delete_by_id ((DatabaseTable*) self, _tmp1_, &_inner_error_);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			g_propagate_error (error, _inner_error_);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			return;
#line 1155 "TombstoneTable.c"
		} else {
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			g_clear_error (&_inner_error_);
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
			return;
#line 1163 "TombstoneTable.c"
		}
	}
}


static void tombstone_table_class_init (TombstoneTableClass * klass) {
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	tombstone_table_parent_class = g_type_class_peek_parent (klass);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	((DatabaseTableClass *) klass)->finalize = tombstone_table_finalize;
#line 1174 "TombstoneTable.c"
}


static void tombstone_table_instance_init (TombstoneTable * self) {
}


static void tombstone_table_finalize (DatabaseTable * obj) {
	TombstoneTable * self;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOMBSTONE_TABLE, TombstoneTable);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/db/TombstoneTable.vala"
	DATABASE_TABLE_CLASS (tombstone_table_parent_class)->finalize (obj);
#line 1188 "TombstoneTable.c"
}


GType tombstone_table_get_type (void) {
	static volatile gsize tombstone_table_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TombstoneTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tombstone_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TombstoneTable), 0, (GInstanceInitFunc) tombstone_table_instance_init, NULL };
		GType tombstone_table_type_id;
		tombstone_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TombstoneTable", &g_define_type_info, 0);
		g_once_init_leave (&tombstone_table_type_id__volatile, tombstone_table_type_id);
	}
	return tombstone_table_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



