/* VersionTable.c generated by valac 0.36.4, the Vala compiler
 * generated from VersionTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>


#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
typedef struct _VersionTablePrivate VersionTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VersionTable {
	DatabaseTable parent_instance;
	VersionTablePrivate * priv;
};

struct _VersionTableClass {
	DatabaseTableClass parent_class;
};


static gpointer version_table_parent_class = NULL;
static VersionTable* version_table_instance;
static VersionTable* version_table_instance = NULL;

gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
enum  {
	VERSION_TABLE_DUMMY_PROPERTY
};
static VersionTable* version_table_new (void);
static VersionTable* version_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self, const gchar* data);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self, gchar* * app_version);
void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data);
void database_table_bind_int (sqlite3_stmt* stmt, gint column, gint data);
void database_table_bind_text (sqlite3_stmt* stmt, gint column, const gchar* data);
void version_table_update_version (VersionTable* self, gint version, const gchar* app_version);
static void version_table_finalize (DatabaseTable * obj);


static VersionTable* version_table_construct (GType object_type) {
	VersionTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	self = (VersionTable*) database_table_construct (object_type);
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")");
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	stmt = _tmp0_;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp1_ = stmt;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp2_ = sqlite3_step (_tmp1_);
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	res = _tmp2_;
#line 32 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp3_ = res;
#line 32 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (_tmp3_ != SQLITE_DONE) {
#line 132 "VersionTable.c"
		gint _tmp4_;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp4_ = res;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		database_table_fatal ("create version table", _tmp4_);
#line 138 "VersionTable.c"
	}
#line 35 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "VersionTable");
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	return self;
#line 146 "VersionTable.c"
}


static VersionTable* version_table_new (void) {
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	return version_table_construct (TYPE_VERSION_TABLE);
#line 153 "VersionTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 160 "VersionTable.c"
}


VersionTable* version_table_get_instance (void) {
	VersionTable* result = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp2_;
	VersionTable* _tmp3_;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp0_ = version_table_instance;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (_tmp0_ == NULL) {
#line 173 "VersionTable.c"
		VersionTable* _tmp1_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp1_ = version_table_new ();
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_database_table_unref0 (version_table_instance);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		version_table_instance = _tmp1_;
#line 181 "VersionTable.c"
	}
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp2_ = version_table_instance;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	result = _tmp3_;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	return result;
#line 191 "VersionTable.c"
}


gint version_table_get_version (VersionTable* self, gchar* * app_version) {
	gchar* _vala_app_version = NULL;
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT schema_version, app_version FROM VersionTable ORDER BY schema_v" \
"ersion DESC LIMIT 1");
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	stmt = _tmp0_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp1_ = stmt;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp2_ = sqlite3_step (_tmp1_);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	res = _tmp2_;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp3_ = res;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (_tmp3_ != SQLITE_ROW) {
#line 225 "VersionTable.c"
		gint _tmp4_;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp4_ = res;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		if (_tmp4_ != SQLITE_DONE) {
#line 231 "VersionTable.c"
			gint _tmp5_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
			_tmp5_ = res;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
			database_table_fatal ("get_version", _tmp5_);
#line 237 "VersionTable.c"
		}
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_g_free0 (_vala_app_version);
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_vala_app_version = NULL;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		result = -1;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_sqlite3_finalize0 (stmt);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		if (app_version) {
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
			*app_version = _vala_app_version;
#line 251 "VersionTable.c"
		} else {
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
			_g_free0 (_vala_app_version);
#line 255 "VersionTable.c"
		}
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		return result;
#line 259 "VersionTable.c"
	}
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp6_ = stmt;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp7_ = sqlite3_column_text (_tmp6_, 1);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_g_free0 (_vala_app_version);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_vala_app_version = _tmp8_;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp9_ = stmt;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp10_ = sqlite3_column_int (_tmp9_, 0);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	result = _tmp10_;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (app_version) {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		*app_version = _vala_app_version;
#line 283 "VersionTable.c"
	} else {
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_g_free0 (_vala_app_version);
#line 287 "VersionTable.c"
	}
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	return result;
#line 291 "VersionTable.c"
}


void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data) {
	sqlite3_stmt* stmt = NULL;
	gchar* bitbucket = NULL;
	gchar* _tmp0_ = NULL;
	gint _tmp1_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	sqlite3_stmt* _tmp8_;
	const gchar* _tmp9_;
	gint res = 0;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	g_return_if_fail (app_version != NULL);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp1_ = version_table_get_version (self, &_tmp0_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_g_free0 (bitbucket);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	bitbucket = _tmp0_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (_tmp1_ != -1) {
#line 322 "VersionTable.c"
		sqlite3_stmt* _tmp2_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VersionTable SET schema_version=?, app_version=?, user_data=?");
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_sqlite3_finalize0 (stmt);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		stmt = _tmp2_;
#line 330 "VersionTable.c"
	} else {
		sqlite3_stmt* _tmp3_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp3_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO VersionTable (schema_version, app_version, user_data) VALU" \
"ES (?,?, ?)");
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_sqlite3_finalize0 (stmt);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		stmt = _tmp3_;
#line 339 "VersionTable.c"
	}
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp4_ = stmt;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp5_ = version;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	database_table_bind_int (_tmp4_, 1, _tmp5_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp6_ = stmt;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp7_ = app_version;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	database_table_bind_text (_tmp6_, 2, _tmp7_);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp8_ = stmt;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp9_ = user_data;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	database_table_bind_text (_tmp8_, 3, _tmp9_);
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp10_ = stmt;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp11_ = sqlite3_step (_tmp10_);
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	res = _tmp11_;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp12_ = res;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (_tmp12_ != SQLITE_DONE) {
#line 369 "VersionTable.c"
		gint _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gint _tmp18_;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp13_ = version;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp14_ = app_version;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp15_ = user_data;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp16_ = g_strdup_printf ("set_version %d %s %s", _tmp13_, _tmp14_, _tmp15_);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp17_ = _tmp16_;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp18_ = res;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		database_table_fatal (_tmp17_, _tmp18_);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_g_free0 (_tmp17_);
#line 392 "VersionTable.c"
	}
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_g_free0 (bitbucket);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 398 "VersionTable.c"
}


void version_table_update_version (VersionTable* self, gint version, const gchar* app_version) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_;
	const gchar* _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	g_return_if_fail (self != NULL);
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	g_return_if_fail (app_version != NULL);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VersionTable SET schema_version=?, app_version=?");
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	stmt = _tmp0_;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp1_ = stmt;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp2_ = version;
#line 86 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	database_table_bind_int (_tmp1_, 1, _tmp2_);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp3_ = stmt;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp4_ = app_version;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	database_table_bind_text (_tmp3_, 2, _tmp4_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp5_ = stmt;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp6_ = sqlite3_step (_tmp5_);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	res = _tmp6_;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_tmp7_ = res;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	if (_tmp7_ != SQLITE_DONE) {
#line 443 "VersionTable.c"
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gint _tmp11_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp8_ = version;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp9_ = g_strdup_printf ("update_version %d", _tmp8_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp10_ = _tmp9_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_tmp11_ = res;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		database_table_fatal (_tmp10_, _tmp11_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
		_g_free0 (_tmp10_);
#line 460 "VersionTable.c"
	}
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 464 "VersionTable.c"
}


static void version_table_class_init (VersionTableClass * klass) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	version_table_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	((DatabaseTableClass *) klass)->finalize = version_table_finalize;
#line 473 "VersionTable.c"
}


static void version_table_instance_init (VersionTable * self) {
}


static void version_table_finalize (DatabaseTable * obj) {
	VersionTable * self;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VERSION_TABLE, VersionTable);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VersionTable.vala"
	DATABASE_TABLE_CLASS (version_table_parent_class)->finalize (obj);
#line 487 "VersionTable.c"
}


GType version_table_get_type (void) {
	static volatile gsize version_table_type_id__volatile = 0;
	if (g_once_init_enter (&version_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VersionTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) version_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VersionTable), 0, (GInstanceInitFunc) version_table_instance_init, NULL };
		GType version_table_type_id;
		version_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VersionTable", &g_define_type_info, 0);
		g_once_init_leave (&version_table_type_id__volatile, version_table_type_id);
	}
	return version_table_type_id__volatile;
}



