/* VideoTable.c generated by valac 0.36.4, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecVideoRow ParamSpecVideoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
typedef struct _VideoTablePrivate VideoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VideoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _ParamSpecVideoRow {
	GParamSpec parent_instance;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VideoTable {
	DatabaseTable parent_instance;
	VideoTablePrivate * priv;
};

struct _VideoTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer video_row_parent_class = NULL;
static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;
extern sqlite3* database_table_db;

GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
#define VIDEO_ID_INVALID ((gint64) -1)
void video_id_init (VideoID *self, gint64 id);
gboolean video_id_is_invalid (VideoID *self);
gboolean video_id_is_valid (VideoID *self);
guint video_id_hash (VideoID* a);
guint int64_hash (gint64* n);
gboolean video_id_equal (void* a, void* b);
gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id);
#define VIDEO_TYPENAME "video"
gpointer video_row_ref (gpointer instance);
void video_row_unref (gpointer instance);
GParamSpec* param_spec_video_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_video_row (GValue* value, gpointer v_object);
void value_take_video_row (GValue* value, gpointer v_object);
gpointer value_get_video_row (const GValue* value);
GType video_row_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
enum  {
	VIDEO_ROW_DUMMY_PROPERTY
};
VideoRow* video_row_new (void);
VideoRow* video_row_construct (GType object_type);
static void video_row_finalize (VideoRow * obj);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType video_table_get_type (void) G_GNUC_CONST;
enum  {
	VIDEO_TABLE_DUMMY_PROPERTY
};
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self, const gchar* data);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
VideoTable* video_table_get_instance (void);
GQuark database_error_quark (void);
void video_table_add (VideoTable* self, VideoRow* video_row, VideoID* result, GError** error);
gulong now_sec (void);
void database_table_bind_text (sqlite3_stmt* stmt, gint column, const gchar* data);
void database_table_bind_int (sqlite3_stmt* stmt, gint column, gint data);
void database_table_bind_double (sqlite3_stmt* stmt, gint column, gdouble data);
void database_table_bind_int64 (sqlite3_stmt* stmt, gint column, gint64 data);
#define EVENT_ID_INVALID ((gint64) -1)
void database_table_throw_error (const gchar* method, gint res, GError** error);
void event_id_init (EventID *self, gint64 id);
gboolean video_table_drop_event (VideoTable* self, EventID* event_id);
VideoRow* video_table_get_row (VideoTable* self, VideoID* video_id);
GeeArrayList* video_table_get_all (VideoTable* self);
void video_table_set_filepath (VideoTable* self, VideoID* video_id, const gchar* filepath, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void video_table_set_title (VideoTable* self, VideoID* video_id, const gchar* new_title, GError** error);
void video_table_set_comment (VideoTable* self, VideoID* video_id, const gchar* new_comment, GError** error);
void video_table_set_exposure_time (VideoTable* self, VideoID* video_id, time_t time, GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error);
void video_table_set_flags (VideoTable* self, VideoID* video_id, guint64 flags, GError** error);
void video_table_update_backlinks (VideoTable* self, VideoID* video_id, const gchar* backlinks, GError** error);
void video_table_update_is_interpretable (VideoTable* self, VideoID* video_id, gboolean is_interpretable, GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error);
gboolean video_table_set_event (VideoTable* self, VideoID* video_id, EventID* event_id);
gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value);
void video_table_remove_by_file (VideoTable* self, GFile* file, GError** error);
void video_table_remove (VideoTable* self, VideoID* videoID, GError** error);
gboolean video_table_is_video_stored (VideoTable* self, GFile* file);
void video_table_get_id (VideoTable* self, GFile* file, VideoID* result);
GeeArrayList* video_table_get_videos (VideoTable* self, GError** error);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self, GFile* file, const gchar* md5);
gboolean video_table_has_duplicate (VideoTable* self, GFile* file, const gchar* md5);
VideoID* video_table_get_duplicate_ids (VideoTable* self, GFile* file, const gchar* md5, int* result_length1);
static void _vala_array_add137 (VideoID* * array, int* length, int* size, const VideoID* value);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self, EventID* event_id);
void video_table_set_timestamp (VideoTable* self, VideoID* video_id, time_t timestamp, GError** error);
static void video_table_finalize (DatabaseTable * obj);


void video_id_init (VideoID *self, gint64 id) {
	gint64 _tmp0_;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	memset (self, 0, sizeof (VideoID));
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = id;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	(*self).id = _tmp0_;
#line 267 "VideoTable.c"
}


gboolean video_id_is_invalid (VideoID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = (*self).id;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp0_ == VIDEO_ID_INVALID;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 280 "VideoTable.c"
}


gboolean video_id_is_valid (VideoID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = (*self).id;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp0_ != VIDEO_ID_INVALID;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 293 "VideoTable.c"
}


guint video_id_hash (VideoID* a) {
	guint result = 0U;
	VideoID* _tmp0_;
	gint64 _tmp1_;
	guint _tmp2_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = a;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = (*_tmp0_).id;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = int64_hash (&_tmp1_);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp2_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 312 "VideoTable.c"
}


gboolean video_id_equal (void* a, void* b) {
	gboolean result = FALSE;
	void* _tmp0_;
	gint64 _tmp1_;
	void* _tmp2_;
	gint64 _tmp3_;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = a;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = (*((VideoID*) _tmp0_)).id;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = b;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = (*((VideoID*) _tmp2_)).id;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp1_ == _tmp3_;
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 334 "VideoTable.c"
}


gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id) {
	gchar* result = NULL;
	VideoID _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, _tmp1_);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp2_;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 355 "VideoTable.c"
}


VideoID* video_id_dup (const VideoID* self) {
	VideoID* dup;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	dup = g_new0 (VideoID, 1);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	memcpy (dup, self, sizeof (VideoID));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return dup;
#line 367 "VideoTable.c"
}


void video_id_free (VideoID* self) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_free (self);
#line 374 "VideoTable.c"
}


GType video_id_get_type (void) {
	static volatile gsize video_id_type_id__volatile = 0;
	if (g_once_init_enter (&video_id_type_id__volatile)) {
		GType video_id_type_id;
		video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
		g_once_init_leave (&video_id_type_id__volatile, video_id_type_id);
	}
	return video_id_type_id__volatile;
}


VideoRow* video_row_construct (GType object_type) {
	VideoRow* self = NULL;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = (VideoRow*) g_type_create_instance (object_type);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return self;
#line 395 "VideoTable.c"
}


VideoRow* video_row_new (void) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return video_row_construct (TYPE_VIDEO_ROW);
#line 402 "VideoTable.c"
}


static void value_video_row_init (GValue* value) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	value->data[0].v_pointer = NULL;
#line 409 "VideoTable.c"
}


static void value_video_row_free_value (GValue* value) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (value->data[0].v_pointer) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_unref (value->data[0].v_pointer);
#line 418 "VideoTable.c"
	}
}


static void value_video_row_copy_value (const GValue* src_value, GValue* dest_value) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (src_value->data[0].v_pointer) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = video_row_ref (src_value->data[0].v_pointer);
#line 428 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 432 "VideoTable.c"
	}
}


static gpointer value_video_row_peek_pointer (const GValue* value) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 440 "VideoTable.c"
}


static gchar* value_video_row_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (collect_values[0].v_pointer) {
#line 447 "VideoTable.c"
		VideoRow * object;
		object = collect_values[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 454 "VideoTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 458 "VideoTable.c"
		}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = video_row_ref (object);
#line 462 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 466 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return NULL;
#line 470 "VideoTable.c"
}


static gchar* value_video_row_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	VideoRow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (!object_p) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 481 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (!value->data[0].v_pointer) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*object_p = NULL;
#line 487 "VideoTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*object_p = value->data[0].v_pointer;
#line 491 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*object_p = video_row_ref (value->data[0].v_pointer);
#line 495 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return NULL;
#line 499 "VideoTable.c"
}


GParamSpec* param_spec_video_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecVideoRow* spec;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_ROW), NULL);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return G_PARAM_SPEC (spec);
#line 513 "VideoTable.c"
}


gpointer value_get_video_row (const GValue* value) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW), NULL);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return value->data[0].v_pointer;
#line 522 "VideoTable.c"
}


void value_set_video_row (GValue* value, gpointer v_object) {
	VideoRow * old;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (v_object) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_ref (value->data[0].v_pointer);
#line 542 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 546 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (old) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_unref (old);
#line 552 "VideoTable.c"
	}
}


void value_take_video_row (GValue* value, gpointer v_object) {
	VideoRow * old;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	old = value->data[0].v_pointer;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (v_object) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_ROW));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = v_object;
#line 571 "VideoTable.c"
	} else {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		value->data[0].v_pointer = NULL;
#line 575 "VideoTable.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (old) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_row_unref (old);
#line 581 "VideoTable.c"
	}
}


static void video_row_class_init (VideoRowClass * klass) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_row_parent_class = g_type_class_peek_parent (klass);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	((VideoRowClass *) klass)->finalize = video_row_finalize;
#line 591 "VideoTable.c"
}


static void video_row_instance_init (VideoRow * self) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self->ref_count = 1;
#line 598 "VideoTable.c"
}


static void video_row_finalize (VideoRow * obj) {
	VideoRow * self;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_ROW, VideoRow);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_signal_handlers_destroy (self);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->filepath);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->md5);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->title);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->backlinks);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (self->comment);
#line 618 "VideoTable.c"
}


GType video_row_get_type (void) {
	static volatile gsize video_row_type_id__volatile = 0;
	if (g_once_init_enter (&video_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_row_init, value_video_row_free_value, value_video_row_copy_value, value_video_row_peek_pointer, "p", value_video_row_collect_value, "p", value_video_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoRow), 0, (GInstanceInitFunc) video_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_row_type_id;
		video_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_row_type_id__volatile, video_row_type_id);
	}
	return video_row_type_id__volatile;
}


gpointer video_row_ref (gpointer instance) {
	VideoRow * self;
	self = instance;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return instance;
#line 643 "VideoTable.c"
}


void video_row_unref (gpointer instance) {
	VideoRow * self;
	self = instance;
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		VIDEO_ROW_GET_CLASS (self)->finalize (self);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 656 "VideoTable.c"
	}
}


static VideoTable* video_table_construct (GType object_type) {
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = (VideoTable*) database_table_construct (object_type);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0, " "comment TEXT " ")");
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_step (_tmp1_);
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp2_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp3_ != SQLITE_DONE) {
#line 689 "VideoTable.c"
		gint _tmp4_;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4_ = res;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", _tmp4_);
#line 695 "VideoTable.c"
	}
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)");
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp5_;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = stmt;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = sqlite3_step (_tmp6_);
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp7_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = res;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp8_ != SQLITE_DONE) {
#line 713 "VideoTable.c"
		gint _tmp9_;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = res;
#line 104 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", _tmp9_);
#line 719 "VideoTable.c"
	}
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "VideoTable");
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return self;
#line 727 "VideoTable.c"
}


static VideoTable* video_table_new (void) {
#line 74 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return video_table_construct (TYPE_VIDEO_TABLE);
#line 734 "VideoTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 741 "VideoTable.c"
}


VideoTable* video_table_get_instance (void) {
	VideoTable* result = NULL;
	VideoTable* _tmp0_;
	VideoTable* _tmp2_;
	VideoTable* _tmp3_;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = video_table_instance;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp0_ == NULL) {
#line 754 "VideoTable.c"
		VideoTable* _tmp1_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp1_ = video_table_new ();
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_database_table_unref0 (video_table_instance);
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_table_instance = _tmp1_;
#line 762 "VideoTable.c"
	}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = video_table_instance;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp3_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 772 "VideoTable.c"
}


void video_table_add (VideoTable* self, VideoRow* video_row, VideoID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gulong time_created = 0UL;
	gulong _tmp1_;
	sqlite3_stmt* _tmp2_;
	VideoRow* _tmp3_;
	const gchar* _tmp4_;
	sqlite3_stmt* _tmp5_;
	VideoRow* _tmp6_;
	gint _tmp7_;
	sqlite3_stmt* _tmp8_;
	VideoRow* _tmp9_;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	VideoRow* _tmp12_;
	gdouble _tmp13_;
	gint _tmp14_ = 0;
	VideoRow* _tmp15_;
	gboolean _tmp16_;
	sqlite3_stmt* _tmp17_;
	sqlite3_stmt* _tmp18_;
	VideoRow* _tmp19_;
	gint64 _tmp20_;
	sqlite3_stmt* _tmp21_;
	VideoRow* _tmp22_;
	time_t _tmp23_;
	sqlite3_stmt* _tmp24_;
	VideoRow* _tmp25_;
	time_t _tmp26_;
	sqlite3_stmt* _tmp27_;
	VideoRow* _tmp28_;
	ImportID _tmp29_;
	gint64 _tmp30_;
	sqlite3_stmt* _tmp31_;
	sqlite3_stmt* _tmp32_;
	VideoRow* _tmp33_;
	const gchar* _tmp34_;
	sqlite3_stmt* _tmp35_;
	gulong _tmp36_;
	sqlite3_stmt* _tmp37_;
	VideoRow* _tmp38_;
	const gchar* _tmp39_;
	sqlite3_stmt* _tmp40_;
	VideoRow* _tmp41_;
	const gchar* _tmp42_;
	gint res = 0;
	sqlite3_stmt* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	VideoRow* _tmp48_;
	sqlite3* _tmp49_;
	gint64 _tmp50_;
	VideoRow* _tmp51_;
	VideoRow* _tmp52_;
	gulong _tmp53_;
	VideoRow* _tmp54_;
	VideoRow* _tmp55_;
	VideoID _tmp56_;
	GError * _inner_error_ = NULL;
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_row != NULL);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title, comment) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = now_sec ();
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	time_created = _tmp1_;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = video_row;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_->filepath;
#line 126 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp2_, 1, _tmp4_);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = video_row;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = _tmp6_->width;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int (_tmp5_, 2, _tmp7_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = stmt;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp9_ = video_row;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp10_ = _tmp9_->height;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int (_tmp8_, 3, _tmp10_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp11_ = stmt;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp12_ = video_row;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_ = _tmp12_->clip_duration;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_double (_tmp11_, 4, _tmp13_);
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp15_ = video_row;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp16_ = _tmp15_->is_interpretable;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp16_) {
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp14_ = 1;
#line 888 "VideoTable.c"
	} else {
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp14_ = 0;
#line 892 "VideoTable.c"
	}
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int (_tmp17_, 5, _tmp14_);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp18_ = stmt;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp19_ = video_row;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp20_ = _tmp19_->filesize;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp18_, 6, _tmp20_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp21_ = stmt;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp22_ = video_row;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp23_ = _tmp22_->timestamp;
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp21_, 7, (gint64) _tmp23_);
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp24_ = stmt;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp25_ = video_row;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp26_ = _tmp25_->exposure_time;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp24_, 8, (gint64) _tmp26_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp27_ = stmt;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp28_ = video_row;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp29_ = _tmp28_->import_id;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp30_ = _tmp29_.id;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp27_, 9, _tmp30_);
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp31_ = stmt;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp31_, 10, EVENT_ID_INVALID);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp32_ = stmt;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp33_ = video_row;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp34_ = _tmp33_->md5;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp32_, 11, _tmp34_);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp35_ = stmt;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp36_ = time_created;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp35_, 12, (gint64) _tmp36_);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp37_ = stmt;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp38_ = video_row;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp39_ = _tmp38_->title;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp37_, 13, _tmp39_);
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp40_ = stmt;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp41_ = video_row;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp42_ = _tmp41_->comment;
#line 139 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp40_, 14, _tmp42_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp43_ = stmt;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp44_ = sqlite3_step (_tmp43_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp44_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp45_ = res;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp45_ != SQLITE_DONE) {
#line 976 "VideoTable.c"
		gint _tmp46_;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp46_ = res;
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_tmp46_ != SQLITE_CONSTRAINT) {
#line 982 "VideoTable.c"
			gint _tmp47_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp47_ = res;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			database_table_throw_error ("VideoTable.add", _tmp47_, &_inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					g_propagate_error (error, _inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					return;
#line 998 "VideoTable.c"
				} else {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					g_clear_error (&_inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					return;
#line 1008 "VideoTable.c"
				}
			}
		}
	}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp48_ = video_row;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp49_ = database_table_db;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp50_ = sqlite3_last_insert_rowid (_tmp49_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_id_init (&_tmp48_->video_id, _tmp50_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp51_ = video_row;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	event_id_init (&_tmp51_->event_id, EVENT_ID_INVALID);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp52_ = video_row;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp53_ = time_created;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp52_->time_created = (time_t) _tmp53_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp54_ = video_row;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp54_->flags = (guint64) 0;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp55_ = video_row;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp56_ = _tmp55_->video_id;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	*result = _tmp56_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return;
#line 1045 "VideoTable.c"
}


gboolean video_table_drop_event (VideoTable* self, EventID* event_id) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	EventID _tmp3_;
	gint64 _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?");
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, EVENT_ID_INVALID);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = stmt;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = *event_id;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp2_, 2, _tmp4_);
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = sqlite3_step (_tmp5_);
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp6_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = res;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp7_ != SQLITE_DONE) {
#line 1091 "VideoTable.c"
		gint _tmp8_;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = res;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable.drop_event", _tmp8_);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		result = FALSE;
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 166 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return result;
#line 1103 "VideoTable.c"
	}
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = TRUE;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 1111 "VideoTable.c"
}


VideoRow* video_table_get_row (VideoTable* self, VideoID* video_id) {
	VideoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	VideoID _tmp2_;
	gint64 _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	VideoRow* row = NULL;
	VideoRow* _tmp6_;
	VideoRow* _tmp7_;
	VideoID _tmp8_;
	VideoRow* _tmp9_;
	sqlite3_stmt* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	VideoRow* _tmp13_;
	sqlite3_stmt* _tmp14_;
	gint _tmp15_;
	VideoRow* _tmp16_;
	sqlite3_stmt* _tmp17_;
	gint _tmp18_;
	VideoRow* _tmp19_;
	sqlite3_stmt* _tmp20_;
	gdouble _tmp21_;
	VideoRow* _tmp22_;
	sqlite3_stmt* _tmp23_;
	gint _tmp24_;
	VideoRow* _tmp25_;
	sqlite3_stmt* _tmp26_;
	gint64 _tmp27_;
	VideoRow* _tmp28_;
	sqlite3_stmt* _tmp29_;
	gint64 _tmp30_;
	VideoRow* _tmp31_;
	sqlite3_stmt* _tmp32_;
	gint64 _tmp33_;
	VideoRow* _tmp34_;
	sqlite3_stmt* _tmp35_;
	gint64 _tmp36_;
	VideoRow* _tmp37_;
	sqlite3_stmt* _tmp38_;
	gint64 _tmp39_;
	VideoRow* _tmp40_;
	sqlite3_stmt* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	VideoRow* _tmp44_;
	sqlite3_stmt* _tmp45_;
	gint64 _tmp46_;
	VideoRow* _tmp47_;
	sqlite3_stmt* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	VideoRow* _tmp51_;
	sqlite3_stmt* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	VideoRow* _tmp55_;
	sqlite3_stmt* _tmp56_;
	gint64 _tmp57_;
	VideoRow* _tmp58_;
	sqlite3_stmt* _tmp59_;
	gint64 _tmp60_;
	VideoRow* _tmp61_;
	sqlite3_stmt* _tmp62_;
	const gchar* _tmp63_;
	gchar* _tmp64_;
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, title, backlink" \
"s, " "time_reimported, flags, comment FROM VideoTable WHERE id=?");
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *video_id;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp3_);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp5_ != SQLITE_ROW) {
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		result = NULL;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return result;
#line 1212 "VideoTable.c"
	}
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = video_row_new ();
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	row = _tmp6_;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = row;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = *video_id;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_->video_id = _tmp8_;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp9_ = row;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp10_ = stmt;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp11_ = sqlite3_column_text (_tmp10_, 0);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp9_->filepath);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp9_->filepath = _tmp12_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_ = row;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp14_ = stmt;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp15_ = sqlite3_column_int (_tmp14_, 1);
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_->width = _tmp15_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp16_ = row;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp18_ = sqlite3_column_int (_tmp17_, 2);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp16_->height = _tmp18_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp19_ = row;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp20_ = stmt;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp21_ = sqlite3_column_double (_tmp20_, 3);
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp19_->clip_duration = _tmp21_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp22_ = row;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp23_ = stmt;
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp24_ = sqlite3_column_int (_tmp23_, 4);
#line 189 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp22_->is_interpretable = _tmp24_ == 1;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp25_ = row;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp26_ = stmt;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp27_ = sqlite3_column_int64 (_tmp26_, 5);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp25_->filesize = _tmp27_;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp28_ = row;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp29_ = stmt;
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp30_ = sqlite3_column_int64 (_tmp29_, 6);
#line 191 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp28_->timestamp = (time_t) _tmp30_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp31_ = row;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp32_ = stmt;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp33_ = sqlite3_column_int64 (_tmp32_, 7);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp31_->exposure_time = (time_t) _tmp33_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp34_ = row;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp35_ = stmt;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp36_ = sqlite3_column_int64 (_tmp35_, 8);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp34_->import_id.id = _tmp36_;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp37_ = row;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp38_ = stmt;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp39_ = sqlite3_column_int64 (_tmp38_, 9);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp37_->event_id.id = _tmp39_;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp40_ = row;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp41_ = stmt;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp42_ = sqlite3_column_text (_tmp41_, 10);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp40_->md5);
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp40_->md5 = _tmp43_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp44_ = row;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp45_ = stmt;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp46_ = sqlite3_column_int64 (_tmp45_, 11);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp44_->time_created = (time_t) _tmp46_;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp47_ = row;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp48_ = stmt;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp49_ = sqlite3_column_text (_tmp48_, 12);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp50_ = g_strdup (_tmp49_);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp47_->title);
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp47_->title = _tmp50_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp51_ = row;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp52_ = stmt;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp53_ = sqlite3_column_text (_tmp52_, 13);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp54_ = g_strdup (_tmp53_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp51_->backlinks);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp51_->backlinks = _tmp54_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp55_ = row;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp56_ = stmt;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp57_ = sqlite3_column_int64 (_tmp56_, 14);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp55_->time_reimported = (time_t) _tmp57_;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp58_ = row;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp59_ = stmt;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp60_ = sqlite3_column_int64 (_tmp59_, 15);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp58_->flags = (guint64) _tmp60_;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp61_ = row;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp62_ = stmt;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp63_ = sqlite3_column_text (_tmp62_, 16);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp64_ = g_strdup (_tmp63_);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp61_->comment);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp61_->comment = _tmp64_;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = row;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 1386 "VideoTable.c"
}


GeeArrayList* video_table_get_all (VideoTable* self) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp1_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, titl" \
"e, " "backlinks, time_reimported, flags, comment FROM VideoTable");
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_ref, (GDestroyNotify) video_row_unref, NULL, NULL, NULL);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	all = _tmp1_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	while (TRUE) {
#line 1408 "VideoTable.c"
		sqlite3_stmt* _tmp2_;
		gint _tmp3_;
		VideoRow* row = NULL;
		VideoRow* _tmp4_;
		VideoRow* _tmp5_;
		sqlite3_stmt* _tmp6_;
		gint64 _tmp7_;
		VideoRow* _tmp8_;
		sqlite3_stmt* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		VideoRow* _tmp12_;
		sqlite3_stmt* _tmp13_;
		gint _tmp14_;
		VideoRow* _tmp15_;
		sqlite3_stmt* _tmp16_;
		gint _tmp17_;
		VideoRow* _tmp18_;
		sqlite3_stmt* _tmp19_;
		gdouble _tmp20_;
		VideoRow* _tmp21_;
		sqlite3_stmt* _tmp22_;
		gint _tmp23_;
		VideoRow* _tmp24_;
		sqlite3_stmt* _tmp25_;
		gint64 _tmp26_;
		VideoRow* _tmp27_;
		sqlite3_stmt* _tmp28_;
		gint64 _tmp29_;
		VideoRow* _tmp30_;
		sqlite3_stmt* _tmp31_;
		gint64 _tmp32_;
		VideoRow* _tmp33_;
		sqlite3_stmt* _tmp34_;
		gint64 _tmp35_;
		VideoRow* _tmp36_;
		sqlite3_stmt* _tmp37_;
		gint64 _tmp38_;
		VideoRow* _tmp39_;
		sqlite3_stmt* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		VideoRow* _tmp43_;
		sqlite3_stmt* _tmp44_;
		gint64 _tmp45_;
		VideoRow* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		VideoRow* _tmp50_;
		sqlite3_stmt* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		VideoRow* _tmp54_;
		sqlite3_stmt* _tmp55_;
		gint64 _tmp56_;
		VideoRow* _tmp57_;
		sqlite3_stmt* _tmp58_;
		gint64 _tmp59_;
		VideoRow* _tmp60_;
		sqlite3_stmt* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		GeeArrayList* _tmp64_;
		VideoRow* _tmp65_;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = stmt;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp3_ = sqlite3_step (_tmp2_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (!(_tmp3_ == SQLITE_ROW)) {
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			break;
#line 1482 "VideoTable.c"
		}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp4_ = video_row_new ();
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		row = _tmp4_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_ = row;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = stmt;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = sqlite3_column_int64 (_tmp6_, 0);
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_->video_id.id = _tmp7_;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = row;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = stmt;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp10_ = sqlite3_column_text (_tmp9_, 1);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp8_->filepath);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_->filepath = _tmp11_;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_ = row;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp13_ = stmt;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp14_ = sqlite3_column_int (_tmp13_, 2);
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_->width = _tmp14_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp15_ = row;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp16_ = stmt;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp17_ = sqlite3_column_int (_tmp16_, 3);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp15_->height = _tmp17_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp18_ = row;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp19_ = stmt;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp20_ = sqlite3_column_double (_tmp19_, 4);
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp18_->clip_duration = _tmp20_;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp21_ = row;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp22_ = stmt;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp23_ = sqlite3_column_int (_tmp22_, 5);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp21_->is_interpretable = _tmp23_ == 1;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp24_ = row;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp25_ = stmt;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp26_ = sqlite3_column_int64 (_tmp25_, 6);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp24_->filesize = _tmp26_;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp27_ = row;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp28_ = stmt;
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp29_ = sqlite3_column_int64 (_tmp28_, 7);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp27_->timestamp = (time_t) _tmp29_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp30_ = row;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp31_ = stmt;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp32_ = sqlite3_column_int64 (_tmp31_, 8);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp30_->exposure_time = (time_t) _tmp32_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp33_ = row;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp34_ = stmt;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp35_ = sqlite3_column_int64 (_tmp34_, 9);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp33_->import_id.id = _tmp35_;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp36_ = row;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp37_ = stmt;
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp38_ = sqlite3_column_int64 (_tmp37_, 10);
#line 227 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp36_->event_id.id = _tmp38_;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp39_ = row;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp40_ = stmt;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp41_ = sqlite3_column_text (_tmp40_, 11);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp42_ = g_strdup (_tmp41_);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp39_->md5);
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp39_->md5 = _tmp42_;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp43_ = row;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp44_ = stmt;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp45_ = sqlite3_column_int64 (_tmp44_, 12);
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp43_->time_created = (time_t) _tmp45_;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp46_ = row;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp47_ = stmt;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp48_ = sqlite3_column_text (_tmp47_, 13);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp46_->title);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp46_->title = _tmp49_;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp50_ = row;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp51_ = stmt;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp52_ = sqlite3_column_text (_tmp51_, 14);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp53_ = g_strdup (_tmp52_);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp50_->backlinks);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp50_->backlinks = _tmp53_;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp54_ = row;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp55_ = stmt;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp56_ = sqlite3_column_int64 (_tmp55_, 15);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp54_->time_reimported = (time_t) _tmp56_;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp57_ = row;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp58_ = stmt;
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp59_ = sqlite3_column_int64 (_tmp58_, 16);
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp57_->flags = (guint64) _tmp59_;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp60_ = row;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp61_ = stmt;
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp62_ = sqlite3_column_text (_tmp61_, 17);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp63_ = g_strdup (_tmp62_);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp60_->comment);
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp60_->comment = _tmp63_;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp64_ = all;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp65_ = row;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp64_, _tmp65_);
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_video_row_unref0 (row);
#line 1660 "VideoTable.c"
	}
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = all;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 1668 "VideoTable.c"
}


void video_table_set_filepath (VideoTable* self, VideoID* video_id, const gchar* filepath, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = filepath;
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp1_, "filename", _tmp2_, &_inner_error_);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1699 "VideoTable.c"
		} else {
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 243 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1707 "VideoTable.c"
		}
	}
}


void video_table_set_title (VideoTable* self, VideoID* video_id, const gchar* new_title, GError** error) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	VideoID _tmp3_;
	gint64 _tmp4_;
	GError * _inner_error_ = NULL;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = new_title;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 1727 "VideoTable.c"
		const gchar* _tmp2_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = new_title;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_;
#line 1733 "VideoTable.c"
	} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1737 "VideoTable.c"
	}
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = *video_id;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp4_, "title", _tmp0_, &_inner_error_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1753 "VideoTable.c"
		} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1761 "VideoTable.c"
		}
	}
}


void video_table_set_comment (VideoTable* self, VideoID* video_id, const gchar* new_comment, GError** error) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	VideoID _tmp3_;
	gint64 _tmp4_;
	GError * _inner_error_ = NULL;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = new_comment;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 1781 "VideoTable.c"
		const gchar* _tmp2_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = new_comment;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_;
#line 1787 "VideoTable.c"
	} else {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1791 "VideoTable.c"
	}
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = *video_id;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp4_, "comment", _tmp0_, &_inner_error_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1807 "VideoTable.c"
		} else {
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1815 "VideoTable.c"
		}
	}
}


void video_table_set_exposure_time (VideoTable* self, VideoID* video_id, time_t time, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	time_t _tmp2_;
	GError * _inner_error_ = NULL;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = time;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp1_, "exposure_time", (gint64) _tmp2_, &_inner_error_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1846 "VideoTable.c"
		} else {
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1854 "VideoTable.c"
		}
	}
}


void video_table_set_flags (VideoTable* self, VideoID* video_id, guint64 flags, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	guint64 _tmp2_;
	GError * _inner_error_ = NULL;
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 258 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = flags;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp1_, "flags", (gint64) _tmp2_, &_inner_error_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1885 "VideoTable.c"
		} else {
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1893 "VideoTable.c"
		}
	}
}


void video_table_update_backlinks (VideoTable* self, VideoID* video_id, const gchar* backlinks, GError** error) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	VideoID _tmp3_;
	gint64 _tmp4_;
	GError * _inner_error_ = NULL;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = backlinks;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 1913 "VideoTable.c"
		const gchar* _tmp2_;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = backlinks;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_;
#line 1919 "VideoTable.c"
	} else {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1923 "VideoTable.c"
	}
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = *video_id;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 ((DatabaseTable*) self, _tmp4_, "backlinks", _tmp0_, &_inner_error_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1939 "VideoTable.c"
		} else {
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 263 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1947 "VideoTable.c"
		}
	}
}


void video_table_update_is_interpretable (VideoTable* self, VideoID* video_id, gboolean is_interpretable, GError** error) {
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	VideoID _tmp2_;
	gint64 _tmp3_;
	GError * _inner_error_ = NULL;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = is_interpretable;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp1_) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = 1;
#line 1969 "VideoTable.c"
	} else {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = 0;
#line 1973 "VideoTable.c"
	}
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *video_id;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int_by_id_2 ((DatabaseTable*) self, _tmp3_, "is_interpretable", _tmp0_, &_inner_error_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1989 "VideoTable.c"
		} else {
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 1997 "VideoTable.c"
		}
	}
}


gboolean video_table_set_event (VideoTable* self, VideoID* video_id, EventID* event_id) {
	gboolean result = FALSE;
	VideoID _tmp0_;
	gint64 _tmp1_;
	EventID _tmp2_;
	gint64 _tmp3_;
	gboolean _tmp4_;
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, FALSE);
#line 270 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *event_id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = database_table_update_int64_by_id ((DatabaseTable*) self, _tmp1_, "event_id", _tmp3_);
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp4_;
#line 271 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2030 "VideoTable.c"
}


void video_table_remove_by_file (VideoTable* self, GFile* file, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GError * _inner_error_ = NULL;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (file != NULL);
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM VideoTable WHERE filename=?");
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = file;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp4_);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp4_);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = sqlite3_step (_tmp5_);
#line 279 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp6_;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = res;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp7_ != SQLITE_DONE) {
#line 2076 "VideoTable.c"
		gint _tmp8_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = res;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove_by_file", _tmp8_, &_inner_error_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2092 "VideoTable.c"
			} else {
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_clear_error (&_inner_error_);
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2102 "VideoTable.c"
			}
		}
	}
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2108 "VideoTable.c"
}


void video_table_remove (VideoTable* self, VideoID* videoID, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	VideoID _tmp2_;
	gint64 _tmp3_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (videoID != NULL);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "DELETE FROM VideoTable WHERE id=?");
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *videoID;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 287 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp3_);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 289 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp5_;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = res;
#line 290 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 2149 "VideoTable.c"
		gint _tmp7_;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = res;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove", _tmp7_, &_inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2165 "VideoTable.c"
			} else {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				g_clear_error (&_inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				return;
#line 2175 "VideoTable.c"
			}
		}
	}
#line 284 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2181 "VideoTable.c"
}


gboolean video_table_is_video_stored (VideoTable* self, GFile* file) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	VideoID _tmp1_ = {0};
	gboolean _tmp2_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = file;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_table_get_id (self, _tmp0_, &_tmp1_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = video_id_is_valid (&_tmp1_);
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp2_;
#line 295 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2204 "VideoTable.c"
}


void video_table_get_id (VideoTable* self, GFile* file, VideoID* result) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint res = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	VideoID _tmp7_ = {0};
	gint _tmp8_;
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 298 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (file != NULL);
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT ID FROM VideoTable WHERE filename=?");
#line 299 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = file;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_;
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_text (_tmp1_, 1, _tmp4_);
#line 301 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (_tmp4_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp6_ = sqlite3_step (_tmp5_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp6_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp8_ = res;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp8_ == SQLITE_ROW) {
#line 2250 "VideoTable.c"
		sqlite3_stmt* _tmp9_;
		gint64 _tmp10_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = stmt;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp10_ = sqlite3_column_int64 (_tmp9_, 0);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_id_init (&_tmp7_, _tmp10_);
#line 2259 "VideoTable.c"
	} else {
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_id_init (&_tmp7_, VIDEO_ID_INVALID);
#line 2263 "VideoTable.c"
	}
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	*result = _tmp7_;
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 304 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return;
#line 2271 "VideoTable.c"
}


GeeArrayList* video_table_get_videos (VideoTable* self, GError** error) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	GeeArrayList* video_ids = NULL;
	GeeArrayList* _tmp1_;
	GError * _inner_error_ = NULL;
#line 307 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM VideoTable");
#line 308 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, (GDestroyNotify) video_id_free, NULL, NULL, NULL);
#line 310 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_ids = _tmp1_;
#line 2292 "VideoTable.c"
	{
		gboolean _tmp2_ = FALSE;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = TRUE;
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		while (TRUE) {
#line 2299 "VideoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			GeeArrayList* _tmp8_;
			sqlite3_stmt* _tmp9_;
			gint64 _tmp10_;
			VideoID _tmp11_ = {0};
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (!_tmp2_) {
#line 2310 "VideoTable.c"
			}
#line 311 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp2_ = FALSE;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp3_ = stmt;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp4_ = sqlite3_step (_tmp3_);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			res = _tmp4_;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp5_ = res;
#line 313 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_tmp5_ == SQLITE_DONE) {
#line 314 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				break;
#line 2326 "VideoTable.c"
			} else {
				gint _tmp6_;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_tmp6_ = res;
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				if (_tmp6_ != SQLITE_ROW) {
#line 2333 "VideoTable.c"
					gint _tmp7_;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_tmp7_ = res;
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					database_table_throw_error ("VideoTable.get_videos", _tmp7_, &_inner_error_);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							g_propagate_error (error, _inner_error_);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							return NULL;
#line 2351 "VideoTable.c"
						} else {
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							g_clear_error (&_inner_error_);
#line 316 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
							return NULL;
#line 2363 "VideoTable.c"
						}
					}
				}
			}
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp8_ = video_ids;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp9_ = stmt;
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp10_ = sqlite3_column_int64 (_tmp9_, 0);
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			video_id_init (&_tmp11_, _tmp10_);
#line 319 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, &_tmp11_);
#line 2378 "VideoTable.c"
		}
	}
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = video_ids;
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 322 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2387 "VideoTable.c"
}


static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self, GFile* file, const gchar* md5) {
	sqlite3_stmt* result = NULL;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	gchar* sql = NULL;
	gchar* _tmp3_;
	gboolean first = FALSE;
	GFile* _tmp4_;
	const gchar* _tmp7_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp13_;
	sqlite3_stmt* _tmp14_;
	gint col = 0;
	GFile* _tmp15_;
	const gchar* _tmp21_;
#line 325 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = file;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = TRUE;
#line 2414 "VideoTable.c"
	} else {
		const gchar* _tmp2_;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp2_ = md5;
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 2421 "VideoTable.c"
	}
#line 326 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_vala_assert (_tmp0_, "file != null || md5 != null");
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = g_strdup ("SELECT id FROM VideoTable WHERE");
#line 328 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	sql = _tmp3_;
#line 329 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	first = TRUE;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = file;
#line 331 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp4_ != NULL) {
#line 2435 "VideoTable.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_ = sql;
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = g_strconcat (_tmp5_, " filename=?", NULL);
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (sql);
#line 332 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		sql = _tmp6_;
#line 333 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		first = FALSE;
#line 2448 "VideoTable.c"
	}
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp7_ = md5;
#line 336 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp7_ != NULL) {
#line 2454 "VideoTable.c"
		gboolean _tmp8_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = first;
#line 337 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (!_tmp8_) {
#line 2462 "VideoTable.c"
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp9_ = sql;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp10_ = g_strconcat (_tmp9_, " OR ", NULL);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_g_free0 (sql);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			sql = _tmp10_;
#line 2473 "VideoTable.c"
		}
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp11_ = sql;
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_ = g_strconcat (_tmp11_, " md5=?", NULL);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (sql);
#line 340 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		sql = _tmp12_;
#line 2483 "VideoTable.c"
	}
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_ = sql;
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp14_ = database_table_create_stmt ((DatabaseTable*) self, _tmp13_);
#line 344 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp14_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	col = 1;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp15_ = file;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp15_ != NULL) {
#line 2497 "VideoTable.c"
		sqlite3_stmt* _tmp16_;
		gint _tmp17_;
		GFile* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp16_ = stmt;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp17_ = col;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		col = _tmp17_ + 1;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp18_ = file;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp19_ = g_file_get_path (_tmp18_);
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp20_ = _tmp19_;
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_bind_text (_tmp16_, _tmp17_, _tmp20_);
#line 349 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_g_free0 (_tmp20_);
#line 2519 "VideoTable.c"
	}
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp21_ = md5;
#line 352 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp21_ != NULL) {
#line 2525 "VideoTable.c"
		sqlite3_stmt* _tmp22_;
		gint _tmp23_;
		const gchar* _tmp24_;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp22_ = stmt;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp23_ = col;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		col = _tmp23_ + 1;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp24_ = md5;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		database_table_bind_text (_tmp22_, _tmp23_, _tmp24_);
#line 2539 "VideoTable.c"
	}
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = stmt;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_g_free0 (sql);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2547 "VideoTable.c"
}


gboolean video_table_has_duplicate (VideoTable* self, GFile* file, const gchar* md5) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gint res = 0;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = file;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = md5;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = video_table_get_duplicate_stmt (self, _tmp0_, _tmp1_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp2_;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = sqlite3_step (_tmp3_);
#line 361 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp4_;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = res;
#line 363 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (_tmp5_ == SQLITE_DONE) {
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		result = FALSE;
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 365 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		return result;
#line 2587 "VideoTable.c"
	} else {
		gint _tmp6_;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = res;
#line 366 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_tmp6_ == SQLITE_ROW) {
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			result = TRUE;
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 368 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return result;
#line 2600 "VideoTable.c"
		} else {
			gint _tmp7_;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp7_ = res;
#line 370 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			database_table_fatal ("VideoTable.has_duplicate", _tmp7_);
#line 2607 "VideoTable.c"
		}
	}
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = FALSE;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2616 "VideoTable.c"
}


static void _vala_array_add137 (VideoID* * array, int* length, int* size, const VideoID* value) {
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if ((*length) == (*size)) {
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*array = g_renew (VideoID, *array, *size);
#line 2627 "VideoTable.c"
	}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	(*array)[(*length)++] = *value;
#line 2631 "VideoTable.c"
}


VideoID* video_table_get_duplicate_ids (VideoTable* self, GFile* file, const gchar* md5, int* result_length1) {
	VideoID* result = NULL;
	sqlite3_stmt* stmt = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	sqlite3_stmt* _tmp2_;
	VideoID* ids = NULL;
	VideoID* _tmp3_;
	gint ids_length1;
	gint _ids_size_;
	gint res = 0;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_;
	VideoID* _tmp13_;
	gint _tmp13__length1;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = file;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = md5;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = video_table_get_duplicate_stmt (self, _tmp0_, _tmp1_);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp2_;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = g_new0 (VideoID, 0);
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	ids = _tmp3_;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	ids_length1 = 0;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_ids_size_ = ids_length1;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 381 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	res = _tmp5_;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	while (TRUE) {
#line 2676 "VideoTable.c"
		gint _tmp6_;
		VideoID* _tmp7_;
		gint _tmp7__length1;
		sqlite3_stmt* _tmp8_;
		gint64 _tmp9_;
		VideoID _tmp10_ = {0};
		sqlite3_stmt* _tmp11_;
		gint _tmp12_;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp6_ = res;
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (!(_tmp6_ == SQLITE_ROW)) {
#line 382 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			break;
#line 2691 "VideoTable.c"
		}
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7_ = ids;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp7__length1 = ids_length1;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp8_ = stmt;
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp9_ = sqlite3_column_int64 (_tmp8_, 0);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		video_id_init (&_tmp10_, _tmp9_);
#line 383 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_vala_array_add137 (&ids, &ids_length1, &_ids_size_, &_tmp10_);
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp11_ = stmt;
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp12_ = sqlite3_step (_tmp11_);
#line 384 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		res = _tmp12_;
#line 2711 "VideoTable.c"
	}
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13_ = ids;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp13__length1 = ids_length1;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (result_length1) {
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		*result_length1 = _tmp13__length1;
#line 2721 "VideoTable.c"
	}
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _tmp13_;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2729 "VideoTable.c"
}


GeeArrayList* video_table_get_event_source_ids (VideoTable* self, EventID* event_id) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	EventID _tmp2_;
	gint64 _tmp3_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp4_;
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 390 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT id FROM VideoTable WHERE event_id = ?");
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	stmt = _tmp0_;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = stmt;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = *event_id;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_bind_int64 (_tmp1_, 1, _tmp3_);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 395 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_result_ = _tmp4_;
#line 2762 "VideoTable.c"
	{
		gboolean _tmp5_ = FALSE;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		_tmp5_ = TRUE;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		while (TRUE) {
#line 2769 "VideoTable.c"
			gint res = 0;
			sqlite3_stmt* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			GeeArrayList* _tmp11_;
			sqlite3_stmt* _tmp12_;
			gint64 _tmp13_;
			VideoID _tmp14_ = {0};
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (!_tmp5_) {
#line 2782 "VideoTable.c"
			}
#line 396 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp5_ = FALSE;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp6_ = stmt;
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp7_ = sqlite3_step (_tmp6_);
#line 397 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			res = _tmp7_;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp8_ = res;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			if (_tmp8_ == SQLITE_DONE) {
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				break;
#line 2798 "VideoTable.c"
			} else {
				gint _tmp9_;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				_tmp9_ = res;
#line 400 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
				if (_tmp9_ != SQLITE_ROW) {
#line 2805 "VideoTable.c"
					gint _tmp10_;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					_tmp10_ = res;
#line 401 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					database_table_fatal ("get_event_source_ids", _tmp10_);
#line 403 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
					break;
#line 2813 "VideoTable.c"
				}
			}
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp11_ = _result_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp12_ = stmt;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp13_ = sqlite3_column_int64 (_tmp12_, 0);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			video_id_init (&_tmp14_, _tmp13_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp15_ = video_id_upgrade_video_id_to_source_id (&_tmp14_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_tmp16_ = _tmp15_;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp16_);
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			_g_free0 (_tmp16_);
#line 2832 "VideoTable.c"
		}
	}
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	result = _result_;
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	return result;
#line 2841 "VideoTable.c"
}


void video_table_set_timestamp (VideoTable* self, VideoID* video_id, time_t timestamp, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	time_t _tmp2_;
	GError * _inner_error_ = NULL;
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (self != NULL);
#line 412 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	_tmp2_ = timestamp;
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 ((DatabaseTable*) self, _tmp1_, "timestamp", (gint64) _tmp2_, &_inner_error_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 2870 "VideoTable.c"
		} else {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
			return;
#line 2878 "VideoTable.c"
		}
	}
}


static void video_table_class_init (VideoTableClass * klass) {
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	video_table_parent_class = g_type_class_peek_parent (klass);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	((DatabaseTableClass *) klass)->finalize = video_table_finalize;
#line 2889 "VideoTable.c"
}


static void video_table_instance_init (VideoTable * self) {
}


static void video_table_finalize (DatabaseTable * obj) {
	VideoTable * self;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_TABLE, VideoTable);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
#line 2903 "VideoTable.c"
}


GType video_table_get_type (void) {
	static volatile gsize video_table_type_id__volatile = 0;
	if (g_once_init_enter (&video_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
		GType video_table_type_id;
		video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
		g_once_init_leave (&video_table_type_id__volatile, video_table_type_id);
	}
	return video_table_type_id__volatile;
}



