/* TopDisplay.c generated by valac 0.36.4, the Vala compiler
 * generated from TopDisplay.vala, do not modify */

/*
* Copyright (c) 2016 elementary LLC. (http://launchpad.net/pantheon-photos)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_TOP_DISPLAY (top_display_get_type ())
#define TOP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOP_DISPLAY, TopDisplay))
#define TOP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOP_DISPLAY, TopDisplayClass))
#define IS_TOP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOP_DISPLAY))
#define IS_TOP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOP_DISPLAY))
#define TOP_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOP_DISPLAY, TopDisplayClass))

typedef struct _TopDisplay TopDisplay;
typedef struct _TopDisplayClass TopDisplayClass;
typedef struct _TopDisplayPrivate TopDisplayPrivate;

#define TYPE_UNITY_PROGRESS_BAR (unity_progress_bar_get_type ())
#define UNITY_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNITY_PROGRESS_BAR, UnityProgressBar))
#define UNITY_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNITY_PROGRESS_BAR, UnityProgressBarClass))
#define IS_UNITY_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNITY_PROGRESS_BAR))
#define IS_UNITY_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNITY_PROGRESS_BAR))
#define UNITY_PROGRESS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNITY_PROGRESS_BAR, UnityProgressBarClass))

typedef struct _UnityProgressBar UnityProgressBar;
typedef struct _UnityProgressBarClass UnityProgressBarClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TopDisplay {
	GtkStack parent_instance;
	TopDisplayPrivate * priv;
};

struct _TopDisplayClass {
	GtkStackClass parent_class;
};

struct _TopDisplayPrivate {
	GtkLabel* app_label;
	GtkGrid* top_grid;
	GtkLabel* background_progress_label;
	GtkProgressBar* background_progress_bar;
	gint current_priority;
	guint background_progress_pulse_id;
	UnityProgressBar* uniprobar;
};


static gpointer top_display_parent_class = NULL;

GType top_display_get_type (void) G_GNUC_CONST;
GType unity_progress_bar_get_type (void) G_GNUC_CONST;
#define TOP_DISPLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TOP_DISPLAY, TopDisplayPrivate))
enum  {
	TOP_DISPLAY_DUMMY_PROPERTY
};
#define TOP_DISPLAY_BACKGROUND_PROGRESS_PULSE_MSEC 250
TopDisplay* top_display_new (void);
TopDisplay* top_display_construct (GType object_type);
void top_display_set_title (TopDisplay* self, const gchar* title);
void top_display_set_show_progress (TopDisplay* self, gboolean show_progress);
void top_display_start_pulse_background_progress_bar (TopDisplay* self, const gchar* label, gint priority);
void top_display_stop_pulse_background_progress_bar (TopDisplay* self, gint priority, gboolean clear);
static gboolean top_display_on_pulse_background_progress_bar (TopDisplay* self);
static gboolean _top_display_on_pulse_background_progress_bar_gsource_func (gpointer self);
void top_display_clear_background_progress_bar (TopDisplay* self, gint priority);
void top_display_update_background_progress_bar (TopDisplay* self, const gchar* label, gint priority, gdouble count, gdouble total);
void unity_progress_bar_set_visible (UnityProgressBar* self, gboolean visible);
void unity_progress_bar_set_progress (UnityProgressBar* self, gdouble percent);
void unity_progress_bar_reset (UnityProgressBar* self);
static GObject * top_display_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
UnityProgressBar* unity_progress_bar_get_instance (void);
static void top_display_finalize (GObject * obj);


TopDisplay* top_display_construct (GType object_type) {
	TopDisplay * self = NULL;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self = (TopDisplay*) g_object_new (object_type, NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	return self;
#line 110 "TopDisplay.c"
}


TopDisplay* top_display_new (void) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	return top_display_construct (TYPE_TOP_DISPLAY);
#line 117 "TopDisplay.c"
}


void top_display_set_title (TopDisplay* self, const gchar* title) {
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (title != NULL);
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = self->priv->app_label;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp1_ = title;
#line 64 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 134 "TopDisplay.c"
}


void top_display_set_show_progress (TopDisplay* self, gboolean show_progress) {
	gboolean _tmp0_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = show_progress;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp0_) {
#line 146 "TopDisplay.c"
		GtkGrid* _tmp1_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp1_ = self->priv->top_grid;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp1_);
#line 152 "TopDisplay.c"
	} else {
		GtkLabel* _tmp2_;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp2_ = self->priv->app_label;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp2_);
#line 159 "TopDisplay.c"
	}
}


static gboolean _top_display_on_pulse_background_progress_bar_gsource_func (gpointer self) {
	gboolean result;
	result = top_display_on_pulse_background_progress_bar ((TopDisplay*) self);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	return result;
#line 169 "TopDisplay.c"
}


void top_display_start_pulse_background_progress_bar (TopDisplay* self, const gchar* label, gint priority) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkLabel* _tmp4_;
	const gchar* _tmp5_;
	GtkProgressBar* _tmp6_;
	guint _tmp7_;
	guint _tmp9_;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (label != NULL);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = priority;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp1_ = self->priv->current_priority;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp0_ < _tmp1_) {
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		return;
#line 195 "TopDisplay.c"
	}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp2_ = priority;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, _tmp2_, FALSE);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp3_ = priority;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->current_priority = _tmp3_;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp4_ = self->priv->background_progress_label;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp5_ = label;
#line 83 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp4_, _tmp5_);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp6_ = self->priv->background_progress_bar;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_progress_bar_pulse (_tmp6_);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_set_show_progress (self, TRUE);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp7_ = self->priv->background_progress_pulse_id;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp7_ > ((guint) 0)) {
#line 221 "TopDisplay.c"
		guint _tmp8_;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp8_ = self->priv->background_progress_pulse_id;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		g_source_remove (_tmp8_);
#line 227 "TopDisplay.c"
	}
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp9_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) TOP_DISPLAY_BACKGROUND_PROGRESS_PULSE_MSEC, _top_display_on_pulse_background_progress_bar_gsource_func, g_object_ref (self), g_object_unref);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->background_progress_pulse_id = _tmp9_;
#line 233 "TopDisplay.c"
}


static gboolean top_display_on_pulse_background_progress_bar (TopDisplay* self) {
	gboolean result = FALSE;
	GtkProgressBar* _tmp0_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_bar;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_progress_bar_pulse (_tmp0_);
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	result = TRUE;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	return result;
#line 250 "TopDisplay.c"
}


void top_display_stop_pulse_background_progress_bar (TopDisplay* self, gint priority, gboolean clear) {
	gint _tmp0_;
	gint _tmp1_;
	guint _tmp2_;
	gboolean _tmp4_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = priority;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp1_ = self->priv->current_priority;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp0_ < _tmp1_) {
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		return;
#line 269 "TopDisplay.c"
	}
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp2_ = self->priv->background_progress_pulse_id;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp2_ > ((guint) 0)) {
#line 275 "TopDisplay.c"
		guint _tmp3_;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp3_ = self->priv->background_progress_pulse_id;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		g_source_remove (_tmp3_);
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		self->priv->background_progress_pulse_id = (guint) 0;
#line 283 "TopDisplay.c"
	}
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp4_ = clear;
#line 110 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp4_) {
#line 289 "TopDisplay.c"
		gint _tmp5_;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp5_ = priority;
#line 111 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		top_display_clear_background_progress_bar (self, _tmp5_);
#line 295 "TopDisplay.c"
	}
}


void top_display_update_background_progress_bar (TopDisplay* self, const gchar* label, gint priority, gdouble count, gdouble total) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gdouble _tmp5_;
	gint _tmp10_;
	gdouble fraction = 0.0;
	gdouble _tmp11_;
	gdouble _tmp12_;
	GtkProgressBar* _tmp13_;
	gdouble _tmp14_;
	GtkLabel* _tmp15_;
	const gchar* _tmp16_;
	gdouble _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	UnityProgressBar* _tmp20_;
	UnityProgressBar* _tmp21_;
	gdouble _tmp22_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (label != NULL);
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = priority;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp1_ = self->priv->current_priority;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp0_ < _tmp1_) {
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		return;
#line 333 "TopDisplay.c"
	}
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp2_ = priority;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, _tmp2_, FALSE);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp5_ = count;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp5_ <= 0.0) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp4_ = TRUE;
#line 345 "TopDisplay.c"
	} else {
		gdouble _tmp6_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp6_ = total;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp4_ = _tmp6_ <= 0.0;
#line 352 "TopDisplay.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp4_) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp3_ = TRUE;
#line 358 "TopDisplay.c"
	} else {
		gdouble _tmp7_;
		gdouble _tmp8_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp7_ = count;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp8_ = total;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp3_ = _tmp7_ >= _tmp8_;
#line 368 "TopDisplay.c"
	}
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp3_) {
#line 372 "TopDisplay.c"
		gint _tmp9_;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		_tmp9_ = priority;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		top_display_clear_background_progress_bar (self, _tmp9_);
#line 124 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		return;
#line 380 "TopDisplay.c"
	}
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp10_ = priority;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->current_priority = _tmp10_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp11_ = count;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp12_ = total;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	fraction = _tmp11_ / _tmp12_;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp13_ = self->priv->background_progress_bar;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp14_ = fraction;
#line 130 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_progress_bar_set_fraction (_tmp13_, _tmp14_);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp15_ = self->priv->background_progress_label;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp16_ = label;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp17_ = fraction;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp18_ = g_strdup_printf (_ ("%s (%d%%)"), _tmp16_, (gint) (_tmp17_ * 100.0));
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp19_ = _tmp18_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp15_, _tmp19_);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_free0 (_tmp19_);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_set_show_progress (self, TRUE);
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp20_ = self->priv->uniprobar;
#line 136 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	unity_progress_bar_set_visible (_tmp20_, TRUE);
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp21_ = self->priv->uniprobar;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp22_ = fraction;
#line 137 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	unity_progress_bar_set_progress (_tmp21_, _tmp22_);
#line 424 "TopDisplay.c"
}


void top_display_clear_background_progress_bar (TopDisplay* self, gint priority) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkProgressBar* _tmp3_;
	GtkLabel* _tmp4_;
	UnityProgressBar* _tmp5_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = priority;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp1_ = self->priv->current_priority;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	if (_tmp0_ < _tmp1_) {
#line 143 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
		return;
#line 445 "TopDisplay.c"
	}
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp2_ = priority;
#line 145 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, _tmp2_, FALSE);
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->current_priority = 0;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp3_ = self->priv->background_progress_bar;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_progress_bar_set_fraction (_tmp3_, 0.0);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp4_ = self->priv->background_progress_label;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp4_, "");
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_set_show_progress (self, FALSE);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp5_ = self->priv->uniprobar;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	unity_progress_bar_reset (_tmp5_);
#line 467 "TopDisplay.c"
}


static GObject * top_display_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TopDisplay * self;
	GtkStyleContext* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkGrid* _tmp4_;
	GtkGrid* _tmp5_;
	GtkGrid* _tmp6_;
	GtkGrid* _tmp7_;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkProgressBar* _tmp12_;
	GtkProgressBar* _tmp13_;
	GtkGrid* _tmp14_;
	GtkLabel* _tmp15_;
	GtkGrid* _tmp16_;
	GtkProgressBar* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	UnityProgressBar* _tmp20_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	parent_class = G_OBJECT_CLASS (top_display_parent_class);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOP_DISPLAY, TopDisplay);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_stack_set_transition_type ((GtkStack*) self, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_style_context_add_class (_tmp0_, "seek-bar");
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_ ("Photos"));
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp1_);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->app_label);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->app_label = _tmp1_;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp2_ = self->priv->app_label;
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 43 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_TITLE);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp4_ = (GtkGrid*) gtk_grid_new ();
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp4_);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->top_grid);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->top_grid = _tmp4_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp5_ = self->priv->top_grid;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp5_, GTK_ORIENTATION_VERTICAL);
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp6_ = self->priv->top_grid;
#line 46 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_grid_set_row_spacing (_tmp6_, 6);
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp7_ = self->priv->top_grid;
#line 47 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp8_ = self->priv->top_grid;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp9_ = self->priv->top_grid;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp9_, 200, -1);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp10_);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_label);
#line 50 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->background_progress_label = _tmp10_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp11_ = self->priv->background_progress_label;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp12_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp12_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_bar);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->background_progress_bar = _tmp12_;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp13_ = self->priv->background_progress_bar;
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp14_ = self->priv->top_grid;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp15_ = self->priv->background_progress_label;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp16_ = self->priv->top_grid;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp17_ = self->priv->background_progress_bar;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp18_ = self->priv->app_label;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp19_ = self->priv->top_grid;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_tmp20_ = unity_progress_bar_get_instance ();
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->uniprobar);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->uniprobar = _tmp20_;
#line 38 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	return obj;
#line 604 "TopDisplay.c"
}


static void top_display_class_init (TopDisplayClass * klass) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	top_display_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	g_type_class_add_private (klass, sizeof (TopDisplayPrivate));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->constructor = top_display_constructor;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->finalize = top_display_finalize;
#line 617 "TopDisplay.c"
}


static void top_display_instance_init (TopDisplay * self) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv = TOP_DISPLAY_GET_PRIVATE (self);
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->current_priority = 0;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self->priv->background_progress_pulse_id = 0U;
#line 628 "TopDisplay.c"
}


static void top_display_finalize (GObject * obj) {
	TopDisplay * self;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOP_DISPLAY, TopDisplay);
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->app_label);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->top_grid);
#line 23 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_label);
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_bar);
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->uniprobar);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/library/TopDisplay.vala"
	G_OBJECT_CLASS (top_display_parent_class)->finalize (obj);
#line 648 "TopDisplay.c"
}


GType top_display_get_type (void) {
	static volatile gsize top_display_type_id__volatile = 0;
	if (g_once_init_enter (&top_display_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TopDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) top_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TopDisplay), 0, (GInstanceInitFunc) top_display_instance_init, NULL };
		GType top_display_type_id;
		top_display_type_id = g_type_register_static (gtk_stack_get_type (), "TopDisplay", &g_define_type_info, 0);
		g_once_init_leave (&top_display_type_id__volatile, top_display_type_id);
	}
	return top_display_type_id__volatile;
}



