/* GRaw.c generated by valac 0.36.4, the Vala compiler
 * generated from GRaw.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <libraw/libraw.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define GRAW_TYPE_COLORSPACE (graw_colorspace_get_type ())

#define GRAW_TYPE_FLIP (graw_flip_get_type ())

#define GRAW_TYPE_FUJI_ROTATE (graw_fuji_rotate_get_type ())

#define GRAW_TYPE_HIGHLIGHT_MODE (graw_highlight_mode_get_type ())

#define GRAW_TYPE_INTERPOLATION_QUALITY (graw_interpolation_quality_get_type ())

#define GRAW_TYPE_PROCESSED_IMAGE (graw_processed_image_get_type ())
#define GRAW_PROCESSED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRAW_TYPE_PROCESSED_IMAGE, GRawProcessedImage))
#define GRAW_PROCESSED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRAW_TYPE_PROCESSED_IMAGE, GRawProcessedImageClass))
#define GRAW_IS_PROCESSED_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRAW_TYPE_PROCESSED_IMAGE))
#define GRAW_IS_PROCESSED_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRAW_TYPE_PROCESSED_IMAGE))
#define GRAW_PROCESSED_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRAW_TYPE_PROCESSED_IMAGE, GRawProcessedImageClass))

typedef struct _GRawProcessedImage GRawProcessedImage;
typedef struct _GRawProcessedImageClass GRawProcessedImageClass;
typedef struct _GRawProcessedImagePrivate GRawProcessedImagePrivate;
#define _free0(var) ((var == NULL) ? NULL : (var = (free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _graw_processed_image_unref0(var) ((var == NULL) ? NULL : (var = (graw_processed_image_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GRawParamSpecProcessedImage GRawParamSpecProcessedImage;

#define GRAW_TYPE_PROCESSOR (graw_processor_get_type ())
#define GRAW_PROCESSOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRAW_TYPE_PROCESSOR, GRawProcessor))
#define GRAW_PROCESSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRAW_TYPE_PROCESSOR, GRawProcessorClass))
#define GRAW_IS_PROCESSOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRAW_TYPE_PROCESSOR))
#define GRAW_IS_PROCESSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRAW_TYPE_PROCESSOR))
#define GRAW_PROCESSOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRAW_TYPE_PROCESSOR, GRawProcessorClass))

typedef struct _GRawProcessor GRawProcessor;
typedef struct _GRawProcessorClass GRawProcessorClass;
typedef struct _GRawProcessorPrivate GRawProcessorPrivate;
#define _libraw_close0(var) ((var == NULL) ? NULL : (var = (libraw_close (var), NULL)))
typedef struct _GRawParamSpecProcessor GRawParamSpecProcessor;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	GRAW_COLORSPACE_RAW = 0,
	GRAW_COLORSPACE_SRGB = 1,
	GRAW_COLORSPACE_ADOBE = 2,
	GRAW_COLORSPACE_WIDE = 3,
	GRAW_COLORSPACE_PROPHOTO = 4,
	GRAW_COLORSPACE_XYZ = 5
} GRawColorspace;

typedef enum  {
	GRAW_EXCEPTION_UNSPECIFIED,
	GRAW_EXCEPTION_UNSUPPORTED_FILE,
	GRAW_EXCEPTION_NONEXISTANT_IMAGE,
	GRAW_EXCEPTION_OUT_OF_ORDER_CALL,
	GRAW_EXCEPTION_NO_THUMBNAIL,
	GRAW_EXCEPTION_UNSUPPORTED_THUMBNAIL,
	GRAW_EXCEPTION_OUT_OF_MEMORY,
	GRAW_EXCEPTION_DATA_ERROR,
	GRAW_EXCEPTION_IO_ERROR,
	GRAW_EXCEPTION_CANCELLED_BY_CALLBACK,
	GRAW_EXCEPTION_BAD_CROP,
	GRAW_EXCEPTION_SYSTEM_ERROR
} GRawException;
#define GRAW_EXCEPTION graw_exception_quark ()
typedef enum  {
	GRAW_FLIP_FROM_SOURCE = -1,
	GRAW_FLIP_NONE = 0,
	GRAW_FLIP_UPSIDE_DOWN = 3,
	GRAW_FLIP_COUNTERCLOCKWISE = 5,
	GRAW_FLIP_CLOCKWISE = 6
} GRawFlip;

typedef enum  {
	GRAW_FUJI_ROTATE_USE = -1,
	GRAW_FUJI_ROTATE_DONT_USE = 0
} GRawFujiRotate;

typedef enum  {
	GRAW_HIGHLIGHT_MODE_CLIP = 0,
	GRAW_HIGHLIGHT_MODE_UNCLIP = 1,
	GRAW_HIGHLIGHT_MODE_BLEND = 2,
	GRAW_HIGHLIGHT_MODE_REBUILD = 3
} GRawHighlightMode;

typedef enum  {
	GRAW_INTERPOLATION_QUALITY_LINEAR = 0,
	GRAW_INTERPOLATION_QUALITY_VNG = 1,
	GRAW_INTERPOLATION_QUALITY_PPG = 2,
	GRAW_INTERPOLATION_QUALITY_AHD = 3
} GRawInterpolationQuality;

struct _GRawProcessedImage {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GRawProcessedImagePrivate * priv;
};

struct _GRawProcessedImageClass {
	GTypeClass parent_class;
	void (*finalize) (GRawProcessedImage *self);
};

struct _GRawProcessedImagePrivate {
	libraw_processed_image_t* image;
	GdkPixbuf* pixbuf;
};

struct _GRawParamSpecProcessedImage {
	GParamSpec parent_instance;
};

struct _GRawProcessor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GRawProcessorPrivate * priv;
};

struct _GRawProcessorClass {
	GTypeClass parent_class;
	void (*finalize) (GRawProcessor *self);
};

struct _GRawProcessorPrivate {
	libraw_data_t* proc;
};

struct _GRawParamSpecProcessor {
	GParamSpec parent_instance;
};


static gpointer graw_processed_image_parent_class = NULL;
static gpointer graw_processor_parent_class = NULL;

#define GRAW_HD_POWER 2.222
#define GRAW_HD_SLOPE 4.5
#define GRAW_SRGB_POWER 2.4
#define GRAW_SRGB_SLOPE 12.92
GType graw_colorspace_get_type (void) G_GNUC_CONST;
GQuark graw_exception_quark (void);
GType graw_flip_get_type (void) G_GNUC_CONST;
GType graw_fuji_rotate_get_type (void) G_GNUC_CONST;
GType graw_highlight_mode_get_type (void) G_GNUC_CONST;
GType graw_interpolation_quality_get_type (void) G_GNUC_CONST;
gpointer graw_processed_image_ref (gpointer instance);
void graw_processed_image_unref (gpointer instance);
GParamSpec* graw_param_spec_processed_image (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void graw_value_set_processed_image (GValue* value, gpointer v_object);
void graw_value_take_processed_image (GValue* value, gpointer v_object);
gpointer graw_value_get_processed_image (const GValue* value);
GType graw_processed_image_get_type (void) G_GNUC_CONST;
#define GRAW_PROCESSED_IMAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRAW_TYPE_PROCESSED_IMAGE, GRawProcessedImagePrivate))
enum  {
	GRAW_PROCESSED_IMAGE_DUMMY_PROPERTY
};
GRawProcessedImage* graw_processed_image_new (libraw_data_t* proc, GError** error);
GRawProcessedImage* graw_processed_image_construct (GType object_type, libraw_data_t* proc, GError** error);
void graw_throw_exception (const gchar* caller, enum LibRaw_errors _result_, GError** error);
GRawProcessedImage* graw_processed_image_new_from_thumb (libraw_data_t* proc, GError** error);
GRawProcessedImage* graw_processed_image_construct_from_thumb (GType object_type, libraw_data_t* proc, GError** error);
static guint8* _vala_array_dup15 (guint8* self, int length);
GdkPixbuf* graw_processed_image_get_pixbuf_copy (GRawProcessedImage* self);
gushort graw_processed_image_get_width (GRawProcessedImage* self);
gushort graw_processed_image_get_height (GRawProcessedImage* self);
gushort graw_processed_image_get_colors (GRawProcessedImage* self);
gushort graw_processed_image_get_bits (GRawProcessedImage* self);
guint8* graw_processed_image_get_data (GRawProcessedImage* self);
guint graw_processed_image_get_data_size (GRawProcessedImage* self);
static void graw_processed_image_finalize (GRawProcessedImage * obj);
gpointer graw_processor_ref (gpointer instance);
void graw_processor_unref (gpointer instance);
GParamSpec* graw_param_spec_processor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void graw_value_set_processor (GValue* value, gpointer v_object);
void graw_value_take_processor (GValue* value, gpointer v_object);
gpointer graw_value_get_processor (const GValue* value);
GType graw_processor_get_type (void) G_GNUC_CONST;
#define GRAW_PROCESSOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRAW_TYPE_PROCESSOR, GRawProcessorPrivate))
enum  {
	GRAW_PROCESSOR_DUMMY_PROPERTY
};
GRawProcessor* graw_processor_new (enum LibRaw_constructor_flags options);
GRawProcessor* graw_processor_construct (GType object_type, enum LibRaw_constructor_flags options);
void graw_processor_adjust_sizes_info_only (GRawProcessor* self, GError** error);
libraw_imgother_t graw_processor_get_image_other (GRawProcessor* self);
libraw_iparams_t graw_processor_get_image_params (GRawProcessor* self);
libraw_image_sizes_t graw_processor_get_sizes (GRawProcessor* self);
libraw_thumbnail_t graw_processor_get_thumbnail (GRawProcessor* self);
GRawProcessedImage* graw_processor_make_mem_image (GRawProcessor* self, GError** error);
GRawProcessedImage* graw_processor_make_thumb_image (GRawProcessor* self, GError** error);
void graw_processor_open_buffer (GRawProcessor* self, guint8* buffer, int buffer_length1, GError** error);
void graw_processor_open_file (GRawProcessor* self, const gchar* filename, GError** error);
void graw_processor_process (GRawProcessor* self, GError** error);
void graw_processor_ppm_tiff_writer (GRawProcessor* self, const gchar* filename, GError** error);
void graw_processor_thumb_writer (GRawProcessor* self, const gchar* filename, GError** error);
void graw_processor_recycle (GRawProcessor* self);
void graw_processor_unpack (GRawProcessor* self, GError** error);
void graw_processor_unpack_thumb (GRawProcessor* self, GError** error);
void graw_processor_configure_for_rgb_display (GRawProcessor* self, gboolean half_size);
libraw_output_params_t* graw_processor_get_output_params (GRawProcessor* self);
static void graw_processor_finalize (GRawProcessor * obj);


GType graw_colorspace_get_type (void) {
	static volatile gsize graw_colorspace_type_id__volatile = 0;
	if (g_once_init_enter (&graw_colorspace_type_id__volatile)) {
		static const GEnumValue values[] = {{GRAW_COLORSPACE_RAW, "GRAW_COLORSPACE_RAW", "raw"}, {GRAW_COLORSPACE_SRGB, "GRAW_COLORSPACE_SRGB", "srgb"}, {GRAW_COLORSPACE_ADOBE, "GRAW_COLORSPACE_ADOBE", "adobe"}, {GRAW_COLORSPACE_WIDE, "GRAW_COLORSPACE_WIDE", "wide"}, {GRAW_COLORSPACE_PROPHOTO, "GRAW_COLORSPACE_PROPHOTO", "prophoto"}, {GRAW_COLORSPACE_XYZ, "GRAW_COLORSPACE_XYZ", "xyz"}, {0, NULL, NULL}};
		GType graw_colorspace_type_id;
		graw_colorspace_type_id = g_enum_register_static ("GRawColorspace", values);
		g_once_init_leave (&graw_colorspace_type_id__volatile, graw_colorspace_type_id);
	}
	return graw_colorspace_type_id__volatile;
}


GQuark graw_exception_quark (void) {
	return g_quark_from_static_string ("graw_exception-quark");
}


GType graw_flip_get_type (void) {
	static volatile gsize graw_flip_type_id__volatile = 0;
	if (g_once_init_enter (&graw_flip_type_id__volatile)) {
		static const GEnumValue values[] = {{GRAW_FLIP_FROM_SOURCE, "GRAW_FLIP_FROM_SOURCE", "from-source"}, {GRAW_FLIP_NONE, "GRAW_FLIP_NONE", "none"}, {GRAW_FLIP_UPSIDE_DOWN, "GRAW_FLIP_UPSIDE_DOWN", "upside-down"}, {GRAW_FLIP_COUNTERCLOCKWISE, "GRAW_FLIP_COUNTERCLOCKWISE", "counterclockwise"}, {GRAW_FLIP_CLOCKWISE, "GRAW_FLIP_CLOCKWISE", "clockwise"}, {0, NULL, NULL}};
		GType graw_flip_type_id;
		graw_flip_type_id = g_enum_register_static ("GRawFlip", values);
		g_once_init_leave (&graw_flip_type_id__volatile, graw_flip_type_id);
	}
	return graw_flip_type_id__volatile;
}


GType graw_fuji_rotate_get_type (void) {
	static volatile gsize graw_fuji_rotate_type_id__volatile = 0;
	if (g_once_init_enter (&graw_fuji_rotate_type_id__volatile)) {
		static const GEnumValue values[] = {{GRAW_FUJI_ROTATE_USE, "GRAW_FUJI_ROTATE_USE", "use"}, {GRAW_FUJI_ROTATE_DONT_USE, "GRAW_FUJI_ROTATE_DONT_USE", "dont-use"}, {0, NULL, NULL}};
		GType graw_fuji_rotate_type_id;
		graw_fuji_rotate_type_id = g_enum_register_static ("GRawFujiRotate", values);
		g_once_init_leave (&graw_fuji_rotate_type_id__volatile, graw_fuji_rotate_type_id);
	}
	return graw_fuji_rotate_type_id__volatile;
}


GType graw_highlight_mode_get_type (void) {
	static volatile gsize graw_highlight_mode_type_id__volatile = 0;
	if (g_once_init_enter (&graw_highlight_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GRAW_HIGHLIGHT_MODE_CLIP, "GRAW_HIGHLIGHT_MODE_CLIP", "clip"}, {GRAW_HIGHLIGHT_MODE_UNCLIP, "GRAW_HIGHLIGHT_MODE_UNCLIP", "unclip"}, {GRAW_HIGHLIGHT_MODE_BLEND, "GRAW_HIGHLIGHT_MODE_BLEND", "blend"}, {GRAW_HIGHLIGHT_MODE_REBUILD, "GRAW_HIGHLIGHT_MODE_REBUILD", "rebuild"}, {0, NULL, NULL}};
		GType graw_highlight_mode_type_id;
		graw_highlight_mode_type_id = g_enum_register_static ("GRawHighlightMode", values);
		g_once_init_leave (&graw_highlight_mode_type_id__volatile, graw_highlight_mode_type_id);
	}
	return graw_highlight_mode_type_id__volatile;
}


GType graw_interpolation_quality_get_type (void) {
	static volatile gsize graw_interpolation_quality_type_id__volatile = 0;
	if (g_once_init_enter (&graw_interpolation_quality_type_id__volatile)) {
		static const GEnumValue values[] = {{GRAW_INTERPOLATION_QUALITY_LINEAR, "GRAW_INTERPOLATION_QUALITY_LINEAR", "linear"}, {GRAW_INTERPOLATION_QUALITY_VNG, "GRAW_INTERPOLATION_QUALITY_VNG", "vng"}, {GRAW_INTERPOLATION_QUALITY_PPG, "GRAW_INTERPOLATION_QUALITY_PPG", "ppg"}, {GRAW_INTERPOLATION_QUALITY_AHD, "GRAW_INTERPOLATION_QUALITY_AHD", "ahd"}, {0, NULL, NULL}};
		GType graw_interpolation_quality_type_id;
		graw_interpolation_quality_type_id = g_enum_register_static ("GRawInterpolationQuality", values);
		g_once_init_leave (&graw_interpolation_quality_type_id__volatile, graw_interpolation_quality_type_id);
	}
	return graw_interpolation_quality_type_id__volatile;
}


GRawProcessedImage* graw_processed_image_construct (GType object_type, libraw_data_t* proc, GError** error) {
	GRawProcessedImage* self = NULL;
	enum LibRaw_errors _result_ = 0;
	libraw_data_t* _tmp0_;
	libraw_processed_image_t* _tmp1_;
	enum LibRaw_errors _tmp2_;
	libraw_processed_image_t* _tmp3_;
	libraw_processed_image_t* _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	libraw_processed_image_t* _tmp6_;
	gushort _tmp7_;
	libraw_processed_image_t* _tmp8_;
	gushort _tmp9_;
	libraw_processed_image_t* _tmp10_;
	gushort _tmp11_;
	libraw_processed_image_t* _tmp12_;
	gushort _tmp13_;
	libraw_processed_image_t* _tmp14_;
	gushort _tmp15_;
	GdkPixbuf* _tmp16_;
	GError * _inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (proc != NULL, NULL);
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self = (GRawProcessedImage*) g_type_create_instance (object_type);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_result_ = LIBRAW_SUCCESS;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = proc;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_dcraw_make_mem_image (_tmp0_, &_result_);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_free0 (self->priv->image);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv->image = _tmp1_;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = _result_;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("ProcessedImage", _tmp2_, &_inner_error_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_graw_processed_image_unref0 (self);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 357 "GRaw.c"
		} else {
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 365 "GRaw.c"
		}
	}
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp3_ = self->priv->image;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_vala_assert (_tmp3_ != NULL, "image != null");
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp4_ = self->priv->image;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp5_ = _tmp4_->data;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp5__length1 = -1;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp6_ = self->priv->image;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp7_ = _tmp6_->bits;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp8_ = self->priv->image;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp9_ = _tmp8_->width;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp10_ = self->priv->image;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp11_ = _tmp10_->height;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp12_ = self->priv->image;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp13_ = _tmp12_->width;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp14_ = self->priv->image;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp15_ = _tmp14_->colors;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp16_ = gdk_pixbuf_new_from_data (_tmp5_, GDK_COLORSPACE_RGB, FALSE, (gint) _tmp7_, (gint) _tmp9_, (gint) _tmp11_, (gint) (_tmp13_ * _tmp15_), (GdkPixbufDestroyNotify) NULL, NULL);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv->pixbuf = _tmp16_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return self;
#line 406 "GRaw.c"
}


GRawProcessedImage* graw_processed_image_new (libraw_data_t* proc, GError** error) {
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return graw_processed_image_construct (GRAW_TYPE_PROCESSED_IMAGE, proc, error);
#line 413 "GRaw.c"
}


static guint8* _vala_array_dup15 (guint8* self, int length) {
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 420 "GRaw.c"
}


GRawProcessedImage* graw_processed_image_construct_from_thumb (GType object_type, libraw_data_t* proc, GError** error) {
	GRawProcessedImage* self = NULL;
	enum LibRaw_errors _result_ = 0;
	libraw_data_t* _tmp0_;
	libraw_processed_image_t* _tmp1_;
	enum LibRaw_errors _tmp2_;
	libraw_processed_image_t* _tmp3_;
	libraw_processed_image_t* _tmp16_;
	GdkPixbuf* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	libraw_processed_image_t* _tmp20_;
	GdkPixbuf* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	libraw_processed_image_t* _tmp24_;
	GdkPixbuf* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	libraw_processed_image_t* _tmp28_;
	GdkPixbuf* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	GError * _inner_error_ = NULL;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (proc != NULL, NULL);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self = (GRawProcessedImage*) g_type_create_instance (object_type);
#line 132 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_result_ = LIBRAW_SUCCESS;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = proc;
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_dcraw_make_mem_thumb (_tmp0_, &_result_);
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_free0 (self->priv->image);
#line 133 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv->image = _tmp1_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = _result_;
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("ProcessedImage.from_thumb", _tmp2_, &_inner_error_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_graw_processed_image_unref0 (self);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 476 "GRaw.c"
		} else {
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 134 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 484 "GRaw.c"
		}
	}
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp3_ = self->priv->image;
#line 135 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_vala_assert (_tmp3_ != NULL, "image != null");
#line 491 "GRaw.c"
	{
		GdkPixbuf* _tmp4_ = NULL;
		libraw_processed_image_t* _tmp5_;
		guint8* _tmp6_;
		gint _tmp6__length1;
		guint8* _tmp7_;
		gint _tmp7__length1;
		GMemoryInputStream* _tmp8_;
		GMemoryInputStream* _tmp9_;
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp5_ = self->priv->image;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp6_ = _tmp5_->data;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp6__length1 = -1;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup15 (_tmp6_, _tmp6__length1) : ((gpointer) _tmp6_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp7__length1 = _tmp6__length1;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp8_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp7_, _tmp7__length1, NULL);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp9_ = _tmp8_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp10_ = gdk_pixbuf_new_from_stream ((GInputStream*) _tmp9_, NULL, &_inner_error_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp11_ = _tmp10_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_g_object_unref0 (_tmp9_);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp4_ = _tmp11_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 528 "GRaw.c"
			goto __catch512_g_error;
		}
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp12_ = _tmp4_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp4_ = NULL;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_g_object_unref0 (self->priv->pixbuf);
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		self->priv->pixbuf = _tmp12_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_g_object_unref0 (_tmp4_);
#line 541 "GRaw.c"
	}
	goto __finally512;
	__catch512_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		GError* _tmp15_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		err = _inner_error_;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp13_ = err;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp14_ = _tmp13_->message;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp15_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_UNSUPPORTED_THUMBNAIL, _tmp14_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_inner_error_ = _tmp15_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_g_error_free0 (err);
#line 564 "GRaw.c"
		goto __finally512;
	}
	__finally512:
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_graw_processed_image_unref0 (self);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 578 "GRaw.c"
		} else {
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 586 "GRaw.c"
		}
	}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp16_ = self->priv->image;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp17_ = self->priv->pixbuf;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp18_ = gdk_pixbuf_get_width (_tmp17_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp19_ = _tmp18_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp16_->width = (gushort) _tmp19_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp20_ = self->priv->image;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp21_ = self->priv->pixbuf;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp22_ = gdk_pixbuf_get_height (_tmp21_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp23_ = _tmp22_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp20_->height = (gushort) _tmp23_;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp24_ = self->priv->image;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp25_ = self->priv->pixbuf;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp26_ = gdk_pixbuf_get_n_channels (_tmp25_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp27_ = _tmp26_;
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp24_->colors = (gushort) _tmp27_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp28_ = self->priv->image;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp29_ = self->priv->pixbuf;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp30_ = gdk_pixbuf_get_bits_per_sample (_tmp29_);
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp31_ = _tmp30_;
#line 151 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp28_->bits = (gushort) _tmp31_;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return self;
#line 631 "GRaw.c"
}


GRawProcessedImage* graw_processed_image_new_from_thumb (libraw_data_t* proc, GError** error) {
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return graw_processed_image_construct_from_thumb (GRAW_TYPE_PROCESSED_IMAGE, proc, error);
#line 638 "GRaw.c"
}


GdkPixbuf* graw_processed_image_get_pixbuf_copy (GRawProcessedImage* self) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->pixbuf;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = gdk_pixbuf_copy (_tmp0_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 656 "GRaw.c"
}


gushort graw_processed_image_get_width (GRawProcessedImage* self) {
	gushort result;
	libraw_processed_image_t* _tmp0_;
	gushort _tmp1_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->image;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_->width;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 674 "GRaw.c"
}


gushort graw_processed_image_get_height (GRawProcessedImage* self) {
	gushort result;
	libraw_processed_image_t* _tmp0_;
	gushort _tmp1_;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->image;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_->height;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 692 "GRaw.c"
}


gushort graw_processed_image_get_colors (GRawProcessedImage* self) {
	gushort result;
	libraw_processed_image_t* _tmp0_;
	gushort _tmp1_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->image;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_->colors;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 710 "GRaw.c"
}


gushort graw_processed_image_get_bits (GRawProcessedImage* self) {
	gushort result;
	libraw_processed_image_t* _tmp0_;
	gushort _tmp1_;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->image;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_->bits;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 728 "GRaw.c"
}


guint8* graw_processed_image_get_data (GRawProcessedImage* self) {
	guint8* result;
	libraw_processed_image_t* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->image;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_->data;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1__length1 = -1;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 109 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 749 "GRaw.c"
}


guint graw_processed_image_get_data_size (GRawProcessedImage* self) {
	guint result;
	libraw_processed_image_t* _tmp0_;
	guint _tmp1_;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->image;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_->data_size;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 767 "GRaw.c"
}


static void graw_value_processed_image_init (GValue* value) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	value->data[0].v_pointer = NULL;
#line 774 "GRaw.c"
}


static void graw_value_processed_image_free_value (GValue* value) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (value->data[0].v_pointer) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processed_image_unref (value->data[0].v_pointer);
#line 783 "GRaw.c"
	}
}


static void graw_value_processed_image_copy_value (const GValue* src_value, GValue* dest_value) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (src_value->data[0].v_pointer) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		dest_value->data[0].v_pointer = graw_processed_image_ref (src_value->data[0].v_pointer);
#line 793 "GRaw.c"
	} else {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		dest_value->data[0].v_pointer = NULL;
#line 797 "GRaw.c"
	}
}


static gpointer graw_value_processed_image_peek_pointer (const GValue* value) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return value->data[0].v_pointer;
#line 805 "GRaw.c"
}


static gchar* graw_value_processed_image_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (collect_values[0].v_pointer) {
#line 812 "GRaw.c"
		GRawProcessedImage * object;
		object = collect_values[0].v_pointer;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (object->parent_instance.g_class == NULL) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 819 "GRaw.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 823 "GRaw.c"
		}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = graw_processed_image_ref (object);
#line 827 "GRaw.c"
	} else {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = NULL;
#line 831 "GRaw.c"
	}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return NULL;
#line 835 "GRaw.c"
}


static gchar* graw_value_processed_image_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GRawProcessedImage ** object_p;
	object_p = collect_values[0].v_pointer;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (!object_p) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 846 "GRaw.c"
	}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (!value->data[0].v_pointer) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		*object_p = NULL;
#line 852 "GRaw.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		*object_p = value->data[0].v_pointer;
#line 856 "GRaw.c"
	} else {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		*object_p = graw_processed_image_ref (value->data[0].v_pointer);
#line 860 "GRaw.c"
	}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return NULL;
#line 864 "GRaw.c"
}


GParamSpec* graw_param_spec_processed_image (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GRawParamSpecProcessedImage* spec;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GRAW_TYPE_PROCESSED_IMAGE), NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return G_PARAM_SPEC (spec);
#line 878 "GRaw.c"
}


gpointer graw_value_get_processed_image (const GValue* value) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRAW_TYPE_PROCESSED_IMAGE), NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return value->data[0].v_pointer;
#line 887 "GRaw.c"
}


void graw_value_set_processed_image (GValue* value, gpointer v_object) {
	GRawProcessedImage * old;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRAW_TYPE_PROCESSED_IMAGE));
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	old = value->data[0].v_pointer;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (v_object) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRAW_TYPE_PROCESSED_IMAGE));
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = v_object;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processed_image_ref (value->data[0].v_pointer);
#line 907 "GRaw.c"
	} else {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = NULL;
#line 911 "GRaw.c"
	}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (old) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processed_image_unref (old);
#line 917 "GRaw.c"
	}
}


void graw_value_take_processed_image (GValue* value, gpointer v_object) {
	GRawProcessedImage * old;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRAW_TYPE_PROCESSED_IMAGE));
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	old = value->data[0].v_pointer;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (v_object) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRAW_TYPE_PROCESSED_IMAGE));
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = v_object;
#line 936 "GRaw.c"
	} else {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = NULL;
#line 940 "GRaw.c"
	}
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (old) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processed_image_unref (old);
#line 946 "GRaw.c"
	}
}


static void graw_processed_image_class_init (GRawProcessedImageClass * klass) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_processed_image_parent_class = g_type_class_peek_parent (klass);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	((GRawProcessedImageClass *) klass)->finalize = graw_processed_image_finalize;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_type_class_add_private (klass, sizeof (GRawProcessedImagePrivate));
#line 958 "GRaw.c"
}


static void graw_processed_image_instance_init (GRawProcessedImage * self) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv = GRAW_PROCESSED_IMAGE_GET_PRIVATE (self);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv->pixbuf = NULL;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->ref_count = 1;
#line 969 "GRaw.c"
}


static void graw_processed_image_finalize (GRawProcessedImage * obj) {
	GRawProcessedImage * self;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRAW_TYPE_PROCESSED_IMAGE, GRawProcessedImage);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_signal_handlers_destroy (self);
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_free0 (self->priv->image);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 983 "GRaw.c"
}


GType graw_processed_image_get_type (void) {
	static volatile gsize graw_processed_image_type_id__volatile = 0;
	if (g_once_init_enter (&graw_processed_image_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { graw_value_processed_image_init, graw_value_processed_image_free_value, graw_value_processed_image_copy_value, graw_value_processed_image_peek_pointer, "p", graw_value_processed_image_collect_value, "p", graw_value_processed_image_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GRawProcessedImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) graw_processed_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GRawProcessedImage), 0, (GInstanceInitFunc) graw_processed_image_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType graw_processed_image_type_id;
		graw_processed_image_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GRawProcessedImage", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&graw_processed_image_type_id__volatile, graw_processed_image_type_id);
	}
	return graw_processed_image_type_id__volatile;
}


gpointer graw_processed_image_ref (gpointer instance) {
	GRawProcessedImage * self;
	self = instance;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_atomic_int_inc (&self->ref_count);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return instance;
#line 1008 "GRaw.c"
}


void graw_processed_image_unref (gpointer instance) {
	GRawProcessedImage * self;
	self = instance;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		GRAW_PROCESSED_IMAGE_GET_CLASS (self)->finalize (self);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1021 "GRaw.c"
	}
}


GRawProcessor* graw_processor_construct (GType object_type, enum LibRaw_constructor_flags options) {
	GRawProcessor* self = NULL;
	enum LibRaw_constructor_flags _tmp0_;
	libraw_data_t* _tmp1_;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self = (GRawProcessor*) g_type_create_instance (object_type);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = options;
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_init (_tmp0_);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_libraw_close0 (self->priv->proc);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv->proc = _tmp1_;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return self;
#line 1042 "GRaw.c"
}


GRawProcessor* graw_processor_new (enum LibRaw_constructor_flags options) {
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return graw_processor_construct (GRAW_TYPE_PROCESSOR, options);
#line 1049 "GRaw.c"
}


void graw_processor_adjust_sizes_info_only (GRawProcessor* self, GError** error) {
	libraw_data_t* _tmp0_;
	enum LibRaw_errors _tmp1_;
	GError * _inner_error_ = NULL;
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_adjust_sizes_info_only (_tmp0_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("adjust_sizes_info_only", _tmp1_, &_inner_error_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1073 "GRaw.c"
		} else {
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1081 "GRaw.c"
		}
	}
}


static libraw_imgother_t libraw_get_image_other (libraw_data_t* self) {
	libraw_imgother_t result = {0};
	libraw_imgother_t _tmp0_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp0_ = self->other;
#line 188 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	result = _tmp0_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	return result;
#line 1096 "GRaw.c"
}


libraw_imgother_t graw_processor_get_image_other (GRawProcessor* self) {
	libraw_imgother_t result = {0};
	libraw_data_t* _tmp0_;
	libraw_imgother_t _tmp1_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_get_image_other (_tmp0_);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1112 "GRaw.c"
}


static libraw_iparams_t libraw_get_image_params (libraw_data_t* self) {
	libraw_iparams_t result = {0};
	libraw_iparams_t _tmp0_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp0_ = self->idata;
#line 189 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	result = _tmp0_;
#line 189 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	return result;
#line 1125 "GRaw.c"
}


libraw_iparams_t graw_processor_get_image_params (GRawProcessor* self) {
	libraw_iparams_t result = {0};
	libraw_data_t* _tmp0_;
	libraw_iparams_t _tmp1_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_get_image_params (_tmp0_);
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1141 "GRaw.c"
}


static libraw_image_sizes_t libraw_get_sizes (libraw_data_t* self) {
	libraw_image_sizes_t result = {0};
	libraw_image_sizes_t _tmp0_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp0_ = self->sizes;
#line 192 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	result = _tmp0_;
#line 192 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	return result;
#line 1154 "GRaw.c"
}


libraw_image_sizes_t graw_processor_get_sizes (GRawProcessor* self) {
	libraw_image_sizes_t result = {0};
	libraw_data_t* _tmp0_;
	libraw_image_sizes_t _tmp1_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_get_sizes (_tmp0_);
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1170 "GRaw.c"
}


static libraw_thumbnail_t libraw_get_thumbnail (libraw_data_t* self) {
	libraw_thumbnail_t result = {0};
	libraw_thumbnail_t _tmp0_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp0_ = self->thumbnail;
#line 193 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	result = _tmp0_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	return result;
#line 1183 "GRaw.c"
}


libraw_thumbnail_t graw_processor_get_thumbnail (GRawProcessor* self) {
	libraw_thumbnail_t result = {0};
	libraw_data_t* _tmp0_;
	libraw_thumbnail_t _tmp1_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_get_thumbnail (_tmp0_);
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp1_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1199 "GRaw.c"
}


GRawProcessedImage* graw_processor_make_mem_image (GRawProcessor* self, GError** error) {
	GRawProcessedImage* result = NULL;
	GRawProcessedImage* _tmp0_ = NULL;
	libraw_data_t* _tmp1_;
	GRawProcessedImage* _tmp2_;
	GRawProcessedImage* _tmp3_;
	GError * _inner_error_ = NULL;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = self->priv->proc;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = graw_processed_image_new (_tmp1_, &_inner_error_);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = _tmp2_;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 1226 "GRaw.c"
		} else {
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 1234 "GRaw.c"
		}
	}
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp3_ = _tmp0_;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = NULL;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp3_;
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_graw_processed_image_unref0 (_tmp0_);
#line 194 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1247 "GRaw.c"
}


GRawProcessedImage* graw_processor_make_thumb_image (GRawProcessor* self, GError** error) {
	GRawProcessedImage* result = NULL;
	GRawProcessedImage* _tmp0_ = NULL;
	libraw_data_t* _tmp1_;
	GRawProcessedImage* _tmp2_;
	GRawProcessedImage* _tmp3_;
	GError * _inner_error_ = NULL;
#line 197 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = self->priv->proc;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = graw_processed_image_new_from_thumb (_tmp1_, &_inner_error_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = _tmp2_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 1274 "GRaw.c"
		} else {
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return NULL;
#line 1282 "GRaw.c"
		}
	}
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp3_ = _tmp0_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = NULL;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = _tmp3_;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_graw_processed_image_unref0 (_tmp0_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1295 "GRaw.c"
}


void graw_processor_open_buffer (GRawProcessor* self, guint8* buffer, int buffer_length1, GError** error) {
	libraw_data_t* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	enum LibRaw_errors _tmp2_;
	GError * _inner_error_ = NULL;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = buffer;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1__length1 = buffer_length1;
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = libraw_open_buffer (_tmp0_, _tmp1_, _tmp1__length1);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("open_buffer", _tmp2_, &_inner_error_);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1325 "GRaw.c"
		} else {
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 202 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1333 "GRaw.c"
		}
	}
}


void graw_processor_open_file (GRawProcessor* self, const gchar* filename, GError** error) {
	libraw_data_t* _tmp0_;
	const gchar* _tmp1_;
	enum LibRaw_errors _tmp2_;
	GError * _inner_error_ = NULL;
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (filename != NULL);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = filename;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = libraw_open_file (_tmp0_, _tmp1_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("open_file", _tmp2_, &_inner_error_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1364 "GRaw.c"
		} else {
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1372 "GRaw.c"
		}
	}
}


void graw_processor_process (GRawProcessor* self, GError** error) {
	libraw_data_t* _tmp0_;
	enum LibRaw_errors _tmp1_;
	GError * _inner_error_ = NULL;
#line 209 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_dcraw_process (_tmp0_);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("process", _tmp1_, &_inner_error_);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1398 "GRaw.c"
		} else {
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 210 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1406 "GRaw.c"
		}
	}
}


void graw_processor_ppm_tiff_writer (GRawProcessor* self, const gchar* filename, GError** error) {
	libraw_data_t* _tmp0_;
	const gchar* _tmp1_;
	enum LibRaw_errors _tmp2_;
	GError * _inner_error_ = NULL;
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 213 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (filename != NULL);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = filename;
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = libraw_dcraw_ppm_tiff_writer (_tmp0_, _tmp1_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("ppm_tiff_writer", _tmp2_, &_inner_error_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1437 "GRaw.c"
		} else {
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 214 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1445 "GRaw.c"
		}
	}
}


void graw_processor_thumb_writer (GRawProcessor* self, const gchar* filename, GError** error) {
	libraw_data_t* _tmp0_;
	const gchar* _tmp1_;
	enum LibRaw_errors _tmp2_;
	GError * _inner_error_ = NULL;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (filename != NULL);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = filename;
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = libraw_dcraw_thumb_writer (_tmp0_, _tmp1_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("thumb_writer", _tmp2_, &_inner_error_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1476 "GRaw.c"
		} else {
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 218 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1484 "GRaw.c"
		}
	}
}


void graw_processor_recycle (GRawProcessor* self) {
	libraw_data_t* _tmp0_;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	libraw_recycle (_tmp0_);
#line 1498 "GRaw.c"
}


void graw_processor_unpack (GRawProcessor* self, GError** error) {
	libraw_data_t* _tmp0_;
	enum LibRaw_errors _tmp1_;
	GError * _inner_error_ = NULL;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_unpack (_tmp0_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("unpack", _tmp1_, &_inner_error_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1522 "GRaw.c"
		} else {
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1530 "GRaw.c"
		}
	}
}


void graw_processor_unpack_thumb (GRawProcessor* self, GError** error) {
	libraw_data_t* _tmp0_;
	enum LibRaw_errors _tmp1_;
	GError * _inner_error_ = NULL;
#line 229 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = libraw_unpack_thumb (_tmp0_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_throw_exception ("unpack_thumb", _tmp1_, &_inner_error_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_propagate_error (error, _inner_error_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1556 "GRaw.c"
		} else {
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			g_clear_error (&_inner_error_);
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 1564 "GRaw.c"
		}
	}
}


static void lib_raw_output_params_set_chromatic_aberrations (libraw_output_params_t self, gdouble red_multiplier, gdouble green_multiplier) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp0_ = red_multiplier;
#line 148 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	self.aber[0] = _tmp0_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp1_ = self.aber[0];
#line 149 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp2_ = green_multiplier;
#line 149 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	self.aber[2] = _tmp2_;
#line 149 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp3_ = self.aber[2];
#line 1587 "GRaw.c"
}


static void lib_raw_output_params_set_gamma_curve (libraw_output_params_t self, gdouble power, gdouble slope) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp0_ = power;
#line 153 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	self.gamm[0] = _tmp0_;
#line 153 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp1_ = self.gamm[0];
#line 154 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp2_ = slope;
#line 154 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	self.gamm[1] = _tmp2_;
#line 154 "/builddir/build/BUILD/photos-0.2.4/vapi/libraw.vapi"
	_tmp3_ = self.gamm[1];
#line 1608 "GRaw.c"
}


void graw_processor_configure_for_rgb_display (GRawProcessor* self, gboolean half_size) {
	libraw_output_params_t* _tmp0_;
	libraw_output_params_t* _tmp1_;
	libraw_output_params_t* _tmp2_;
	libraw_output_params_t* _tmp3_;
	libraw_output_params_t* _tmp4_;
	libraw_output_params_t* _tmp5_;
	libraw_output_params_t* _tmp6_;
	libraw_output_params_t* _tmp7_;
	gboolean _tmp8_;
	libraw_output_params_t* _tmp9_;
	libraw_output_params_t* _tmp10_;
	libraw_output_params_t* _tmp11_;
	libraw_output_params_t* _tmp12_;
	libraw_output_params_t* _tmp13_;
	libraw_output_params_t* _tmp14_;
	libraw_output_params_t* _tmp15_;
	libraw_output_params_t* _tmp16_;
	libraw_output_params_t* _tmp17_;
	libraw_output_params_t* _tmp18_;
	libraw_output_params_t* _tmp19_;
	libraw_output_params_t* _tmp20_;
	libraw_output_params_t* _tmp21_;
	libraw_output_params_t* _tmp22_;
	libraw_output_params_t* _tmp23_;
	libraw_output_params_t* _tmp24_;
	libraw_output_params_t* _tmp25_;
	libraw_output_params_t* _tmp26_;
	libraw_output_params_t* _tmp27_;
	libraw_output_params_t* _tmp28_;
	libraw_output_params_t* _tmp29_;
	libraw_output_params_t* _tmp30_;
#line 236 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (self != NULL);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = graw_processor_get_output_params (self);
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp1_ = _tmp0_;
#line 241 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	lib_raw_output_params_set_chromatic_aberrations (*_tmp1_, 1.0, 1.0);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp2_ = graw_processor_get_output_params (self);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp3_ = _tmp2_;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	lib_raw_output_params_set_gamma_curve (*_tmp3_, GRAW_SRGB_POWER, GRAW_SRGB_SLOPE);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp4_ = graw_processor_get_output_params (self);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp5_ = _tmp4_;
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp5_).bright = 1.0f;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp6_ = graw_processor_get_output_params (self);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp7_ = _tmp6_;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp8_ = half_size;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp7_).half_size = _tmp8_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp9_ = graw_processor_get_output_params (self);
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp10_ = _tmp9_;
#line 250 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp10_).highlight = (gint) GRAW_HIGHLIGHT_MODE_CLIP;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp11_ = graw_processor_get_output_params (self);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp12_ = _tmp11_;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp12_).use_auto_wb = TRUE;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp13_ = graw_processor_get_output_params (self);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp14_ = _tmp13_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp14_).use_camera_wb = TRUE;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp15_ = graw_processor_get_output_params (self);
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp16_ = _tmp15_;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp16_).use_camera_matrix = TRUE;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp17_ = graw_processor_get_output_params (self);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp18_ = _tmp17_;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp18_).output_color = (gint) GRAW_COLORSPACE_SRGB;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp19_ = graw_processor_get_output_params (self);
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp20_ = _tmp19_;
#line 259 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp20_).output_bps = 8;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp21_ = graw_processor_get_output_params (self);
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp22_ = _tmp21_;
#line 261 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp22_).user_flip = (gint) GRAW_FLIP_FROM_SOURCE;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp23_ = graw_processor_get_output_params (self);
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp24_ = _tmp23_;
#line 262 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp24_).user_qual = (gint) GRAW_INTERPOLATION_QUALITY_PPG;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp25_ = graw_processor_get_output_params (self);
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp26_ = _tmp25_;
#line 266 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp26_).no_auto_bright = TRUE;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp27_ = graw_processor_get_output_params (self);
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp28_ = _tmp27_;
#line 267 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp28_).auto_bright_thr = 0.01f;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp29_ = graw_processor_get_output_params (self);
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp30_ = _tmp29_;
#line 268 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	(*_tmp30_).use_fuji_rotate = (gint) GRAW_FUJI_ROTATE_USE;
#line 1738 "GRaw.c"
}


libraw_output_params_t* graw_processor_get_output_params (GRawProcessor* self) {
	libraw_output_params_t* result;
	libraw_data_t* _tmp0_;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = self->priv->proc;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	result = &_tmp0_->params;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return result;
#line 1753 "GRaw.c"
}


static void graw_value_processor_init (GValue* value) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	value->data[0].v_pointer = NULL;
#line 1760 "GRaw.c"
}


static void graw_value_processor_free_value (GValue* value) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (value->data[0].v_pointer) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processor_unref (value->data[0].v_pointer);
#line 1769 "GRaw.c"
	}
}


static void graw_value_processor_copy_value (const GValue* src_value, GValue* dest_value) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (src_value->data[0].v_pointer) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		dest_value->data[0].v_pointer = graw_processor_ref (src_value->data[0].v_pointer);
#line 1779 "GRaw.c"
	} else {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1783 "GRaw.c"
	}
}


static gpointer graw_value_processor_peek_pointer (const GValue* value) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return value->data[0].v_pointer;
#line 1791 "GRaw.c"
}


static gchar* graw_value_processor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (collect_values[0].v_pointer) {
#line 1798 "GRaw.c"
		GRawProcessor * object;
		object = collect_values[0].v_pointer;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (object->parent_instance.g_class == NULL) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1805 "GRaw.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1809 "GRaw.c"
		}
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = graw_processor_ref (object);
#line 1813 "GRaw.c"
	} else {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = NULL;
#line 1817 "GRaw.c"
	}
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return NULL;
#line 1821 "GRaw.c"
}


static gchar* graw_value_processor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GRawProcessor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (!object_p) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1832 "GRaw.c"
	}
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (!value->data[0].v_pointer) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		*object_p = NULL;
#line 1838 "GRaw.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		*object_p = value->data[0].v_pointer;
#line 1842 "GRaw.c"
	} else {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		*object_p = graw_processor_ref (value->data[0].v_pointer);
#line 1846 "GRaw.c"
	}
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return NULL;
#line 1850 "GRaw.c"
}


GParamSpec* graw_param_spec_processor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GRawParamSpecProcessor* spec;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GRAW_TYPE_PROCESSOR), NULL);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return G_PARAM_SPEC (spec);
#line 1864 "GRaw.c"
}


gpointer graw_value_get_processor (const GValue* value) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRAW_TYPE_PROCESSOR), NULL);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return value->data[0].v_pointer;
#line 1873 "GRaw.c"
}


void graw_value_set_processor (GValue* value, gpointer v_object) {
	GRawProcessor * old;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRAW_TYPE_PROCESSOR));
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	old = value->data[0].v_pointer;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (v_object) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRAW_TYPE_PROCESSOR));
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = v_object;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processor_ref (value->data[0].v_pointer);
#line 1893 "GRaw.c"
	} else {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = NULL;
#line 1897 "GRaw.c"
	}
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (old) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processor_unref (old);
#line 1903 "GRaw.c"
	}
}


void graw_value_take_processor (GValue* value, gpointer v_object) {
	GRawProcessor * old;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRAW_TYPE_PROCESSOR));
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	old = value->data[0].v_pointer;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (v_object) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRAW_TYPE_PROCESSOR));
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = v_object;
#line 1922 "GRaw.c"
	} else {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		value->data[0].v_pointer = NULL;
#line 1926 "GRaw.c"
	}
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (old) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		graw_processor_unref (old);
#line 1932 "GRaw.c"
	}
}


static void graw_processor_class_init (GRawProcessorClass * klass) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	graw_processor_parent_class = g_type_class_peek_parent (klass);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	((GRawProcessorClass *) klass)->finalize = graw_processor_finalize;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_type_class_add_private (klass, sizeof (GRawProcessorPrivate));
#line 1944 "GRaw.c"
}


static void graw_processor_instance_init (GRawProcessor * self) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->priv = GRAW_PROCESSOR_GET_PRIVATE (self);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self->ref_count = 1;
#line 1953 "GRaw.c"
}


static void graw_processor_finalize (GRawProcessor * obj) {
	GRawProcessor * self;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRAW_TYPE_PROCESSOR, GRawProcessor);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_signal_handlers_destroy (self);
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_libraw_close0 (self->priv->proc);
#line 1965 "GRaw.c"
}


GType graw_processor_get_type (void) {
	static volatile gsize graw_processor_type_id__volatile = 0;
	if (g_once_init_enter (&graw_processor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { graw_value_processor_init, graw_value_processor_free_value, graw_value_processor_copy_value, graw_value_processor_peek_pointer, "p", graw_value_processor_collect_value, "p", graw_value_processor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GRawProcessorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) graw_processor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GRawProcessor), 0, (GInstanceInitFunc) graw_processor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType graw_processor_type_id;
		graw_processor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GRawProcessor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&graw_processor_type_id__volatile, graw_processor_type_id);
	}
	return graw_processor_type_id__volatile;
}


gpointer graw_processor_ref (gpointer instance) {
	GRawProcessor * self;
	self = instance;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_atomic_int_inc (&self->ref_count);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	return instance;
#line 1990 "GRaw.c"
}


void graw_processor_unref (gpointer instance) {
	GRawProcessor * self;
	self = instance;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		GRAW_PROCESSOR_GET_CLASS (self)->finalize (self);
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2003 "GRaw.c"
	}
}


void graw_throw_exception (const gchar* caller, enum LibRaw_errors _result_, GError** error) {
	enum LibRaw_errors _tmp0_;
	gchar* msg = NULL;
	const gchar* _tmp7_;
	enum LibRaw_errors _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	enum LibRaw_errors _tmp11_;
	GError * _inner_error_ = NULL;
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	g_return_if_fail (caller != NULL);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp0_ = _result_;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	if (_tmp0_ == LIBRAW_SUCCESS) {
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		return;
#line 2025 "GRaw.c"
	} else {
		enum LibRaw_errors _tmp1_;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		_tmp1_ = _result_;
#line 275 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		if (_tmp1_ > 0) {
#line 2032 "GRaw.c"
			const gchar* _tmp2_;
			enum LibRaw_errors _tmp3_;
			enum LibRaw_errors _tmp4_;
			const gchar* _tmp5_;
			GError* _tmp6_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp2_ = caller;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp3_ = _result_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp4_ = _result_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp5_ = g_strerror ((gint) _tmp4_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp6_ = g_error_new (GRAW_EXCEPTION, GRAW_EXCEPTION_SYSTEM_ERROR, "%s: System error %d: %s", _tmp2_, (gint) _tmp3_, _tmp5_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp6_;
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2056 "GRaw.c"
			} else {
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 276 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2064 "GRaw.c"
			}
		}
	}
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp7_ = caller;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp8_ = _result_;
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp9_ = libraw_strerror (_tmp8_);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp10_ = g_strdup_printf ("%s: %s", _tmp7_, _tmp9_);
#line 278 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	msg = _tmp10_;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_tmp11_ = _result_;
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	switch (_tmp11_) {
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_UNSPECIFIED_ERROR:
#line 2084 "GRaw.c"
		{
			const gchar* _tmp12_;
			GError* _tmp13_;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp12_ = msg;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp13_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_UNSPECIFIED, _tmp12_);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp13_;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2102 "GRaw.c"
			} else {
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2112 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_FILE_UNSUPPORTED:
#line 2117 "GRaw.c"
		{
			const gchar* _tmp14_;
			GError* _tmp15_;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp14_ = msg;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp15_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_UNSUPPORTED_FILE, _tmp14_);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp15_;
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2135 "GRaw.c"
			} else {
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 285 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2145 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_REQUEST_FOR_NONEXISTENT_IMAGE:
#line 2150 "GRaw.c"
		{
			const gchar* _tmp16_;
			GError* _tmp17_;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp16_ = msg;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp17_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_NONEXISTANT_IMAGE, _tmp16_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp17_;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2168 "GRaw.c"
			} else {
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2178 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_OUT_OF_ORDER_CALL:
#line 2183 "GRaw.c"
		{
			const gchar* _tmp18_;
			GError* _tmp19_;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp18_ = msg;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp19_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_OUT_OF_ORDER_CALL, _tmp18_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp19_;
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2201 "GRaw.c"
			} else {
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 291 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2211 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_NO_THUMBNAIL:
#line 2216 "GRaw.c"
		{
			const gchar* _tmp20_;
			GError* _tmp21_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp20_ = msg;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp21_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_NO_THUMBNAIL, _tmp20_);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp21_;
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2234 "GRaw.c"
			} else {
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 294 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2244 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_UNSUPPORTED_THUMBNAIL:
#line 2249 "GRaw.c"
		{
			const gchar* _tmp22_;
			GError* _tmp23_;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp22_ = msg;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp23_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_UNSUPPORTED_THUMBNAIL, _tmp22_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp23_;
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2267 "GRaw.c"
			} else {
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 297 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2277 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_UNSUFFICIENT_MEMORY:
#line 2282 "GRaw.c"
		{
			const gchar* _tmp24_;
			GError* _tmp25_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp24_ = msg;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp25_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_OUT_OF_MEMORY, _tmp24_);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp25_;
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2300 "GRaw.c"
			} else {
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 300 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2310 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_DATA_ERROR:
#line 2315 "GRaw.c"
		{
			const gchar* _tmp26_;
			GError* _tmp27_;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp26_ = msg;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp27_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_DATA_ERROR, _tmp26_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp27_;
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2333 "GRaw.c"
			} else {
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 303 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2343 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_IO_ERROR:
#line 2348 "GRaw.c"
		{
			const gchar* _tmp28_;
			GError* _tmp29_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp28_ = msg;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp29_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_IO_ERROR, _tmp28_);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp29_;
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2366 "GRaw.c"
			} else {
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 306 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2376 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_CANCELLED_BY_CALLBACK:
#line 2381 "GRaw.c"
		{
			const gchar* _tmp30_;
			GError* _tmp31_;
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp30_ = msg;
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp31_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_CANCELLED_BY_CALLBACK, _tmp30_);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp31_;
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2399 "GRaw.c"
			} else {
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 309 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2409 "GRaw.c"
			}
		}
#line 280 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
		case LIBRAW_BAD_CROP:
#line 2414 "GRaw.c"
		{
			const gchar* _tmp32_;
			GError* _tmp33_;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp32_ = msg;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_tmp33_ = g_error_new_literal (GRAW_EXCEPTION, GRAW_EXCEPTION_BAD_CROP, _tmp32_);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_inner_error_ = _tmp33_;
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			if (_inner_error_->domain == GRAW_EXCEPTION) {
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_propagate_error (error, _inner_error_);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2432 "GRaw.c"
			} else {
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				_g_free0 (msg);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				g_clear_error (&_inner_error_);
#line 312 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
				return;
#line 2442 "GRaw.c"
			}
		}
		default:
		{
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			_g_free0 (msg);
#line 315 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
			return;
#line 2451 "GRaw.c"
		}
	}
#line 272 "/builddir/build/BUILD/photos-0.2.4/src/photos/GRaw.vala"
	_g_free0 (msg);
#line 2456 "GRaw.c"
}



