/* KeyValueMap.c generated by valac 0.36.4, the Vala compiler
 * generated from KeyValueMap.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;
typedef struct _KeyValueMapPrivate KeyValueMapPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
typedef struct _ParamSpecKeyValueMap ParamSpecKeyValueMap;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KeyValueMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	KeyValueMapPrivate * priv;
};

struct _KeyValueMapClass {
	GTypeClass parent_class;
	void (*finalize) (KeyValueMap *self);
};

struct _KeyValueMapPrivate {
	gchar* group;
	GeeHashMap* map;
};

struct _ParamSpecKeyValueMap {
	GParamSpec parent_instance;
};


static gpointer key_value_map_parent_class = NULL;

gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
#define KEY_VALUE_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_KEY_VALUE_MAP, KeyValueMapPrivate))
enum  {
	KEY_VALUE_MAP_DUMMY_PROPERTY
};
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
gchar* key_value_map_get_group (KeyValueMap* self);
GeeSet* key_value_map_get_keys (KeyValueMap* self);
gboolean key_value_map_has_key (KeyValueMap* self, const gchar* key);
void key_value_map_set_string (KeyValueMap* self, const gchar* key, const gchar* value);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
void key_value_map_set_double (KeyValueMap* self, const gchar* key, gdouble value);
void key_value_map_set_float (KeyValueMap* self, const gchar* key, gfloat value);
void key_value_map_set_bool (KeyValueMap* self, const gchar* key, gboolean value);
gchar* key_value_map_get_string (KeyValueMap* self, const gchar* key, const gchar* def);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
gdouble key_value_map_get_double (KeyValueMap* self, const gchar* key, gdouble def);
gfloat key_value_map_get_float (KeyValueMap* self, const gchar* key, gfloat def);
gboolean key_value_map_get_bool (KeyValueMap* self, const gchar* key, gboolean def);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static void key_value_map_finalize (KeyValueMap * obj);


KeyValueMap* key_value_map_construct (GType object_type, const gchar* group) {
	KeyValueMap* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	self = (KeyValueMap*) g_type_create_instance (object_type);
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = group;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (self->priv->group);
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	self->priv->group = _tmp1_;
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return self;
#line 128 "KeyValueMap.c"
}


KeyValueMap* key_value_map_new (const gchar* group) {
#line 24 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return key_value_map_construct (TYPE_KEY_VALUE_MAP, group);
#line 135 "KeyValueMap.c"
}


KeyValueMap* key_value_map_copy (KeyValueMap* self) {
	KeyValueMap* result = NULL;
	KeyValueMap* clone = NULL;
	const gchar* _tmp0_;
	KeyValueMap* _tmp1_;
#line 28 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->group;
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key_value_map_new (_tmp0_);
#line 29 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	clone = _tmp1_;
#line 152 "KeyValueMap.c"
	{
		GeeIterator* _key_it = NULL;
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp2_ = self->priv->map;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp2_);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp4_ = _tmp3_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_ = _tmp4_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp7_ = _tmp6_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_g_object_unref0 (_tmp5_);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_key_it = _tmp7_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		while (TRUE) {
#line 179 "KeyValueMap.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_;
			gchar* key = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			KeyValueMap* _tmp12_;
			GeeHashMap* _tmp13_;
			const gchar* _tmp14_;
			GeeHashMap* _tmp15_;
			const gchar* _tmp16_;
			gpointer _tmp17_;
			gchar* _tmp18_;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp8_ = _key_it;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			if (!_tmp9_) {
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
				break;
#line 200 "KeyValueMap.c"
			}
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp10_ = _key_it;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			key = (gchar*) _tmp11_;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp12_ = clone;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp13_ = _tmp12_->priv->map;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp14_ = key;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp15_ = self->priv->map;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp16_ = key;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp18_ = (gchar*) _tmp17_;
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp18_);
#line 31 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_g_free0 (_tmp18_);
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_g_free0 (key);
#line 228 "KeyValueMap.c"
		}
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_g_object_unref0 (_key_it);
#line 232 "KeyValueMap.c"
	}
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = clone;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 238 "KeyValueMap.c"
}


gchar* key_value_map_get_group (KeyValueMap* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->group;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp1_;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 256 "KeyValueMap.c"
}


GeeSet* key_value_map_get_keys (KeyValueMap* self) {
	GeeSet* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = _tmp1_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp2_;
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 277 "KeyValueMap.c"
}


gboolean key_value_map_has_key (KeyValueMap* self, const gchar* key) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp2_;
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 300 "KeyValueMap.c"
}


void key_value_map_set_string (KeyValueMap* self, const gchar* key, const gchar* value) {
	const gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (value != NULL);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = key;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_vala_assert (_tmp0_ != NULL, "key != null");
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = self->priv->map;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = key;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = value;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _tmp2_, _tmp3_);
#line 327 "KeyValueMap.c"
}


void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value) {
	const gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = key;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_vala_assert (_tmp0_ != NULL, "key != null");
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = self->priv->map;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = key;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = value;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp5_ = _tmp4_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _tmp2_, _tmp5_);
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (_tmp5_);
#line 360 "KeyValueMap.c"
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 871 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 390 "KeyValueMap.c"
}


void key_value_map_set_double (KeyValueMap* self, const gchar* key, gdouble value) {
	const gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = key;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_vala_assert (_tmp0_ != NULL, "key != null");
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = self->priv->map;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = key;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = value;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = double_to_string (_tmp3_);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp5_ = _tmp4_;
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _tmp2_, _tmp5_);
#line 63 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (_tmp5_);
#line 423 "KeyValueMap.c"
}


void key_value_map_set_float (KeyValueMap* self, const gchar* key, gfloat value) {
	const gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	gfloat _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = key;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_vala_assert (_tmp0_ != NULL, "key != null");
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = self->priv->map;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = key;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = value;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = g_strdup_printf ("%g", _tmp3_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp5_ = _tmp4_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _tmp2_, _tmp5_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (_tmp5_);
#line 456 "KeyValueMap.c"
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
#line 37 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (self) {
#line 464 "KeyValueMap.c"
		gchar* _tmp0_;
#line 38 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp0_;
#line 38 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 472 "KeyValueMap.c"
	} else {
		gchar* _tmp1_;
#line 40 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp1_;
#line 40 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 481 "KeyValueMap.c"
	}
}


void key_value_map_set_bool (KeyValueMap* self, const gchar* key, gboolean value) {
	const gchar* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = key;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_vala_assert (_tmp0_ != NULL, "key != null");
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = self->priv->map;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = key;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = value;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = bool_to_string (_tmp3_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp5_ = _tmp4_;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _tmp2_, _tmp5_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (_tmp5_);
#line 515 "KeyValueMap.c"
}


gchar* key_value_map_get_string (KeyValueMap* self, const gchar* key, const gchar* def) {
	gchar* result = NULL;
	gchar* value = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gchar* _tmp7_;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value = (gchar*) _tmp2_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = value;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (_tmp4_ != NULL) {
#line 544 "KeyValueMap.c"
		const gchar* _tmp5_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_ = value;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp5_;
#line 550 "KeyValueMap.c"
	} else {
		const gchar* _tmp6_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = def;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp6_;
#line 557 "KeyValueMap.c"
	}
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp7_ = g_strdup (_tmp3_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp7_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (value);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 567 "KeyValueMap.c"
}


gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def) {
	gint result = 0;
	gchar* value = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	gint _tmp3_ = 0;
	const gchar* _tmp4_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (key != NULL, 0);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value = (gchar*) _tmp2_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = value;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (_tmp4_ != NULL) {
#line 595 "KeyValueMap.c"
		const gchar* _tmp5_;
		gint _tmp6_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_ = value;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = atoi (_tmp5_);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp6_;
#line 604 "KeyValueMap.c"
	} else {
		gint _tmp7_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp7_ = def;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp7_;
#line 611 "KeyValueMap.c"
	}
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp3_;
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (value);
#line 87 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 619 "KeyValueMap.c"
}


static gdouble double_parse (const gchar* str) {
	gdouble result = 0.0;
	const gchar* _tmp0_;
	gdouble _tmp1_;
#line 877 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 878 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 878 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (_tmp0_, NULL);
#line 878 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 878 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 637 "KeyValueMap.c"
}


gdouble key_value_map_get_double (KeyValueMap* self, const gchar* key, gdouble def) {
	gdouble result = 0.0;
	gchar* value = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	gdouble _tmp3_ = 0.0;
	const gchar* _tmp4_;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (key != NULL, 0.0);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value = (gchar*) _tmp2_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = value;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (_tmp4_ != NULL) {
#line 665 "KeyValueMap.c"
		const gchar* _tmp5_;
		gdouble _tmp6_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_ = value;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = double_parse (_tmp5_);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp6_;
#line 674 "KeyValueMap.c"
	} else {
		gdouble _tmp7_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp7_ = def;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp7_;
#line 681 "KeyValueMap.c"
	}
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp3_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (value);
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 689 "KeyValueMap.c"
}


gfloat key_value_map_get_float (KeyValueMap* self, const gchar* key, gfloat def) {
	gfloat result = 0.0F;
	gchar* value = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	gfloat _tmp3_ = 0.0F;
	const gchar* _tmp4_;
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 96 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (key != NULL, 0.0F);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value = (gchar*) _tmp2_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = value;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (_tmp4_ != NULL) {
#line 717 "KeyValueMap.c"
		const gchar* _tmp5_;
		gdouble _tmp6_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_ = value;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = double_parse (_tmp5_);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = (gfloat) _tmp6_;
#line 726 "KeyValueMap.c"
	} else {
		gfloat _tmp7_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp7_ = def;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp7_;
#line 733 "KeyValueMap.c"
	}
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp3_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (value);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 741 "KeyValueMap.c"
}


static gboolean bool_parse (const gchar* str) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 44 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 45 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (g_strcmp0 (_tmp0_, "true") == 0) {
#line 46 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = TRUE;
#line 46 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 758 "KeyValueMap.c"
	} else {
#line 48 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = FALSE;
#line 48 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 764 "KeyValueMap.c"
	}
}


gboolean key_value_map_get_bool (KeyValueMap* self, const gchar* key, gboolean def) {
	gboolean result = FALSE;
	gchar* value = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 102 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value = (gchar*) _tmp2_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = value;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (_tmp4_ != NULL) {
#line 793 "KeyValueMap.c"
		const gchar* _tmp5_;
		gboolean _tmp6_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_ = value;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = bool_parse (_tmp5_);
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp6_;
#line 802 "KeyValueMap.c"
	} else {
		gboolean _tmp7_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp7_ = def;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp3_ = _tmp7_;
#line 809 "KeyValueMap.c"
	}
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	result = _tmp3_;
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (value);
#line 105 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return result;
#line 817 "KeyValueMap.c"
}


void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result) {
	gchar* value = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	const gchar* _tmp3_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (def != NULL);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 114 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value = (gchar*) _tmp2_;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = value;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (_tmp3_ == NULL) {
#line 845 "KeyValueMap.c"
		GdkPoint _tmp4_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp4_ = *def;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		*result = _tmp4_;
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_g_free0 (value);
#line 117 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		return;
#line 855 "KeyValueMap.c"
	} else {
		GdkPoint _result_ = {0};
		GdkPoint _tmp5_ = {0};
		const gchar* _tmp6_;
		gint _tmp7_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp5_.x = 0;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_result_ = _tmp5_;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp6_ = value;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		_tmp7_ = sscanf (_tmp6_, "(%d, %d)", &_result_.x, &_result_.y);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		if (_tmp7_ == 2) {
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			*result = _result_;
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_g_free0 (value);
#line 121 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			return;
#line 877 "KeyValueMap.c"
		} else {
			GdkPoint _tmp8_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_tmp8_ = *def;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			*result = _tmp8_;
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			_g_free0 (value);
#line 123 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			return;
#line 888 "KeyValueMap.c"
		}
	}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (value);
#line 893 "KeyValueMap.c"
}


void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	GdkPoint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (key != NULL);
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (point != NULL);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = self->priv->map;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp1_ = key;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp2_ = *point;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp3_ = _tmp2_.x;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp4_ = *point;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp5_ = _tmp4_.y;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp6_ = g_strdup_printf ("(%d, %d)", _tmp3_, _tmp5_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp7_ = _tmp6_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp1_, _tmp7_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (_tmp7_);
#line 932 "KeyValueMap.c"
}


static void value_key_value_map_init (GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	value->data[0].v_pointer = NULL;
#line 939 "KeyValueMap.c"
}


static void value_key_value_map_free_value (GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		key_value_map_unref (value->data[0].v_pointer);
#line 948 "KeyValueMap.c"
	}
}


static void value_key_value_map_copy_value (const GValue* src_value, GValue* dest_value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		dest_value->data[0].v_pointer = key_value_map_ref (src_value->data[0].v_pointer);
#line 958 "KeyValueMap.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		dest_value->data[0].v_pointer = NULL;
#line 962 "KeyValueMap.c"
	}
}


static gpointer value_key_value_map_peek_pointer (const GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return value->data[0].v_pointer;
#line 970 "KeyValueMap.c"
}


static gchar* value_key_value_map_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (collect_values[0].v_pointer) {
#line 977 "KeyValueMap.c"
		KeyValueMap * object;
		object = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 984 "KeyValueMap.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 988 "KeyValueMap.c"
		}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		value->data[0].v_pointer = key_value_map_ref (object);
#line 992 "KeyValueMap.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		value->data[0].v_pointer = NULL;
#line 996 "KeyValueMap.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return NULL;
#line 1000 "KeyValueMap.c"
}


static gchar* value_key_value_map_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	KeyValueMap ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (!object_p) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1011 "KeyValueMap.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (!value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		*object_p = NULL;
#line 1017 "KeyValueMap.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		*object_p = value->data[0].v_pointer;
#line 1021 "KeyValueMap.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		*object_p = key_value_map_ref (value->data[0].v_pointer);
#line 1025 "KeyValueMap.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return NULL;
#line 1029 "KeyValueMap.c"
}


GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecKeyValueMap* spec;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_KEY_VALUE_MAP), NULL);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return G_PARAM_SPEC (spec);
#line 1043 "KeyValueMap.c"
}


gpointer value_get_key_value_map (const GValue* value) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEY_VALUE_MAP), NULL);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return value->data[0].v_pointer;
#line 1052 "KeyValueMap.c"
}


void value_set_key_value_map (GValue* value, gpointer v_object) {
	KeyValueMap * old;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEY_VALUE_MAP));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KEY_VALUE_MAP));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		value->data[0].v_pointer = v_object;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		key_value_map_ref (value->data[0].v_pointer);
#line 1072 "KeyValueMap.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		value->data[0].v_pointer = NULL;
#line 1076 "KeyValueMap.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		key_value_map_unref (old);
#line 1082 "KeyValueMap.c"
	}
}


void value_take_key_value_map (GValue* value, gpointer v_object) {
	KeyValueMap * old;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_KEY_VALUE_MAP));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_KEY_VALUE_MAP));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		value->data[0].v_pointer = v_object;
#line 1101 "KeyValueMap.c"
	} else {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		value->data[0].v_pointer = NULL;
#line 1105 "KeyValueMap.c"
	}
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		key_value_map_unref (old);
#line 1111 "KeyValueMap.c"
	}
}


static void key_value_map_class_init (KeyValueMapClass * klass) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	key_value_map_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	((KeyValueMapClass *) klass)->finalize = key_value_map_finalize;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_type_class_add_private (klass, sizeof (KeyValueMapPrivate));
#line 1123 "KeyValueMap.c"
}


static void key_value_map_instance_init (KeyValueMap * self) {
	GeeHashMap* _tmp0_;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	self->priv = KEY_VALUE_MAP_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	self->priv->map = _tmp0_;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	self->ref_count = 1;
#line 1137 "KeyValueMap.c"
}


static void key_value_map_finalize (KeyValueMap * obj) {
	KeyValueMap * self;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KEY_VALUE_MAP, KeyValueMap);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_signal_handlers_destroy (self);
#line 21 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_free0 (self->priv->group);
#line 22 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	_g_object_unref0 (self->priv->map);
#line 1151 "KeyValueMap.c"
}


GType key_value_map_get_type (void) {
	static volatile gsize key_value_map_type_id__volatile = 0;
	if (g_once_init_enter (&key_value_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_key_value_map_init, value_key_value_map_free_value, value_key_value_map_copy_value, value_key_value_map_peek_pointer, "p", value_key_value_map_collect_value, "p", value_key_value_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (KeyValueMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) key_value_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyValueMap), 0, (GInstanceInitFunc) key_value_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType key_value_map_type_id;
		key_value_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "KeyValueMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&key_value_map_type_id__volatile, key_value_map_type_id);
	}
	return key_value_map_type_id__volatile;
}


gpointer key_value_map_ref (gpointer instance) {
	KeyValueMap * self;
	self = instance;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	return instance;
#line 1176 "KeyValueMap.c"
}


void key_value_map_unref (gpointer instance) {
	KeyValueMap * self;
	self = instance;
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		KEY_VALUE_MAP_GET_CLASS (self)->finalize (self);
#line 20 "/builddir/build/BUILD/photos-0.2.4/src/util/KeyValueMap.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1189 "KeyValueMap.c"
	}
}



