/* file.c generated by valac 0.36.4, the Vala compiler
 * generated from file.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);


gboolean claim_file (GFile* file, GError** error);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
void disassemble_filename (const gchar* basename, gchar* * name, gchar* * ext);
glong find_last_offset (const gchar* str, gchar c);
guint64 query_total_file_size (GFile* file_or_dir, GCancellable* cancellable, GError** error);
void delete_all_files (GFile* dir, GeeSet* exceptions, ProgressMonitor monitor, void* monitor_target, guint64 file_count, GCancellable* cancellable, GError** error);
time_t query_file_modified (GFile* file, GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir, GError** error);
gchar* get_display_pathname (GFile* file);
gchar* strip_pretty_path (const gchar* path);
gchar* get_file_info_id (GFileInfo* info);
void skip_uint64 (GInputStream* input, guint64 skip_amount, GError** error);
guint64 count_files_in_directory (GFile* dir, GError** error);
gboolean file_equal (GFile* a, GFile* b);
guint file_hash (GFile* file);


static gpointer _g_error_copy0 (gpointer self) {
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 65 "file.c"
}


gboolean claim_file (GFile* file, GError** error) {
	gboolean result = FALSE;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 25 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 75 "file.c"
	{
		GFile* _tmp0_;
		GFileOutputStream* _tmp1_;
		GFileOutputStream* _tmp2_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = file;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = g_file_create (_tmp0_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = _tmp1_;
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 27 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "file.c"
			goto __catch545_g_error;
		}
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = TRUE;
#line 30 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 97 "file.c"
	}
	goto __finally545;
	__catch545_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		err = _inner_error_;
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = NULL;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = err;
#line 33 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!g_error_matches (_tmp3_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 112 "file.c"
			GFile* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GError* _tmp7_;
			const gchar* _tmp8_;
			GError* _tmp9_;
			GError* _tmp10_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp4_ = file;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp5_ = g_file_get_path (_tmp4_);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp6_ = _tmp5_;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp7_ = err;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp8_ = _tmp7_->message;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_warning ("file.vala:34: claim_file %s: %s", _tmp6_, _tmp8_);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_free0 (_tmp6_);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp9_ = err;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp10_ = _g_error_copy0 (_tmp9_);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_inner_error_ = _tmp10_;
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 142 "file.c"
			goto __finally545;
		}
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = FALSE;
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_error_free0 (err);
#line 39 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 151 "file.c"
	}
	__finally545:
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_propagate_error (error, _inner_error_);
#line 26 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return _tmp11_;
#line 158 "file.c"
}


GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error) {
	gboolean _vala_collision = FALSE;
	GFile* result = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	gboolean _tmp5_;
	gchar* name = NULL;
	gchar* ext = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	GFile* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	GError * _inner_error_ = NULL;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = dir;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = basename;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	file = _tmp2_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = file;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp5_ = claim_file (_tmp4_, &_inner_error_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (file);
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return NULL;
#line 208 "file.c"
	}
#line 52 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp3_) {
#line 53 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_collision = FALSE;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = file;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (collision) {
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			*collision = _vala_collision;
#line 220 "file.c"
		}
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 224 "file.c"
	}
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_vala_collision = TRUE;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp6_ = basename;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	disassemble_filename (_tmp6_, &_tmp7_, &_tmp8_);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (name);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	name = _tmp7_;
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (ext);
#line 62 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	ext = _tmp8_;
#line 240 "file.c"
	{
		gint ctr = 0;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		ctr = 1;
#line 245 "file.c"
		{
			gboolean _tmp9_ = FALSE;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp9_ = TRUE;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			while (TRUE) {
#line 252 "file.c"
				gint _tmp11_;
				gchar* _tmp12_ = NULL;
				const gchar* _tmp13_;
				gchar* new_name = NULL;
				gchar* _tmp21_;
				GFile* _tmp22_;
				const gchar* _tmp23_;
				GFile* _tmp24_;
				gboolean _tmp25_ = FALSE;
				GFile* _tmp26_;
				gboolean _tmp27_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (!_tmp9_) {
#line 266 "file.c"
					gint _tmp10_;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp10_ = ctr;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					ctr = _tmp10_ + 1;
#line 272 "file.c"
				}
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp9_ = FALSE;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp11_ = ctr;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (!(_tmp11_ < G_MAXINT)) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					break;
#line 282 "file.c"
				}
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp13_ = ext;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (_tmp13_ != NULL) {
#line 288 "file.c"
					const gchar* _tmp14_;
					gint _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp14_ = name;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp15_ = ctr;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp16_ = ext;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp17_ = g_strdup_printf ("%s_%d.%s", _tmp14_, _tmp15_, _tmp16_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp12_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp12_ = _tmp17_;
#line 305 "file.c"
				} else {
					const gchar* _tmp18_;
					gint _tmp19_;
					gchar* _tmp20_;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp18_ = name;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp19_ = ctr;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp20_ = g_strdup_printf ("%s_%d", _tmp18_, _tmp19_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp12_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_tmp12_ = _tmp20_;
#line 320 "file.c"
				}
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp21_ = g_strdup (_tmp12_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				new_name = _tmp21_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp22_ = dir;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp23_ = new_name;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp24_ = g_file_get_child (_tmp22_, _tmp23_);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_object_unref0 (file);
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				file = _tmp24_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp26_ = file;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp27_ = claim_file (_tmp26_, &_inner_error_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp25_ = _tmp27_;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					g_propagate_error (error, _inner_error_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (new_name);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp12_);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (ext);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (name);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_object_unref0 (file);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					return NULL;
#line 358 "file.c"
				}
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				if (_tmp25_) {
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					result = file;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (new_name);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (_tmp12_);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (ext);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					_g_free0 (name);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					if (collision) {
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
						*collision = _vala_collision;
#line 376 "file.c"
					}
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
					return result;
#line 380 "file.c"
				}
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_free0 (new_name);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_free0 (_tmp12_);
#line 386 "file.c"
			}
		}
	}
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp28_ = dir;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp29_ = g_file_get_path (_tmp28_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp30_ = _tmp29_;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp31_ = basename;
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_warning ("file.vala:73: generate_unique_filename %s for %s: unable to claim file", _tmp30_, _tmp31_);
#line 73 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (_tmp30_);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = NULL;
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (ext);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (name);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (file);
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (collision) {
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		*collision = _vala_collision;
#line 414 "file.c"
	}
#line 75 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 418 "file.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 441 "file.c"
		glong _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 449 "file.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 461 "file.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
#line 1333 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 485 "file.c"
		glong _tmp2_;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 491 "file.c"
	} else {
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 495 "file.c"
	}
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 499 "file.c"
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 511 "file.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 521 "file.c"
	}
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 527 "file.c"
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 541 "file.c"
	} else {
		glong _tmp12_;
		glong _tmp13_;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 551 "file.c"
	}
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 557 "file.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 566 "file.c"
	}
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 586 "file.c"
}


void disassemble_filename (const gchar* basename, gchar* * name, gchar* * ext) {
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
	const gchar* _tmp0_;
	glong _tmp1_;
	glong _tmp2_;
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = basename;
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = find_last_offset (_tmp0_, '.');
#line 79 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	offset = _tmp1_;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = offset;
#line 80 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp2_ <= ((glong) 0)) {
#line 609 "file.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = basename;
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_name);
#line 81 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_name = _tmp4_;
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_ext);
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_ext = NULL;
#line 624 "file.c"
	} else {
		const gchar* _tmp5_;
		glong _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		glong _tmp9_;
		gchar* _tmp10_;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = basename;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = offset;
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp7_ = string_substring (_tmp5_, (glong) 0, _tmp6_);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_name);
#line 84 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_name = _tmp7_;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp8_ = basename;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp9_ = offset;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp10_ = string_substring (_tmp8_, _tmp9_ + 1, (glong) -1);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_ext);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_vala_ext = _tmp10_;
#line 652 "file.c"
	}
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (name) {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		*name = _vala_name;
#line 658 "file.c"
	} else {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_name);
#line 662 "file.c"
	}
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (ext) {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		*ext = _vala_ext;
#line 668 "file.c"
	} else {
#line 78 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_vala_ext);
#line 672 "file.c"
	}
}


guint64 query_total_file_size (GFile* file_or_dir, GCancellable* cancellable, GError** error) {
	guint64 result = 0ULL;
	GFileType type = 0;
	GFile* _tmp0_;
	GFileType _tmp1_;
	GFileType _tmp2_;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file_or_dir != NULL, 0ULL);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = file_or_dir;
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_query_file_type (_tmp0_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 91 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	type = _tmp1_;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = type;
#line 92 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp2_ == G_FILE_TYPE_REGULAR) {
#line 699 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp17_;
		gint64 _tmp18_;
#line 93 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = NULL;
#line 705 "file.c"
		{
			GFileInfo* _tmp3_ = NULL;
			GFile* _tmp4_;
			GCancellable* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp4_ = file_or_dir;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp5_ = cancellable;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp6_ = g_file_query_info (_tmp4_, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, _tmp5_, &_inner_error_);
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp3_ = _tmp6_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 722 "file.c"
				goto __catch546_g_error;
			}
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp7_ = _tmp3_;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp3_ = NULL;
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 95 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			info = _tmp7_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp3_);
#line 735 "file.c"
		}
		goto __finally546;
		__catch546_g_error:
		{
			GError* err = NULL;
			GError* _tmp8_;
			GFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GError* _tmp14_;
			const gchar* _tmp15_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			err = _inner_error_;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_inner_error_ = NULL;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp8_ = err;
#line 98 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (g_error_matches (_tmp8_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 755 "file.c"
				GError* _tmp9_;
				GError* _tmp10_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp9_ = err;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_inner_error_ = _tmp10_;
#line 99 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				_g_error_free0 (err);
#line 766 "file.c"
				goto __finally546;
			}
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp11_ = file_or_dir;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp12_ = g_file_get_path (_tmp11_);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp13_ = _tmp12_;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp14_ = err;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp15_ = _tmp14_->message;
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_debug ("file.vala:101: Unable to query filesize for %s: %s", _tmp13_, _tmp15_);
#line 101 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_free0 (_tmp13_);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 103 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 791 "file.c"
		}
		__finally546:
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 796 "file.c"
			guint64 _tmp16_ = 0ULL;
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 94 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp16_;
#line 804 "file.c"
		}
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp17_ = info;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp18_ = g_file_info_get_size (_tmp17_);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = (guint64) _tmp18_;
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 106 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 816 "file.c"
	} else {
		GFileType _tmp19_;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp19_ = type;
#line 107 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp19_ != G_FILE_TYPE_DIRECTORY) {
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 108 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 827 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp20_ = NULL;
		GFile* _tmp21_;
		GCancellable* _tmp22_;
		GFileEnumerator* _tmp23_;
		GFileEnumerator* _tmp24_;
		GFileEnumerator* _tmp25_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp21_ = file_or_dir;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp22_ = cancellable;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp23_ = g_file_enumerate_children (_tmp21_, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, _tmp22_, &_inner_error_);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp20_ = _tmp23_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 847 "file.c"
			goto __catch547_g_error;
		}
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp24_ = _tmp20_;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp20_ = NULL;
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 113 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		enumerator = _tmp24_;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp25_ = enumerator;
#line 115 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp25_ == NULL) {
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp20_);
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 116 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 870 "file.c"
		}
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp20_);
#line 874 "file.c"
	}
	goto __finally547;
	__catch547_g_error:
	{
		GError* err = NULL;
		gboolean _tmp26_ = FALSE;
		GError* _tmp27_;
		GError* _tmp29_;
		GError* _tmp30_;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		err = _inner_error_;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp27_ = err;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (g_error_matches (_tmp27_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp26_ = TRUE;
#line 894 "file.c"
		} else {
			GError* _tmp28_;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp28_ = err;
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp26_ = g_error_matches (_tmp28_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 901 "file.c"
		}
#line 119 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp26_) {
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			result = (guint64) 0;
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 120 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return result;
#line 913 "file.c"
		}
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp29_ = err;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp30_ = _g_error_copy0 (_tmp29_);
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = _tmp30_;
#line 122 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_error_free0 (err);
#line 923 "file.c"
		goto __finally547;
	}
	__finally547:
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 929 "file.c"
		guint64 _tmp31_ = 0ULL;
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 112 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp31_;
#line 937 "file.c"
	}
#line 125 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	total_bytes = (guint64) 0;
#line 127 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = NULL;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 945 "file.c"
		GFileInfo* _tmp32_ = NULL;
		GFileEnumerator* _tmp33_;
		GCancellable* _tmp34_;
		GFileInfo* _tmp35_;
		GFileInfo* _tmp37_;
		GFileInfo* _tmp38_;
		guint64 _tmp39_ = 0ULL;
		GFile* _tmp40_;
		GFileInfo* _tmp41_;
		const gchar* _tmp42_;
		GFile* _tmp43_;
		GFile* _tmp44_;
		GCancellable* _tmp45_;
		guint64 _tmp46_;
		guint64 _tmp47_;
		guint64 _tmp49_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp33_ = enumerator;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp34_ = cancellable;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp35_ = g_file_enumerator_next_file (_tmp33_, _tmp34_, &_inner_error_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp32_ = _tmp35_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 972 "file.c"
			guint64 _tmp36_ = 0ULL;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp36_;
#line 982 "file.c"
		}
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp37_ = _tmp32_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp32_ = NULL;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = _tmp37_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp38_ = info;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp38_ != NULL)) {
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp32_);
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1000 "file.c"
		}
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp40_ = file_or_dir;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp41_ = info;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp42_ = g_file_info_get_name (_tmp41_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp43_ = g_file_get_child (_tmp40_, _tmp42_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp44_ = _tmp43_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp45_ = cancellable;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp46_ = query_total_file_size (_tmp44_, _tmp45_, &_inner_error_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp47_ = _tmp46_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp44_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp39_ = _tmp47_;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1024 "file.c"
			guint64 _tmp48_ = 0ULL;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp32_);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp48_;
#line 1036 "file.c"
		}
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp49_ = total_bytes;
#line 129 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		total_bytes = _tmp49_ + _tmp39_;
#line 128 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp32_);
#line 1044 "file.c"
	}
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = total_bytes;
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 131 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1054 "file.c"
}


void delete_all_files (GFile* dir, GeeSet* exceptions, ProgressMonitor monitor, void* monitor_target, guint64 file_count, GCancellable* cancellable, GError** error) {
	GFileType type = 0;
	GFile* _tmp0_;
	GFileType _tmp1_;
	GFileType _tmp2_;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp10_;
	GCancellable* _tmp11_;
	GFileEnumerator* _tmp12_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_if_fail (dir != NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = dir;
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_query_file_type (_tmp0_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 140 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	type = _tmp1_;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = type;
#line 141 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp2_ != G_FILE_TYPE_DIRECTORY) {
#line 1082 "file.c"
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GError* _tmp8_;
		GError* _tmp9_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = dir;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = _tmp4_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = g_strdup_printf ("%s is not a directory", _tmp5_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp7_ = _tmp6_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp8_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp7_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp9_ = _tmp8_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_tmp7_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_tmp5_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_inner_error_ = _tmp9_;
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 142 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return;
#line 1114 "file.c"
	}
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp10_ = dir;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp11_ = cancellable;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp12_ = g_file_enumerate_children (_tmp10_, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, _tmp11_, &_inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	enumerator = _tmp12_;
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 144 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return;
#line 1130 "file.c"
	}
#line 146 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = NULL;
#line 147 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	i = (guint64) 0;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 1138 "file.c"
		GFileInfo* _tmp13_ = NULL;
		GFileEnumerator* _tmp14_;
		GCancellable* _tmp15_;
		GFileInfo* _tmp16_;
		GFileInfo* _tmp17_;
		GFileInfo* _tmp18_;
		GFileInfo* _tmp19_;
		GFileType _tmp20_;
		gboolean _tmp21_ = FALSE;
		GeeSet* _tmp22_;
		GFile* file = NULL;
		GFile* _tmp27_;
		GFileInfo* _tmp28_;
		const gchar* _tmp29_;
		GFile* _tmp30_;
		gboolean _tmp38_ = FALSE;
		ProgressMonitor _tmp39_;
		void* _tmp39__target;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp14_ = enumerator;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp15_ = cancellable;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp16_ = g_file_enumerator_next_file (_tmp14_, _tmp15_, &_inner_error_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp13_ = _tmp16_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return;
#line 1175 "file.c"
		}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp17_ = _tmp13_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp13_ = NULL;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = _tmp17_;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp18_ = info;
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp18_ != NULL)) {
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp13_);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1193 "file.c"
		}
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp19_ = info;
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp20_ = g_file_info_get_file_type (_tmp19_);
#line 149 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp20_ != G_FILE_TYPE_REGULAR) {
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp13_);
#line 150 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			continue;
#line 1205 "file.c"
		}
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp22_ = exceptions;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp22_ != NULL) {
#line 1211 "file.c"
			GeeSet* _tmp23_;
			GFileInfo* _tmp24_;
			const gchar* _tmp25_;
			gboolean _tmp26_;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp23_ = exceptions;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp24_ = info;
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp25_ = g_file_info_get_name (_tmp24_);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp26_ = gee_collection_contains ((GeeCollection*) _tmp23_, _tmp25_);
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp21_ = _tmp26_;
#line 1226 "file.c"
		} else {
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp21_ = FALSE;
#line 1230 "file.c"
		}
#line 152 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp21_) {
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp13_);
#line 153 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			continue;
#line 1238 "file.c"
		}
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp27_ = dir;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp28_ = info;
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp29_ = g_file_info_get_name (_tmp28_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp30_ = g_file_get_child (_tmp27_, _tmp29_);
#line 155 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		file = _tmp30_;
#line 1250 "file.c"
		{
			GFile* _tmp31_;
			GCancellable* _tmp32_;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp31_ = file;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp32_ = cancellable;
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_file_delete (_tmp31_, _tmp32_, &_inner_error_);
#line 157 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1262 "file.c"
				goto __catch548_g_error;
			}
		}
		goto __finally548;
		__catch548_g_error:
		{
			GError* err = NULL;
			GFile* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			err = _inner_error_;
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_inner_error_ = NULL;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp33_ = file;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp34_ = g_file_get_path (_tmp33_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp35_ = _tmp34_;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp36_ = err;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp37_ = _tmp36_->message;
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_warning ("file.vala:159: Unable to delete file %s: %s", _tmp35_, _tmp37_);
#line 159 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_free0 (_tmp35_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_error_free0 (err);
#line 1295 "file.c"
		}
		__finally548:
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (file);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp13_);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 156 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return;
#line 1312 "file.c"
		}
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp39_ = monitor;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp39__target = monitor_target;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp39_ != NULL) {
#line 1320 "file.c"
			guint64 _tmp40_;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp40_ = file_count;
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp38_ = _tmp40_ > ((guint64) 0);
#line 1326 "file.c"
		} else {
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp38_ = FALSE;
#line 1330 "file.c"
		}
#line 162 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp38_) {
#line 1334 "file.c"
			ProgressMonitor _tmp41_;
			void* _tmp41__target;
			guint64 _tmp42_;
			guint64 _tmp43_;
			guint64 _tmp44_;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp41_ = monitor;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp41__target = monitor_target;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp42_ = file_count;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp43_ = i;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			i = _tmp43_ + 1;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp44_ = i;
#line 163 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp41_ (_tmp42_, _tmp44_, TRUE, _tmp41__target);
#line 1354 "file.c"
		}
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (file);
#line 148 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp13_);
#line 1360 "file.c"
	}
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 138 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1366 "file.c"
}


time_t query_file_modified (GFile* file, GError** error) {
	time_t result = 0;
	GFileInfo* info = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GTimeVal _tmp3_ = {0};
	glong _tmp4_;
	GError * _inner_error_ = NULL;
#line 167 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = file;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_query_info (_tmp0_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = _tmp1_;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1388 "file.c"
		time_t _tmp2_ = 0;
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 168 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp2_;
#line 1394 "file.c"
	}
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_file_info_get_modification_time (info, &_tmp3_);
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = _tmp3_.tv_sec;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = (time_t) _tmp4_;
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 171 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1406 "file.c"
}


gboolean query_is_directory (GFile* file) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFileType _tmp1_;
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = file;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_query_file_type (_tmp0_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp1_ == G_FILE_TYPE_DIRECTORY;
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1424 "file.c"
}


gboolean query_is_directory_empty (GFile* dir, GError** error) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFileType _tmp1_;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp2_;
	GFileEnumerator* _tmp3_;
	GFileEnumerator* _tmp5_;
	GFileInfo* _tmp6_ = NULL;
	GFileEnumerator* _tmp7_;
	GFileInfo* _tmp8_;
	GFileInfo* _tmp10_;
	GFileInfo* _tmp11_;
	gboolean _tmp12_;
	GError * _inner_error_ = NULL;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = dir;
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_query_file_type (_tmp0_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 179 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp1_ != G_FILE_TYPE_DIRECTORY) {
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = FALSE;
#line 180 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1455 "file.c"
	}
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = dir;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = g_file_enumerate_children (_tmp2_, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	enumerator = _tmp3_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1465 "file.c"
		gboolean _tmp4_ = FALSE;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp4_;
#line 1471 "file.c"
	}
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp5_ = enumerator;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp5_ == NULL) {
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = FALSE;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1483 "file.c"
	}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp7_ = enumerator;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp6_ = _tmp8_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1493 "file.c"
		gboolean _tmp9_ = FALSE;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp9_;
#line 1501 "file.c"
	}
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp10_ = _tmp6_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp6_ = NULL;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp11_ = _tmp10_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp12_ = _tmp11_ == NULL;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (_tmp11_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp12_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (_tmp6_);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1521 "file.c"
}


gchar* get_display_pathname (GFile* file) {
	gchar* result = NULL;
	gchar* path = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* home = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean _tmp9_;
#line 190 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = file;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_get_parse_name (_tmp0_);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	path = _tmp1_;
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = g_get_home_dir ();
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 193 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	home = _tmp3_;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = path;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp5_ = home;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 1558 "file.c"
		gchar* _tmp6_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = g_strdup ("~");
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = _tmp6_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (home);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (path);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1570 "file.c"
	}
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp7_ = path;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp8_ = home;
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp9_ = g_str_has_prefix (_tmp7_, _tmp8_);
#line 198 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp9_) {
#line 1580 "file.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp10_ = path;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp11_ = home;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp12_ = strlen (_tmp11_);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp14_ = string_substring (_tmp10_, (glong) _tmp13_, (glong) -1);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp16_ = g_strdup_printf ("~%s", _tmp15_);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp17_ = _tmp16_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (_tmp15_);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = _tmp17_;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (home);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_free0 (path);
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1615 "file.c"
	}
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = path;
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (home);
#line 201 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1623 "file.c"
}


gchar* strip_pretty_path (const gchar* path) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = path;
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, "~");
#line 205 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (!_tmp1_) {
#line 1645 "file.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = path;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = _tmp3_;
#line 206 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1656 "file.c"
	}
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp4_ = g_get_home_dir ();
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp5_ = path;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp6_ = string_substring (_tmp5_, (glong) 1, (glong) -1);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp7_ = _tmp6_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp9_ = _tmp8_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_free0 (_tmp7_);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp9_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1676 "file.c"
}


gchar* get_file_info_id (GFileInfo* info) {
	gchar* result = NULL;
	GFileInfo* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = info;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = g_file_info_get_attribute_string (_tmp0_, G_FILE_ATTRIBUTE_ID_FILE);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp2_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1697 "file.c"
}


void skip_uint64 (GInputStream* input, guint64 skip_amount, GError** error) {
	GError * _inner_error_ = NULL;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_if_fail (input != NULL);
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 1707 "file.c"
		guint64 _tmp0_;
		guint64 _tmp1_;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = skip_amount;
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp0_ > ((guint64) 0))) {
#line 217 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1716 "file.c"
		}
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = skip_amount;
#line 219 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (_tmp1_ >= ((guint64) G_MAXSSIZE)) {
#line 1722 "file.c"
			GInputStream* _tmp2_;
			guint64 _tmp3_;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp2_ = input;
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_input_stream_skip (_tmp2_, (gsize) G_MAXSSIZE, NULL, &_inner_error_);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				g_propagate_error (error, _inner_error_);
#line 220 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				return;
#line 1735 "file.c"
			}
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp3_ = skip_amount;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			skip_amount = _tmp3_ - G_MAXSSIZE;
#line 1741 "file.c"
		} else {
			GInputStream* _tmp4_;
			guint64 _tmp5_;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp4_ = input;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_tmp5_ = skip_amount;
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_input_stream_skip (_tmp4_, (gsize) _tmp5_, NULL, &_inner_error_);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				g_propagate_error (error, _inner_error_);
#line 223 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
				return;
#line 1757 "file.c"
			}
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			skip_amount = (guint64) 0;
#line 1761 "file.c"
		}
	}
}


guint64 count_files_in_directory (GFile* dir, GError** error) {
	guint64 result = 0ULL;
	GFile* _tmp0_;
	gboolean _tmp1_;
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp2_;
	GFileEnumerator* _tmp3_;
	GFileInfo* info = NULL;
	GError * _inner_error_ = NULL;
#line 230 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	g_return_val_if_fail (dir != NULL, 0ULL);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp0_ = dir;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = query_is_directory (_tmp0_);
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (!_tmp1_) {
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		result = (guint64) 0;
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return result;
#line 1789 "file.c"
	}
#line 234 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	count = (guint64) 0;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = dir;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp3_ = g_file_enumerate_children (_tmp2_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	enumerator = _tmp3_;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1801 "file.c"
		guint64 _tmp4_ = 0ULL;
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		g_propagate_error (error, _inner_error_);
#line 235 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		return _tmp4_;
#line 1807 "file.c"
	}
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	info = NULL;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	while (TRUE) {
#line 1813 "file.c"
		GFileInfo* _tmp5_ = NULL;
		GFileEnumerator* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		guint64 _tmp11_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = enumerator;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error_);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = _tmp7_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1828 "file.c"
			guint64 _tmp8_ = 0ULL;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			g_propagate_error (error, _inner_error_);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (info);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			return _tmp8_;
#line 1838 "file.c"
		}
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp9_ = _tmp5_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = NULL;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (info);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		info = _tmp9_;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp10_ = info;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		if (!(_tmp10_ != NULL)) {
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			_g_object_unref0 (_tmp5_);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
			break;
#line 1856 "file.c"
		}
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp11_ = count;
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		count = _tmp11_ + 1;
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_g_object_unref0 (_tmp5_);
#line 1864 "file.c"
	}
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = count;
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (info);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 242 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1874 "file.c"
}


gboolean file_equal (GFile* a, GFile* b) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp2_ = a;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp2_ != NULL) {
#line 1887 "file.c"
		GFile* _tmp3_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = b;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = _tmp3_ != NULL;
#line 1893 "file.c"
	} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp1_ = FALSE;
#line 1897 "file.c"
	}
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp1_) {
#line 1901 "file.c"
		GFile* _tmp4_;
		GFile* _tmp5_;
		gboolean _tmp6_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp4_ = a;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp5_ = b;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp6_ = g_file_equal (_tmp4_, _tmp5_);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = _tmp6_;
#line 1913 "file.c"
	} else {
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = FALSE;
#line 1917 "file.c"
	}
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp0_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1923 "file.c"
}


guint file_hash (GFile* file) {
	guint result = 0U;
	guint _tmp0_ = 0U;
	GFile* _tmp1_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	_tmp1_ = file;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	if (_tmp1_ != NULL) {
#line 1935 "file.c"
		GFile* _tmp2_;
		guint _tmp3_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp2_ = file;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp3_ = g_file_hash (_tmp2_);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = _tmp3_;
#line 1944 "file.c"
	} else {
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1948 "file.c"
	}
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	result = _tmp0_;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/util/file.vala"
	return result;
#line 1954 "file.c"
}



